 completing a flag with an = (e.g., %[1]s -n=<TAB>)
    # completions must be prefixed with the flag
    setopt local_options BASH_REMATCH
    if [[ "${lastParam}" =~ '-.*=' ]]; then
        # We are dealing with a flag with an =
        flagPrefix="-P ${BASH_REMATCH}"
    fi

    # Prepare the command to obtain completions
    requestComp="${words[1]} %[2]s ${words[2,-1]}"
    if [ "${lastChar}" = "" ]; then
        # If the last parameter is complete (there is a space following it)
        # We add an extra empty parameter so we can indicate this to the go completion code.
        __%[1]s_debug "Adding extra empty parameter"
        requestComp="${requestComp} \"\""
    fi

    __%[1]s_debug "About to call: eval ${requestComp}"

    # Use eval to handle any environment variables and such
    out=$(eval ${requestComp} 2>/dev/null)
    __%[1]s_debug "completion output: ${out}"

    # Extract the directive integer following a : from the last line
    local lastLine
    while IFS='\n' read -r line; do
        lastLine=${line}
    done < <(printf "%%s\n" "${out[@]}")
    __%[1]s_debug "last line: ${lastLine}"

    if [ "${lastLine[1]}" = : ]; then
        directive=${lastLine[2,-1]}
        # Remove the directive including the : and the newline
        local suffix
        (( suffix=${#lastLine}+2))
        out=${out[1,-$suffix]}
    else
        # There is no directive specified.  Leave $out as is.
        __%[1]s_debug "No directive found.  Setting do default"
        directive=0
    fi

    __%[1]s_debug "directive: ${directive}"
    __%[1]s_debug "completions: ${out}"
    __%[1]s_debug "flagPrefix: ${flagPrefix}"

    if [ $((directive & shellCompDirectiveError)) -ne 0 ]; then
        __%[1]s_debug "Completion received error. Ignoring completions."
        return
    fi

    local activeHelpMarker="%[9]s"
    local endIndex=${#activeHelpMarker}
    local startIndex=$((${#activeHelpMarker}+1))
    local hasActiveHelp=0
    while IFS='\n' read -r comp; do
        # Check if this is an activeHelp statement (i.e., prefixed with $activeHelpMarker)
        if [ "${comp[1,$endIndex]}" = "$activeHelpMarker" ];then
            __%[1]s_debug "ActiveHelp found: $comp"
            comp="${comp[$startIndex,-1]}"
            if [ -n "$comp" ]; then
                compadd -x "${comp}"
                __%[1]s_debug "ActiveHelp will need delimiter"
                hasActiveHelp=1
            fi

            continue
        fi

        if [ -n "$comp" ]; then
            # If requested, completions are returned with a description.
            # The description is preceded by a TAB character.
            # For zsh's _describe, we need to use a : instead of a TAB.
            # We first need to escape any : as part of the completion itself.
            comp=${comp//:/\\:}

            local tab="$(printf '\t')"
            comp=${comp//$tab/:}

            __%[1]s_debug "Adding completion: ${comp}"
            completions+=${comp}
            lastComp=$comp
        fi
    done < <(printf "%%s\n" "${out[@]}")

    # Add a delimiter after the activeHelp statements, but only if:
    # - there are completions following the activeHelp statements, or
    # - file completion will be performed (so there will be choices after the activeHelp)
    if [ $hasActiveHelp -eq 1 ]; then
        if [ ${#completions} -ne 0 ] || [ $((directive & shellCompDirectiveNoFileComp)) -eq 0 ]; then
            __%[1]s_debug "Adding activeHelp delimiter"
            compadd -x "--"
            hasActiveHelp=0
        fi
    fi

    if [ $((directive & shellCompDirectiveNoSpace)) -ne 0 ]; then
        __%[1]s_debug "Activating nospace."
        noSpace="-S ''"
    fi

    if [ $((directive & shellCompDirectiveKeepOrder)) -ne 0 ]; then
        __%[1]s_debug "Activating keep order."
        keepOrder="-V"
    fi

    if [ $((directive & shellCompDirectiveFilterFileExt)) -ne 0 ]; then
        # File extension filtering
        local filteringCmd
        filteringCmd='_files'
        for filter in ${completions[@]}; do
            if [ ${filter[1]} != '*' ]; then
                # zsh requires a glob pattern to do file filtering
                filter="\*.$filter"
            fi
            filteringCmd+=" -g $filter"
        done
        filteringCmd+=" ${flagPrefix}"

        __%[1]s_debug "File filtering command: $filteringCmd"
        _arguments '*:filename:'"$filteringCmd"
    elif [ $((directive & shellCompDirectiveFilterDirs)) -ne 0 ]; then
        # File completion for directories only
        local subdir
        subdir="${completions[1]}"
        if [ -n "$subdir" ]; then
            __%[1]s_debug "Listing directories in $subdir"
            pushd "${subdir}" >/dev/null 2>&1
        else
            __%[1]s_debug "Listing directories in ."
        fi

        local result
        _arguments '*:dirname:_files -/'" ${flagPrefix}"
        result=$?
        if [ -n "$subdir" ]; then
            popd >/dev/null 2>&1
        fi
        return $result
    else
        __%[1]s_debug "Calling _describe"
        if eval _describe $keepOrder "completions" completions $flagPrefix $noSpace; then
            __%[1]s_debug "_describe found some completions"

            # Return the success of having called _describe
            return 0
        else
            __%[1]s_debug "_describe did not find completions."
            __%[1]s_debug "Checking if we should do file completion."
            if [ $((directive & shellCompDirectiveNoFileComp)) -ne 0 ]; then
                __%[1]s_debug "deactivating file completion"

                # We must return an error code here to let zsh know that there were no
                # completions found by _describe; this is what will trigger other
                # matching algorithms to attempt to find completions.
                # For example zsh can match letters in the middle of words.
                return 1
            else
                # Perform file completion
                __%[1]s_debug "Activating file completion"

                # We must return the result of this command, so it must be the
                # last command, or else we must store its result to return it.
                _arguments '*:filename:_files'" ${flagPrefix}"
            fi
        fi
    fi
}

# don't run the completion function when being source-ed or eval-ed
if [ "$funcstack[1]" = "_%[1]s" ]; then
    _%[1]s
fi
//**
Etalab Open License 2.0
https://spdx.org/licenses/etalab-2.0.json
https://github.com/DISIC/politique-de-contribution-open-source/blob/master/LICENSE.pdf
https://raw.githubusercontent.com/DISIC/politique-de-contribution-open-source/master/LICENSE
**//

(( LICENCE OUVERTE / OPEN LICENCE

- Version 2.0

- Avril 2017 ))??

« RÉUTILISATION » DE L'« INFORMATION » SOUS CETTE LICENCE

Le « Concédant » concède au « Réutilisateur » un droit non exclusif et
gratuit de libre « Réutilisation » de l'« Information » objet de la
présente licence, à des fins commerciales ou non, dans le monde entier et pour
une durée illimitée, dans les conditions exprimées ci-dessous.

Le « Réutilisateur » est libre de réutiliser l'« Information » :

   -
   de la reproduire, la copier,

   -
   de l'adapter, la modifier, l'extraire et la transformer, pour créer des «
   Informations dérivées », des produits ou des services,

   -
   de la communiquer, la diffuser, la redistribuer, la publier et la
   transmettre,

   -
   de l'exploiter à titre commercial, par exemple en la combinant avec d'autres
   informations, ou en l'incluant dans son propre produit ou application.

Sous réserve de :

   -
   mentionner la paternité de l'« Information » : sa source (au moins le nom
   du « Concédant ») et la date de dernière mise à jour de l'« Information
   » réutilisée.

Le « Réutilisateur » peut notamment s'acquitter de cette condition en
renvoyant, par un lien hypertexte, vers la source de « l'Information » et
assurant une mention effective de sa paternité.

Par exemple :

« Ministère de xxx - Données originales téléchargées sur
http:/www.data.gouv.fr/fr/datasets/xxx/, mise à jour du 14 février 2017 ».

Cette mention de paternité ne confère aucun caractère officiel à la «
Réutilisation » de l'« Information », et ne doit pas suggérer une
quelconque reconnaissance ou caution par le « Concédant », ou par toute autre
entité publique, du « Réutilisateur » ou de sa « Réutilisation ».

« DONNÉES À CARACTÈRE PERSONNEL »

L'« Information » mise à disposition peut contenir des « Données à
caractère personnel » pouvant faire l'objet d'une « Réutilisation ». Si tel
est le cas, le « Concédant » informe le « Réutilisateur » de leur
présence.

L'« Information » peut être librement réutilisée, dans le cadre des droits
accordés par la présente licence, à condition de respecter le cadre légal
relatif à la protection des données à caractère personnel.

« DROITS DE PROPRIÉTÉ INTELLECTUELLE »

Il est garanti au « Réutilisateur » que les éventuels « Droits de
propriété intellectuelle » détenus par des tiers ou par le « Concédant »
sur l'« Information » ne font pas obstacle aux droits accordés par la
présente licence.

Lorsque le « Concédant » détient des « Droits de propriété intellectuelle
» cessibles sur l'« Information », il les cède au « Réutilisateur » de
façon non exclusive, à titre gracieux, pour le monde entier, pour toute la
durée des « Droits de propriété intellectuelle », et le « Réutilisateur
» peut faire tout usage de l'« Information » conformément aux libertés et
aux conditions définies par la présente licence.

RESPONSABILITÉ

L'« Information » est mise à disposition telle que produite ou reçue par le
« Concédant », sans autre garantie expresse ou tacite que celles prévues par
la présente licence. L'absence de défauts ou d'erreurs éventuellement
contenues dans l'« Information », comme la fourniture continue de l'«
Information » n'est pas garantie par le « Concédant ». Il ne peut être tenu
pour responsable de toute perte, préjudice ou dommage de quelque sorte causé
à des tiers du fait de la « Réutilisation ».

Le « Réutilisateur » est seul responsable de la « Réutilisation » de l'«
Information ».

La « Réutilisation » ne doit pas induire en erreur des tiers quant au contenu
de l'« Information », sa source et sa date de mise à jour.

DROIT APPLICABLE

La présente licence est régie par le droit français.

COMPATIBILITÉ DE LA PRÉSENTE LICENCE

La présente licence a été conçue pour être compatible avec toute licence
libre qui exige au moins la mention de paternité et notamment avec la version
antérieure de la présente licence ainsi qu'avec les licences :

   -
   « Open Government Licence » (OGL) du Royaume-Uni,

   -
   « Creative Commons Attribution » (CC-BY) de Creative Commons et

   -
   « Open Data Commons Attribution » (ODC-BY) de l'Open Knowledge Foundation.

DÉFINITIONS

Sont considérés, au sens de la présente licence comme :

Le « Concédant » : toute personne concédant un droit de « Réutilisation »
sur l'« Information » dans les libertés et les conditions prévues par la
présente licence

L'« Information » :

   -
   toute information publique figurant dans des documents communiqués ou
   publiés par une administration mentionnée au premier alinéa de l'article
   L.300-2 du CRPA;

   -
   toute information mise à disposition par toute personne selon les termes et
   conditions de la présente licence.

La « Réutilisation » : l'utilisation de l'« Information » à d'autres fins
que celles pour lesquelles elle a été produite ou reçue.

Le « Réutilisateur »: toute personne qui réutilise les « Informations »
conformément aux conditions de la présente licence.

Des « Données à caractère personnel » : toute information se rapportant à
une personne physique identifiée ou identifiable, pouvant être identifiée
directement ou indirectement. Leur « Réutilisation » est subordonnée au
respect du cadre juridique en vigueur.

Une « Information dérivée » : toute nouvelle donnée ou information créées
directement à partir de l'« Information » ou à partir d'une combinaison de
l'« Information » et d'autres données ou informations non soumises à cette
licence.

Les « Droits de propriété intellectuelle » : tous droits identifiés comme
tels par le Code de la propriété intellectuelle (notamment le droit d'auteur,
droits voisins au droit d'auteur, droit sui generis des producteurs de bases de
données…).

À PROPOS DE CETTE LICENCE

La présente licence a vocation à être utilisée par les administrations pour
la réutilisation de leurs informations publiques. Elle peut également être
utilisée par toute personne souhaitant mettre à disposition de l'«
Information » dans les conditions définies par la présente licence.

La France est dotée d'un cadre juridique global visant à une diffusion
spontanée par les administrations de leurs informations publiques afin d'en
permettre la plus large réutilisation.

Le droit de la « Réutilisation » de l'« Information » des administrations
est régi par le code des relations entre le public et l'administration (CRPA).

Cette licence facilite la réutilisation libre et gratuite des informations
publiques et figure parmi les licences qui peuvent être utilisées par
l'administration en vertu du décret pris en application de l'article L.323-2 du
CRPA.

Etalab est la mission chargée, sous l'autorité du Premier ministre, d'ouvrir
le plus grand nombre de données publiques des administrations de l'Etat et de
ses établissements publics. Elle a réalisé la Licence Ouverte pour faciliter
la réutilisation libre et gratuite de ces informations publiques, telles que
définies par l'article L321-1 du CRPA.

Cette licence est la version 2.0 de la Licence Ouverte.

Etalab se réserve la faculté de proposer de nouvelles versions de la Licence
Ouverte. Cependant, les « Réutilisateurs » pourront continuer à réutiliser
les informations qu'ils ont obtenues sous cette licence s'ils le souhaitent.
//**
GNU Lesser General Public License v3.0
https://www.gnu.org/licenses/lgpl-3.0-standalone.html
https://opensource.org/licenses/LGPL-3.0
**//

((
	GNU LESSER GENERAL PUBLIC LICENSE Version 3, 29 June 2007
	
	((
		((
			Copyright __20__
			((<https://fsf.org/>))??
			
	((
		51 Franklin
		((Street||St))
		((Fifth Floor||Suite 500,))??
		Boston, MA 02110 __1__ USA
	||
		59 Temple Place, Suite 330, Boston, MA  02111 __1__ USA
	||
		675 Mass Ave, Cambridge, MA 02139, USA
	))??
		))??

		Everyone is permitted to copy and distribute verbatim copies
		of this license document, but changing it is not allowed.

		((Copyright __20__))??
	))??

))??


This version of the GNU Lesser General Public License incorporates the terms and
conditions of version 3 of the GNU General Public License, supplemented by the
additional permissions listed below.

   __1__ Additional Definitions.



      As used herein, "this License" refers to version 3 of the GNU Lesser
      General Public License, and the "GNU GPL" refers to version 3 of the GNU
      General Public License.



      "The Library" refers to a covered work governed by this License, other
      than an Application or a Combined Work as defined below.



      An "Application" is any work that makes use of an interface provided by
      the Library, but which is not otherwise based on the Library. Defining a
      subclass of a class defined by the Library is deemed a mode of using an
      interface provided by the Library.



      A "Combined Work" is a work produced by combining or linking an
      Application with the Library. The particular version of the Library with
      which the Combined Work was made is also called the "Linked Version".



      The "Minimal Corresponding Source" for a Combined Work means the
      Corresponding Source for the Combined Work, excluding any source code for
      portions of the Combined Work that, considered in isolation, are based on
      the Application, and not on the Linked Version.



      The "Corresponding Application Code" for a Combined Work means the object
      code and/or source code for the Application, including any data and
      utility programs needed for reproducing the Combined Work from the
      Application, but excluding the System Libraries of the Combined Work.

   __1__ Exception to Section 3 of the GNU GPL.

   You may convey a covered work under sections 3 and 4 of this License without
   being bound by section 3 of the GNU GPL.

   __1__ Conveying Modified Versions.

   If you modify a copy of the Library, and, in your modifications, a facility
   refers to a function or data to be supplied by an Application that uses the
   facility (other than as an argument passed when the facility is invoked),
   then you may convey a copy of the modified version:

      __1__ under this License, provided that you make a good faith effort to
      ensure that, in the event an Application does not supply the function or
      data, the facility still operates, and performs whatever part of its
      purpose remains meaningful, or

      __1__ under the GNU GPL, with none of the additional permissions of this
      License applicable to that copy.

   __1__ Object Code Incorporating Material from Library Header Files.

   The object code form of an Application may incorporate material from a header
   file that is part of the Library. You may convey such object code under terms
   of your choice, provided that, if the incorporated material is not limited to
   numerical parameters, data structure layouts and accessors, or small macros,
   inline functions and templates (ten or fewer lines in length), you do both of
   the following:

      __1__ Give prominent notice with each copy of the object code that the
      Library is used in it and that the Library and its use are covered by this
      License.

      __1__ Accompany the object code with a copy of the GNU GPL and this
      license document.

   __1__ Combined Works.

   You may convey a Combined Work under terms of your choice that, taken
   together, effectively do not restrict modification of the portions of the
   Library contained in the Combined Work and reverse engineering for debugging
   such modifications, if you also do each of the following:

      __1__ Give prominent notice with each copy of the Combined Work that the
      Library is used in it and that the Library and its use are covered by this
      License.

      __1__ Accompany the Combined Work with a copy of the GNU GPL and this
      license document.

      __1__ For a Combined Work that displays copyright notices during
      execution, include the copyright notice for the Library among these
      notices, as well as a reference directing the user to the copies of the
      GNU GPL and this license document.

      __1__ Do one of the following:

         __1__ Convey the Minimal Corresponding Source under the terms of this
         License, and the Corresponding Application Code in a form suitable for,
         and under terms that permit, the user to recombine or relink the
         Application with a modified version of the Linked Version to produce a
         modified Combined Work, in the manner specified by section 6 of the GNU
         GPL for conveying Corresponding Source.

         __1__ Use a suitable shared library mechanism for linking with the
         Library. A suitable mechanism is one that (a) uses at run time a copy
         of the Library already present on the user's computer system, and (b)
         will operate properly with a modified version of the Library that is
         interface-compatible with the Linked Version.

      __1__ Provide Installation Information, but only if you would otherwise be
      required to provide such information under section 6 of the GNU GPL, and
      only to the extent that such information is necessary to install and
      execute a modified version of the Combined Work produced by recombining or
      relinking the Application with a modified version of the Linked Version.
      (If you use option 4d0, the Installation Information must accompany the
      Minimal Corresponding Source and Corresponding Application Code. If you
      use option 4d1, you must provide the Installation Information in the
      manner specified by section 6 of the GNU GPL for conveying Corresponding
      Source.)

   __1__ Combined Libraries.

   You may place library facilities that are a work based on the Library side by
   side in a single library together with other library facilities that are not
   Applications and are not covered by this License, and convey such a combined
   library under terms of your choice, if you do both of the following:

      __1__ Accompany the combined library with a copy of the same work based on
      the Library, uncombined with any other library facilities, conveyed under
      the terms of this License.

      __1__ Give prominent notice with the combined library that part of it is a
      work based on the Library, and explaining where to find the accompanying
      uncombined form of the same work.

   __1__ Revised Versions of the GNU Lesser General Public License.

   The Free Software Foundation may publish revised and/or new versions of the
   GNU Lesser General Public License from time to time. Such new versions will
   be similar in spirit to the present version, but may differ in detail to
   address new problems or concerns.

   Each version is given a distinguishing version number. If the Library as you
   received it specifies that a certain numbered version of the GNU Lesser
   General Public License "or any later version" applies to it, you have the
   option of following the terms and conditions either of that published version
   or of any later version published by the Free Software Foundation. If the
   Library as you received it does not specify a version number of the GNU
   Lesser General Public License, you may choose any version of the GNU Lesser
   General Public License ever published by the Free Software Foundation.

   If the Library as you received it specifies that a proxy can decide whether
   future versions of the GNU Lesser General Public License shall apply, that
   proxy's public statement of acceptance of any version is permanent
   authorization for you to choose that version for the Library.
//**
CERN Open Hardware Licence v1.1
https://spdx.org/licenses/CERN-OHL-1.1.json
https://www.ohwr.org/project/licenses/wikis/cern-ohl-v1.1
**//

(( CERN OHL v1.1

2011-07-08 - CERN, Geneva, Switzerland

CERN Open Hardware Licence v1.1 ))??

Preamble

Through this CERN Open Hardware Licence ("CERN OHL") version 1.1, the
Organization wishes to disseminate its hardware designs (as published on
http:/www.ohwr.org/) as widely as possible, and generally to foster
collaboration among public research hardware designers. The CERN OHL is
copyright of CERN. Anyone is welcome to use the CERN OHL, in unmodified form
only, for the distribution of his own Open Hardware designs. Any other right is
reserved.

1. Definitions

In this Licence, the following terms have the following meanings:

"Licence" means this CERN OHL.

"Documentation" means schematic diagrams, designs, circuit or circuit board
layouts, mechanical drawings, flow charts and descriptive text, and other
explanatory material that is explicitly stated as being made available under the
conditions of this Licence. The Documentation may be in any medium, including
but not limited to computer files and representations on paper, film, or any
other media.

"Product" means either an entire, or any part of a, device built using the
Documentation or the modified Documentation.

"Licensee" means any natural or legal person exercising rights under this
Licence.

"Licensor" means any natural or legal person that creates or modifies
Documentation and subsequently communicates to the public and/ or distributes
the resulting Documentation under the terms and conditions of this Licence.

A Licensee may at the same time be a Licensor, and vice versa.

2. Applicability

   (( 2.1 ))??
   This Licence governs the use, copying, modification, communication to the
   public and distribution of the Documentation, and the manufacture and
   distribution of Products. By exercising any right granted under this Licence,
   the Licensee irrevocably accepts these terms and conditions.

   (( 2.2 ))??
   This Licence is granted by the Licensor directly to the Licensee, and shall
   apply worldwide and without limitation in time. The Licensee may assign his
   licence rights or grant sub-licences.

   (( 2.3 ))??
   This Licence does not apply to software, firmware, or code loaded into
   programmable devices which may be used in conjunction with the Documentation,
   the modified Documentation or with Products. The use of such software,
   firmware, or code is subject to the applicable licence terms and conditions.

3. Copying, modification, communication to the public and distribution of the
Documentation

   (( 3.1 ))??
   The Licensee shall keep intact all copyright and trademarks notices and all
   notices that refer to this Licence and to the disclaimer of warranties that
   is included in the Documentation. He shall include a copy thereof in every
   copy of the documentation or, as the case may be, modified Documentation,
   that he communicates to the public or distributes.

   (( 3.2 ))??
   The Licensee may use, copy, communicate to the public and distribute verbatim
   copies of the Documentation, in any medium, subject to the requirements
   specified in section 3.1.

   (( 3.3 ))??
   The Licensee may modify the Documentation or any portion thereof. The
   Licensee may communicate to the public and distribute the modified
   Documentation (thereby in addition to being a Licensee also becoming a
   Licensor), always provided that he shall:

      (( a. ))??
      comply with section 3.1;

      (( b. ))??
      cause the modified Documentation to carry prominent notices stating that
      the Licensee has modified the Documentation, with the date and details of
      the modifications;

      (( c. ))??
      license the modified Documentation under the terms and conditions of this
      Licence or, where applicable, a later version of this Licence as may be
      issued by CERN; and

      (( d. ))??
      send a copy of the modified Documentation to all Licensors that
      contributed to the parts of the Documentation that were modified, as well
      as to any other Licensor who has requested to receive a copy of the
      modified Documentation and has provided a means of contact with the
      Documentation.

   (( 3.4 ))??
   The Licence includes a licence to those patents or registered designs that
   are held by the Licensor, to the extent necessary to make use of the rights
   granted under this Licence. The scope of this section 3.4 shall be strictly
   limited to the parts of the Documentation or modified Documentation created
   by the Licensor.

4. Manufacture and distribution of Products

   (( 4.1 ))??
   The Licensee may manufacture or distribute Products always provided that the
   Licensee distributes to each recipient of such Products a copy of the
   Documentation or modified Documentation, as applicable, and complies with
   section 3.

   (( 4.2 ))??
   The Licensee is invited to inform in writing any Licensor who has indicated
   its wish to receive this information about the type, quantity and dates of
   production of Products the Licensee has (had) manufactured.

5. Warranty and liability

   (( 5.1 ))??
   DISCLAIMER – The Documentation and any modified Documentation are provided
   "as is" and any express or implied warranties, including, but not limited to,
   implied warranties of merchantability, of satisfactory quality, and fitness
   for a particular purpose or use are disclaimed in respect of the
   Documentation, the modified Documentation or any Product. The Licensor makes
   no representation that the Documentation, modified Documentation, or any
   Product, does or will not infringe any patent, copyright, trade secret or
   other proprietary right. The entire risk as to the use, quality, and
   performance of a Product shall be with the Licensee and not the Licensor.
   This disclaimer of warranty is an essential part of this Licence and a
   condition for the grant of any rights granted under this Licence. The
   Licensee warrants that it does not act in a consumer capacity.

   (( 5.2 ))??
   LIMITATION OF LIABILITY – The Licensor shall have no liability for direct,
   indirect, special, incidental, consequential, exemplary, punitive or other
   damages of any character including, without limitation, procurement of
   substitute goods or services, loss of use, data or profits, or business
   interruption, however caused and on any theory of contract, warranty, tort
   (including negligence), product liability or otherwise, arising in any way in
   relation to the Documentation, modified Documentation and/or the use,
   manufacture or distribution of a Product, even if advised of the possibility
   of such damages, and the Licensee shall hold the Licensor(s) free and
   harmless from any liability, costs, damages, fees and expenses, including
   claims by third parties, in relation to such use.

6. General

   (( 6.1 ))??
   The rights granted under this Licence do not imply or represent any transfer
   or assignment of intellectual property rights to the Licensee.

   (( 6.2 ))??
   The Licensee shall not use or make reference to any of the names, acronyms,
   images or logos under which the Licensor is known, save in so far as required
   to comply with section 3. Any such permitted use or reference shall be
   factual and shall in no event suggest any kind of endorsement by the Licensor
   or its personnel of the modified Documentation or any Product, or any kind of
   implication by the Licensor or its personnel in the preparation of the
   modified Documentation or Product.

   (( 6.3 ))??
   CERN may publish updated versions of this Licence which retain the same
   general provisions as this version, but differ in detail so far this is
   required and reasonable. New versions will be published with a unique version
   number.

   (( 6.4 ))??
   This Licence shall terminate with immediate effect, upon written notice and
   without involvement of a court if the Licensee fails to comply with any of
   its terms and conditions, or if the Licensee initiates legal action against
   Licensor in relation to this Licence. Section 5 shall continue to apply.

   (( 6.5 ))??
   Except as may be otherwise agreed with the Intergovernmental Organization,
   any dispute with respect to this Licence involving an Intergovernmental
   Organization shall, by virtue of the latter's Intergovernmental status, be
   settled by international arbitration. The arbitration proceedings shall be
   held at the place where the Intergovernmental Organization has its seat. The
   arbitral award shall be final and binding upon the parties, who hereby
   expressly agree to renounce any form of appeal or revision.
//**
Licence Art Libre 1.3
https://spdx.org/licenses/LAL-1.3.json
https://artlibre.org/
**//

(( Licence Art Libre 1.3 (LAL 1.3) ))??

Préambule :

Avec la Licence Art Libre, l'autorisation est donnée de copier, de diffuser et
de transformer librement les œuvres dans le respect des droits de l'auteur.

Loin d'ignorer ces droits, la Licence Art Libre les reconnaît et les protège.
Elle en reformule l'exercice en permettant à tout un chacun de faire un usage
créatif des productions de l'esprit quels que soient leur genre et leur forme
d'expression.

Si, en règle générale, l'application du droit d'auteur conduit à restreindre
l'accès aux œuvres de l'esprit, la Licence Art Libre, au contraire, le
favorise. L'intention est d'autoriser l'utilisation des ressources d'une
œuvre ; créer de nouvelles conditions de création pour amplifier les
possibilités de création. La Licence Art Libre permet d'avoir jouissance des
œuvres tout en reconnaissant les droits et les responsabilités de chacun.

Avec le développement du numérique, l'invention d'internet et des logiciels
libres, les modalités de création ont évolué : les productions de l'esprit
s'offrent naturellement à la circulation, à l'échange et aux transformations.
Elles se prêtent favorablement à la réalisation d'œuvres communes que chacun
peut augmenter pour l'avantage de tous.

C'est la raison essentielle de la Licence Art Libre : promouvoir et protéger
ces productions de l'esprit selon les principes du copyleft : liberté d'usage,
de copie, de diffusion, de transformation et interdiction d'appropriation
exclusive.

Définitions :

Nous désignons par « œuvre », autant l'œuvre initiale, les œuvres
conséquentes, que l'œuvre commune telles que définies ci-après :

L'œuvre commune : Il s'agit d'une œuvre qui comprend l'œuvre initiale ainsi
que toutes les contributions postérieures (les originaux conséquents et les
copies). Elle est créée à l'initiative de l'auteur initial qui par cette
licence définit les conditions selon lesquelles les contributions sont faites.

L'œuvre initiale : C'est-à-dire l'œuvre créée par l'initiateur de l'œuvre
commune dont les copies vont être modifiées par qui le souhaite.

Les œuvres conséquentes : C'est-à-dire les contributions des auteurs qui
participent à la formation de l'œuvre commune en faisant usage des droits de
reproduction, de diffusion et de modification que leur confère la licence.

Originaux (sources ou ressources de l'œuvre) : Chaque exemplaire daté de
l'œuvre initiale ou conséquente que leurs auteurs présentent comme
référence pour toutes actualisations, interprétations, copies ou
reproductions ultérieures.

Copie : Toute reproduction d'un original au sens de cette licence.

   (( 1- ))??
   OBJET.

   Cette licence a pour objet de définir les conditions selon lesquelles vous
   pouvez jouir librement de l'œuvre.

   (( 2. ))??
   L'ÉTENDUE DE LA JOUISSANCE.

   Cette œuvre est soumise au droit d'auteur, et l'auteur par cette licence
   vous indique quelles sont vos libertés pour la copier, la diffuser et la
   modifier.

      (( 2.1 ))??
      LA LIBERTÉ DE COPIER (OU DE REPRODUCTION).

      Vous avez la liberté de copier cette œuvre pour vous, vos amis ou toute
      autre personne, quelle que soit la technique employée.

      (( 2.2 ))??
      LA LIBERTÉ DE DIFFUSER (INTERPRÉTER, REPRÉSENTER, DISTRIBUER).

      Vous pouvez diffuser librement les copies de ces œuvres, modifiées ou
      non, quel que soit le support, quel que soit le lieu, à titre onéreux ou
      gratuit, si vous respectez toutes les conditions suivantes :

         (( 1. ))??
         joindre aux copies cette licence à l'identique ou indiquer
         précisément où se trouve la licence ;

         (( 2. ))??
         indiquer au destinataire le nom de chaque auteur des originaux, y
         compris le vôtre si vous avez modifié l'œuvre ;

         (( 3. ))??
         indiquer au destinataire où il pourrait avoir accès aux originaux
         (initiaux et/ou conséquents). Les auteurs des originaux pourront,
         s'ils le souhaitent, vous autoriser à diffuser l'original dans les
         mêmes conditions que les copies.

      (( 2.3 ))??
      LA LIBERTÉ DE MODIFIER.

      Vous avez la liberté de modifier les copies des originaux (initiaux et
      conséquents) dans le respect des conditions suivantes :

         (( 1. ))??
         celles prévues à l'article 2.2 en cas de diffusion de la copie
         modifiée ;

         (( 2. ))??
         indiquer qu'il s'agit d'une œuvre modifiée et, si possible, la nature
         de la modification ;

         (( 3. ))??
         diffuser cette œuvre conséquente avec la même licence ou avec toute
         licence compatible ;

         (( 4. ))??
         Les auteurs des originaux pourront, s'ils le souhaitent, vous autoriser
         à modifier l'original dans les mêmes conditions que les copies.

   (( 3. ))??
   DROITS CONNEXES.

   Les actes donnant lieu à des droits d'auteur ou des droits voisins ne
   doivent pas constituer un obstacle aux libertés conférées par cette
   licence.

   C'est pourquoi, par exemple, les interprétations doivent être soumises à
   la même licence ou une licence compatible. De même, l'intégration de
   l'œuvre à une base de données, une compilation ou une anthologie ne doit
   pas faire obstacle à la jouissance de l'œuvre telle que définie par cette
   licence.

   (( 4. ))??
   L' INTÉGRATION DE L'ŒUVRE.

   Toute intégration de cette œuvre à un ensemble non soumis à la LAL doit
   assurer l'exercice des libertés conférées par cette licence.

   Si l'œuvre n'est plus accessible indépendamment de l'ensemble, alors
   l'intégration n'est possible qu'à condition que l'ensemble soit soumis à
   la LAL ou une licence compatible.

   (( 5. ))??
   CRITÈRES DE COMPATIBILITÉ.

   Une licence est compatible avec la LAL si et seulement si :

      (( 1. ))??
      elle accorde l'autorisation de copier, diffuser et modifier des copies de
      l'œuvre, y compris à des fins lucratives, et sans autres restrictions
      que celles qu'impose le respect des autres critères de compatibilité ;

      (( 2. ))??
      elle garantit la paternité de l'œuvre et l'accès aux versions
      antérieures de l'œuvre quand cet accès est possible ;

      (( 3. ))??
      elle reconnaît la LAL également compatible (réciprocité) ;

      (( 4. ))??
      elle impose que les modifications faites sur l'œuvre soient soumises à
      la même licence ou encore à une licence répondant aux critères de
      compatibilité posés par la LAL.

   (( 6. ))??
   VOS DROITS INTELLECTUELS.

   La LAL n'a pas pour objet de nier vos droits d'auteur sur votre contribution
   ni vos droits connexes. En choisissant de contribuer à l'évolution de cette
   œuvre commune, vous acceptez seulement d'offrir aux autres les mêmes
   autorisations sur votre contribution que celles qui vous ont été accordées
   par cette licence. Ces autorisations n'entraînent pas un dessaisissement de
   vos droits intellectuels.

   (( 7. ))??
   VOS RESPONSABILITÉS.

   La liberté de jouir de l'œuvre tel que permis par la LAL (liberté de
   copier, diffuser, modifier) implique pour chacun la responsabilité de ses
   propres faits.

   (( 8. ))??
   LA DURÉE DE LA LICENCE.

   Cette licence prend effet dès votre acceptation de ses dispositions. Le fait
   de copier, de diffuser, ou de modifier l'œuvre constitue une acceptation
   tacite.

   Cette licence a pour durée la durée des droits d'auteur attachés à
   l'œuvre. Si vous ne respectez pas les termes de cette licence, vous perdez
   automatiquement les droits qu'elle vous confère.

   Si le régime juridique auquel vous êtes soumis ne vous permet pas de
   respecter les termes de cette licence, vous ne pouvez pas vous prévaloir des
   libertés qu'elle confère.

   (( 9. ))??
   LES DIFFÉRENTES VERSIONS DE LA LICENCE.

   Cette licence pourra être modifiée régulièrement, en vue de son
   amélioration, par ses auteurs (les acteurs du mouvement Copyleft Attitude)
   sous la forme de nouvelles versions numérotées.

   Vous avez toujours le choix entre vous contenter des dispositions contenues
   dans la version de la LAL sous laquelle la copie vous a été communiquée ou
   alors, vous prévaloir des dispositions d'une des versions ultérieures.

   (( 10. ))??
   LES SOUS-LICENCES.

   Les sous-licences ne sont pas autorisées par la présente. Toute personne
   qui souhaite bénéficier des libertés qu'elle confère sera liée
   directement aux auteurs de l'œuvre commune.

   (( 11. ))??
   LE CONTEXTE JURIDIQUE.

   Cette licence est rédigée en référence au droit français et à la
   Convention de Berne relative au droit d'auteur.
//**
Hippocratic License 2.1
https://spdx.org/licenses/Hippocratic-2.1.json
https://firstdonoharm.dev/version/2/1/license.html
https://github.com/EthicalSource/hippocratic-license/blob/58c0e646d64ff6fbee275bfe2b9492f914e3ab2a/LICENSE.txt
**//

//** Copyright **//

(( Hippocratic License Version Number: 2.1. ))??

Purpose. The purpose of this License is for the Licensor named above to permit
the Licensee (as defined below) broad permission, if consistent with Human
Rights Laws and Human Rights Principles (as each is defined below), to use and
work with the Software (as defined below) within the full scope of Licensor's
copyright and patent rights, if any, in the Software, while ensuring attribution
and protecting the Licensor from liability.

Permission and Conditions. The Licensor grants permission by this license
("License"), free of charge, to the extent of Licensor's rights under applicable
copyright and patent law, to any person or entity (the "Licensee") obtaining a
copy of this software and associated documentation files (the "Software"), to do
everything with the Software that would otherwise infringe (i) the Licensor's
copyright in the Software or (ii) any patent claims to the Software that the
Licensor can license or becomes able to license, subject to all of the following
terms and conditions:

   *
   Acceptance. This License is automatically offered to every person and entity
   subject to its terms and conditions. Licensee accepts this License and agrees
   to its terms and conditions by taking any action with the Software that,
   absent this License, would infringe any intellectual property right held by
   Licensor.

   *
   Notice. Licensee must ensure that everyone who gets a copy of any part of
   this Software from Licensee, with or without changes, also receives the
   License and the above copyright notice (and if included by the Licensor,
   patent, trademark and attribution notice). Licensee must cause any modified
   versions of the Software to carry prominent notices stating that Licensee
   changed the Software. For clarity, although Licensee is free to create
   modifications of the Software and distribute only the modified portion
   created by Licensee with additional or different terms, the portion of the
   Software not modified must be distributed pursuant to this License. If anyone
   notifies Licensee in writing that Licensee has not complied with this Notice
   section, Licensee can keep this License by taking all practical steps to
   comply within 30 days after the notice. If Licensee does not do so,
   Licensee's License (and all rights licensed hereunder) shall end
   immediately.

   *
   Compliance with Human Rights Principles and Human Rights Laws.

      (( 1. ))??
      Human Rights Principles.

         (( (a) ))??
         Licensee is advised to consult the articles of the United Nations
         Universal Declaration of Human Rights and the United Nations Global
         Compact that define recognized principles of international human rights
         (the "Human Rights Principles"). Licensee shall use the Software in a
         manner consistent with Human Rights Principles.

         (( (b) ))??
         Unless the Licensor and Licensee agree otherwise, any dispute,
         controversy, or claim arising out of or relating to (i) Section 1(a)
         regarding Human Rights Principles, including the breach of Section
         1(a), termination of this License for breach of the Human Rights
         Principles, or invalidity of Section 1(a) or (ii) a determination of
         whether any Law is consistent or in conflict with Human Rights
         Principles pursuant to Section 2, below, shall be settled by
         arbitration in accordance with the Hague Rules on Business and Human
         Rights Arbitration (the "Rules"); provided, however, that Licensee may
         elect not to participate in such arbitration, in which event this
         License (and all rights licensed hereunder) shall end immediately. The
         number of arbitrators shall be one unless the Rules require otherwise.

         Unless both the Licensor and Licensee agree to the contrary: (1) All
         documents and information concerning the arbitration shall be public
         and may be disclosed by any party; (2) The repository referred to under
         Article 43 of the Rules shall make available to the public in a timely
         manner all documents concerning the arbitration which are communicated
         to it, including all submissions of the parties, all evidence admitted
         into the record of the proceedings, all transcripts or other recordings
         of hearings and all orders, decisions and awards of the arbitral
         tribunal, subject only to the arbitral tribunal's powers to take such
         measures as may be necessary to safeguard the integrity of the arbitral
         process pursuant to Articles 18, 33, 41 and 42 of the Rules; and (3)
         Article 26(6) of the Rules shall not apply.

      (( 2. ))??
      Human Rights Laws. The Software shall not be used by any person or entity
      for any systems, activities, or other uses that violate any Human Rights
      Laws. "Human Rights Laws" means any applicable laws, regulations, or rules
      (collectively, "Laws") that protect human, civil, labor, privacy,
      political, environmental, security, economic, due process, or similar
      rights; provided, however, that such Laws are consistent and not in
      conflict with Human Rights Principles (a dispute over the consistency or a
      conflict between Laws and Human Rights Principles shall be determined by
      arbitration as stated above). Where the Human Rights Laws of more than one
      jurisdiction are applicable or in conflict with respect to the use of the
      Software, the Human Rights Laws that are most protective of the
      individuals or groups harmed shall apply.

      (( 3. ))??
      Indemnity. Licensee shall hold harmless and indemnify Licensor (and any
      other contributor) against all losses, damages, liabilities, deficiencies,
      claims, actions, judgments, settlements, interest, awards, penalties,
      fines, costs, or expenses of whatever kind, including Licensor's
      reasonable attorneys' fees, arising out of or relating to Licensee's use
      of the Software in violation of Human Rights Laws or Human Rights
      Principles.

   *
   Failure to Comply. Any failure of Licensee to act according to the terms and
   conditions of this License is both a breach of the License and an
   infringement of the intellectual property rights of the Licensor (subject to
   exceptions under Laws, e.g., fair use). In the event of a breach or
   infringement, the terms and conditions of this License may be enforced by
   Licensor under the Laws of any jurisdiction to which Licensee is subject.
   Licensee also agrees that the Licensor may enforce the terms and conditions
   of this License against Licensee through specific performance (or similar
   remedy under Laws) to the extent permitted by Laws. For clarity, except in
   the event of a breach of this License, infringement, or as otherwise stated
   in this License, Licensor may not terminate this License with Licensee.

   *
   Enforceability and Interpretation. If any term or provision of this License
   is determined to be invalid, illegal, or unenforceable by a court of
   competent jurisdiction, then such invalidity, illegality, or unenforceability
   shall not affect any other term or provision of this License or invalidate or
   render unenforceable such term or provision in any other jurisdiction;
   provided, however, subject to a court modification pursuant to the
   immediately following sentence, if any term or provision of this License
   pertaining to Human Rights Laws or Human Rights Principles is deemed invalid,
   illegal, or unenforceable against Licensee by a court of competent
   jurisdiction, all rights in the Software granted to Licensee shall be deemed
   null and void as between Licensor and Licensee. Upon a determination that any
   term or provision is invalid, illegal, or unenforceable, to the extent
   permitted by Laws, the court may modify this License to affect the original
   purpose that the Software be used in compliance with Human Rights Principles
   and Human Rights Laws as closely as possible. The language in this License
   shall be interpreted as to its fair meaning and not strictly for or against
   any party.

   *
   Disclaimer. TO THE FULL EXTENT ALLOWED BY LAW, THIS SOFTWARE COMES "AS IS,"
   WITHOUT ANY WARRANTY, EXPRESS OR IMPLIED, AND LICENSOR AND ANY OTHER
   CONTRIBUTOR SHALL NOT BE LIABLE TO ANYONE FOR ANY DAMAGES OR OTHER LIABILITY
   ARISING FROM, OUT OF, OR IN CONNECTION WITH THE SOFTWARE OR THIS LICENSE,
   UNDER ANY KIND OF LEGAL CLAIM.

This Hippocratic License is an Ethical Source license (https:/ethicalsource.dev)
and is offered for use by licensors and licensees at their own risk, on an "AS
IS" basis, and with no warranties express or implied, to the maximum extent
permitted by Laws.
//**
LaTeX Project Public License v1.0
https://spdx.org/licenses/LPPL-1.0.json
http://www.latex-project.org/lppl/lppl-1-0.txt
**//

(( LaTeX Project Public License
LPPL Version 1.0 1999-03-01

((Copyright __20__))??
))??

Everyone is permitted to copy and distribute verbatim copies of this license
document, but modification is not allowed.

Preamble

The LaTeX Project Public License (LPPL) is the license under which the base
LaTeX distribution is distributed. As described below you may use this licence
for any software that you wish to distribute.

It may be particularly suitable if your software is TeX related (such as a LaTeX
package file) but it may be used for any software, even if it is unrelated to
TeX.

To use this license, the files of your distribution should have an explicit
copyright notice giving your name and the year, together with a reference to
this license.

A typical example would be

%% pig.sty
%% Copyright 2001 M. Y. Name
% This program can redistributed and/or modified under the terms
% of the LaTeX Project Public License Distributed from CTAN
% archives in directory macros/latex/base/lppl.txt; either
% version 1 of the License, or (at your option) any later version.

Given such a notice in the file, the conditions of this document would apply,
with:

`The Program' referring to the software `pig.sty' and `The Copyright Holder'
referring to the person `M. Y. Name'.

To see a real example, see the file legal.txt which carries the copyright notice
for the base latex distribution.

This license gives terms under which files of The Program may be distributed and
modified. Individual files may have specific further constraints on
modification, but no file should have restrictions on distribution other than
those specified below.

This is to ensure that a distributor wishing to distribute a complete unmodified
copy of The Program need only check the conditions in this file, and does not
need to check every file in The Program for extra restrictions. If you do need
to modify the distribution terms of some files, do not refer to this license,
instead distribute The Program under a different license. You may use the parts
of the text of LPPL as a model for your own license, but your license should not
directly refer to the LPPL or otherwise give the impression that The Program is
distributed under the LPPL.

The LaTeX Project Public License

================================

Terms And Conditions For Copying, Distribution And Modification

===============================================================

WARRANTY

========

There is no warranty for The Program, to the extent permitted by applicable law.
Except when otherwise stated in writing, The Copyright Holder provides The
Program `as is' without warranty of any kind, either expressed or implied,
including, but not limited to, the implied warranties of merchantability and
fitness for a particular purpose. The entire risk as to the quality and
performance of the program is with you. Should The Program prove defective, you
assume the cost of all necessary servicing, repair or correction.

In no event unless required by applicable law or agreed to in writing will The
Copyright Holder, or any of the individual authors named in the source for The
Program, be liable to you for damages, including any general, special,
incidental or consequential damages arising out of any use of The Program or out
of inability to use The Program (including but not limited to loss of data or
data being rendered inaccurate or losses sustained by you or by third parties as
a result of a failure of The Program to operate with any other programs), even
if such holder or other party has been advised of the possibility of such
damages.

DISTRIBUTION

============

Redistribution of unchanged files is allowed provided that all files that make
up the distribution of The Program are distributed. In particular this means
that The Program has to be distributed including its documentation if
documentation was part of the original distribution.

The distribution of The Program will contain a prominent file listing all the
files covered by this license.

If you receive only some of these files from someone, complain!

The distribution of changed versions of certain files included in the The
Program, and the reuse of code from The Program, are allowed under the following
restrictions:

   *
   It is allowed only if the legal notice in the file does not expressly forbid
   it. See note below, under "Conditions on individual files".

   *
   You rename the file before you make any changes to it, unless the file
   explicitly says that renaming is not required. Any such changed files must be
   distributed under a license that forbids distribution of those files, and any
   files derived from them, under the names used by the original files in the
   distribution of The Program.

   *
   You change any `identification string' in The Program to clearly indicate
   that the file is not part of the standard system.

   *
   If The Program includes an `error report address' so that errors may be
   reported to The Copyright Holder, or other specified addresses, this address
   must be changed in any modified versions of The Program, so that reports for
   files not maintained by the original program maintainers are directed to the
   maintainers of the changed files.

   *
   You acknowledge the source and authorship of the original version in the
   modified file.

   *
   You also distribute the unmodified version of the file or alternatively
   provide sufficient information so that the user of your modified file can be
   reasonably expected to be able to obtain an original, unmodified copy of The
   Program. For example, you may specify a URL to a site that you expect will
   freely provide the user with a copy of The Program (either the version on
   which your modification is based, or perhaps a later version).

   *
   If The Program is intended to be used with, or is based on, LaTeX, then files
   with the following file extensions which have special meaning in LaTeX
   Software, have special modification rules under the license:

      -
      Files with extension `.ins' (installation files): these files may not be
      modified at all because they contain the legal notices that are placed in
      the generated files.

      -
      Files with extension `.fd' (LaTeX font definitions files): these files are
      allowed to be modified without changing the name, but only to enable use
      of all available fonts and to prevent attempts to access unavailable
      fonts. However, modified files are not allowed to be distributed in place
      of original files.

      -
      Files with extension `.cfg' (configuration files): these files can be
      created or modified to enable easy configuration of the system. The
      documentation in cfgguide.tex in the base LaTeX distribution describes
      when it makes sense to modify or generate such files.

The above restrictions are not intended to prohibit, and hence do not apply to,
the updating, by any method, of a file so that it becomes identical to the
latest version of that file in The Program.

========================================================================

NOTES

=====

We believe that these requirements give you the freedom you to make
modifications that conform with whatever technical specifications you wish,
whilst maintaining the availability, integrity and reliability of The Program.
If you do not see how to achieve your goal whilst adhering to these requirements
then read the document cfgguide.tex in the base LaTeX distribution for
suggestions.

Because of the portability and exchangeability aspects of systems like LaTeX,
The LaTeX3 Project deprecates the distribution of non-standard versions of
components of LaTeX or of generally available contributed code for them but such
distributions are permitted under the above restrictions.

The document modguide.tex in the base LaTeX distribution details the reasons for
the legal requirements detailed above. Even if The Program is unrelated to
LaTeX, the argument in modguide.tex may still apply, and should be read before a
modified version of The Program is distributed.

Conditions on individual files

==============================

The individual files may bear additional conditions which supersede the general
conditions on distribution and modification contained in this file. If there are
any such files, the distribution of The Program will contain a prominent file
that lists all the exceptional files.

Typical examples of files with more restrictive modification conditions would be
files that contain the text of copyright notices.

   *
   The conditions on individual files differ only in the extent of
   *modification* that is allowed.

   *
   The conditions on *distribution* are the same for all the files. Thus a
   (re)distributor of a complete, unchanged copy of The Program need meet only
   the conditions in this file; it is not necessary to check the header of every
   file in the distribution to check that a distribution meets these
   requirements.
//**
Norwegian Licence for Open Government Data
https://spdx.org/licenses/NLOD-1.0.json
http://data.norge.no/nlod/en/1.0
**//

(( Norwegian Licence for Open Government Data (NLOD) ))??

Preface of licence

This licence grants you the right to copy, use and distribute information,
provided you acknowledge the contributors and comply with the terms and
conditions stipulated in this licence. By using information made available under
this licence, you accept the terms and conditions set forth in this licence. As
set out in Section 7, the licensor disclaims any and all liability for the
quality of the information and what the information is used for.

This licence shall not impose any limitations on the rights or freedoms of the
licensee under the Norwegian Freedom of Information Act or any other legislation
granting the general public a right of access to public sector information, or
that follow from exemptions or limitations stipulated in the Norwegian Copyright
Act. Further, the licence shall not impose any limitations on the licensee's
freedom of expression recognized by law.

   (( 1. ))??
   Definitions

   «Database» shall mean a database or similar protected under Section 43 of
   the Norwegian Copyright Act.

   «Information» shall mean texts, images, recordings, data sets or other
   works protected under Section 1 of the Norwegian Copyright Act, or which are
   protected under provisions addressing what is referred to as «neighbouring
   rights» in Chapter 5 of the Norwegian Copyright Act (including databases and
   photographs), and which are distributed under this licence.

   «Copy» shall mean reproduction in any form.

   «Licensee» and «you» shall mean natural or legal persons using
   information under this licence.

   «Licensor» shall mean the natural or legal person that makes information
   available under this licence.

   «Distribute» shall mean any actions whereby information is made available,
   including to distribute, transfer, communicate, disperse, show, perform,
   sell, lend and rent.

   «Use» shall mean one or more actions relevant to copyright law requiring
   permission from the owner of the copyright.

   (( 2. ))??
   Licence

   The licensee, subject to the limitations that follow from this licence, may
   use the information for any purpose and in all contexts, by:

   *
   copying the information and distributing the information to others,

   *
   modifying the information and/or combining the information with other
   information, and

   *
   copying and distributing such changed or combined information.

   *
   This is a non-exclusive, free, perpetual and worldwide licence. The
   information may be used in any medium and format known today and/or which
   will become known in the future. The Licensee shall not sub-license or
   transfer this licence.

   (( 3. ))??
   Exemptions

   The licence does not apply to and therefore does not grant a right to use:

   *
   information which contains personal data covered by the Norwegian Personal
   Data Act unless there is a legitimate basis for the disclosure and further
   processing of the personal data

   *
   information distributed in violation of a statutory obligation to observe
   confidentiality

   *
   information excluded from public disclosure pursuant to law, including
   information deemed sensitive under the Norwegian National Security Act

   *
   information subject to third party rights which the licensor is not
   authorised to license to the licensee

   *
   information protected by intellectual property rights other than copyright
   and neighbouring rights in accordance with Chapter 5 of the Norwegian
   Copyright Act, such as trademarks, patents and design rights, but this does
   not entail an impediment to use information where the licensor's logo has
   been permanently integrated into the information or to attribute the origin
   of the information in accordance with the article below relating to
   attribution.

   If the licensor has made available information not covered by the licence
   according to the above list, the licensee must cease all use of the
   information under the licence, and erase the information as soon as he or she
   becomes aware of or should have understood that the information is not
   covered by the licence.

   (( 4. ))??
   Effects of breach of the licence

   The licence is subject to the licensee's compliance with the terms and
   conditions of this licence. In the event that the licensee commits a breach
   of this licence, this will entail that the licensee's right to use the
   information will be revoked immediately without further notice. In case of
   such a breach, the licensee must immediately and without further notice take
   measures to cause the infringement to end. Because the right to use the
   information has been terminated, the licensee must cease all use of the
   information by virtue of the licence.

   (( 5. ))??
   Attribution

   The licensee shall attribute the licensor as specified by the licensor and
   include a reference to this licence. To the extent practically possible, the
   licensee shall provide a link to both this licence and the source of the
   information.

   If the licensor has not specified how attributions shall be made, the
   licensee shall normally state the following: «Contains data under the
   Norwegian licence for Open Government data (NLOD) distributed by [name of
   licensor]».

   If the licensor has specified that the information shall only be available
   under a specific version of this licence, cf. Section 10, the licensee shall
   also state this.

   If the information has been changed, the licensee must clearly indicate that
   changes have been made by the licensee.

   (( 6. ))??
   Proper use

   The licensee shall not use the information in a manner that appears
   misleading nor present the information in a distorted or incorrect manner.

   Neither the licensor's nor other contributors' names or trademarks must be
   used to support, recommend or market the licensee or any products or services
   using the information.

   (( 7. ))??
   Disclaimer of liability

   The information is licensed «as is». The information may contain errors and
   omissions. The licensor provides no warranties, including relating to the
   content and relevance of the information.

   The licensor disclaims any liability for errors and defects associated with
   the information to the maximum extent permitted by law.

   The licensor shall not be liable for direct or indirect losses as a result of
   use of the information or in connection with copying or further distribution
   of the information.

   (( 8. ))??
   Guarantees regarding data quality and accessibility

   This licence does not prevent the licensor from issuing supplementary
   statements regarding expected or intended data quality and accessibility.
   Such statements shall be regarded as indicative in nature and not binding on
   the part of the licensor. The disclaimers in Section 7 also apply in full for
   such indicative statements. Based on separate agreement, the licensor may
   provide guarantees and distribute the information on terms and conditions
   different from those set forth in this licence.

   (( 9. ))??
   Licence compatibility

   If the licensee is to distribute an adapted or combined work based on
   information covered by this licence and some other work licensed under a
   licence compatible by contract, such distribution may be based on an
   appropriate licence compatible by contract, cf. the list below.

   A licence compatible by contract shall mean the following licences:

   *
   for all information: Open Government Licence (version 1.0),

   *
   for those parts of the information which do not constitute databases:
   Creative Commons Attribution Licence (generic version 1.0, 2.0, 2.5 and
   unported version 3.0) and Creative Commons Navngivelse 3.0 Norge,

   *
   for those parts of the information which constitute databases: Open Data
   Commons Attribution License (version 1.0).

   This provision does not prevent other licences from being compatible with
   this licence based on their content.

   (( 10. ))??
   New versions of the licence

   The licensee may choose to use the information covered by this licence under
   any new versions of the Norwegian licence for Open Government data (NLOD)
   issued by the responsible ministry (currently the Ministry of Government
   Administration, Reform and Church Affairs) when these versions are final and
   official, unless the licensor when making the information available under
   this licence specifically has stated that solely version 1.0 of this licence
   may be used.

   (( 11. ))??
   Governing law and legal venue

This licence, including its formation, and any disputes and claims arising in
connection with or relating to this licence, shall be regulated by Norwegian
law. The legal venue shall be the licensor's ordinary legal venue. The licensor
may, with regard to intellectual proprietary rights, choose to pursue a claim at
other competent legal venues and/or based on the laws of the country where the
intellectual property rights are sought enforced.
//**
Licence Libre du Québec – Réciprocité forte version 1.1
https://spdx.org/licenses/LiLiQ-Rplus-1.1.json
https://www.forge.gouv.qc.ca/participez/licence-logicielle/licence-libre-du-quebec-liliq-en-francais/licence-libre-du-quebec-reciprocite-forte-liliq-r-v1-1/
http://opensource.org/licenses/LiLiQ-Rplus-1.1
**//

(( Licence Libre du Québec – Réciprocité forte (LiLiQ-R+)

Version 1.1 ))??

   (( 1. ))??
   Préambule

   Cette licence s'applique à tout logiciel distribué dont le titulaire du
   droit d'auteur précise qu'il est sujet aux termes de la Licence Libre du
   Québec – Réciprocité forte (LiLiQ-R+) (ci-après appelée la
   « licence »).

   (( 2. ))??
   Définitions

   Dans la présente licence, à moins que le contexte n'indique un sens
   différent, on entend par:

   « concédant » : le titulaire du droit d'auteur sur le logiciel, ou toute
   personne dûment autorisée par ce dernier à accorder la présente licence;

   « contributeur » : le titulaire du droit d'auteur ou toute personne
   autorisée par ce dernier à soumettre au concédant une contribution. Un
   contributeur dont sa contribution est incorporée au logiciel est considéré
   comme un concédant en regard de sa contribution;

   « contribution » : tout logiciel original, ou partie de logiciel original
   soumis et destiné à être incorporé dans le logiciel;

   « distribution » : le fait de délivrer une copie du logiciel;

   « licencié » : toute personne qui possède une copie du logiciel et qui
   exerce les droits concédés par la licence;

   « logiciel » : une œuvre protégée par le droit d'auteur, telle qu'un
   programme d'ordinateur et sa documentation, pour laquelle le titulaire du
   droit d'auteur a précisé qu'elle est sujette aux termes de la présente
   licence;

   « logiciel dérivé » : tout logiciel original réalisé par un licencié,
   autre que le logiciel ou un logiciel modifié, qui produit ou reproduit la
   totalité ou une partie importante du logiciel;

   « logiciel modifié » : toute modification par un licencié de l'un des
   fichiers source du logiciel ou encore tout nouveau fichier source qui
   incorpore le logiciel ou une partie importante de ce dernier.

   (( 3. ))??
   Licence de droit d'auteur

   Sous réserve des termes de la licence, le concédant accorde au licencié
   une licence non exclusive et libre de redevances lui permettant d'exercer les
   droits suivants sur le logiciel:

      (( 1 ))??
      Produire ou reproduire la totalité ou une partie importante;

      (( 2 ))??
      Exécuter ou représenter la totalité ou une partie importante en
      public;

      (( 3 ))??
      Publier la totalité ou une partie importante.

   Cette licence est accordée sans limite territoriale et sans limite de
   temps.

   L'exercice complet de ces droits est sujet à la distribution par le
   concédant du code source du logiciel, lequel doit être sous une forme
   permettant d'y apporter des modifications. Le concédant peut aussi
   distribuer le logiciel accompagné d'une offre de distribuer le code source
   du logiciel, sans frais supplémentaires, autres que ceux raisonnables afin
   de permettre la livraison du code source. Cette offre doit être valide
   pendant une durée raisonnable.

   (( 4. ))??
   Distribution

   Le licencié peut distribuer des copies du logiciel, d'un logiciel modifié
   ou dérivé, sous réserve de respecter les conditions suivantes :

      (( 1 ))??
      Le logiciel doit être accompagné d'un exemplaire de cette licence;

      (( 2 ))??
      Si le logiciel a été modifié, le licencié doit en faire la mention, de
      préférence dans chacun des fichiers modifiés dont la nature permet une
      telle mention;

      (( 3 ))??
      Les étiquettes ou mentions faisant état des droits d'auteur, des marques
      de commerce, des garanties ou de la paternité concernant le logiciel ne
      doivent pas être modifiées ou supprimées, à moins que ces étiquettes
      ou mentions ne soient inapplicables à un logiciel modifié ou dérivé
      donné.

   (( 4.1. ))??
   Réciprocité

   Chaque fois que le licencié distribue le logiciel, le concédant offre au
   récipiendaire une concession sur le logiciel selon les termes de la
   présente licence. Le licencié doit offrir une concession selon les termes
   de la présente licence pour tout logiciel modifié ou dérivé qu'il
   distribue.

   Chaque fois que le licencié distribue le logiciel, un logiciel modifié, ou
   un logiciel dérivé, ce dernier doit assumer l'obligation d'en distribuer le
   code source, de la manière prévue au troisième alinéa de l'article 3.

   (( 4.2. ))??
   Compatibilité

   Dans la mesure où le licencié souhaite distribuer un logiciel modifié ou
   dérivé combiné à un logiciel assujetti à une licence compatible, mais
   dont il ne serait pas possible d'en respecter les termes, le concédant
   offre, en plus de la présente concession, une concession selon les termes de
   cette licence compatible.

   Un licencié qui est titulaire exclusif du droit d'auteur sur le logiciel
   assujetti à une licence compatible ne peut pas se prévaloir de cette offre.
   Il en est de même pour toute autre personne dûment autorisée à
   sous-licencier par le titulaire exclusif du droit d'auteur sur le logiciel
   assujetti à une licence compatible.

   Est considérée comme une licence compatible toute licence libre approuvée
   ou certifiée par la Free Software Foundation ou l'Open Source Initiative,
   dont le niveau de réciprocité est comparable à celui de la présente
   licence, sans toutefois être moindre, notamment:

      (( 1 ))??
      Common Public License Version 1.0 (CPL-1.0)

      (( 2 ))??
      Contrat de licence de logiciel libre CeCILL, version 2.1 (CECILL-2.1)

      (( 3 ))??
      Eclipse Public License - v 1.0 (EPL-1.0)

      (( 4 ))??
      European Union Public License, version 1.1 (EUPL v. 1.1)

      (( 5 ))??
      GNU General Public License Version 2 (GNU GPLv2)

      (( 6 ))??
      GNU General Public License Version 3 (GNU GPLv3)

   (( 5. ))??
   Contributions

   Sous réserve d'une entente distincte, toute contribution soumise par un
   contributeur au concédant pour inclusion dans le logiciel sera soumise aux
   termes de cette licence.

   (( 6. ))??
   Marques de commerce

   La licence n'accorde aucune permission particulière qui permettrait
   d'utiliser les marques de commerce du concédant, autre que celle requise
   permettant d'identifier la provenance du logiciel.

   (( 7. ))??
   Garanties

   Sauf mention contraire, le concédant distribue le logiciel sans aucune
   garantie, aux risques et périls de l'acquéreur de la copie du logiciel, et
   ce, sans assurer que le logiciel puisse répondre à un besoin particulier ou
   puisse donner un résultat quelconque.

   Sans lier le concédant d'une quelconque manière, rien n'empêche un
   licencié d'offrir ou d'exclure des garanties ou du support.

   (( 8. ))??
   Responsabilité

   Le licencié est responsable de tout préjudice résultant de l'exercice des
   droits accordés par la licence.

   Le concédant ne saurait être tenu responsable du préjudice subi par le
   licencié ou par des tiers, pour quelque cause que ce soit en lien avec la
   licence et les droits qui y sont accordés.

   (( 9. ))??
   Résiliation

   La présente licence est résiliée de plein droit dès que les droits qui y
   sont accordés ne sont pas exercés conformément aux termes qui y sont
   stipulés.

   Toutefois, si le défaut est corrigé dans un délai de 30 jours de sa prise
   de connaissance par la personne en défaut, et qu'il s'agit du premier
   défaut, la licence est accordée de nouveau.

   Pour tout défaut subséquent, le consentement exprès du concédant est
   nécessaire afin que la licence soit accordée de nouveau.

   (( 10. ))??
   Version de la licence

   Le Centre de services partagés du Québec, ses ayants cause ou toute
   personne qu'il désigne, peuvent diffuser des versions révisées ou
   modifiées de cette licence. Chaque version recevra un numéro unique. Si un
   logiciel est déjà soumis aux termes d'une version spécifique, c'est
   seulement cette version qui liera les parties à la licence.

   Le concédant peut aussi choisir de concéder la licence sous la version
   actuelle ou toute version ultérieure, auquel cas le licencié peut choisir
   sous quelle version la licence lui est accordée.

   (( 11. ))??
   Divers

   Dans la mesure où le concédant est un ministère, un organisme public ou
   une personne morale de droit public, créés en vertu d'une loi de
   l'Assemblée nationale du Québec, la licence est régie par le droit
   applicable au Québec et en cas de contestation, les tribunaux du Québec
   seront seuls compétents.

   La présente licence peut être distribuée sans conditions particulières.
   Toutefois, une version modifiée doit être distribuée sous un nom
   différent. Toute référence au Centre de services partagés du Québec, et,
   le cas échéant, ses ayant cause, doit être retirée, autre que celle
   permettant d'identifier la provenance de la licence.
//**
Mulan Permissive Software License, Version 1
https://spdx.org/licenses/MulanPSL-1.0.json
https://license.coscl.org.cn/MulanPSL/
https://github.com/yuwenlong/longphp/blob/25dfb70cc2a466dc4bb55ba30901cbce08d164b5/LICENSE
**//

(( 木兰宽松许可证, 第1版 ))??

(( 木兰宽松许可证， 第1版

2019年8月 http:/license.coscl.org.cn/MulanPSL ))??

您对"软件"的复制、使用、修改及分发受木兰宽松许可证，第1版（"本许可证"）的如下条款的约束：

   (( 0. ))??
   定义

   "软件"是指由"贡献"构成的许可在"本许可证"下的程序和相关文档的集合。

   "贡献者"是指将受版权法保护的作品许可在"本许可证"下的自然人或"法人实体"。

   "法人实体"是指提交贡献的机构及其"关联实体"。

   "关联实体"是指，对"本许可证"下的一方而言，控制、受控制或与其共同受控制的机构，此处的控制是指有受控方或共同受控方至少50%直接或间接的投票权、资金或其他有价证券。

   "贡献"是指由任一"贡献者"许可在"本许可证"下的受版权法保护的作品。

   (( 1. ))??
   授予版权许可

   每个"贡献者"根据"本许可证"授予您永久性的、全球性的、免费的、非独占的、不可撤销的版权许可，您可以复制、使用、修改、分发其"贡献"，不论修改与否。

   (( 2. ))??
   授予专利许可

   每个"贡献者"根据"本许可证"授予您永久性的、全球性的、免费的、非独占的、不可撤销的（根据本条规定撤销除外）专利许可，供您制造、委托制造、使用、许诺销售、销售、进口其"贡献"或以其他方式转移其"贡献"。前述专利许可仅限于"贡献者"现在或将来拥有或控制的其"贡献"本身或其"贡献"与许可"贡献"时的"软件"结合而将必然会侵犯的专利权利要求，不包括仅因您或他人修改"贡献"或其他结合而将必然会侵犯到的专利权利要求。如您或您的"关联实体"直接或间接地（包括通过代理、专利被许可人或受让人），就"软件"或其中的"贡献"对任何人发起专利侵权诉讼（包括反诉或交叉诉讼）或其他专利维权行动，指控其侵犯专利权，则"本许可证"授予您对"软件"的专利许可自您提起诉讼或发起维权行动之日终止。

   (( 3. ))??
   无商标许可

   "本许可证"不提供对"贡献者"的商品名称、商标、服务标志或产品名称的商标许可，但您为满足第4条规定的声明义务而必须使用除外。

   (( 4. ))??
   分发限制

   您可以在任何媒介中将"软件"以源程序形式或可执行形式重新分发，不论修改与否，但您必须向接收者提供"本许可证"的副本，并保留"软件"中的版权、商标、专利及免责声明。

   (( 5. ))??
   免责声明与责任限制

   "软件"及其中的"贡献"在提供时不带任何明示或默示的担保。在任何情况下，"贡献者"或版权所有者不对任何人因使用"软件"或其中的"贡献"而引发的任何直接或间接损失承担责任，不论因何种原因导致或者基于何种法律理论,即使其曾被建议有此种损失的可能性。

条款结束

如何将木兰宽松许可证，第1版，应用到您的软件

如果您希望将木兰宽松许可证，第1版，应用到您的新软件，为了方便接收者查阅，建议您完成如下三步：

   (( 1， ))??
   请您补充如下声明中的空白，包括软件名、软件的首次发表年份以及您作为版权人的名字；

   (( 2， ))??
   请您在软件包的一级目录下创建以"LICENSE"为名的文件，将整个许可证文本放入该文件中；

   (( 3， ))??
   请将如下声明文本放入每个源文件的头部注释中。

Copyright (c) [2019] [name of copyright holder]

[Software Name] is licensed under the Mulan PSL v1.

You can use this software according to the terms and conditions of the Mulan PSL
v1.

You may obtain a copy of Mulan PSL v1 at:

http:/license.coscl.org.cn/MulanPSL

THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.

See the Mulan PSL v1 for more details.
(( Mulan Permissive Software License，Version 1 ))??

(( Mulan Permissive Software License，Version 1 (Mulan PSL v1)

August 2019 http:/license.coscl.org.cn/MulanPSL ))??

Your reproduction, use, modification and distribution of the Software shall be
subject to Mulan PSL v1 (this License) with following terms and conditions:

   (( 0. ))??
   Definition

   Software means the program and related documents which are comprised of those
   Contribution and licensed under this License.

   Contributor means the Individual or Legal Entity who licenses its
   copyrightable work under this License.

   Legal Entity means the entity making a Contribution and all its Affiliates.

   Affiliates means entities that control, or are controlled by, or are under
   common control with a party to this License, 'control' means direct or
   indirect ownership of at least fifty percent (50%) of the voting power,
   capital or other securities of controlled or commonly controlled entity.

   Contribution means the copyrightable work licensed by a particular
   Contributor under this License.

   (( 1. ))??
   Grant of Copyright License

   Subject to the terms and conditions of this License, each Contributor hereby
   grants to you a perpetual, worldwide, royalty-free, non-exclusive,
   irrevocable copyright license to reproduce, use, modify, or distribute its
   Contribution, with modification or not.

   (( 2. ))??
   Grant of Patent License

   Subject to the terms and conditions of this License, each Contributor hereby
   grants to you a perpetual, worldwide, royalty-free, non-exclusive,
   irrevocable (except for revocation under this Section) patent license to
   make, have made, use, offer for sale, sell, import or otherwise transfer its
   Contribution where such patent license is only limited to the patent claims
   owned or controlled by such Contributor now or in future which will be
   necessarily infringed by its Contribution alone, or by combination of the
   Contribution with the Software to which the Contribution was contributed,
   excluding of any patent claims solely be infringed by your or others'
   modification or other combinations. If you or your Affiliates directly or
   indirectly (including through an agent, patent licensee or assignee）,
   institute patent litigation (including a cross claim or counterclaim in a
   litigation) or other patent enforcement activities against any individual or
   entity by alleging that the Software or any Contribution in it infringes
   patents, then any patent license granted to you under this License for the
   Software shall terminate as of the date such litigation or activity is filed
   or taken.

   (( 3. ))??
   No Trademark License

   No trademark license is granted to use the trade names, trademarks, service
   marks, or product names of Contributor, except as required to fulfill notice
   requirements in section 4.

   (( 4. ))??
   Distribution Restriction

   You may distribute the Software in any medium with or without modification,
   whether in source or executable forms, provided that you provide recipients
   with a copy of this License and retain copyright, patent, trademark and
   disclaimer statements in the Software.

   (( 5. ))??
   Disclaimer of Warranty and Limitation of Liability

   The Software and Contribution in it are provided without warranties of any
   kind, either express or implied. In no event shall any Contributor or
   copyright holder be liable to you for any damages,including, but not limited
   to any direct, or indirect, special or consequential damages arising from
   your use or inability to use the Software or the Contribution in it, no
   matter how it's caused or based on which legal theory, even if advised of the
   possibility of such damages.

End of the Terms and Conditions

How to apply the Mulan Permissive Software License，Version 1 (Mulan PSL v1) to
your software

To apply the Mulan PSL v1 to your work, for easy identification by recipients,
you are suggested to complete following three steps:

   (( i. ))??
   Fill in the blanks in following statement, including insert your software
   name, the year of the first publication of your software, and your name
   identified as the copyright owner;

   (( ii. ))??
   Create a file named "LICENSE" which contains the whole context of this
   License in the first directory of your software package;

   (( iii. ))??
   Attach the statement to the appropriate annotated syntax at the beginning of
   each source file.

Copyright (c) [2019] [name of copyright holder]

[Software Name] is licensed under the Mulan PSL v1.

You can use this software according to the terms and conditions of the Mulan PSL
v1.

You may obtain a copy of Mulan PSL v1 at:

http:/license.coscl.org.cn/MulanPSL

THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.

See the Mulan PSL v1 for more details.
//**
Artistic License 2.0
https://spdx.org/licenses/Artistic-2.0.json
http://www.perlfoundation.org/artistic_license_2_0
https://opensource.org/licenses/artistic-license-2.0
**//

(( The Artistic License 2.0 ))??

((Copyright (c) 2000-2006, The Perl Foundation.))??

Everyone is permitted to copy and distribute verbatim copies of this license
document, but changing it is not allowed.

Preamble

This license establishes the terms under which a given free software Package may
be copied, modified, distributed, and/or redistributed. The intent is that the
Copyright Holder maintains some artistic control over the development of that
Package while still keeping the Package available as open source and free
software.

You are always permitted to make arrangements wholly outside of this license
directly with the Copyright Holder of a given Package. If the terms of this
license do not permit the full use that you propose to make of the Package, you
should contact the Copyright Holder and seek a different licensing arrangement.

Definitions

   "Copyright Holder" means the individual(s) or organization(s) named in the
   copyright notice for the entire Package.

   "Contributor" means any party that has contributed code or other material to
   the Package, in accordance with the Copyright Holder's procedures.

   "You" and "your" means any person who would like to copy, distribute, or
   modify the Package.

   "Package" means the collection of files distributed by the Copyright Holder,
   and derivatives of that collection and/or of those files. A given Package may
   consist of either the Standard Version, or a Modified Version.

   "Distribute" means providing a copy of the Package or making it accessible to
   anyone else, or in the case of a company or organization, to others outside
   of your company or organization.

   "Distributor Fee" means any fee that you charge for Distributing this Package
   or providing support for this Package to another party. It does not mean
   licensing fees.

   "Standard Version" refers to the Package if it has not been modified, or has
   been modified only in ways explicitly requested by the Copyright Holder.

   "Modified Version" means the Package, if it has been changed, and such
   changes were not explicitly requested by the Copyright Holder.

   "Original License" means this Artistic License as Distributed with the
   Standard Version of the Package, in its current version or as it may be
   modified by The Perl Foundation in the future.

   "Source" form means the source code, documentation source, and configuration
   files for the Package.

   "Compiled" form means the compiled bytecode, object code, binary, or any
   other form resulting from mechanical transformation or translation of the
   Source form.

Permission for Use and Modification Without Distribution

   (( (1) ))??
   You are permitted to use the Standard Version and create and use Modified
   Versions for any purpose without restriction, provided that you do not
   Distribute the Modified Version.

Permissions for Redistribution of the Standard Version

   (( (2) ))??
   You may Distribute verbatim copies of the Source form of the Standard Version
   of this Package in any medium without restriction, either gratis or for a
   Distributor Fee, provided that you duplicate all of the original copyright
   notices and associated disclaimers. At your discretion, such verbatim copies
   may or may not include a Compiled form of the Package.

   (( (3) ))??
   You may apply any bug fixes, portability changes, and other modifications
   made available from the Copyright Holder. The resulting Package will still be
   considered the Standard Version, and as such will be subject to the Original
   License.

Distribution of Modified Versions of the Package as Source

   (( (4) ))??
   You may Distribute your Modified Version as Source (either gratis or for a
   Distributor Fee, and with or without a Compiled form of the Modified Version)
   provided that you clearly document how it differs from the Standard Version,
   including, but not limited to, documenting any non-standard features,
   executables, or modules, and provided that you do at least ONE of the
   following:

      (( (a) ))??
      make the Modified Version available to the Copyright Holder of the
      Standard Version, under the Original License, so that the Copyright Holder
      may include your modifications in the Standard Version.

      (( (b) ))??
      ensure that installation of your Modified Version does not prevent the
      user installing or running the Standard Version. In addition, the Modified
      Version must bear a name that is different from the name of the Standard
      Version.

      (( c ))??
      allow anyone who receives a copy of the Modified Version to make the
      Source form of the Modified Version available to others under

         (( (i) ))??
         the Original License or

         (( (ii) ))??
         a license that permits the licensee to freely copy, modify and
         redistribute the Modified Version using the same licensing terms that
         apply to the copy that the licensee received, and requires that the
         Source form of the Modified Version, and of any works derived from it,
         be made freely available in that license fees are prohibited but
         Distributor Fees are allowed.

Distribution of Compiled Forms of the Standard Version or Modified Versions
without the Source

   (( (5) ))??
   You may Distribute Compiled forms of the Standard Version without the Source,
   provided that you include complete instructions on how to get the Source of
   the Standard Version. Such instructions must be valid at the time of your
   distribution. If these instructions, at any time while you are carrying out
   such distribution, become invalid, you must provide new instructions on
   demand or cease further distribution. If you provide valid instructions or
   cease distribution within thirty days after you become aware that the
   instructions are invalid, then you do not forfeit any of your rights under
   this license.

   (( (6) ))??
   You may Distribute a Modified Version in Compiled form without the Source,
   provided that you comply with Section 4 with respect to the Source of the
   Modified Version.

Aggregating or Linking the Package

   (( (7) ))??
   You may aggregate the Package (either the Standard Version or Modified
   Version) with other packages and Distribute the resulting aggregation
   provided that you do not charge a licensing fee for the Package. Distributor
   Fees are permitted, and licensing fees for other components in the
   aggregation are permitted. The terms of this license apply to the use and
   Distribution of the Standard or Modified Versions as included in the
   aggregation.

   (( (8) ))??
   You are permitted to link Modified and Standard Versions with other works, to
   embed the Package in a larger work of your own, or to build stand-alone
   binary or bytecode versions of applications that include the Package, and
   Distribute the result without restriction, provided the result does not
   expose a direct interface to the Package.

Items That are Not Considered Part of a Modified Version

   (( (9) ))??
   Works (including, but not limited to, modules and scripts) that merely extend
   or make use of the Package, do not, by themselves, cause the Package to be a
   Modified Version. In addition, such works are not considered parts of the
   Package itself, and are not subject to the terms of this license.

General Provisions

   (( (10) ))??
   Any use, modification, and distribution of the Standard or Modified Versions
   is governed by this Artistic License. By using, modifying or distributing the
   Package, you accept this license. Do not use, modify, or distribute the
   Package, if you do not accept this license.

   (( (11) ))??
   If your Modified Version has been derived from a Modified Version made by
   someone other than you, you are nevertheless required to ensure that your
   Modified Version complies with the requirements of this license.

   (( (12) ))??
   This license does not grant you the right to use any trademark, service mark,
   tradename, or logo of the Copyright Holder.

   (( (13) ))??
   This license includes the non-exclusive, worldwide, free-of-charge patent
   license to make, have made, use, offer to sell, sell, import and otherwise
   transfer the Package with respect to any patent claims licensable by the
   Copyright Holder that are necessarily infringed by the Package. If you
   institute patent litigation (including a cross-claim or counterclaim) against
   any party alleging that the Package constitutes direct or contributory patent
   infringement, then this Artistic License to you shall terminate on the date
   that such litigation is filed.

   (( (14) ))??
   Disclaimer of Warranty:

   THE PACKAGE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS "AS IS" AND
   WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES. THE IMPLIED WARRANTIES OF
   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT ARE
   DISCLAIMED TO THE EXTENT PERMITTED BY YOUR LOCAL LAW. UNLESS REQUIRED BY LAW,
   NO COPYRIGHT HOLDER OR CONTRIBUTOR WILL BE LIABLE FOR ANY DIRECT, INDIRECT,
   INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING IN ANY WAY OUT OF THE USE OF THE
   PACKAGE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

function __%[1]s_debug
    set -l file "$BASH_COMP_DEBUG_FILE"
    if test -n "$file"
        echo "$argv" >> $file
    end
end

function __%[1]s_perform_completion
    __%[1]s_debug "Starting __%[1]s_perform_completion"

    # Extract all args except the last one
    set -l args (commandline -opc)
    # Extract the last arg and escape it in case it is a space
    set -l lastArg (string escape -- (commandline -ct))

    __%[1]s_debug "args: $args"
    __%[1]s_debug "last arg: $lastArg"

    # Disable ActiveHelp which is not supported for fish shell
    set -l requestComp "%[10]s=0 $args[1] %[3]s $args[2..-1] $lastArg"

    __%[1]s_debug "Calling $requestComp"
    set -l results (eval $requestComp 2> /dev/null)

    # Some programs may output extra empty lines after the directive.
    # Let's ignore them or else it will break completion.
    # Ref: https://github.com/spf13/cobra/issues/1279
    for line in $results[-1..1]
        if test (string trim -- $line) = ""
            # Found an empty line, remove it
            set results $results[1..-2]
        else
            # Found non-empty line, we have our proper output
            break
        end
    end

    set -l comps $results[1..-2]
    set -l directiveLine $results[-1]

    # For Fish, when completing a flag with an = (e.g., <program> -n=<TAB>)
    # completions must be prefixed with the flag
    set -l flagPrefix (string match -r -- '-.*=' "$lastArg")

    __%[1]s_debug "Comps: $comps"
    __%[1]s_debug "DirectiveLine: $directiveLine"
    __%[1]s_debug "flagPrefix: $flagPrefix"

    for comp in $comps
        printf "%%s%%s\n" "$flagPrefix" "$comp"
    end

    printf "%%s\n" "$directiveLine"
end

# this function limits calls to __%[1]s_perform_completion, by caching the result behind $__%[1]s_perform_completion_once_result
function __%[1]s_perform_completion_once
    __%[1]s_debug "Starting __%[1]s_perform_completion_once"

    if test -n "$__%[1]s_perform_completion_once_result"
        __%[1]s_debug "Seems like a valid result already exists, skipping __%[1]s_perform_completion"
        return 0
    end

    set --global __%[1]s_perform_completion_once_result (__%[1]s_perform_completion)
    if test -z "$__%[1]s_perform_completion_once_result"
        __%[1]s_debug "No completions, probably due to a failure"
        return 1
    end

    __%[1]s_debug "Performed completions and set __%[1]s_perform_completion_once_result"
    return 0
end

# this function is used to clear the $__%[1]s_perform_completion_once_result variable after completions are run
function __%[1]s_clear_perform_completion_once_result
    __%[1]s_debug ""
    __%[1]s_debug "========= clearing previously set __%[1]s_perform_completion_once_result variable =========="
    set --erase __%[1]s_perform_completion_once_result
    __%[1]s_debug "Successfully erased the variable __%[1]s_perform_completion_once_result"
end

function __%[1]s_requires_order_preservation
    __%[1]s_debug ""
    __%[1]s_debug "========= checking if order preservation is required =========="

    __%[1]s_perform_completion_once
    if test -z "$__%[1]s_perform_completion_once_result"
        __%[1]s_debug "Error determining if order preservation is required"
        return 1
    end

    set -l directive (string sub --start 2 $__%[1]s_perform_completion_once_result[-1])
    __%[1]s_debug "Directive is: $directive"

    set -l shellCompDirectiveKeepOrder %[9]d
    set -l keeporder (math (math --scale 0 $directive / $shellCompDirectiveKeepOrder) %% 2)
    __%[1]s_debug "Keeporder is: $keeporder"

    if test $keeporder -ne 0
        __%[1]s_debug "This does require order preservation"
        return 0
    end

    __%[1]s_debug "This doesn't require order preservation"
    return 1
end


# This function does two things:
# - Obtain the completions and store them in the global __%[1]s_comp_results
# - Return false if file completion should be performed
function __%[1]s_prepare_completions
    __%[1]s_debug ""
    __%[1]s_debug "========= starting completion logic =========="

    # Start fresh
    set --erase __%[1]s_comp_results

    __%[1]s_perform_completion_once
    __%[1]s_debug "Completion results: $__%[1]s_perform_completion_once_result"

    if test -z "$__%[1]s_perform_completion_once_result"
        __%[1]s_debug "No completion, probably due to a failure"
        # Might as well do file completion, in case it helps
        return 1
    end

    set -l directive (string sub --start 2 $__%[1]s_perform_completion_once_result[-1])
    set --global __%[1]s_comp_results $__%[1]s_perform_completion_once_result[1..-2]

    __%[1]s_debug "Completions are: $__%[1]s_comp_results"
    __%[1]s_debug "Directive is: $directive"

    set -l shellCompDirectiveError %[4]d
    set -l shellCompDirectiveNoSpace %[5]d
    set -l shellCompDirectiveNoFileComp %[6]d
    set -l shellCompDirectiveFilterFileExt %[7]d
    set -l shellCompDirectiveFilterDirs %[8]d

    if test -z "$directive"
        set directive 0
    end

    set -l compErr (math (math --scale 0 $directive / $shellCompDirectiveError) %% 2)
    if test $compErr -eq 1
        __%[1]s_debug "Received error directive: aborting."
        # Might as well do file completion, in case it helps
        return 1
    end

    set -l filefilter (math (math --scale 0 $directive / $shellCompDirectiveFilterFileExt) %% 2)
    set -l dirfilter (math (math --scale 0 $directive / $shellCompDirectiveFilterDirs) %% 2)
    if test $filefilter -eq 1; or test $dirfilter -eq 1
        __%[1]s_debug "File extension filtering or directory filtering not supported"
        # Do full file completion instead
        return 1
    end

    set -l nospace (math (math --scale 0 $directive / $shellCompDirectiveNoSpace) %% 2)
    set -l nofiles (math (math --scale 0 $directive / $shellCompDirectiveNoFileComp) %% 2)

    __%[1]s_debug "nospace: $nospace, nofiles: $nofiles"

    # If we want to prevent a space, or if file completion is NOT disabled,
    # we need to count the number of valid completions.
    # To do so, we will filter on prefix as the completions we have received
    # may not already be filtered so as to allow fish to match on different
    # criteria than the prefix.
    if test $nospace -ne 0; or test $nofiles -eq 0
        set -l prefix (commandline -t | string escape --style=regex)
        __%[1]s_debug "prefix: $prefix"

        set -l completions (string match -r -- "^$prefix.*" $__%[1]s_comp_results)
        set --global __%[1]s_comp_results $completions
        __%[1]s_debug "Filtered completions are: $__%[1]s_comp_results"

        # Important not to quote the variable for count to work
        set -l numComps (count $__%[1]s_comp_results)
        __%[1]s_debug "numComps: $numComps"

        if test $numComps -eq 1; and test $nospace -ne 0
            # We must first split on \t to get rid of the descriptions to be
            # able to check what the actual completion will be.
            # We don't need descriptions anyway since there is only a single
            # real completion which the shell will expand immediately.
            set -l split (string split --max 1 \t $__%[1]s_comp_results[1])

            # Fish won't add a space if the completion ends with any
            # of the following characters: @=/:.,
            set -l lastChar (string sub -s -1 -- $split)
            if not string match -r -q "[@=/:.,]" -- "$lastChar"
                # In other cases, to support the "nospace" directive we trick the shell
                # by outputting an extra, longer completion.
                __%[1]s_debug "Adding second completion to perform nospace directive"
                set --global __%[1]s_comp_results $split[1] $split[1].
                __%[1]s_debug "Completions are now: $__%[1]s_comp_results"
            end
        end

        if test $numComps -eq 0; and test $nofiles -eq 0
            # To be consistent with bash and zsh, we only trigger file
            # completion when there are no other completions
            __%[1]s_debug "Requesting file completion"
            return 1
        end
    end

    return 0
end

# Since Fish completions are only loaded once the user triggers them, we trigger them ourselves
# so we can properly delete any completions provided by another script.
# Only do this if the program can be found, or else fish may print some errors; besides,
# the existing completions will only be loaded if the program can be found.
if type -q "%[2]s"
    # The space after the program name is essential to trigger completion for the program
    # and not completion of the program name itself.
    # Also, we use '> /dev/null 2>&1' since '&>' is not supported in older versions of fish.
    complete --do-complete "%[2]s " > /dev/null 2>&1
end

# Remove any pre-existing completions for the program since we will be handling all of them.
complete -c %[2]s -e

# this will get called after the two calls below and clear the $__%[1]s_perform_completion_once_result global
complete -c %[2]s -n '__%[1]s_clear_perform_completion_once_result'
# The call to __%[1]s_prepare_completions will setup __%[1]s_comp_results
# which provides the program's completion choices.
# If this doesn't require order preservation, we don't use the -k flag
complete -c %[2]s -n 'not __%[1]s_requires_order_preservation && __%[1]s_prepare_completions' -f -a '$__%[1]s_comp_results'
# otherwise we use the -k flag
complete -k -c %[2]s -n '__%[1]s_requires_order_preservation && __%[1]s_prepare_completions' -f -a '$__%[1]s_comp_results'
//**
CERN Open Hardware Licence Version 2 - Permissive
https://spdx.org/licenses/CERN-OHL-P-2.0.json
https://www.ohwr.org/project/cernohl/wikis/Documents/CERN-OHL-version-2
**//

(( CERN Open Hardware Licence Version 2 - Permissive ))??

Preamble

CERN has developed this licence to promote collaboration among hardware
designers and to provide a legal tool which supports the freedom to use, study,
modify, share and distribute hardware designs and products based on those
designs. Version 2 of the CERN Open Hardware Licence comes in three variants:
this licence, CERN-OHL-P (permissive); and two reciprocal licences: CERN- OHL-W
(weakly reciprocal) and CERN-OHL-S (strongly reciprocal).

The CERN-OHL-P is copyright CERN 2020. Anyone is welcome to use it, in
unmodified form only.

Use of this Licence does not imply any endorsement by CERN of any Licensor or
their designs nor does it imply any involvement by CERN in their development.

   (( 1 ))??
   Definitions

      (( 1.1 ))??
      'Licence' means this CERN-OHL-P.

      (( 1.2 ))??
      'Source' means information such as design materials or digital code which
      can be applied to Make or test a Product or to prepare a Product for use,
      Conveyance or sale, regardless of its medium or how it is expressed. It
      may include Notices.

      (( 1.3 ))??
      'Covered Source' means Source that is explicitly made available under this
      Licence.

      (( 1.4 ))??
      'Product' means any device, component, work or physical object, whether in
      finished or intermediate form, arising from the use, application or
      processing of Covered Source.

      (( 1.5 ))??
      'Make' means to create or configure something, whether by manufacture,
      assembly, compiling, loading or applying Covered Source or another Product
      or otherwise.

      (( 1.6 ))??
      'Notice' means copyright, acknowledgement and trademark notices,
      references to the location of any Notices, modification notices
      (subsection 3.3(b) and all notices that refer to this Licence and to the
      disclaimer of warranties that are included in the Covered Source.

      (( 1.7 ))??
      'Licensee' or 'You' means any person exercising rights under this
      Licence.

      (( 1.8 ))??
      'Licensor' means a person who creates Source or modifies Covered Source
      and subsequently Conveys the resulting Covered Source under the terms and
      conditions of this Licence. A person may be a Licensee and a Licensor at
      the same time.

      (( 1.9 ))??
      'Convey' means to communicate to the public or distribute.

   (( 2 ))??
   Applicability

      (( 2.1 ))??
      This Licence governs the use, copying, modification, Conveying of Covered
      Source and Products, and the Making of Products. By exercising any right
      granted under this Licence, You irrevocably accept these terms and
      conditions.

      (( 2.2 ))??
      This Licence is granted by the Licensor directly to You, and shall apply
      worldwide and without limitation in time.

      (( 2.3 ))??
      You shall not attempt to restrict by contract or otherwise the rights
      granted under this Licence to other Licensees.

      (( 2.4 ))??
      This Licence is not intended to restrict fair use, fair dealing, or any
      other similar right.

   (( 3 ))??
   Copying, modifying and Conveying Covered Source

      (( 3.1 ))??
      You may copy and Convey verbatim copies of Covered Source, in any medium,
      provided You retain all Notices.

      (( 3.2 ))??
      You may modify Covered Source, other than Notices.

      You may only delete Notices if they are no longer applicable to the
      corresponding Covered Source as modified by You and You may add additional
      Notices applicable to Your modifications.

      (( 3.3 ))??
      You may Convey modified Covered Source (with the effect that You shall
      also become a Licensor) provided that You:

         (( a) ))??
         retain Notices as required in subsection 3.2; and

         (( b) ))??
         add a Notice to the modified Covered Source stating that You have
         modified it, with the date and brief description of how You have
         modified it.

      (( 3.4 ))??
      You may Convey Covered Source or modified Covered Source under licence
      terms which differ from the terms of this Licence provided that:

         (( a) ))??
         You comply at all times with subsection 3.3; and

         (( b) ))??
         You provide a copy of this Licence to anyone to whom You Convey Covered
         Source or modified Covered Source.

   (( 4 ))??
   Making and Conveying Products

   You may Make Products, and/or Convey them, provided that You ensure that the
   recipient of the Product has access to any Notices applicable to the
   Product.

   (( 5 ))??
   DISCLAIMER AND LIABILITY

      (( 5.1 ))??
      DISCLAIMER OF WARRANTY -- The Covered Source and any Products are provided
      'as is' and any express or implied warranties, including, but not limited
      to, implied warranties of merchantability, of satisfactory quality,
      non-infringement of third party rights, and fitness for a particular
      purpose or use are disclaimed in respect of any Source or Product to the
      maximum extent permitted by law. The Licensor makes no representation that
      any Source or Product does not or will not infringe any patent, copyright,
      trade secret or other proprietary right. The entire risk as to the use,
      quality, and performance of any Source or Product shall be with You and
      not the Licensor. This disclaimer of warranty is an essential part of this
      Licence and a condition for the grant of any rights granted under this
      Licence.

      (( 5.2 ))??
      EXCLUSION AND LIMITATION OF LIABILITY -- The Licensor shall, to the
      maximum extent permitted by law, have no liability for direct, indirect,
      special, incidental, consequential, exemplary, punitive or other damages
      of any character including, without limitation, procurement of substitute
      goods or services, loss of use, data or profits, or business interruption,
      however caused and on any theory of contract, warranty, tort (including
      negligence), product liability or otherwise, arising in any way in
      relation to the Covered Source, modified Covered Source and/or the Making
      or Conveyance of a Product, even if advised of the possibility of such
      damages, and You shall hold the Licensor(s) free and harmless from any
      liability, costs, damages, fees and expenses, including claims by third
      parties, in relation to such use.

   (( 6 ))??
   Patents

      (( 6.1 ))??
      Subject to the terms and conditions of this Licence, each Licensor hereby
      grants to You a perpetual, worldwide, non-exclusive, no-charge,
      royalty-free, irrevocable (except as stated in this section 6, or where
      terminated by the Licensor for cause) patent license to Make, have Made,
      use, offer to sell, sell, import, and otherwise transfer the Covered
      Source and Products, where such licence applies only to those patent
      claims licensable by such Licensor that are necessarily infringed by
      exercising rights under the Covered Source as Conveyed by that Licensor.

      (( 6.2 ))??
      If You institute patent litigation against any entity (including a
      cross-claim or counterclaim in a lawsuit) alleging that the Covered Source
      or a Product constitutes direct or contributory patent infringement, or
      You seek any declaration that a patent licensed to You under this Licence
      is invalid or unenforceable then any rights granted to You under this
      Licence shall terminate as of the date such process is initiated.

   (( 7 ))??
   General

      (( 7.1 ))??
      If any provisions of this Licence are or subsequently become invalid or
      unenforceable for any reason, the remaining provisions shall remain
      effective.

      (( 7.2 ))??
      You shall not use any of the name (including acronyms and abbreviations),
      image, or logo by which the Licensor or CERN is known, except where needed
      to comply with section 3, or where the use is otherwise allowed by law.
      Any such permitted use shall be factual and shall not be made so as to
      suggest any kind of endorsement or implication of involvement by the
      Licensor or its personnel.

      (( 7.3 ))??
      CERN may publish updated versions and variants of this Licence which it
      considers to be in the spirit of this version, but may differ in detail to
      address new problems or concerns. New versions will be published with a
      unique version number and a variant identifier specifying the variant. If
      the Licensor has specified that a given variant applies to the Covered
      Source without specifying a version, You may treat that Covered Source as
      being released under any version of the CERN-OHL with that variant. If no
      variant is specified, the Covered Source shall be treated as being
      released under CERN-OHL-S. The Licensor may also specify that the Covered
      Source is subject to a specific version of the CERN-OHL or any later
      version in which case You may apply this or any later version of CERN-OHL
      with the same variant identifier published by CERN.

      (( 7.4 ))??
      This Licence shall not be enforceable except by a Licensor acting as such,
      and third party beneficiary rights are specifically excluded.
//**
Open Software License 1.0
https://spdx.org/licenses/OSL-1.0.json
https://opensource.org/licenses/OSL-1.0
**//

(( The Open Software License v. 1.0 ))??

This Open Software License (the "License") applies to any original work of
authorship (the "Original Work") whose owner (the "Licensor") has placed the
following notice immediately following the copyright notice for the Original
Work:

Licensed under the Open Software License version 1.0

License Terms

   (( 1) ))??
   Grant of Copyright License. Licensor hereby grants You a world-wide,
   royalty-free, non-exclusive, perpetual, non-sublicenseable license to do the
   following:

      (( a) ))??
      to reproduce the Original Work in copies;

      (( b) ))??
      to prepare derivative works ("Derivative Works") based upon the Original
      Work;

      (( c) ))??
      to distribute copies of the Original Work and Derivative Works to the
      public, with the proviso that copies of Original Work or Derivative Works
      that You distribute shall be licensed under the Open Software License;

      (( d) ))??
      to perform the Original Work publicly; and

      (( e) ))??
      to display the Original Work publicly.

   (( 2) ))??
   Grant of Patent License. Licensor hereby grants You a world-wide,
   royalty-free, non-exclusive, perpetual, non-sublicenseable license, under
   patent claims owned or controlled by the Licensor that are embodied in the
   Original Work as furnished by the Licensor ("Licensed Claims") to make, use,
   sell and offer for sale the Original Work. Licensor hereby grants You a
   world-wide, royalty-free, non-exclusive, perpetual, non-sublicenseable
   license under the Licensed Claims to make, use, sell and offer for sale
   Derivative Works.

   (( 3) ))??
   Grant of Source Code License. The term "Source Code" means the preferred form
   of the Original Work for making modifications to it and all available
   documentation describing how to access and modify the Original Work. Licensor
   hereby agrees to provide a machine-readable copy of the Source Code of the
   Original Work along with each copy of the Original Work that Licensor
   distributes. Licensor reserves the right to satisfy this obligation by
   placing a machine-readable copy of the Source Code in an information
   repository reasonably calculated to permit inexpensive and convenient access
   by You for as long as Licensor continues to distribute the Original Work, and
   by publishing the address of that information repository in a notice
   immediately following the copyright notice that applies to the Original
   Work.

   (( 4) ))??
   Exclusions From License Grant. Nothing in this License shall be deemed to
   grant any rights to trademarks, copyrights, patents, trade secrets or any
   other intellectual property of Licensor except as expressly stated herein. No
   patent license is granted to make, use, sell or offer to sell embodiments of
   any patent claims other than the Licensed Claims defined in Section 2. No
   right is granted to the trademarks of Licensor even if such marks are
   included in the Original Work. Nothing in this License shall be interpreted
   to prohibit Licensor from licensing under different terms from this License
   any Original Work that Licensor otherwise would have a right to license.

   (( 5) ))??
   External Deployment. The term "External Deployment" means the use or
   distribution of the Original Work or Derivative Works in any way such that
   the Original Work or Derivative Works may be accessed or used by anyone other
   than You, whether the Original Work or Derivative Works are distributed to
   those persons, made available as an application intended for use over a
   computer network, or used to provide services or otherwise deliver content to
   anyone other than You. As an express condition for the grants of license
   hereunder, You agree that any External Deployment by You shall be deemed a
   distribution and shall be licensed to all under the terms of this License, as
   prescribed in section 1(c) herein.

   (( 6) ))??
   Warranty and Disclaimer of Warranty. LICENSOR WARRANTS THAT THE COPYRIGHT IN
   AND TO THE ORIGINAL WORK IS OWNED BY THE LICENSOR OR THAT THE ORIGINAL WORK
   IS DISTRIBUTED BY LICENSOR UNDER A VALID CURRENT LICENSE FROM THE COPYRIGHT
   OWNER. EXCEPT AS EXPRESSLY STATED IN THE IMMEDIATELY PRECEEDING SENTENCE, THE
   ORIGINAL WORK IS PROVIDED UNDER THIS LICENSE ON AN "AS IS" BASIS, WITHOUT
   WARRANTY, EITHER EXPRESS OR IMPLIED, INCLUDING, WITHOUT LIMITATION, THE
   WARRANTY OF NON-INFRINGEMENT AND WARRANTIES THAT THE ORIGINAL WORK IS
   MERCHANTABLE OR FIT FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE
   QUALITY OF THE ORIGINAL WORK IS WITH YOU. THIS DISCLAIMER OF WARRANTY
   CONSTITUTES AN ESSENTIAL PART OF THIS LICENSE. NO LICENSE TO ORIGINAL WORK IS
   GRANTED HEREUNDER EXCEPT UNDER THIS DISCLAIMER.

   (( 7) ))??
   Limitation of Liability. UNDER NO CIRCUMSTANCES AND UNDER NO LEGAL THEORY,
   WHETHER TORT (INCLUDING NEGLIGENCE), CONTRACT, OR OTHERWISE, SHALL THE
   LICENSOR BE LIABLE TO ANY PERSON FOR ANY DIRECT, INDIRECT, SPECIAL,
   INCIDENTAL, OR CONSEQUENTIAL DAMAGES OF ANY CHARACTER ARISING AS A RESULT OF
   THIS LICENSE OR THE USE OF THE ORIGINAL WORK INCLUDING, WITHOUT LIMITATION,
   DAMAGES FOR LOSS OF GOODWILL, WORK STOPPAGE, COMPUTER FAILURE OR MALFUNCTION,
   OR ANY AND ALL OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF SUCH PERSON SHALL
   HAVE BEEN INFORMED OF THE POSSIBILITY OF SUCH DAMAGES. THIS LIMITATION OF
   LIABILITY SHALL NOT APPLY TO LIABILITY FOR DEATH OR PERSONAL INJURY RESULTING
   FROM SUCH PARTY'S NEGLIGENCE TO THE EXTENT APPLICABLE LAW PROHIBITS SUCH
   LIMITATION. SOME JURISDICTIONS DO NOT ALLOW THE EXCLUSION OR LIMITATION OF
   INCIDENTAL OR CONSEQUENTIAL DAMAGES, SO THIS EXCLUSION AND LIMITATION MAY NOT
   APPLY TO YOU.

   (( 8) ))??
   Acceptance and Termination. Nothing else but this License (or another written
   agreement between Licensor and You) grants You permission to create
   Derivative Works based upon the Original Work, and any attempt to do so
   except under the terms of this License (or another written agreement between
   Licensor and You) is expressly prohibited by U.S. copyright law, the
   equivalent laws of other countries, and by international treaty. Therefore,
   by exercising any of the rights granted to You in Sections 1 and 2 herein,
   You indicate Your acceptance of this License and all of its terms and
   conditions. This license shall terminate immediately and you may no longer
   exercise any of the rights granted to You by this License upon Your failure
   to honor the proviso in Section 1(c) herein.

   (( 9) ))??
   Mutual Termination for Patent Action. This License shall terminate
   automatically and You may no longer exercise any of the rights granted to You
   by this License if You file a lawsuit in any court alleging that any OSI
   Certified open source software that is licensed under any license containing
   this "Mutual Termination for Patent Action" clause infringes any patent
   claims that are essential to use that software.

   (( 10) ))??
   Jurisdiction, Venue and Governing Law. You agree that any lawsuit arising
   under or relating to this License shall be maintained in the courts of the
   jurisdiction wherein the Licensor resides or in which Licensor conducts its
   primary business, and under the laws of that jurisdiction excluding its
   conflict-of-law provisions. The application of the United Nations Convention
   on Contracts for the International Sale of Goods is expressly excluded. Any
   use of the Original Work outside the scope of this License or after its
   termination shall be subject to the requirements and penalties of the U.S.
   Copyright Act, 17 U.S.C. § 101 et seq., the equivalent laws of other
   countries, and international treaty. This section shall survive the
   termination of this License.

   (( 11) ))??
   Attorneys Fees. In any action to enforce the terms of this License or seeking
   damages relating thereto, the prevailing party shall be entitled to recover
   its costs and expenses, including, without limitation, reasonable attorneys'
   fees and costs incurred in connection with such action, including any appeal
   of such action. This section shall survive the termination of this License.

   (( 12) ))??
   Miscellaneous. This License represents the complete agreement concerning the
   subject matter hereof. If any provision of this License is held to be
   unenforceable, such provision shall be reformed only to the extent necessary
   to make it enforceable.

   (( 13) ))??
   Definition of "You" in This License. "You" throughout this License, whether
   in upper or lower case, means an individual or a legal entity exercising
   rights under, and complying with all of the terms of, this License. For legal
   entities, "You" includes any entity that controls, is controlled by, or is
   under common control with you. For purposes of this definition, "control"
   means (i) the power, direct or indirect, to cause the direction or management
   of such entity, whether by contract or otherwise, or (ii) ownership of fifty
   percent (50%) or more of the outstanding shares, or (iii) beneficial
   ownership of such entity.

This license is Copyright (C) 2002 Lawrence E. Rosen. All rights reserved.
Permission is hereby granted to copy and distribute this license without
modification. This license may not be modified without the express written
permission of its copyright owner.
//**
Mulan Permissive Software License, Version 2
https://spdx.org/licenses/MulanPSL-2.0.json
https://license.coscl.org.cn/MulanPSL2/
**//

(( 木兰宽松许可证, 第2版 ))??

(( 木兰宽松许可证， 第2版

2020年1月 http:/license.coscl.org.cn/MulanPSL2 ))??

您对"软件"的复制、使用、修改及分发受木兰宽松许可证，第2版（"本许可证"）的如下条款的约束：

   (( 0. ))??
   定义

   "软件"
   是指由"贡献"构成的许可在"本许可证"下的程序和相关文档的集合。

   "贡献"
   是指由任一"贡献者"许可在"本许可证"下的受版权法保护的作品。

   "贡献者"
   是指将受版权法保护的作品许可在"本许可证"下的自然人或"法人实体"。

   "法人实体" 是指提交贡献的机构及其"关联实体"。

   "关联实体"
   是指，对"本许可证"下的行为方而言，控制、受控制或与其共同受控制的机构，此处的控制是指有受控方或共同受控方至少50%直接或间接的投票权、资金或其他有价证券。

   (( 1. ))??
   授予版权许可

   每个"贡献者"根据"本许可证"授予您永久性的、全球性的、免费的、非独占的、不可撤销的版权许可，您可以复制、使用、修改、分发其"贡献"，不论修改与否。

   (( 2. ))??
   授予专利许可

   每个"贡献者"根据"本许可证"授予您永久性的、全球性的、免费的、非独占的、不可撤销的（根据本条规定撤销除外）专利许可，供您制造、委托制造、使用、许诺销售、销售、进口其"贡献"或以其他方式转移其"贡献"。前述专利许可仅限于"贡献者"现在或将来拥有或控制的其"贡献"本身或其"贡献"与许可"贡献"时的"软件"结合而将必然会侵犯的专利权利要求，不包括对"贡献"的修改或包含"贡献"的其他结合。如果您或您的"关联实体"直接或间接地，就"软件"或其中的"贡献"对任何人发起专利侵权诉讼（包括反诉或交叉诉讼）或其他专利维权行动，指控其侵犯专利权，则"本许可证"授予您对"软件"的专利许可自您提起诉讼或发起维权行动之日终止。

   (( 3. ))??
   无商标许可

   "本许可证"不提供对"贡献者"的商品名称、商标、服务标志或产品名称的商标许可，但您为满足第4条规定的声明义务而必须使用除外。

   (( 4. ))??
   分发限制

   您可以在任何媒介中将"软件"以源程序形式或可执行形式重新分发，不论修改与否，但您必须向接收者提供"本许可证"的副本，并保留"软件"中的版权、商标、专利及免责声明。

   (( 5. ))??
   免责声明与责任限制

   "软件"及其中的"贡献"在提供时不带任何明示或默示的担保。在任何情况下，"贡献者"或版权所有者不对任何人因使用"软件"或其中的"贡献"而引发的任何直接或间接损失承担责任，不论因何种原因导致或者基于何种法律理论，即使其曾被建议有此种损失的可能性。

   (( 6. ))??
   语言

   "本许可证"以中英文双语表述，中英文版本具有同等法律效力。如果中英文版本存在任何冲突不一致，以中文版为准。

条款结束

如何将木兰宽松许可证，第2版，应用到您的软件

如果您希望将木兰宽松许可证，第2版，应用到您的新软件，为了方便接收者查阅，建议您完成如下三步：

   (( 1， ))??
   请您补充如下声明中的空白，包括软件名、软件的首次发表年份以及您作为版权人的名字；

   (( 2， ))??
   请您在软件包的一级目录下创建以"LICENSE"为名的文件，将整个许可证文本放入该文件中；

   (( 3， ))??
   请将如下声明文本放入每个源文件的头部注释中。

Copyright (c) [Year] [name of copyright holder]

[Software Name] is licensed under Mulan PSL v2.

You can use this software according to the terms and conditions of the Mulan PSL
v2.

You may obtain a copy of Mulan PSL v2 at:

http:/license.coscl.org.cn/MulanPSL2

THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,

EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,

MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.

See the Mulan PSL v2 for more details.
(( Mulan Permissive Software License，Version 2 ))??

(( Mulan Permissive Software License，Version 2 (Mulan PSL v2)

January 2020 http:/license.coscl.org.cn/MulanPSL2 ))??

Your reproduction, use, modification and distribution of the Software shall be
subject to Mulan PSL v2 (this License) with the following terms and conditions:

   (( 0. ))??
   Definition

   Software means the program and related documents which are licensed under
   this License and comprise all Contribution(s).

   Contribution means the copyrightable work licensed by a particular
   Contributor under this License.

   Contributor means the Individual or Legal Entity who licenses its
   copyrightable work under this License.

   Legal Entity means the entity making a Contribution and all its Affiliates.

   Affiliates means entities that control, are controlled by, or are under
   common control with the acting entity under this License, 'control' means
   direct or indirect ownership of at least fifty percent (50%) of the voting
   power, capital or other securities of controlled or commonly controlled
   entity.

   (( 1. ))??
   Grant of Copyright License

   Subject to the terms and conditions of this License, each Contributor hereby
   grants to you a perpetual, worldwide, royalty-free, non-exclusive,
   irrevocable copyright license to reproduce, use, modify, or distribute its
   Contribution, with modification or not.

   (( 2. ))??
   Grant of Patent License

   Subject to the terms and conditions of this License, each Contributor hereby
   grants to you a perpetual, worldwide, royalty-free, non-exclusive,
   irrevocable (except for revocation under this Section) patent license to
   make, have made, use, offer for sale, sell, import or otherwise transfer its
   Contribution, where such patent license is only limited to the patent claims
   owned or controlled by such Contributor now or in future which will be
   necessarily infringed by its Contribution alone, or by combination of the
   Contribution with the Software to which the Contribution was contributed. The
   patent license shall not apply to any modification of the Contribution, and
   any other combination which includes the Contribution. If you or your
   Affiliates directly or indirectly institute patent litigation (including a
   cross claim or counterclaim in a litigation) or other patent enforcement
   activities against any individual or entity by alleging that the Software or
   any Contribution in it infringes patents, then any patent license granted to
   you under this License for the Software shall terminate as of the date such
   litigation or activity is filed or taken.

   (( 3. ))??
   No Trademark License

   No trademark license is granted to use the trade names, trademarks, service
   marks, or product names of Contributor, except as required to fulfill notice
   requirements in section 4.

   (( 4. ))??
   Distribution Restriction

   You may distribute the Software in any medium with or without modification,
   whether in source or executable forms, provided that you provide recipients
   with a copy of this License and retain copyright, patent, trademark and
   disclaimer statements in the Software.

   (( 5. ))??
   Disclaimer of Warranty and Limitation of Liability

   THE SOFTWARE AND CONTRIBUTION IN IT ARE PROVIDED WITHOUT WARRANTIES OF ANY
   KIND, EITHER EXPRESS OR IMPLIED. IN NO EVENT SHALL ANY CONTRIBUTOR OR
   COPYRIGHT HOLDER BE LIABLE TO YOU FOR ANY DAMAGES, INCLUDING, BUT NOT LIMITED
   TO ANY DIRECT, OR INDIRECT, SPECIAL OR CONSEQUENTIAL DAMAGES ARISING FROM
   YOUR USE OR INABILITY TO USE THE SOFTWARE OR THE CONTRIBUTION IN IT, NO
   MATTER HOW IT'S CAUSED OR BASED ON WHICH LEGAL THEORY, EVEN IF ADVISED OF THE
   POSSIBILITY OF SUCH DAMAGES.

   (( 6. ))??
   Language

   THIS LICENSE IS WRITTEN IN BOTH CHINESE AND ENGLISH, AND THE CHINESE VERSION
   AND ENGLISH VERSION SHALL HAVE THE SAME LEGAL EFFECT. IN THE CASE OF
   DIVERGENCE BETWEEN THE CHINESE AND ENGLISH VERSIONS, THE CHINESE VERSION
   SHALL PREVAIL.

END OF THE TERMS AND CONDITIONS

How to Apply the Mulan Permissive Software License，Version 2 (Mulan PSL v2) to
Your Software

To apply the Mulan PSL v2 to your work, for easy identification by recipients,
you are suggested to complete following three steps:

   (( i. ))??
   Fill in the blanks in following statement, including insert your software
   name, the year of the first publication of your software, and your name
   identified as the copyright owner;

   (( ii. ))??
   Create a file named "LICENSE" which contains the whole context of this
   License in the first directory of your software package;

   (( iii. ))??
   Attach the statement to the appropriate annotated syntax at the beginning of
   each source file.

Copyright (c) [Year] [name of copyright holder]

[Software Name] is licensed under Mulan PSL v2.

You can use this software according to the terms and conditions of the Mulan PSL
v2.

You may obtain a copy of Mulan PSL v2 at:

http:/license.coscl.org.cn/MulanPSL2

THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,

EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,

MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.

See the Mulan PSL v2 for more details.
//**
Academic Free License v2.1
https://spdx.org/licenses/AFL-2.1.json
http://opensource.linux-mirror.org/licenses/afl-2.1.txt
**//

(( The Academic Free License

v.2.1 ))??

(( This Academic Free License (the "License") applies to any original work of
authorship (the "Original Work") whose owner (the "Licensor") has placed the
following notice immediately following the copyright notice for the Original
Work:

Licensed under the Academic Free License version 2.1 ))??

   (( 1) ))??
   Grant of Copyright License. Licensor hereby grants You a world-wide,
   royalty-free, non-exclusive, perpetual, sublicenseable license to do the
   following:

      (( a) ))??
      to reproduce the Original Work in copies;

      (( b) ))??
      to prepare derivative works ("Derivative Works") based upon the Original
      Work;

      (( c) ))??
      to distribute copies of the Original Work and Derivative Works to the
      public;

      (( d) ))??
      to perform the Original Work publicly; and

      (( e) ))??
      to display the Original Work publicly.

   (( 2) ))??
   Grant of Patent License. Licensor hereby grants You a world-wide,
   royalty-free, non-exclusive, perpetual, sublicenseable license, under patent
   claims owned or controlled by the Licensor that are embodied in the Original
   Work as furnished by the Licensor, to make, use, sell and offer for sale the
   Original Work and Derivative Works.

   (( 3) ))??
   Grant of Source Code License. The term "Source Code" means the preferred form
   of the Original Work for making modifications to it and all available
   documentation describing how to modify the Original Work. Licensor hereby
   agrees to provide a machine-readable copy of the Source Code of the Original
   Work along with each copy of the Original Work that Licensor distributes.
   Licensor reserves the right to satisfy this obligation by placing a
   machine-readable copy of the Source Code in an information repository
   reasonably calculated to permit inexpensive and convenient access by You for
   as long as Licensor continues to distribute the Original Work, and by
   publishing the address of that information repository in a notice immediately
   following the copyright notice that applies to the Original Work.

   (( 4) ))??
   Exclusions From License Grant. Neither the names of Licensor, nor the names
   of any contributors to the Original Work, nor any of their trademarks or
   service marks, may be used to endorse or promote products derived from this
   Original Work without express prior written permission of the Licensor.
   Nothing in this License shall be deemed to grant any rights to trademarks,
   copyrights, patents, trade secrets or any other intellectual property of
   Licensor except as expressly stated herein. No patent license is granted to
   make, use, sell or offer to sell embodiments of any patent claims other than
   the licensed claims defined in Section 2. No right is granted to the
   trademarks of Licensor even if such marks are included in the Original Work.
   Nothing in this License shall be interpreted to prohibit Licensor from
   licensing under different terms from this License any Original Work that
   Licensor otherwise would have a right to license.

   (( 5) ))??
   This section intentionally omitted.

   (( 6) ))??
   Attribution Rights. You must retain, in the Source Code of any Derivative
   Works that You create, all copyright, patent or trademark notices from the
   Source Code of the Original Work, as well as any notices of licensing and any
   descriptive text identified therein as an "Attribution Notice." You must
   cause the Source Code for any Derivative Works that You create to carry a
   prominent Attribution Notice reasonably calculated to inform recipients that
   You have modified the Original Work.

   (( 7) ))??
   Warranty of Provenance and Disclaimer of Warranty. Licensor warrants that the
   copyright in and to the Original Work and the patent rights granted herein by
   Licensor are owned by the Licensor or are sublicensed to You under the terms
   of this License with the permission of the contributor(s) of those copyrights
   and patent rights. Except as expressly stated in the immediately proceeding
   sentence, the Original Work is provided under this License on an "AS IS"
   BASIS and WITHOUT WARRANTY, either express or implied, including, without
   limitation, the warranties of NON-INFRINGEMENT, MERCHANTABILITY or FITNESS
   FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY OF THE ORIGINAL
   WORK IS WITH YOU. This DISCLAIMER OF WARRANTY constitutes an essential part
   of this License. No license to Original Work is granted hereunder except
   under this disclaimer.

   (( 8) ))??
   Limitation of Liability. Under no circumstances and under no legal theory,
   whether in tort (including negligence), contract, or otherwise, shall the
   Licensor be liable to any person for any direct, indirect, special,
   incidental, or consequential damages of any character arising as a result of
   this License or the use of the Original Work including, without limitation,
   damages for loss of goodwill, work stoppage, computer failure or malfunction,
   or any and all other commercial damages or losses. This limitation of
   liability shall not apply to liability for death or personal injury resulting
   from Licensor's negligence to the extent applicable law prohibits such
   limitation. Some jurisdictions do not allow the exclusion or limitation of
   incidental or consequential damages, so this exclusion and limitation may not
   apply to You.

   (( 9) ))??
   Acceptance and Termination. If You distribute copies of the Original Work or
   a Derivative Work, You must make a reasonable effort under the circumstances
   to obtain the express assent of recipients to the terms of this License.
   Nothing else but this License (or another written agreement between Licensor
   and You) grants You permission to create Derivative Works based upon the
   Original Work or to exercise any of the rights granted in Section 1 herein,
   and any attempt to do so except under the terms of this License (or another
   written agreement between Licensor and You) is expressly prohibited by U.S.
   copyright law, the equivalent laws of other countries, and by international
   treaty. Therefore, by exercising any of the rights granted to You in Section
   1 herein, You indicate Your acceptance of this License and all of its terms
   and conditions.

   (( 10) ))??
   Termination for Patent Action. This License shall terminate automatically and
   You may no longer exercise any of the rights granted to You by this License
   as of the date You commence an action, including a cross-claim or
   counterclaim, against Licensor or any licensee alleging that the Original
   Work infringes a patent. This termination provision shall not apply for an
   action alleging patent infringement by combinations of the Original Work with
   other software or hardware.

   (( 11) ))??
   Jurisdiction, Venue and Governing Law. Any action or suit relating to this
   License may be brought only in the courts of a jurisdiction wherein the
   Licensor resides or in which Licensor conducts its primary business, and
   under the laws of that jurisdiction excluding its conflict-of-law provisions.
   The application of the United Nations Convention on Contracts for the
   International Sale of Goods is expressly excluded. Any use of the Original
   Work outside the scope of this License or after its termination shall be
   subject to the requirements and penalties of the U.S. Copyright Act, 17
   U.S.C. § 101 et seq., the equivalent laws of other countries, and
   international treaty. This section shall survive the termination of this
   License.

   (( 12) ))??
   Attorneys Fees. In any action to enforce the terms of this License or seeking
   damages relating thereto, the prevailing party shall be entitled to recover
   its costs and expenses, including, without limitation, reasonable attorneys'
   fees and costs incurred in connection with such action, including any appeal
   of such action. This section shall survive the termination of this License.

   (( 13) ))??
   Miscellaneous. This License represents the complete agreement concerning the
   subject matter hereof. If any provision of this License is held to be
   unenforceable, such provision shall be reformed only to the extent necessary
   to make it enforceable.

   (( 14) ))??
   Definition of "You" in This License. "You" throughout this License, whether
   in upper or lower case, means an individual or a legal entity exercising
   rights under, and complying with all of the terms of, this License. For legal
   entities, "You" includes any entity that controls, is controlled by, or is
   under common control with you. For purposes of this definition, "control"
   means (i) the power, direct or indirect, to cause the direction or management
   of such entity, whether by contract or otherwise, or (ii) ownership of fifty
   percent (50%) or more of the outstanding shares, or (iii) beneficial
   ownership of such entity.

   (( 15) ))??
   Right to Use. You may use the Original Work in all ways not otherwise
   restricted or conditioned by this License or by law, and Licensor promises
   not to interfere with or be responsible for such uses by You.

This license is Copyright (C) 2003-2004 Lawrence E. Rosen. All rights reserved.

Permission is hereby granted to copy and distribute this license without
modification. This license may not be modified without the express written
permission of its copyright owner.
//**
Academic Free License v2.0
https://spdx.org/licenses/AFL-2.0.json
http://wayback.archive.org/web/20060924134533/http://www.opensource.org/licenses/afl-2.0.txt
**//

(( The Academic Free License

v. 2.0 ))??

(( This Academic Free License (the "License") applies to any original work of
authorship (the "Original Work") whose owner (the "Licensor") has placed the
following notice immediately following the copyright notice for the Original
Work:

Licensed under the Academic Free License version 2.0 ))??

   (( 1) ))??
   Grant of Copyright License. Licensor hereby grants You a world-wide,
   royalty-free, non-exclusive, perpetual, sublicenseable license to do the
   following:

      (( a) ))??
      to reproduce the Original Work in copies;

      (( b) ))??
      to prepare derivative works ("Derivative Works") based upon the Original
      Work;

      (( c) ))??
      to distribute copies of the Original Work and Derivative Works to the
      public;

      (( d) ))??
      to perform the Original Work publicly; and

      (( e) ))??
      to display the Original Work publicly.

   (( 2) ))??
   Grant of Patent License. Licensor hereby grants You a world-wide,
   royalty-free, non-exclusive, perpetual, sublicenseable license, under patent
   claims owned or controlled by the Licensor that are embodied in the Original
   Work as furnished by the Licensor, to make, use, sell and offer for sale the
   Original Work and Derivative Works.

   (( 3) ))??
   Grant of Source Code License. The term "Source Code" means the preferred form
   of the Original Work for making modifications to it and all available
   documentation describing how to modify the Original Work. Licensor hereby
   agrees to provide a machine-readable copy of the Source Code of the Original
   Work along with each copy of the Original Work that Licensor distributes.
   Licensor reserves the right to satisfy this obligation by placing a
   machine-readable copy of the Source Code in an information repository
   reasonably calculated to permit inexpensive and convenient access by You for
   as long as Licensor continues to distribute the Original Work, and by
   publishing the address of that information repository in a notice immediately
   following the copyright notice that applies to the Original Work.

   (( 4) ))??
   Exclusions From License Grant. Neither the names of Licensor, nor the names
   of any contributors to the Original Work, nor any of their trademarks or
   service marks, may be used to endorse or promote products derived from this
   Original Work without express prior written permission of the Licensor.
   Nothing in this License shall be deemed to grant any rights to trademarks,
   copyrights, patents, trade secrets or any other intellectual property of
   Licensor except as expressly stated herein. No patent license is granted to
   make, use, sell or offer to sell embodiments of any patent claims other than
   the licensed claims defined in Section 2. No right is granted to the
   trademarks of Licensor even if such marks are included in the Original Work.
   Nothing in this License shall be interpreted to prohibit Licensor from
   licensing under different terms from this License any Original Work that
   Licensor otherwise would have a right to license.

   (( 5) ))??
   This section intentionally omitted.

   (( 6) ))??
   Attribution Rights. You must retain, in the Source Code of any Derivative
   Works that You create, all copyright, patent or trademark notices from the
   Source Code of the Original Work, as well as any notices of licensing and any
   descriptive text identified therein as an "Attribution Notice." You must
   cause the Source Code for any Derivative Works that You create to carry a
   prominent Attribution Notice reasonably calculated to inform recipients that
   You have modified the Original Work.

   (( 7) ))??
   Warranty of Provenance and Disclaimer of Warranty. Licensor warrants that the
   copyright in and to the Original Work and the patent rights granted herein by
   Licensor are owned by the Licensor or are sublicensed to You under the terms
   of this License with the permission of the contributor(s) of those copyrights
   and patent rights. Except as expressly stated in the immediately proceeding
   sentence, the Original Work is provided under this License on an "AS IS"
   BASIS and WITHOUT WARRANTY, either express or implied, including, without
   limitation, the warranties of NON-INFRINGEMENT, MERCHANTABILITY or FITNESS
   FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY OF THE ORIGINAL
   WORK IS WITH YOU. This DISCLAIMER OF WARRANTY constitutes an essential part
   of this License. No license to Original Work is granted hereunder except
   under this disclaimer.

   (( 8) ))??
   Limitation of Liability. Under no circumstances and under no legal theory,
   whether in tort (including negligence), contract, or otherwise, shall the
   Licensor be liable to any person for any direct, indirect, special,
   incidental, or consequential damages of any character arising as a result of
   this License or the use of the Original Work including, without limitation,
   damages for loss of goodwill, work stoppage, computer failure or malfunction,
   or any and all other commercial damages or losses. This limitation of
   liability shall not apply to liability for death or personal injury resulting
   from Licensor's negligence to the extent applicable law prohibits such
   limitation. Some jurisdictions do not allow the exclusion or limitation of
   incidental or consequential damages, so this exclusion and limitation may not
   apply to You.

   (( 9) ))??
   Acceptance and Termination. If You distribute copies of the Original Work or
   a Derivative Work, You must make a reasonable effort under the circumstances
   to obtain the express assent of recipients to the terms of this License.
   Nothing else but this License (or another written agreement between Licensor
   and You) grants You permission to create Derivative Works based upon the
   Original Work or to exercise any of the rights granted in Section 1 herein,
   and any attempt to do so except under the terms of this License (or another
   written agreement between Licensor and You) is expressly prohibited by U.S.
   copyright law, the equivalent laws of other countries, and by international
   treaty. Therefore, by exercising any of the rights granted to You in Section
   1 herein, You indicate Your acceptance of this License and all of its terms
   and conditions.

   (( 10) ))??
   Termination for Patent Action. This License shall terminate automatically and
   You may no longer exercise any of the rights granted to You by this License
   as of the date You commence an action, including a cross-claim or
   counterclaim, for patent infringement (i) against Licensor with respect to a
   patent applicable to software or (ii) against any entity with respect to a
   patent applicable to the Original Work (but excluding combinations of the
   Original Work with other software or hardware).

   (( 11) ))??
   Jurisdiction, Venue and Governing Law. Any action or suit relating to this
   License may be brought only in the courts of a jurisdiction wherein the
   Licensor resides or in which Licensor conducts its primary business, and
   under the laws of that jurisdiction excluding its conflict-of-law provisions.
   The application of the United Nations Convention on Contracts for the
   International Sale of Goods is expressly excluded. Any use of the Original
   Work outside the scope of this License or after its termination shall be
   subject to the requirements and penalties of the U.S. Copyright Act, 17
   U.S.C. ¤ 101 et seq., the equivalent laws of other countries, and
   international treaty. This section shall survive the termination of this
   License.

   (( 12) ))??
   Attorneys Fees. In any action to enforce the terms of this License or seeking
   damages relating thereto, the prevailing party shall be entitled to recover
   its costs and expenses, including, without limitation, reasonable attorneys'
   fees and costs incurred in connection with such action, including any appeal
   of such action. This section shall survive the termination of this License.

   (( 13) ))??
   Miscellaneous. This License represents the complete agreement concerning the
   subject matter hereof. If any provision of this License is held to be
   unenforceable, such provision shall be reformed only to the extent necessary
   to make it enforceable.

   (( 14) ))??
   Definition of "You" in This License. "You" throughout this License, whether
   in upper or lower case, means an individual or a legal entity exercising
   rights under, and complying with all of the terms of, this License. For legal
   entities, "You" includes any entity that controls, is controlled by, or is
   under common control with you. For purposes of this definition, "control"
   means (i) the power, direct or indirect, to cause the direction or management
   of such entity, whether by contract or otherwise, or (ii) ownership of fifty
   percent (50%) or more of the outstanding shares, or (iii) beneficial
   ownership of such entity.

   (( 15) ))??
   Right to Use. You may use the Original Work in all ways not otherwise
   restricted or conditioned by this License or by law, and Licensor promises
   not to interfere with or be responsible for such uses by You.

This license is Copyright (C) 2003 Lawrence E. Rosen. All rights reserved.

Permission is hereby granted to copy and distribute this license without
modification. This license may not be modified without the express written
permission of its copyright owner.
//**
Zimbra Public License v1.4
https://spdx.org/licenses/Zimbra-1.4.json
http://www.zimbra.com/legal/zimbra-public-license-1-4
**//

(( Zimbra Public License, Version 1.4 (ZPL) ))??

This Zimbra Public License (this "Agreement") is a legal agreement that
describes the terms under which Zimbra, Inc., a Texas corporation ("Zimbra")
will provide software to you via download or otherwise ("Software"). By using
the Software, you, an individual or an entity ("You") agree to the terms of this
Agreement.

In consideration of the mutual promises and upon the terms and conditions set
forth below, the parties agree as follows:

   (( 1. ))??
   Grant of Copyright License

      (( 1.1 ))??
      - Subject to the terms and conditions of this Agreement, Zimbra hereby
      grants to You, under any and all of its copyright interest in and to the
      Software, a royalty-free, non-exclusive, non-transferable license to copy,
      modify, compile, execute, and distribute the Software and Modifications.
      For the purposes of this Agreement, any change to, addition to, or
      abridgement of the Software made by You is a "Modification;" however, any
      file You add to the Software that does not contain any part of the
      Software is not a "Modification."

      (( 1.2 ))??
      - If You are an individual acting on behalf of a corporation or other
      entity, Your use of the Software or any Modification is subject to Your
      having the authority to bind such corporation or entity to this Agreement.
      Providing copies to persons within such corporation or entity is not
      considered distribution for purposes of this Agreement.

      (( 1.3 ))??
      - For the Software or any Modification You distribute in source code
      format, You must do so only under the terms of this Agreement, and You
      must include a complete copy of this Agreement with Your distribution.
      With respect to any Modification You distribute in source code format, the
      terms of this Agreement will apply to You in the same way those terms
      apply to Zimbra with respect to the Software. In other words, when You are
      distributing Modifications under this Agreement, You "stand in the shoes"
      of Zimbra in terms of the rights You grant and how the terms and
      conditions apply to You and the licensees of Your Modifications.
      Notwithstanding the foregoing, when You "stand in the shoes" of Zimbra,
      You are not subject to the jurisdiction provision under Section 7, which
      requires all disputes under this Agreement to be subject to the
      jurisdiction of federal or state courts of Northern Texas.

      (( 1.4 ))??
      - For the Software or any Modification You distribute in compiled or
      object code format, You must also provide recipients with access to the
      Software or Modification in source code format along with a complete copy
      of this Agreement. The distribution of the Software or Modifications in
      compiled or object code format may be under a license of Your choice,
      provided that You are in compliance with the terms of this Agreement. In
      addition, You must make absolutely clear that any license terms applying
      to such Software or Modification that differ from this Agreement are
      offered by You alone and not by Zimbra, and that such license does not
      restrict recipients from exercising rights in the source code to the
      Software granted by Zimbra under this Agreement or rights in the source
      code to any Modification granted by You as described in Section 1.3.

      (( 1.5 ))??
      - This Agreement does not limit Your right to distribute files that are
      entirely Your own work (i.e., which do not incorporate any portion of the
      Software and are not Modifications) under any terms You choose.

   (( 2. ))??
   Support

   Zimbra has no obligation to provide technical support or updates to You.
   Nothing in this Agreement requires Zimbra to enter into any license with You
   for any other edition of the Software.

   (( 3. ))??
   Intellectual Property Rights

      (( 3.1 - ))??
      Except for the license expressly granted under copyright in Section 1.1,
      no rights, licenses or forbearances are granted or may arise in relation
      to this Agreement whether expressly, by implication, exhaustion, estoppel
      or otherwise. All rights, including all intellectual property rights, that
      are not expressly granted under this Agreement are hereby reserved.

      (( 3.2 - ))??
      In any copy of the Software or in any Modification you create, You must
      retain and reproduce any and all copyright, patent, trademark, and
      attribution notices that are included in the Software in the same form as
      they appear in the Software. This includes the preservation of attribution
      notices in the form of trademarks or logos that exist within a user
      interface of the Software.

      (( 3.3 - ))??
      This license does not grant You rights to use any party's name, logo, or
      trademarks, except solely as necessary to comply with Section 3.2.

   (( 4. ))??
   Disclaimer of Warranties

   THE SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY OF ANY KIND. ZIMBRA
   MAKES NO WARRANTIES, WHETHER EXPRESS, IMPLIED, OR STATUTORY, REGARDING OR
   RELATING TO THE SOFTWARE. SPECIFICALLY, ZIMBRA DOES NOT WARRANT THAT THE
   SOFTWARE WILL BE ERROR FREE OR WILL PERFORM IN AN UNINTERRUPTED MANNER. TO
   THE GREATEST EXTENT ALLOWED BY LAW, ZIMBRA SPECIFICALLY DISCLAIMS ALL IMPLIED
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE (EVEN IF
   ZIMBRA HAD BEEN INFORMED OF SUCH PURPOSE), AND NONINFRINGEMENT WITH RESPECT
   TO THE SOFTWARE, ANY MODIFICATIONS THERETO, AND WITH RESPECT TO THE USE OF
   THE FOREGOING.

   (( 5. ))??
   Limitation of Liability

   IN NO EVENT WILL ZIMBRA BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES OF ANY KIND (INCLUDING WITHOUT
   LIMITATION LOSS OF PROFITS, LOSS OF USE, BUSINESS INTERRUPTION, LOSS OF DATA,
   AND COST OF COVER) IN CONNECTION WITH OR ARISING OUT OF OR RELATING TO THE
   FURNISHING, PERFORMANCE, OR USE OF THE SOFTWARE OR ANY OTHER RIGHTS GRANTED
   HEREUNDER, WHETHER ALLEGED AS A BREACH OF CONTRACT OR TORTIOUS CONDUCT,
   INCLUDING NEGLIGENCE, AND EVEN IF ZIMBRA HAS BEEN ADVISED OF THE POSSIBILITY
   OF SUCH DAMAGES.

   (( 6. ))??
   Term and Termination

      (( 6.1 - ))??
      This Agreement will continue in effect unless and until terminated earlier
      pursuant to this Section 6.

      (( 6.2 - ))??
      In the event You violate the terms of this Agreement, Zimbra may terminate
      this Agreement.

      (( 6.3 - ))??
      All licenses granted hereunder shall terminate upon the termination of
      this Agreement. Termination will be in addition to any rights and remedies
      available to Zimbra at law or equity or under this Agreement.

      (( 6.4 - ))??
      Termination of this Agreement will not affect the provisions regarding
      reservation of rights (Section 3.1), provisions disclaiming or limiting
      Zimbra's liability (Sections 4 and 5), Termination (Section 6), or
      Miscellaneous (Section 7), which provisions will survive termination of
      this Agreement.

   (( 7. ))??
   Miscellaneous

   This Agreement contains the entire agreement of the parties with respect to
   the subject matter of this Agreement and supersedes all previous
   communications, representations, understandings, and agreements, either oral
   or written, between the parties with respect to said subject matter. The
   relationship of the parties hereunder is that of independent contractors, and
   this Agreement will not be construed as creating an agency, partnership,
   joint venture, or any other form of legal association between the parties. If
   any term, condition, or provision in this Agreement is found to be invalid,
   unlawful, or unenforceable to any extent, this Agreement will be construed in
   a manner that most closely effectuates the intent of this Agreement. Such
   invalid term, condition or provision will be severed from the remaining
   terms, conditions, and provisions, which will continue to be valid and
   enforceable to the fullest extent permitted by law. This Agreement will be
   interpreted and construed in accordance with the laws of the State of
   Delaware and the United States of America, without regard to conflict of law
   principles. The U.N. Convention on Contracts for the International Sale of
   Goods shall not apply to this Agreement. All disputes arising out of this
   Agreement involving Zimbra or any of its parents or subsidiaries shall be
   subject to the jurisdiction of the federal or state courts of Northern Texas,
   with venue lying in Dallas County, Texas. No rights may be assigned, no
   obligations may be delegated, and this Agreement may not be transferred by
   You, in whole or in part, whether voluntary or by operation of law, including
   by way of sale of assets, merger, or consolidation, without the prior written
   consent of Zimbra, and any purported assignment, delegation, or transfer
   without such consent shall be void ab initio. Any waiver of the provisions of
   this Agreement or of a party's rights or remedies under this Agreement must
   be in writing to be effective. Failure, neglect, or delay by a party to
   enforce the provisions of this Agreement or its rights or remedies at any
   time will not be construed or be deemed to be a waiver of such party's rights
   under this Agreement and will not in any way affect the validity of the whole
   or any part of this Agreement or prejudice such party's right to take
   subsequent action.
//**
Licence Libre du Québec – Réciprocité version 1.1
https://spdx.org/licenses/LiLiQ-R-1.1.json
https://www.forge.gouv.qc.ca/participez/licence-logicielle/licence-libre-du-quebec-liliq-en-francais/licence-libre-du-quebec-reciprocite-liliq-r-v1-1/
http://opensource.org/licenses/LiLiQ-R-1.1
**//

(( Licence Libre du Québec – Réciprocité (LiLiQ-R)

Version 1.1 ))??

   (( 1. ))??
   Préambule

   Cette licence s'applique à tout logiciel distribué dont le titulaire du
   droit d'auteur précise qu'il est sujet aux termes de la Licence Libre du
   Québec – Réciprocité (LiLiQ-R) (ci-après appelée la « licence »).

   (( 2. ))??
   Définitions

   Dans la présente licence, à moins que le contexte n'indique un sens
   différent, on entend par:

   « concédant » : le titulaire du droit d'auteur sur le logiciel, ou
   toute personne dûment autorisée par ce dernier à accorder la présente
   licence;

   « contributeur » : le titulaire du droit d'auteur ou toute personne
   autorisée par ce dernier à soumettre au concédant une contribution. Un
   contributeur dont sa contribution est incorporée au logiciel est considéré
   comme un concédant en regard de sa contribution;

   « contribution » : tout logiciel original, ou partie de logiciel
   original soumis et destiné à être incorporé dans le logiciel;

   « distribution » : le fait de délivrer une copie du logiciel;

   « licencié » : toute personne qui possède une copie du logiciel et qui
   exerce les droits concédés par la licence;

   « logiciel » : une œuvre protégée par le droit d'auteur, telle qu'un
   programme d'ordinateur et sa documentation, pour laquelle le titulaire du
   droit d'auteur a précisé qu'elle est sujette aux termes de la présente
   licence;

   « logiciel dérivé » : tout logiciel original réalisé par un
   licencié, autre que le logiciel ou un logiciel modifié, qui produit ou
   reproduit la totalité ou une partie importante du logiciel;

   « logiciel modifié » : toute modification par un licencié de l'un des
   fichiers source du logiciel ou encore tout nouveau fichier source qui
   incorpore le logiciel ou une partie importante de ce dernier.

   (( 3. ))??
   Licence de droit d'auteur

   Sous réserve des termes de la licence, le concédant accorde au licencié
   une licence non exclusive et libre de redevances lui permettant d'exercer les
   droits suivants sur le logiciel :

      (( 1  ))??
      Produire ou reproduire la totalité ou une partie importante;

      (( 2  ))??
      Exécuter ou représenter la totalité ou une partie importante en
      public;

      (( 3  ))??
      Publier la totalité ou une partie importante.

   Cette licence est accordée sans limite territoriale et sans limite de
   temps.

   L'exercice complet de ces droits est sujet à la distribution par le
   concédant du code source du logiciel, lequel doit être sous une forme
   permettant d'y apporter des modifications. Le concédant peut aussi
   distribuer le logiciel accompagné d'une offre de distribuer le code source
   du logiciel, sans frais supplémentaires, autres que ceux raisonnables afin
   de permettre la livraison du code source. Cette offre doit être valide
   pendant une durée raisonnable.

   (( 4. ))??
   Distribution

   Le licencié peut distribuer des copies du logiciel, d'un logiciel modifié
   ou dérivé, sous réserve de respecter les conditions suivantes :

      (( 1  ))??
      Le logiciel doit être accompagné d'un exemplaire de cette licence;

      (( 2  ))??
      Si le logiciel a été modifié, le licencié doit en faire la mention, de
      préférence dans chacun des fichiers modifiés dont la nature permet une
      telle mention;

      (( 3  ))??
      Les étiquettes ou mentions faisant état des droits d'auteur, des marques
      de commerce, des garanties ou de la paternité concernant le logiciel ne
      doivent pas être modifiées ou supprimées, à moins que ces étiquettes
      ou mentions ne soient inapplicables à un logiciel modifié ou dérivé
      donné.

   (( 4.1. ))??
   Réciprocité

   Chaque fois que le licencié distribue le logiciel, le concédant offre au
   récipiendaire une concession sur le logiciel selon les termes de la
   présente licence. Le licencié doit offrir une concession selon les termes
   de la présente licence pour tout logiciel modifié qu'il distribue.

   Chaque fois que le licencié distribue le logiciel ou un logiciel modifié,
   ce dernier doit assumer l'obligation d'en distribuer le code source, de la
   manière prévue au troisième alinéa de l'article 3.

   (( 4.2. ))??
   Compatibilité

   Dans la mesure où le licencié souhaite distribuer un logiciel modifié
   combiné à un logiciel assujetti à une licence compatible, mais dont il ne
   serait pas possible d'en respecter les termes, le concédant offre, en plus
   de la présente concession, une concession selon les termes de cette licence
   compatible.

   Un licencié qui est titulaire exclusif du droit d'auteur sur le logiciel
   assujetti à une licence compatible ne peut pas se prévaloir de cette offre.
   Il en est de même pour toute autre personne dûment autorisée à
   sous-licencier par le titulaire exclusif du droit d'auteur sur le logiciel
   assujetti à une licence compatible.

   Est considérée comme une licence compatible toute licence libre approuvée
   ou certifiée par la Free Software Foundation ou l'Open Source Initiative,
   dont le niveau de réciprocité est comparable ou supérieur à celui de la
   présente licence, sans toutefois être moindre, notamment :

      (( 1  ))??
      Common Development and Distribution License (CDDL-1.0)

      (( 2  ))??
      Common Public License Version 1.0 (CPL-1.0)

      (( 3  ))??
      Contrat de licence de logiciel libre CeCILL, version 2.1 (CECILL-2.1)

      (( 4  ))??
      Contrat de licence de logiciel libre CeCILL-C (CECILL-C)

      (( 5  ))??
      Eclipse Public License - v 1.0 (EPL-1.0)

      (( 6  ))??
      European Union Public License, version 1.1 (EUPL v. 1.1)

      (( 7  ))??
      Licence Libre du Québec – Réciprocité forte version 1.1 (LiLiQ-R+
      1.1)

      (( 8  ))??
      GNU General Public License Version 2 (GNU GPLv2)

      (( 9  ))??
      GNU General Public License Version 3 (GNU GPLv3)

      (( 10  ))??
      GNU Lesser General Public License Version 2.1 (GNU LGPLv2.1)

      (( 11  ))??
      GNU Lesser General Public License Version 3 (GNU LGPLv3)

      (( 12  ))??
      Mozilla Public License Version 2.0 (MPL-2.0)

   (( 5. ))??
   Contributions

   Sous réserve d'une entente distincte, toute contribution soumise par un
   contributeur au concédant pour inclusion dans le logiciel sera soumise aux
   termes de cette licence.

   (( 6. ))??
   Marques de commerce

   La licence n'accorde aucune permission particulière qui permettrait
   d'utiliser les marques de commerce du concédant, autre que celle requise
   permettant d'identifier la provenance du logiciel.

   (( 7. ))??
   Garanties

   Sauf mention contraire, le concédant distribue le logiciel sans aucune
   garantie, aux risques et périls de l'acquéreur de la copie du logiciel, et
   ce, sans assurer que le logiciel puisse répondre à un besoin particulier ou
   puisse donner un résultat quelconque.

   Sans lier le concédant d'une quelconque manière, rien n'empêche un
   licencié d'offrir ou d'exclure des garanties ou du support.

   (( 8. ))??
   Responsabilité

   Le licencié est responsable de tout préjudice résultant de l'exercice des
   droits accordés par la licence.

   Le concédant ne saurait être tenu responsable du préjudice subi par le
   licencié ou par des tiers, pour quelque cause que ce soit en lien avec la
   licence et les droits qui y sont accordés.

   (( 9. ))??
   Résiliation

   La présente licence est résiliée de plein droit dès que les droits qui y
   sont accordés ne sont pas exercés conformément aux termes qui y sont
   stipulés.

   Toutefois, si le défaut est corrigé dans un délai de 30 jours de sa prise
   de connaissance par la personne en défaut, et qu'il s'agit du premier
   défaut, la licence est accordée de nouveau.

   Pour tout défaut subséquent, le consentement exprès du concédant est
   nécessaire afin que la licence soit accordée de nouveau.

   (( 10. ))??
   Version de la licence

   Le Centre de services partagés du Québec, ses ayants cause ou toute
   personne qu'il désigne, peuvent diffuser des versions révisées ou
   modifiées de cette licence. Chaque version recevra un numéro unique. Si un
   logiciel est déjà soumis aux termes d'une version spécifique, c'est
   seulement cette version qui liera les parties à la licence.

   Le concédant peut aussi choisir de concéder la licence sous la version
   actuelle ou toute version ultérieure, auquel cas le licencié peut choisir
   sous quelle version la licence lui est accordée.

   (( 11. ))??
   Divers

   Dans la mesure où le concédant est un ministère, un organisme public ou
   une personne morale de droit public, créés en vertu d'une loi de
   l'Assemblée nationale du Québec, la licence est régie par le droit
   applicable au Québec et en cas de contestation, les tribunaux du Québec
   seront seuls compétents.

   La présente licence peut être distribuée sans conditions particulières.
   Toutefois, une version modifiée doit être distribuée sous un nom
   différent. Toute référence au Centre de services partagés du Québec, et,
   le cas échéant, ses ayant droit, doit être retirée, autre que celle
   permettant d'identifier la provenance de la licence.
//**
Yahoo! Public License v1.1
https://spdx.org/licenses/YPL-1.1.json
http://www.zimbra.com/license/yahoo_public_license_1.1.html
**//

(( Yahoo! Public License, Version 1.1 (YPL) ))??

This Yahoo! Public License (this "Agreement") is a legal agreement that
describes the terms under which Yahoo! Inc., a Delaware corporation having its
principal place of business at 701 First Avenue, Sunnyvale, California 94089
("Yahoo!") will provide software to you via download or otherwise ("Software").
By using the Software, you, an individual or an entity ("You") agree to the
terms of this Agreement.

In consideration of the mutual promises and upon the terms and conditions set
forth below, the parties agree as follows:

   (( 1. ))??
   Grant of Copyright License

      (( 1.1 ))??
      - Subject to the terms and conditions of this Agreement, Yahoo! hereby
      grants to You, under any and all of its copyright interest in and to the
      Software, a royalty-free, non-exclusive, non-transferable license to copy,
      modify, compile, execute, and distribute the Software and Modifications.
      For the purposes of this Agreement, any change to, addition to, or
      abridgement of the Software made by You is a "Modification;" however, any
      file You add to the Software that does not contain any part of the
      Software is not a "Modification."

      (( 1.2 ))??
      - If You are an individual acting on behalf of a corporation or other
      entity, Your use of the Software or any Modification is subject to Your
      having the authority to bind such corporation or entity to this Agreement.
      Providing copies to persons within such corporation or entity is not
      considered distribution for purposes of this Agreement.

      (( 1.3 ))??
      - For the Software or any Modification You distribute in source code
      format, You must do so only under the terms of this Agreement, and You
      must include a complete copy of this Agreement with Your distribution.
      With respect to any Modification You distribute in source code format, the
      terms of this Agreement will apply to You in the same way those terms
      apply to Yahoo! with respect to the Software. In other words, when You are
      distributing Modifications under this Agreement, You "stand in the shoes"
      of Yahoo! in terms of the rights You grant and how the terms and
      conditions apply to You and the licensees of Your Modifications.
      Notwithstanding the foregoing, when You "stand in the shoes" of Yahoo!,
      You are not subject to the jurisdiction provision under Section 7, which
      requires all disputes under this Agreement to be subject to the
      jurisdiction of federal or state courts of northern California.

      (( 1.4 ))??
      - For the Software or any Modification You distribute in compiled or
      object code format, You must also provide recipients with access to the
      Software or Modification in source code format along with a complete copy
      of this Agreement. The distribution of the Software or Modifications in
      compiled or object code format may be under a license of Your choice,
      provided that You are in compliance with the terms of this Agreement. In
      addition, You must make absolutely clear that any license terms applying
      to such Software or Modification that differ from this Agreement are
      offered by You alone and not by Yahoo!, and that such license does not
      restrict recipients from exercising rights in the source code to the
      Software granted by Yahoo! under this Agreement or rights in the source
      code to any Modification granted by You as described in Section 1.3.

      (( 1.5 ))??
      - This Agreement does not limit Your right to distribute files that are
      entirely Your own work (i.e., which do not incorporate any portion of the
      Software and are not Modifications) under any terms You choose.

   (( 2. ))??
   Support

   Yahoo! has no obligation to provide technical support or updates to You.
   Nothing in this Agreement requires Yahoo! to enter into any license with You
   for any other edition of the Software.

   (( 3. ))??
   Intellectual Property Rights

      (( 3.1 ))??
      - Except for the license expressly granted under copyright in Section 1.1,
      no rights, licenses or forbearances are granted or may arise in relation
      to this Agreement whether expressly, by implication, exhaustion, estoppel
      or otherwise. All rights, including all intellectual property rights, that
      are not expressly granted under this Agreement are hereby reserved.

      (( 3.2 ))??
      - In any copy of the Software or in any Modification you create, You must
      retain and reproduce, any and all copyright, patent, trademark, and
      attribution notices that are included in the Software in the same form as
      they appear in the Software. This includes the preservation of attribution
      notices in the form of trademarks or logos that exist within a user
      interface of the Software.

      (( 3.3 ))??
      - This license does not grant You rights to use any party's name, logo, or
      trademarks, except solely as necessary to comply with Section 3.2.

   (( 4. ))??
   Disclaimer of Warranties

   THE SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY OF ANY KIND. YAHOO!
   MAKES NO WARRANTIES, WHETHER EXPRESS, IMPLIED, OR STATUTORY REGARDING OR
   RELATING TO THE SOFTWARE. SPECIFICALLY, YAHOO! DOES NOT WARRANT THAT THE
   SOFTWARE WILL BE ERROR FREE OR WILL PERFORM IN AN UNINTERRUPTED MANNER. TO
   THE GREATEST EXTENT ALLOWED BY LAW, YAHOO! SPECIFICALLY DISCLAIMS ALL IMPLIED
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE (EVEN IF
   YAHOO! HAD BEEN INFORMED OF SUCH PURPOSE), AND NONINFRINGEMENT WITH RESPECT
   TO THE SOFTWARE, ANY MODIFICATIONS THERETO AND WITH RESPECT TO THE USE OF THE
   FOREGOING.

   (( 5. ))??
   Limitation of Liability

   IN NO EVENT WILL YAHOO! BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES OF ANY KIND (INCLUDING WITHOUT
   LIMITATION LOSS OF PROFITS, LOSS OF USE, BUSINESS INTERRUPTION, LOSS OF DATA,
   COST OF COVER) IN CONNECTION WITH OR ARISING OUT OF OR RELATING TO THE
   FURNISHING, PERFORMANCE OR USE OF THE SOFTWARE OR ANY OTHER RIGHTS GRANTED
   HEREUNDER, WHETHER ALLEGED AS A BREACH OF CONTRACT OR TORTIOUS CONDUCT,
   INCLUDING NEGLIGENCE, AND EVEN IF YAHOO! HAS BEEN ADVISED OF THE POSSIBILITY
   OF SUCH DAMAGES.

   (( 6. ))??
   Term and Termination

      (( 6.1 ))??
      - This Agreement will continue in effect unless and until terminated
      earlier pursuant to this Section 6.

      (( 6.2 ))??
      - In the event You violate the terms of this Agreement, Yahoo! may
      terminate this Agreement.

      (( 6.3 ))??
      - All licenses granted hereunder shall terminate upon the termination of
      this Agreement. Termination will be in addition to any rights and remedies
      available to Yahoo! at law or equity or under this Agreement.

      (( 6.4 ))??
      - Termination of this Agreement will not affect the provisions regarding
      reservation of rights (Section 3.1), provisions disclaiming or limiting
      Yahoo!'s liability (Sections 4 and 5), Termination (Section 6) or
      Miscellaneous (Section 7), which provisions will survive termination of
      this Agreement.

   (( 7. ))??
   Miscellaneous

   This Agreement contains the entire agreement of the parties with respect to
   the subject matter of this Agreement and supersedes all previous
   communications, representations, understandings and agreements, either oral
   or written, between the parties with respect to said subject matter. The
   relationship of the parties hereunder is that of independent contractors, and
   this Agreement will not be construed as creating an agency, partnership,
   joint venture or any other form of legal association between the parties. If
   any term, condition, or provision in this Agreement is found to be invalid,
   unlawful or unenforceable to any extent, this Agreement will be construed in
   a manner that most closely effectuates the intent of this Agreement. Such
   invalid term, condition or provision will be severed from the remaining
   terms, conditions and provisions, which will continue to be valid and
   enforceable to the fullest extent permitted by law. This Agreement will be
   interpreted and construed in accordance with the laws of the State of
   California and the United States of America, without regard to conflict of
   law principles. The U.N. Convention on Contracts for the International Sale
   of Goods shall not apply to this Agreement. All disputes arising out of this
   Agreement involving Yahoo! or any of its subsidiaries shall be subject to the
   jurisdiction of the federal or state courts of northern California, with
   venue lying in Santa Clara County, California. No rights may be assigned, no
   obligations may be delegated, and this Agreement may not be transferred by
   You, in whole or in part, whether voluntary or by operation of law, including
   by way of sale of assets, merger or consolidation, without the prior written
   consent of Yahoo!, and any purported assignment, delegation or transfer
   without such consent shall be void ab initio. Any waiver of the provisions of
   this Agreement or of a party's rights or remedies under this Agreement must
   be in writing to be effective. Failure, neglect or delay by a party to
   enforce the provisions of this Agreement or its rights or remedies at any
   time, will not be construed or be deemed to be a waiver of such party's
   rights under this Agreement and will not in any way affect the validity of
   the whole or any part of this Agreement or prejudice such party's right to
   take subsequent action.
//**
Yahoo! Public License v1.0
https://spdx.org/licenses/YPL-1.0.json
http://www.zimbra.com/license/yahoo_public_license_1.0.html
**//

(( Yahoo! Public License, Version 1.0 (YPL) ))??

This Yahoo! Public License (this "Agreement") is a legal agreement that
describes the terms under which Yahoo! Inc., a Delaware corporation having its
principal place of business at 701 First Avenue, Sunnyvale, California 94089
("Yahoo!") will provide software to you via download or otherwise ("Software").
By using the Software, you, an individual or an entity ("You") agree to the
terms of this Agreement.

In consideration of the mutual promises and upon the terms and conditions set
forth below, the parties agree as follows:

   (( 1. ))??
   Grant of Copyright License

      (( 1.1 ))??
      - Subject to the terms and conditions of this Agreement, Yahoo! hereby
      grants to You, under any and all of its copyright interest in and to the
      Software, a royalty-free, non-exclusive, non-transferable license to copy,
      modify, compile, execute, and distribute the Software and Modifications.
      For the purposes of this Agreement, any change to, addition to, or
      abridgement of the Software made by You is a "Modification;" however, any
      file You add to the Software that does not contain any part of the
      Software is not a "Modification."

      (( 1.2 ))??
      - If You are an individual acting on behalf of a corporation or other
      entity, Your use of the Software or any Modification is subject to Your
      having the authority to bind such corporation or entity to this Agreement.
      Providing copies to persons within such corporation or entity is not
      considered distribution for purposes of this Agreement.

      (( 1.3 ))??
      - For the Software or any Modification You distribute in source code
      format, You must do so only under the terms of this Agreement, and You
      must include a complete copy of this Agreement with Your distribution.
      With respect to any Modification You distribute in source code format, the
      terms of this Agreement will apply to You in the same way those terms
      apply to Yahoo! with respect to the Software. In other words, when You are
      distributing Modifications under this Agreement, You "stand in the shoes"
      of Yahoo! in terms of the rights You grant and how the terms and
      conditions apply to You and the licensees of Your Modifications.
      Notwithstanding the foregoing, when You "stand in the shoes" of Yahoo!,
      You are not subject to the jurisdiction provision under Section 7, which
      requires all disputes under this Agreement to be subject to the
      jurisdiction of federal or state courts of northern California.

      (( 1.4 ))??
      - For the Software or any Modification You distribute in compiled or
      object code format, You must also provide recipients with access to the
      Software or Modification in source code format along with a complete copy
      of this Agreement. The distribution of the Software or Modifications in
      compiled or object code format may be under a license of Your choice,
      provided that You are in compliance with the terms of this Agreement. In
      addition, You must make absolutely clear that any license terms applying
      to such Software or Modification that differ from this Agreement are
      offered by You alone and not by Yahoo!, and that such license does not
      restrict recipients from exercising rights in the source code to the
      Software granted by Yahoo! under this Agreement or rights in the source
      code to any Modification granted by You as described in Section 1.3.

      (( 1.5 ))??
      - This Agreement does not limit Your right to distribute files that are
      entirely Your own work (i.e., which do not incorporate any portion of the
      Software and are not Modifications) under any terms You choose.

   (( 2. ))??
   Support

   Yahoo! has no obligation to provide technical support or updates to You.
   Nothing in this Agreement requires Yahoo! to enter into any license with You
   for any other edition of the Software.

   (( 3. ))??
   Intellectual Property Rights

      (( 3.1 ))??
      - Except for the license expressly granted under copyright in Section 1.1,
      no rights, licenses or forbearances are granted or may arise in relation
      to this Agreement whether expressly, by implication, exhaustion, estoppel
      or otherwise. All rights, including all intellectual property rights, that
      are not expressly granted under this Agreement are hereby reserved.

      (( 3.2 ))??
      - In any copy of the Software or in any Modification you create, You must
      retain and reproduce, any and all copyright, patent, trademark, and
      attribution notices that are included in the Software in the same form as
      they appear in the Software. This includes the preservation of attribution
      notices in the form of trademarks or logos that exist within a user
      interface of the Software.

      (( 3.3 ))??
      - This license does not grant You rights to use any party's name, logo, or
      trademarks, except solely as necessary to comply with Section 3.2.

   (( 4. ))??
   Disclaimer of Warranties

   THE SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY OF ANY KIND. YAHOO!
   MAKES NO WARRANTIES, WHETHER EXPRESS, IMPLIED, OR STATUTORY REGARDING OR
   RELATING TO THE SOFTWARE. SPECIFICALLY, YAHOO! DOES NOT WARRANT THAT THE
   SOFTWARE WILL BE ERROR FREE OR WILL PERFORM IN AN UNINTERRUPTED MANNER. TO
   THE GREATEST EXTENT ALLOWED BY LAW, YAHOO! SPECIFICALLY DISCLAIMS ALL IMPLIED
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE (EVEN IF
   YAHOO! HAD BEEN INFORMED OF SUCH PURPOSE), AND NONINFRINGEMENT WITH RESPECT
   TO THE SOFTWARE, ANY MODIFICATIONS THERETO AND WITH RESPECT TO THE USE OF THE
   FOREGOING.

   (( 5. ))??
   Limitation of Liability

   IN NO EVENT WILL YAHOO! BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES OF ANY KIND (INCLUDING WITHOUT
   LIMITATION LOSS OF PROFITS, LOSS OF USE, BUSINESS INTERRUPTION, LOSS OF DATA,
   COST OF COVER) IN CONNECTION WITH OR ARISING OUT OF OR RELATING TO THE
   FURNISHING, PERFORMANCE OR USE OF THE SOFTWARE OR ANY OTHER RIGHTS GRANTED
   HEREUNDER, WHETHER ALLEGED AS A BREACH OF CONTRACT OR TORTIOUS CONDUCT,
   INCLUDING NEGLIGENCE, AND EVEN IF YAHOO! HAS BEEN ADVISED OF THE POSSIBILITY
   OF SUCH DAMAGES.

   (( 6. ))??
   Term and Termination

      (( 6.1 ))??
      - This Agreement will continue in effect unless and until terminated
      earlier pursuant to this Section 6.

      (( 6.2 ))??
      - In the event Yahoo! determines that You have breached this Agreement,
      Yahoo! may terminate this Agreement.

      (( 6.3 ))??
      - All licenses granted hereunder shall terminate upon the termination of
      this Agreement. Termination will be in addition to any rights and remedies
      available to Yahoo! at law or equity or under this Agreement.

      (( 6.4 ))??
      - Termination of this Agreement will not affect the provisions regarding
      reservation of rights (Section 3.1), provisions disclaiming or limiting
      Yahoo!'s liability (Sections 4 and 5), Termination (Section 6) or
      Miscellaneous (Section 7), which provisions will survive termination of
      this Agreement.

   (( 7. ))??
   Miscellaneous

   This Agreement contains the entire agreement of the parties with respect to
   the subject matter of this Agreement and supersedes all previous
   communications, representations, understandings and agreements, either oral
   or written, between the parties with respect to said subject matter. The
   relationship of the parties hereunder is that of independent contractors, and
   this Agreement will not be construed as creating an agency, partnership,
   joint venture or any other form of legal association between the parties. If
   any term, condition, or provision in this Agreement is found to be invalid,
   unlawful or unenforceable to any extent, this Agreement will be construed in
   a manner that most closely effectuates the intent of this Agreement. Such
   invalid term, condition or provision will be severed from the remaining
   terms, conditions and provisions, which will continue to be valid and
   enforceable to the fullest extent permitted by law. This Agreement will be
   interpreted and construed in accordance with the laws of the State of
   California and the United States of America, without regard to conflict of
   law principles. The U.N. Convention on Contracts for the International Sale
   of Goods shall not apply to this Agreement. All disputes arising out of this
   Agreement involving Yahoo! or any of its subsidiaries shall be subject to the
   jurisdiction of the federal or state courts of northern California, with
   venue lying in Santa Clara County, California. No rights may be assigned, no
   obligations may be delegated, and this Agreement may not be transferred by
   You, in whole or in part, whether voluntary or by operation of law, including
   by way of sale of assets, merger or consolidation, without the prior written
   consent of Yahoo!, and any purported assignment, delegation or transfer
   without such consent shall be void ab initio. Any waiver of the provisions of
   this Agreement or of a party's rights or remedies under this Agreement must
   be in writing to be effective. Failure, neglect or delay by a party to
   enforce the provisions of this Agreement or its rights or remedies at any
   time, will not be construed or be deemed to be a waiver of such party's
   rights under this Agreement and will not in any way affect the validity of
   the whole or any part of this Agreement or prejudice such party's right to
   take subsequent action.
//**
CERN Open Hardware Licence v1.2
https://spdx.org/licenses/CERN-OHL-1.2.json
https://www.ohwr.org/project/licenses/wikis/cern-ohl-v1.2
**//

(( CERN OHL v1.2

2013-09-06 - CERN, Geneva, Switzerland

CERN Open Hardware Licence v1.2 ))??

Preamble

Through this CERN Open Hardware Licence ("CERN OHL") version 1.2, CERN wishes to
provide a tool to foster collaboration and sharing among hardware designers. The
CERN OHL is copyright CERN. Anyone is welcome to use the CERN OHL, in unmodified
form only, for the distribution of their own Open Hardware designs. Any other
right is reserved. Release of hardware designs under the CERN OHL does not
constitute an endorsement of the licensor or its designs nor does it imply any
involvement by CERN in the development of such designs.

1. Definitions

In this Licence, the following terms have the following meanings:

"Licence" means this CERN OHL.

"Documentation" means schematic diagrams, designs, circuit or circuit board
layouts, mechanical drawings, flow charts and descriptive text, and other
explanatory material that is explicitly stated as being made available under the
conditions of this Licence. The Documentation may be in any medium, including
but not limited to computer files and representations on paper, film, or any
other media.

"Documentation Location" means a location where the Licensor has placed
Documentation, and which he believes will be publicly accessible for at least
three years from the first communication to the public or distribution of
Documentation.

"Product" means either an entire, or any part of a, device built using the
Documentation or the modified Documentation.

"Licensee" means any natural or legal person exercising rights under this
Licence.

"Licensor" means any natural or legal person that creates or modifies
Documentation and subsequently communicates to the public and/ or distributes
the resulting Documentation under the terms and conditions of this Licence.

A Licensee may at the same time be a Licensor, and vice versa.

Use of the masculine gender includes the feminine and neuter genders and is
employed solely to facilitate reading.

2. Applicability

   (( 2.1. ))??
   This Licence governs the use, copying, modification, communication to the
   public and distribution of the Documentation, and the manufacture and
   distribution of Products. By exercising any right granted under this Licence,
   the Licensee irrevocably accepts these terms and conditions.

   (( 2.2. ))??
   This Licence is granted by the Licensor directly to the Licensee, and shall
   apply worldwide and without limitation in time. The Licensee may assign his
   licence rights or grant sub-licences.

   (( 2.3. ))??
   This Licence does not extend to software, firmware, or code loaded into
   programmable devices which may be used in conjunction with the Documentation,
   the modified Documentation or with Products, unless such software, firmware,
   or code is explicitly expressed to be subject to this Licence. The use of
   such software, firmware, or code is otherwise subject to the applicable
   licence terms and conditions.

3. Copying, modification, communication to the public and distribution of the
Documentation

   (( 3.1. ))??
   The Licensee shall keep intact all copyright and trademarks notices, all
   notices referring to Documentation Location, and all notices that refer to
   this Licence and to the disclaimer of warranties that are included in the
   Documentation. He shall include a copy thereof in every copy of the
   Documentation or, as the case may be, modified Documentation, that he
   communicates to the public or distributes.

   (( 3.2. ))??
   The Licensee may copy, communicate to the public and distribute verbatim
   copies of the Documentation, in any medium, subject to the requirements
   specified in section 3.1.

   (( 3.3. ))??
   The Licensee may modify the Documentation or any portion thereof provided
   that upon modification of the Documentation, the Licensee shall make the
   modified Documentation available from a Documentation Location such that it
   can be easily located by an original Licensor once the Licensee communicates
   to the public or distributes the modified Documentation under section 3.4,
   and, where required by section 4.1, by a recipient of a Product. However, the
   Licensor shall not assert his rights under the foregoing proviso unless or
   until a Product is distributed.

   (( 3.4. ))??
   The Licensee may communicate to the public and distribute the modified
   Documentation (thereby in addition to being a Licensee also becoming a
   Licensor), always provided that he shall:

      (( a) ))??
      comply with section 3.1;

      (( b) ))??
      cause the modified Documentation to carry prominent notices stating that
      the Licensee has modified the Documentation, with the date and description
      of the modifications;

      (( c) ))??
      cause the modified Documentation to carry a new Documentation Location
      notice if the original Documentation provided for one;

      (( d) ))??
      make available the modified Documentation at the same level of abstraction
      as that of the Documentation, in the preferred format for making
      modifications to it (e.g. the native format of the CAD tool as
      applicable), and in the event that format is proprietary, in a format
      viewable with a tool licensed under an OSI-approved license if the
      proprietary tool can create it; and

      (( e) ))??
      license the modified Documentation under the terms and conditions of this
      Licence or, where applicable, a later version of this Licence as may be
      issued by CERN.

   (( 3.5. ))??
   The Licence includes a non-exclusive licence to those patents or registered
   designs that are held by, under the control of, or sub-licensable by the
   Licensor, to the extent necessary to make use of the rights granted under
   this Licence. The scope of this section 3.5 shall be strictly limited to the
   parts of the Documentation or modified Documentation created by the
   Licensor.

4. Manufacture and distribution of Products

   (( 4.1. ))??
   The Licensee may manufacture or distribute Products always provided that,
   where such manufacture or distribution requires a licence under this Licence
   the Licensee provides to each recipient of such Products an easy means of
   accessing a copy of the Documentation or modified Documentation, as
   applicable, as set out in section 3.

   (( 4.2. ))??
   The Licensee is invited to inform any Licensor who has indicated his wish to
   receive this information about the type, quantity and dates of production of
   Products the Licensee has (had) manufactured

5. Warranty and liability

   (( 5.1. ))??
   DISCLAIMER – The Documentation and any modified Documentation are provided
   "as is" and any express or implied warranties, including, but not limited to,
   implied warranties of merchantability, of satisfactory quality,
   non-infringement of third party rights, and fitness for a particular purpose
   or use are disclaimed in respect of the Documentation, the modified
   Documentation or any Product. The Licensor makes no representation that the
   Documentation, modified Documentation, or any Product, does or will not
   infringe any patent, copyright, trade secret or other proprietary right. The
   entire risk as to the use, quality, and performance of a Product shall be
   with the Licensee and not the Licensor. This disclaimer of warranty is an
   essential part of this Licence and a condition for the grant of any rights
   granted under this Licence. The Licensee warrants that it does not act in a
   consumer capacity.

   (( 5.2. ))??
   LIMITATION OF LIABILITY – The Licensor shall have no liability for direct,
   indirect, special, incidental, consequential, exemplary, punitive or other
   damages of any character including, without limitation, procurement of
   substitute goods or services, loss of use, data or profits, or business
   interruption, however caused and on any theory of contract, warranty, tort
   (including negligence), product liability or otherwise, arising in any way in
   relation to the Documentation, modified Documentation and/or the use,
   manufacture or distribution of a Product, even if advised of the possibility
   of such damages, and the Licensee shall hold the Licensor(s) free and
   harmless from any liability, costs, damages, fees and expenses, including
   claims by third parties, in relation to such use.

6. General

   (( 6.1. ))??
   Except for the rights explicitly granted hereunder, this Licence does not
   imply or represent any transfer or assignment of intellectual property rights
   to the Licensee.

   (( 6.2. ))??
   The Licensee shall not use or make reference to any of the names (including
   acronyms and abbreviations), images, or logos under which the Licensor is
   known, save in so far as required to comply with section 3. Any such
   permitted use or reference shall be factual and shall in no event suggest any
   kind of endorsement by the Licensor or its personnel of the modified
   Documentation or any Product, or any kind of implication by the Licensor or
   its personnel in the preparation of the modified Documentation or Product.

   (( 6.3. ))??
   CERN may publish updated versions of this Licence which retain the same
   general provisions as this version, but differ in detail so far this is
   required and reasonable. New versions will be published with a unique version
   number.

   (( 6.4. ))??
   This Licence shall terminate with immediate effect, upon written notice and
   without involvement of a court if the Licensee fails to comply with any of
   its terms and conditions, or if the Licensee initiates legal action against
   Licensor in relation to this Licence. Section 5 shall continue to apply.
//**
Zimbra Public License v1.3
https://spdx.org/licenses/Zimbra-1.3.json
http://web.archive.org/web/20100302225219/http://www.zimbra.com/license/zimbra-public-license-1-3.html
**//

(( Zimbra Public License, Version 1.3 (ZPL) ))??

This Zimbra Public License (this "Agreement") is a legal agreement that
describes the terms under which VMware, Inc., a Delaware corporation having its
principal place of business at 3401 Hillview Avenue, Palo Alto, California 94304
("VMware") will provide software to you via download or otherwise ("Software").
By using the Software, you, an individual or an entity ("You") agree to the
terms of this Agreement.

In consideration of the mutual promises and upon the terms and conditions set
forth below, the parties agree as follows:

   (( 1. ))??
   Grant of Copyright License

      (( 1.1 - ))??
      Subject to the terms and conditions of this Agreement, VMware hereby
      grants to You, under any and all of its copyright interest in and to the
      Software, a royalty-free, non-exclusive, non-transferable license to copy,
      modify, compile, execute, and distribute the Software and Modifications.
      For the purposes of this Agreement, any change to, addition to, or
      abridgement of the Software made by You is a "Modification;" however, any
      file You add to the Software that does not contain any part of the
      Software is not a "Modification."

      (( 1.2 - ))??
      If You are an individual acting on behalf of a corporation or other
      entity, Your use of the Software or any Modification is subject to Your
      having the authority to bind such corporation or entity to this Agreement.
      Providing copies to persons within such corporation or entity is not
      considered distribution for purposes of this Agreement.

      (( 1.3 - ))??
      For the Software or any Modification You distribute in source code format,
      You must do so only under the terms of this Agreement, and You must
      include a complete copy of this Agreement with Your distribution. With
      respect to any Modification You distribute in source code format, the
      terms of this Agreement will apply to You in the same way those terms
      apply to VMware with respect to the Software. In other words, when You are
      distributing Modifications under this Agreement, You "stand in the shoes"
      of VMware in terms of the rights You grant and how the terms and
      conditions apply to You and the licensees of Your Modifications.
      Notwithstanding the foregoing, when You "stand in the shoes" of VMware,
      You are not subject to the jurisdiction provision under Section 7, which
      requires all disputes under this Agreement to be subject to the
      jurisdiction of federal or state courts of northern California.

      (( 1.4 - ))??
      For the Software or any Modification You distribute in compiled or object
      code format, You must also provide recipients with access to the Software
      or Modification in source code format along with a complete copy of this
      Agreement. The distribution of the Software or Modifications in compiled
      or object code format may be under a license of Your choice, provided that
      You are in compliance with the terms of this Agreement. In addition, You
      must make absolutely clear that any license terms applying to such
      Software or Modification that differ from this Agreement are offered by
      You alone and not by VMware, and that such license does not restrict
      recipients from exercising rights in the source code to the Software
      granted by VMware under this Agreement or rights in the source code to any
      Modification granted by You as described in Section 1.3.

      (( 1.5 - ))??
      This Agreement does not limit Your right to distribute files that are
      entirely Your own work (i.e., which do not incorporate any portion of the
      Software and are not Modifications) under any terms You choose.

   (( 2. ))??
   Support

   VMware has no obligation to provide technical support or updates to You.
   Nothing in this Agreement requires VMware to enter into any license with You
   for any other edition of the Software.

   (( 3. ))??
   Intellectual Property Rights

      (( 3.1 - ))??
      Except for the license expressly granted under copyright in Section 1.1,
      no rights, licenses or forbearances are granted or may arise in relation
      to this Agreement whether expressly, by implication, exhaustion, estoppel
      or otherwise. All rights, including all intellectual property rights, that
      are not expressly granted under this Agreement are hereby reserved.

      (( 3.2 - ))??
      In any copy of the Software or in any Modification you create, You must
      retain and reproduce, any and all copyright, patent, trademark, and
      attribution notices that are included in the Software in the same form as
      they appear in the Software. This includes the preservation of attribution
      notices in the form of trademarks or logos that exist within a user
      interface of the Software.

      (( 3.3 - ))??
      This license does not grant You rights to use any party's name, logo, or
      trademarks, except solely as necessary to comply with Section 3.2.

   (( 4. ))??
   Disclaimer of Warranties

   THE SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY OF ANY KIND. VMWARE
   MAKES NO WARRANTIES, WHETHER EXPRESS, IMPLIED, OR STATUTORY REGARDING OR
   RELATING TO THE SOFTWARE. SPECIFICALLY, VMWARE DOES NOT WARRANT THAT THE
   SOFTWARE WILL BE ERROR FREE OR WILL PERFORM IN AN UNINTERRUPTED MANNER. TO
   THE GREATEST EXTENT ALLOWED BY LAW, VMWARE SPECIFICALLY DISCLAIMS ALL IMPLIED
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE (EVEN IF
   VMWARE HAD BEEN INFORMED OF SUCH PURPOSE), AND NONINFRINGEMENT WITH RESPECT
   TO THE SOFTWARE, ANY MODIFICATIONS THERETO AND WITH RESPECT TO THE USE OF THE
   FOREGOING.

   (( 5. ))??
   Limitation of Liability

   IN NO EVENT WILL VMWARE BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES OF ANY KIND (INCLUDING WITHOUT
   LIMITATION LOSS OF PROFITS, LOSS OF USE, BUSINESS INTERRUPTION, LOSS OF DATA,
   COST OF COVER) IN CONNECTION WITH OR ARISING OUT OF OR RELATING TO THE
   FURNISHING, PERFORMANCE OR USE OF THE SOFTWARE OR ANY OTHER RIGHTS GRANTED
   HEREUNDER, WHETHER ALLEGED AS A BREACH OF CONTRACT OR TORTIOUS CONDUCT,
   INCLUDING NEGLIGENCE, AND EVEN IF VMWARE HAS BEEN ADVISED OF THE POSSIBILITY
   OF SUCH DAMAGES.

   (( 6. ))??
   Term and Termination

      (( 6.1 - ))??
      This Agreement will continue in effect unless and until terminated earlier
      pursuant to this Section 6.

      (( 6.2 - ))??
      In the event You violate the terms of this Agreement, VMware may terminate
      this Agreement.

      (( 6.3 - ))??
      All licenses granted hereunder shall terminate upon the termination of
      this Agreement. Termination will be in addition to any rights and remedies
      available to VMware at law or equity or under this Agreement.

      (( 6.4 - ))??
      Termination of this Agreement will not affect the provisions regarding
      reservation of rights (Section 3.1), provisions disclaiming or limiting
      VMware's liability (Sections 4 and 5), Termination (Section 6) or
      Miscellaneous (Section 7), which provisions will survive termination of
      this Agreement.

   (( 7. ))??
   Miscellaneous

   This Agreement contains the entire agreement of the parties with respect to
   the subject matter of this Agreement and supersedes all previous
   communications, representations, understandings and agreements, either oral
   or written, between the parties with respect to said subject matter. The
   relationship of the parties hereunder is that of independent contractors, and
   this Agreement will not be construed as creating an agency, partnership,
   joint venture or any other form of legal association between the parties. If
   any term, condition, or provision in this Agreement is found to be invalid,
   unlawful or unenforceable to any extent, this Agreement will be construed in
   a manner that most closely effectuates the intent of this Agreement. Such
   invalid term, condition or provision will be severed from the remaining
   terms, conditions and provisions, which will continue to be valid and
   enforceable to the fullest extent permitted by law. This Agreement will be
   interpreted and construed in accordance with the laws of the State of
   California and the United States of America, without regard to conflict of
   law principles. The U.N. Convention on Contracts for the International Sale
   of Goods shall not apply to this Agreement. All disputes arising out of this
   Agreement involving VMware or any of its subsidiaries shall be subject to the
   jurisdiction of the federal or state courts of northern California, with
   venue lying in Santa Clara County, California. No rights may be assigned, no
   obligations may be delegated, and this Agreement may not be transferred by
   You, in whole or in part, whether voluntary or by operation of law, including
   by way of sale of assets, merger or consolidation, without the prior written
   consent of VMware, and any purported assignment, delegation or transfer
   without such consent shall be void ab initio. Any waiver of the provisions of
   this Agreement or of a party's rights or remedies under this Agreement must
   be in writing to be effective. Failure, neglect or delay by a party to
   enforce the provisions of this Agreement or its rights or remedies at any
   time, will not be construed or be deemed to be a waiver of such party's
   rights under this Agreement and will not in any way affect the validity of
   the whole or any part of this Agreement or prejudice such party's right to
   take subsequent action.
//**
IPA Font License
https://spdx.org/licenses/IPA.json
https://opensource.org/licenses/IPA
**//

(( IPA Font License Agreement v1.0 ))??

The Licensor provides the Licensed Program (as defined in Article 1 below) under
the terms of this license agreement ("Agreement"). Any use, reproduction or
distribution of the Licensed Program, or any exercise of rights under this
Agreement by a Recipient (as defined in Article 1 below) constitutes the
Recipient's acceptance of this Agreement.

Article 1 (Definitions)

   (( 1. ))??
   "Digital Font Program" shall mean a computer program containing, or used to
   render or display fonts.

   (( 2. ))??
   "Licensed Program" shall mean a Digital Font Program licensed by the Licensor
   under this Agreement.

   (( 3. ))??
   "Derived Program" shall mean a Digital Font Program created as a result of a
   modification, addition, deletion, replacement or any other adaptation to or
   of a part or all of the Licensed Program, and includes a case where a Digital
   Font Program newly created by retrieving font information from a part or all
   of the Licensed Program or Embedded Fonts from a Digital Document File with
   or without modification of the retrieved font information.

   (( 4. ))??
   "Digital Content" shall mean products provided to end users in the form of
   digital data, including video content, motion and/or still pictures, TV
   programs or other broadcasting content and products consisting of character
   text, pictures, photographic images, graphic symbols and/or the like.

   (( 5. ))??
   "Digital Document File" shall mean a PDF file or other Digital Content
   created by various software programs in which a part or all of the Licensed
   Program becomes embedded or contained in the file for the display of the font
   ("Embedded Fonts"). Embedded Fonts are used only in the display of characters
   in the particular Digital Document File within which they are embedded, and
   shall be distinguished from those in any Digital Font Program, which may be
   used for display of characters outside that particular Digital Document
   File.

   (( 6. ))??
   "Computer" shall include a server in this Agreement.

   (( 7. ))??
   "Reproduction and Other Exploitation" shall mean reproduction, transfer,
   distribution, lease, public transmission, presentation, exhibition,
   adaptation and any other exploitation.

   (( 8. ))??
   "Recipient" shall mean anyone who receives the Licensed Program under this
   Agreement, including one that receives the Licensed Program from a
   Recipient.

Article 2 (Grant of License)

The Licensor grants to the Recipient a license to use the Licensed Program in
any and all countries in accordance with each of the provisions set forth in
this Agreement. However, any and all rights underlying in the Licensed Program
shall be held by the Licensor. In no sense is this Agreement intended to
transfer any right relating to the Licensed Program held by the Licensor except
as specifically set forth herein or any right relating to any trademark, trade
name, or service mark to the Recipient.

   (( 1. ))??
   The Recipient may install the Licensed Program on any number of Computers and
   use the same in accordance with the provisions set forth in this Agreement.

   (( 2. ))??
   The Recipient may use the Licensed Program, with or without modification in
   printed materials or in Digital Content as an expression of character texts
   or the like.

   (( 3. ))??
   The Recipient may conduct Reproduction and Other Exploitation of the printed
   materials and Digital Content created in accordance with the preceding
   Paragraph, for commercial or non-commercial purposes and in any form of media
   including but not limited to broadcasting, communication and various
   recording media.

   (( 4. ))??
   If any Recipient extracts Embedded Fonts from a Digital Document File to
   create a Derived Program, such Derived Program shall be subject to the terms
   of this agreement.

   (( 5. ))??
   If any Recipient performs Reproduction or Other Exploitation of a Digital
   Document File in which Embedded Fonts of the Licensed Program are used only
   for rendering the Digital Content within such Digital Document File then such
   Recipient shall have no further obligations under this Agreement in relation
   to such actions.

   (( 6. ))??
   The Recipient may reproduce the Licensed Program as is without modification
   and transfer such copies, publicly transmit or otherwise redistribute the
   Licensed Program to a third party for commercial or non-commercial purposes
   ("Redistribute"), in accordance with the provisions set forth in Article 3
   Paragraph 2.

   (( 7. ))??
   The Recipient may create, use, reproduce and/or Redistribute a Derived
   Program under the terms stated above for the Licensed Program: provided, that
   the Recipient shall follow the provisions set forth in Article 3 Paragraph 1
   when Redistributing the Derived Program.

Article 3 (Restriction)

The license granted in the preceding Article shall be subject to the following
restrictions:

   (( 1. ))??
   If a Derived Program is Redistributed pursuant to Paragraph 4 and 7 of the
   preceding Article, the following conditions must be met :

      (( (1) ))??
      The following must be also Redistributed together with the Derived
      Program, or be made available online or by means of mailing mechanisms in
      exchange for a cost which does not exceed the total costs of postage,
      storage medium and handling fees:

         (( (a) ))??
         a copy of the Derived Program; and

         (( (b) ))??
         any additional file created by the font developing program in the
         course of creating the Derived Program that can be used for further
         modification of the Derived Program, if any.

      (( (2) ))??
      It is required to also Redistribute means to enable recipients of the
      Derived Program to replace the Derived Program with the Licensed Program
      first released under this License (the "Original Program"). Such means may
      be to provide a difference file from the Original Program, or instructions
      setting out a method to replace the Derived Program with the Original
      Program.

      (( (3) ))??
      The Recipient must license the Derived Program under the terms and
      conditions of this Agreement.

      (( (4) ))??
      No one may use or include the name of the Licensed Program as a program
      name, font name or file name of the Derived Program.

      (( (5) ))??
      Any material to be made available online or by means of mailing a medium
      to satisfy the requirements of this paragraph may be provided, verbatim,
      by any party wishing to do so.

   (( 2. ))??
   If the Recipient Redistributes the Licensed Program pursuant to Paragraph 6
   of the preceding Article, the Recipient shall meet all of the following
   conditions:

      (( (1) ))??
      The Recipient may not change the name of the Licensed Program.

      (( (2) ))??
      The Recipient may not alter or otherwise modify the Licensed Program.

      (( (3) ))??
      The Recipient must attach a copy of this Agreement to the Licensed
      Program.

   (( 3. ))??
   THIS LICENSED PROGRAM IS PROVIDED BY THE LICENSOR "AS IS" AND ANY EXPRESSED
   OR IMPLIED WARRANTY AS TO THE LICENSED PROGRAM OR ANY DERIVED PROGRAM,
   INCLUDING, BUT NOT LIMITED TO, WARRANTIES OF TITLE, NON-INFRINGEMENT,
   MERCHANTABILITY, OR FITNESS FOR A PARTICULAR PURPOSE, ARE DISCLAIMED. IN NO
   EVENT SHALL THE LICENSOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXTENDED, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO; PROCUREMENT OF SUBSTITUTED GOODS OR SERVICE; DAMAGES ARISING FROM
   SYSTEM FAILURE; LOSS OR CORRUPTION OF EXISTING DATA OR PROGRAM; LOST
   PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
   STRICT LIABILITY OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
   WAY OUT OF THE INSTALLATION, USE, THE REPRODUCTION OR OTHER EXPLOITATION OF
   THE LICENSED PROGRAM OR ANY DERIVED PROGRAM OR THE EXERCISE OF ANY RIGHTS
   GRANTED HEREUNDER, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

   (( 4. ))??
   The Licensor is under no obligation to respond to any technical questions or
   inquiries, or provide any other user support in connection with the
   installation, use or the Reproduction and Other Exploitation of the Licensed
   Program or Derived Programs thereof.

Article 4 (Termination of Agreement)

   (( 1. ))??
   The term of this Agreement shall begin from the time of receipt of the
   Licensed Program by the Recipient and shall continue as long as the Recipient
   retains any such Licensed Program in any way.

   (( 2. ))??
   Notwithstanding the provision set forth in the preceding Paragraph, in the
   event of the breach of any of the provisions set forth in this Agreement by
   the Recipient, this Agreement shall automatically terminate without any
   notice. In the case of such termination, the Recipient may not use or conduct
   Reproduction and Other Exploitation of the Licensed Program or a Derived
   Program: provided that such termination shall not affect any rights of any
   other Recipient receiving the Licensed Program or the Derived Program from
   such Recipient who breached this Agreement.

Article 5 (Governing Law)

   (( 1. ))??
   IPA may publish revised and/or new versions of this License. In such an
   event, the Recipient may select either this Agreement or any subsequent
   version of the Agreement in using, conducting the Reproduction and Other
   Exploitation of, or Redistributing the Licensed Program or a Derived Program.
   Other matters not specified above shall be subject to the Copyright Law of
   Japan and other related laws and regulations of Japan.

   (( 2. ))??
   This Agreement shall be construed under the laws of Japan.
//**
Python License 2.0
https://spdx.org/licenses/Python-2.0.json
https://opensource.org/licenses/Python-2.0
**//

(( PYTHON SOFTWARE FOUNDATION LICENSE VERSION 2 ))??

   (( 1. ))??
   This LICENSE AGREEMENT is between the Python Software Foundation ("PSF"), and
   the Individual or Organization ("Licensee") accessing and otherwise using
   this software ("Python") in source or binary form and its associated
   documentation.

   (( 2. ))??
   Subject to the terms and conditions of this License Agreement, PSF hereby
   grants Licensee a nonexclusive, royalty-free, world-wide license to
   reproduce, analyze, test, perform and/or display publicly, prepare derivative
   works, distribute, and otherwise use Python alone or in any derivative
   version, provided, however, that PSF's License Agreement and PSF's notice of
   copyright, i.e., "Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006 Python
   Software Foundation; All Rights Reserved" are retained in Python alone or in
   any derivative version prepared by Licensee.

   (( 3. ))??
   In the event Licensee prepares a derivative work that is based on or
   incorporates Python or any part thereof, and wants to make the derivative
   work available to others as provided herein, then Licensee hereby agrees to
   include in any such work a brief summary of the changes made to Python.

   (( 4. ))??
   PSF is making Python available to Licensee on an "AS IS" basis. PSF MAKES NO
   REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED. BY WAY OF EXAMPLE, BUT NOT
   LIMITATION, PSF MAKES NO AND DISCLAIMS ANY REPRESENTATION OR WARRANTY OF
   MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR PURPOSE OR THAT THE USE OF
   PYTHON WILL NOT INFRINGE ANY THIRD PARTY RIGHTS.

   (( 5. ))??
   PSF SHALL NOT BE LIABLE TO LICENSEE OR ANY OTHER USERS OF PYTHON FOR ANY
   INCIDENTAL, SPECIAL, OR CONSEQUENTIAL DAMAGES OR LOSS AS A RESULT OF
   MODIFYING, DISTRIBUTING, OR OTHERWISE USING PYTHON, OR ANY DERIVATIVE
   THEREOF, EVEN IF ADVISED OF THE POSSIBILITY THEREOF.

   (( 6. ))??
   This License Agreement will automatically terminate upon a material breach of
   its terms and conditions.

   (( 7. ))??
   Nothing in this License Agreement shall be deemed to create any relationship
   of agency, partnership, or joint venture between PSF and Licensee. This
   License Agreement does not grant permission to use PSF trademarks or trade
   name in a trademark sense to endorse or promote products or services of
   Licensee, or any third party.

   (( 8. ))??
   By copying, installing or otherwise using Python, Licensee agrees to be bound
   by the terms and conditions of this License Agreement.


(( BEOPEN.COM LICENSE AGREEMENT FOR PYTHON 2.0

BEOPEN PYTHON OPEN SOURCE LICENSE AGREEMENT VERSION 1 ))??

   (( 1. ))??
   This LICENSE AGREEMENT is between BeOpen.com ("BeOpen"), having an office at
   160 Saratoga Avenue, Santa Clara, CA 95051, and the Individual or
   Organization ("Licensee") accessing and otherwise using this software in
   source or binary form and its associated documentation ("the Software").

   (( 2. ))??
   Subject to the terms and conditions of this BeOpen Python License Agreement,
   BeOpen hereby grants Licensee a non-exclusive, royalty-free, world-wide
   license to reproduce, analyze, test, perform and/or display publicly, prepare
   derivative works, distribute, and otherwise use the Software alone or in any
   derivative version, provided, however, that the BeOpen Python License is
   retained in the Software, alone or in any derivative version prepared by
   Licensee.

   (( 3. ))??
   BeOpen is making the Software available to Licensee on an "AS IS" basis.
   BEOPEN MAKES NO REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED. BY WAY OF
   EXAMPLE, BUT NOT LIMITATION, BEOPEN MAKES NO AND DISCLAIMS ANY REPRESENTATION
   OR WARRANTY OF MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR PURPOSE OR THAT
   THE USE OF THE SOFTWARE WILL NOT INFRINGE ANY THIRD PARTY RIGHTS.

   (( 4. ))??
   BEOPEN SHALL NOT BE LIABLE TO LICENSEE OR ANY OTHER USERS OF THE SOFTWARE FOR
   ANY INCIDENTAL, SPECIAL, OR CONSEQUENTIAL DAMAGES OR LOSS AS A RESULT OF
   USING, MODIFYING OR DISTRIBUTING THE SOFTWARE, OR ANY DERIVATIVE THEREOF,
   EVEN IF ADVISED OF THE POSSIBILITY THEREOF.

   (( 5. ))??
   This License Agreement will automatically terminate upon a material breach of
   its terms and conditions.

   (( 6. ))??
   This License Agreement shall be governed by and interpreted in all respects
   by the law of the State of California, excluding conflict of law provisions.
   Nothing in this License Agreement shall be deemed to create any relationship
   of agency, partnership, or joint venture between BeOpen and Licensee. This
   License Agreement does not grant permission to use BeOpen trademarks or trade
   names in a trademark sense to endorse or promote products or services of
   Licensee, or any third party. As an exception, the "BeOpen Python" logos
   available at http:/www.pythonlabs.com/logos.html may be used according to the
   permissions granted on that web page.

   (( 7. ))??
   By copying, installing or otherwise using the software, Licensee agrees to be
   bound by the terms and conditions of this License Agreement.


(( CNRI OPEN SOURCE LICENSE AGREEMENT (for Python 1.6b1) ))??

   (( IMPORTANT: PLEASE READ THE FOLLOWING AGREEMENT CAREFULLY.

BY CLICKING ON "ACCEPT" WHERE INDICATED BELOW, OR BY COPYING, INSTALLING OR
OTHERWISE USING PYTHON 1.6, beta 1 SOFTWARE, YOU ARE DEEMED TO HAVE AGREED TO
THE TERMS AND CONDITIONS OF THIS LICENSE AGREEMENT. ))??

   (( 1. ))??
   This LICENSE AGREEMENT is between the Corporation for National Research
   Initiatives, having an office at 1895 Preston White Drive, Reston, VA 20191
   ("CNRI"), and the Individual or Organization ("Licensee") accessing and
   otherwise using Python 1.6, beta 1 software in source or binary form and its
   associated documentation, as released at the www.python.org Internet site on
   August 4, 2000 ("Python 1.6b1").

   (( 2. ))??
   Subject to the terms and conditions of this License Agreement, CNRI hereby
   grants Licensee a non-exclusive, royalty-free, world-wide license to
   reproduce, analyze, test, perform and/or display publicly, prepare derivative
   works, distribute, and otherwise use Python 1.6b1 alone or in any derivative
   version, provided, however, that CNRIs License Agreement is retained in
   Python 1.6b1, alone or in any derivative version prepared by Licensee.

   Alternately, in lieu of CNRIs License Agreement, Licensee may substitute the
   following text (omitting the quotes): "Python 1.6, beta 1, is made available
   subject to the terms and conditions in CNRIs License Agreement. This
   Agreement may be located on the Internet using the following unique,
   persistent identifier (known as a handle): 1895.22/1011. This Agreement may
   also be obtained from a proxy server on the Internet using the
   URL:http:/hdl.handle.net/1895.22/1011".

   (( 3. ))??
   In the event Licensee prepares a derivative work that is based on or
   incorporates Python 1.6b1 or any part thereof, and wants to make the
   derivative work available to the public as provided herein, then Licensee
   hereby agrees to indicate in any such work the nature of the modifications
   made to Python 1.6b1.

   (( 4. ))??
   CNRI is making Python 1.6b1 available to Licensee on an "AS IS" basis. CNRI
   MAKES NO REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED. BY WAY OF
   EXAMPLE, BUT NOT LIMITATION, CNRI MAKES NO AND DISCLAIMS ANY REPRESENTATION
   OR WARRANTY OF MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR PURPOSE OR THAT
   THE USE OF PYTHON 1.6b1 WILL NOT INFRINGE ANY THIRD PARTY RIGHTS.

   (( 5. ))??
   CNRI SHALL NOT BE LIABLE TO LICENSEE OR ANY OTHER USERS OF THE SOFTWARE FOR
   ANY INCIDENTAL, SPECIAL, OR CONSEQUENTIAL DAMAGES OR LOSS AS A RESULT OF
   USING, MODIFYING OR DISTRIBUTING PYTHON 1.6b1, OR ANY DERIVATIVE THEREOF,
   EVEN IF ADVISED OF THE POSSIBILITY THEREOF.

   (( 6. ))??
   This License Agreement will automatically terminate upon a material breach of
   its terms and conditions.

   (( 7. ))??
   This License Agreement shall be governed by and interpreted in all respects
   by the law of the State of Virginia, excluding conflict of law provisions.
   Nothing in this License Agreement shall be deemed to create any relationship
   of agency, partnership, or joint venture between CNRI and Licensee. This
   License Agreement does not grant permission to use CNRI trademarks or trade
   name in a trademark sense to endorse or promote products or services of
   Licensee, or any third party.

   (( 8. ))??
   By clicking on the "ACCEPT" button where indicated, or by copying, installing
   or otherwise using Python 1.6b1, Licensee agrees to be bound by the terms and
   conditions of this License Agreement.
   (( ACCEPT ))??

   (( CWI LICENSE AGREEMENT FOR PYTHON 0.9.0 THROUGH 1.2 ))??

   Copyright (c) 1991 - 1995, Stichting Mathematisch Centrum Amsterdam, The Netherlands. All rights reserved.

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted, provided that
the above copyright notice appear in all copies and that both that copyright
notice and this permission notice appear in supporting documentation, and that
the name of Stichting Mathematisch Centrum or CWI not be used in advertising or
publicity pertaining to distribution of the software without specific, written
prior permission.

STICHTING MATHEMATISCH CENTRUM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
EVENT SHALL STICHTING MATHEMATISCH CENTRUM BE LIABLE FOR ANY SPECIAL, INDIRECT
OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
//**
Open Software License 1.1
https://spdx.org/licenses/OSL-1.1.json
https://fedoraproject.org/wiki/Licensing/OSL1.1
**//

(( The Open Software License v. 1.1 ))??

This Open Software License (the "License") applies to any original work of
authorship (the "Original Work") whose owner (the "Licensor") has placed the
following notice immediately following the copyright notice for the Original
Work:

Licensed under the Open Software License version 1.1

   (( 1) ))??
   Grant of Copyright License. Licensor hereby grants You a world-wide,
   royalty-free, non-exclusive, perpetual, non-sublicenseable license to do the
   following:

      (( a) ))??
      to reproduce the Original Work in copies;

      (( b) ))??
      to prepare derivative works ("Derivative Works") based upon the Original
      Work;

      (( c) ))??
      to distribute copies of the Original Work and Derivative Works to the
      public, with the proviso that copies of Original Work or Derivative Works
      that You distribute shall be licensed under the Open Software License;

      (( d) ))??
      to perform the Original Work publicly; and

      (( e) ))??
      to display the Original Work publicly.

   (( 2) ))??
   Grant of Patent License. Licensor hereby grants You a world-wide,
   royalty-free, non-exclusive, perpetual, non-sublicenseable license, under
   patent claims owned or controlled by the Licensor that are embodied in the
   Original Work as furnished by the Licensor ("Licensed Claims") to make, use,
   sell and offer for sale the Original Work. Licensor hereby grants You a
   world-wide, royalty-free, non-exclusive, perpetual, non-sublicenseable
   license under the Licensed Claims to make, use, sell and offer for sale
   Derivative Works.

   (( 3) ))??
   Grant of Source Code License. The term "Source Code" means the preferred form
   of the Original Work for making modifications to it and all available
   documentation describing how to modify the Original Work. Licensor hereby
   agrees to provide a machine-readable copy of the Source Code of the Original
   Work along with each copy of the Original Work that Licensor distributes.
   Licensor reserves the right to satisfy this obligation by placing a
   machine-readable copy of the Source Code in an information repository
   reasonably calculated to permit inexpensive and convenient access by You for
   as long as Licensor continues to distribute the Original Work, and by
   publishing the address of that information repository in a notice immediately
   following the copyright notice that applies to the Original Work.

   (( 4) ))??
   Exclusions From License Grant. Nothing in this License shall be deemed to
   grant any rights to trademarks, copyrights, patents, trade secrets or any
   other intellectual property of Licensor except as expressly stated herein. No
   patent license is granted to make, use, sell or offer to sell embodiments of
   any patent claims other than the Licensed Claims defined in Section 2. No
   right is granted to the trademarks of Licensor even if such marks are
   included in the Original Work. Nothing in this License shall be interpreted
   to prohibit Licensor from licensing under different terms from this License
   any Original Work that Licensor otherwise would have a right to license.

   (( 5) ))??
   External Deployment. The term "External Deployment" means the use or
   distribution of the Original Work or Derivative Works in any way such that
   the Original Work or Derivative Works may be used by anyone other than You,
   whether the Original Work or Derivative Works are distributed to those
   persons or made available as an application intended for use over a computer
   network. As an express condition for the grants of license hereunder, You
   agree that any External Deployment by You of a Derivative Work shall be
   deemed a distribution and shall be licensed to all under the terms of this
   License, as prescribed in section 1(c) herein.

   (( 6) ))??
   Attribution Rights. You must retain, in the Source Code of any Derivative
   Works that You create, all copyright, patent or trademark notices from the
   Source Code of the Original Work, as well as any notices of licensing and any
   descriptive text identified therein as an "Attribution Notice." You must
   cause the Source Code for any Derivative Works that You create to carry a
   prominent Attribution Notice reasonably calculated to inform recipients that
   You have modified the Original Work.

   (( 7) ))??
   Warranty and Disclaimer of Warranty. Licensor warrants that the copyright in
   and to the Original Work is owned by the Licensor or that the Original Work
   is distributed by Licensor under a valid current license from the copyright
   owner. Except as expressly stated in the immediately proceeding sentence, the
   Original Work is provided under this License on an "AS IS" BASIS and WITHOUT
   WARRANTY, either express or implied, including, without limitation, the
   warranties of NON-INFRINGEMENT, MERCHANTABILITY or FITNESS FOR A PARTICULAR
   PURPOSE. THE ENTIRE RISK AS TO THE QUALITY OF THE ORIGINAL WORK IS WITH YOU.
   This DISCLAIMER OF WARRANTY constitutes an essential part of this License. No
   license to Original Work is granted hereunder except under this disclaimer.

   (( 8) ))??
   Limitation of Liability. Under no circumstances and under no legal theory,
   whether in tort (including negligence), contract, or otherwise, shall the
   Licensor be liable to any person for any direct, indirect, special,
   incidental, or consequential damages of any character arising as a result of
   this License or the use of the Original Work including, without limitation,
   damages for loss of goodwill, work stoppage, computer failure or malfunction,
   or any and all other commercial damages or losses. This limitation of
   liability shall not apply to liability for death or personal injury resulting
   from Licensor's negligence to the extent applicable law prohibits such
   limitation. Some jurisdictions do not allow the exclusion or limitation of
   incidental or consequential damages, so this exclusion and limitation may not
   apply to You.

   (( 9) ))??
   Acceptance and Termination. If You distribute copies of the Original Work or
   a Derivative Work, You must make a reasonable effort under the circumstances
   to obtain the express and volitional assent of recipients to the terms of
   this License. Nothing else but this License (or another written agreement
   between Licensor and You) grants You permission to create Derivative Works
   based upon the Original Work or to exercise any of the rights granted in
   Sections 1 herein, and any attempt to do so except under the terms of this
   License (or another written agreement between Licensor and You) is expressly
   prohibited by U.S. copyright law, the equivalent laws of other countries, and
   by international treaty. Therefore, by exercising any of the rights granted
   to You in Sections 1 herein, You indicate Your acceptance of this License and
   all of its terms and conditions. This License shall terminate immediately and
   you may no longer exercise any of the rights granted to You by this License
   upon Your failure to honor the proviso in Section 1(c) herein.

   (( 10) ))??
   Mutual Termination for Patent Action. This License shall terminate
   automatically and You may no longer exercise any of the rights granted to You
   by this License if You file a lawsuit in any court alleging that any OSI
   Certified open source software that is licensed under any license containing
   this "Mutual Termination for Patent Action" clause infringes any patent
   claims that are essential to use that software.

   (( 11) ))??
   Jurisdiction, Venue and Governing Law. Any action or suit relating to this
   License may be brought only in the courts of a jurisdiction wherein the
   Licensor resides or in which Licensor conducts its primary business, and
   under the laws of that jurisdiction excluding its conflict-of-law provisions.
   The application of the United Nations Convention on Contracts for the
   International Sale of Goods is expressly excluded. Any use of the Original
   Work outside the scope of this License or after its termination shall be
   subject to the requirements and penalties of the U.S. Copyright Act, 17
   U.S.C. å¤ 101 et seq., the equivalent laws of other countries, and
   international treaty. This section shall survive the termination of this
   License.

   (( 12) ))??
   Attorneys Fees. In any action to enforce the terms of this License or seeking
   damages relating thereto, the prevailing party shall be entitled to recover
   its costs and expenses, including, without limitation, reasonable attorneys'
   fees and costs incurred in connection with such action, including any appeal
   of such action. This section shall survive the termination of this License.

   (( 13) ))??
   Miscellaneous. This License represents the complete agreement concerning the
   subject matter hereof. If any provision of this License is held to be
   unenforceable, such provision shall be reformed only to the extent necessary
   to make it enforceable.

   (( 14) ))??
   Definition of "You" in This License. "You" throughout this License, whether
   in upper or lower case, means an individual or a legal entity exercising
   rights under, and complying with all of the terms of, this License. For legal
   entities, "You" includes any entity that controls, is controlled by, or is
   under common control with you. For purposes of this definition, "control"
   means (i) the power, direct or indirect, to cause the direction or management
   of such entity, whether by contract or otherwise, or (ii) ownership of fifty
   percent (50%) or more of the outstanding shares, or (iii) beneficial
   ownership of such entity.

   (( 15) ))??
   Right to Use. You may use the Original Work in all ways not otherwise
   restricted or conditioned by this License or by law, and Licensor promises
   not to interfere with or be responsible for such uses by You.

This license is Copyright (C) 2002 Lawrence E. Rosen. All rights reserved.
Permission is hereby granted to copy and distribute this license without
modification. This license may not be modified without the express written
permission of its copyright owner.
//**
copyleft-next 0.3.0
https://spdx.org/licenses/copyleft-next-0.3.0.json
https://github.com/copyleft-next/copyleft-next/blob/master/Releases/copyleft-next-0.3.0
**//

(( copyleft-next 0.3.0 ("this License")

Release date: 2013-05-16 ))??

   (( 1. ))??
   License Grants; No Trademark License

   Subject to the terms of this License, I grant You:

      (( a) ))??
      A non-exclusive, worldwide, perpetual, royalty-free, irrevocable copyright
      license, to reproduce, Distribute, prepare derivative works of, publicly
      perform and publicly display My Work.

      (( b) ))??
      A non-exclusive, worldwide, perpetual, royalty-free, irrevocable patent
      license under Licensed Patents to make, have made, use, sell, offer for
      sale, and import Covered Works.

   This License does not grant any rights in My name, trademarks, service marks,
   or logos.

   (( 2. ))??
   Distribution: General Conditions

   You may Distribute Covered Works, provided that You (i) inform recipients how
   they can obtain a copy of this License; (ii) satisfy the applicable
   conditions of sections 3 through 6; and (iii) preserve all Legal Notices
   contained in My Work (to the extent they remain pertinent). "Legal Notices"
   means copyright notices, license notices, license texts, and author
   attributions, but does not include logos, other graphical images, trademarks
   or trademark legends.

   (( 3. ))??
   Conditions for Distributing Derived Works; Outbound GPL Compatibility

   If You Distribute a Derived Work, You must license the entire Derived Work as
   a whole under this License, with prominent notice of such licensing. This
   condition may not be avoided through such means as separate Distribution of
   portions of the Derived Work. You may additionally license the Derived Work
   under the GPL, so that the recipient may further Distribute the Derived Work
   under either this License or the GPL.

   (( 4. ))??
   Condition Against Further Restrictions; Inbound License Compatibility

   When Distributing a Covered Work, You may not impose further restrictions on
   the exercise of rights in the Covered Work granted under this License. This
   condition is not excused merely because such restrictions result from Your
   compliance with conditions or obligations extrinsic to this License (such as
   a court order or an agreement with a third party).

   However, You may Distribute a Covered Work incorporating material governed by
   a license that is both OSI-Approved and FSF-Free as of the release date of
   this License, provided that Your Distribution complies with such other
   license.

   (( 5. ))??
   Conditions for Distributing Object Code

   You may Distribute an Object Code form of a Covered Work, provided that you
   accompany the Object Code with a URL through which the Corresponding Source
   is made available, at no charge, by some standard or customary means of
   providing network access to source code.

   If you Distribute the Object Code in a physical product or tangible storage
   medium ("Product"), the Corresponding Source must be available through such
   URL for two years from the date of Your most recent Distribution of the
   Object Code in the Product. However, if the Product itself contains or is
   accompanied by the Corresponding Source (made available in a customarily
   accessible manner), You need not also comply with the first paragraph of this
   section.

   Each recipient of the Covered Work from You is an intended third-party
   beneficiary of this License solely as to this section 5, with the right to
   enforce its terms.

   (( 6. ))??
   Symmetrical Licensing Condition for Upstream Contributions

   If You Distribute a work to Me specifically for inclusion in or modification
   of a Covered Work (a "Patch"), and no explicit licensing terms apply to the
   Patch, You license the Patch under this License, to the extent of Your
   copyright in the Patch. This condition does not negate the other conditions
   of this License, if applicable to the Patch.

   (( 7. ))??
   Nullification of Copyleft/Proprietary Dual Licensing

   If I offer to license, for a fee, a Covered Work under terms other than a
   license that is OSI-Approved or FSF-Free as of the release date of this
   License or a numbered version of copyleft-next released by the Copyleft-Next
   Project, then the license I grant You under section 1 is no longer subject to
   the conditions in sections 2 through 5.

   (( 8. ))??
   Copyleft Sunset

   The conditions in sections 2 through 5 no longer apply once fifteen years
   have elapsed from the date of My first Distribution of My Work under this
   License.

   (( 9. ))??
   Pass-Through

   When You Distribute a Covered Work, the recipient automatically receives a
   license to My Work from Me, subject to the terms of this License.

   (( 10. ))??
   Termination

   Your license grants under section 1 are automatically terminated if You

      (( a) ))??
      fail to comply with the conditions of this License, unless You cure such
      noncompliance within thirty days after becoming aware of it, or

      (( b) ))??
      initiate a patent infringement litigation claim (excluding declaratory
      judgment actions, counterclaims, and cross-claims) alleging that any part
      of My Work directly or indirectly infringes any patent.

   Termination of Your license grants extends to all copies of Covered Works You
   subsequently obtain. Termination does not terminate the rights of those who
   have received copies or rights from You subject to this License.

   To the extent permission to make copies of a Covered Work is necessary merely
   for running it, such permission is not terminable.

   (( 11. ))??
   Later License Versions

   The Copyleft-Next Project may release new versions of copyleft-next,
   designated by a distinguishing version number ("Later Versions"). Unless I
   explicitly remove the option of Distributing Covered Works under Later
   Versions, You may Distribute Covered Works under any Later Version.

   (( 12. ))??
   No Warranty

   My Work is provided "as-is", without warranty. You bear the risk of using it.
   To the extent permitted by applicable law, each Distributor of My Work
   excludes the implied warranties of title, merchantability, fitness for a
   particular purpose and non-infringement.

   (( 13. ))??
   Limitation of Liability

   To the extent permitted by applicable law, in no event will any Distributor
   of My Work be liable to You for any damages whatsoever, whether direct,
   indirect, special, incidental, or consequential damages, whether arising
   under contract, tort (including negligence), or otherwise, even where the
   Distributor knew or should have known about the possibility of such damages.

   (( 14. ))??
   Severability

   The invalidity or unenforceability of any provision of this License does not
   affect the validity or enforceability of the remainder of this License. Such
   provision is to be reformed to the minimum extent necessary to make it valid
   and enforceable.

   (( 15. ))??
   Definitions

   "Copyleft-Next Project" means the project that maintains the source code
   repository at <https:/gitorious.org/copyleft-next/> as of the release date of
   this License.

   "Corresponding Source" of a Covered Work in Object Code form means (i) the
   Source Code form of the Covered Work; (ii) all scripts, instructions and
   similar information that are reasonably necessary for a skilled developer to
   generate such Object Code from the Source Code provided under (i); and (iii)
   a list clearly identifying all Separate Works (other than those provided in
   compliance with (ii) that were specifically used in building and (if
   applicable) installing the Covered Work (for example, a specified proprietary
   compiler including its version number). Corresponding Source must be
   machine-readable.

   "Covered Work" means My Work or a Derived Work.

   "Derived Work" means a work of authorship that copies from, modifies, adapts,
   is based on, is a derivative work of, transforms, translates or contains all
   or part of My Work, such that copyright permission is required. The following
   are not Derived Works: (i) Mere Aggregation; (ii) a mere reproduction of My
   Work; and (iii) if My Work fails to explicitly state an expectation
   otherwise, a work that merely makes reference to My Work.

   "Distribute" means to distribute, transfer or make a copy available to
   someone else, such that copyright permission is required.

   "Distributor" means Me and anyone else who Distributes a Covered Work.

   "FSF-Free" means classified as 'free' by the Free Software Foundation.

   "GPL" means a version of the GNU General Public License or the GNU Affero
   General Public License.

   "I"/"Me"/"My" refers to the individual or legal entity that places My Work
   under this License. "You"/"Your" refers to the individual or legal entity
   exercising rights in My Work under this License. A legal entity includes each
   entity that controls, is controlled by, or is under common control with such
   legal entity. "Control" means (a) the power to direct the actions of such
   legal entity, whether by contract or otherwise, or (b) ownership of more than
   fifty percent of the outstanding shares or beneficial ownership of such legal
   entity.

   "Licensed Patents" means all patent claims licensable royalty-free by Me, now
   or in the future, that are necessarily infringed by making, using, or selling
   My Work, and excludes claims that would be infringed only as a consequence of
   further modification of My Work.

   "Mere Aggregation" means an aggregation of a Covered Work with a Separate
   Work.

   "My Work" means the particular work of authorship I license to You under this
   License.

   "Object Code" means any form of a work that is not Source Code.

   "OSI-Approved" means approved as 'Open Source' by the Open Source
   Initiative.

   "Separate Work" means a work that is separate from and independent of a
   particular Covered Work and is not by its nature an extension or enhancement
   of the Covered Work, and/or a runtime library, standard library or similar
   component that is used to generate an Object Code form of a Covered Work.

   "Source Code" means the preferred form of a work for making modifications to
   it.
//**
copyleft-next 0.3.1
https://spdx.org/licenses/copyleft-next-0.3.1.json
https://github.com/copyleft-next/copyleft-next/blob/master/Releases/copyleft-next-0.3.1
**//

(( copyleft-next 0.3.1 ("this License")

Release date: 2016-04-29 ))??

   (( 1. ))??
   License Grants; No Trademark License

   Subject to the terms of this License, I grant You:

      (( a) ))??
      A non-exclusive, worldwide, perpetual, royalty-free, irrevocable copyright
      license, to reproduce, Distribute, prepare derivative works of, publicly
      perform and publicly display My Work.

      (( b) ))??
      A non-exclusive, worldwide, perpetual, royalty-free, irrevocable patent
      license under Licensed Patents to make, have made, use, sell, offer for
      sale, and import Covered Works.

   This License does not grant any rights in My name, trademarks, service marks,
   or logos.

   (( 2. ))??
   Distribution: General Conditions

   You may Distribute Covered Works, provided that You (i) inform recipients how
   they can obtain a copy of this License; (ii) satisfy the applicable
   conditions of sections 3 through 6; and (iii) preserve all Legal Notices
   contained in My Work (to the extent they remain pertinent). "Legal Notices"
   means copyright notices, license notices, license texts, and author
   attributions, but does not include logos, other graphical images, trademarks
   or trademark legends.

   (( 3. ))??
   Conditions for Distributing Derived Works; Outbound GPL Compatibility

   If You Distribute a Derived Work, You must license the entire Derived Work as
   a whole under this License, with prominent notice of such licensing. This
   condition may not be avoided through such means as separate Distribution of
   portions of the Derived Work.

   If the Derived Work includes material licensed under the GPL, You may instead
   license the Derived Work under the GPL.

   (( 4. ))??
   Condition Against Further Restrictions; Inbound License Compatibility

   When Distributing a Covered Work, You may not impose further restrictions on
   the exercise of rights in the Covered Work granted under this License. This
   condition is not excused merely because such restrictions result from Your
   compliance with conditions or obligations extrinsic to this License (such as
   a court order or an agreement with a third party).

   However, You may Distribute a Covered Work incorporating material governed by
   a license that is both OSI-Approved and FSF-Free as of the release date of
   this License, provided that compliance with such other license would not
   conflict with any conditions stated in other sections of this License.

   (( 5. ))??
   Conditions for Distributing Object Code

   You may Distribute an Object Code form of a Covered Work, provided that you
   accompany the Object Code with a URL through which the Corresponding Source
   is made available, at no charge, by some standard or customary means of
   providing network access to source code.

   If you Distribute the Object Code in a physical product or tangible storage
   medium ("Product"), the Corresponding Source must be available through such
   URL for two years from the date of Your most recent Distribution of the
   Object Code in the Product. However, if the Product itself contains or is
   accompanied by the Corresponding Source (made available in a customarily
   accessible manner), You need not also comply with the first paragraph of this
   section.

   Each direct and indirect recipient of the Covered Work from You is an
   intended third-party beneficiary of this License solely as to this section 5,
   with the right to enforce its terms.

   (( 6. ))??
   Symmetrical Licensing Condition for Upstream Contributions

   If You Distribute a work to Me specifically for inclusion in or modification
   of a Covered Work (a "Patch"), and no explicit licensing terms apply to the
   Patch, You license the Patch under this License, to the extent of Your
   copyright in the Patch. This condition does not negate the other conditions
   of this License, if applicable to the Patch.

   (( 7. ))??
   Nullification of Copyleft/Proprietary Dual Licensing

   If I offer to license, for a fee, a Covered Work under terms other than a
   license that is OSI-Approved or FSF-Free as of the release date of this
   License or a numbered version of copyleft-next released by the Copyleft-Next
   Project, then the license I grant You under section 1 is no longer subject to
   the conditions in sections 3 through 5.

   (( 8. ))??
   Copyleft Sunset

   The conditions in sections 3 through 5 no longer apply once fifteen years
   have elapsed from the date of My first Distribution of My Work under this
   License.

   (( 9. ))??
   Pass-Through

   When You Distribute a Covered Work, the recipient automatically receives a
   license to My Work from Me, subject to the terms of this License.

   (( 10. ))??
   Termination

   Your license grants under section 1 are automatically terminated if You

      (( a) ))??
      fail to comply with the conditions of this License, unless You cure such
      noncompliance within thirty days after becoming aware of it, or

      (( b) ))??
      initiate a patent infringement litigation claim (excluding declaratory
      judgment actions, counterclaims, and cross-claims) alleging that any part
      of My Work directly or indirectly infringes any patent.

   Termination of Your license grants extends to all copies of Covered Works You
   subsequently obtain. Termination does not terminate the rights of those who
   have received copies or rights from You subject to this License.

   To the extent permission to make copies of a Covered Work is necessary merely
   for running it, such permission is not terminable.

   (( 11. ))??
   Later License Versions

   The Copyleft-Next Project may release new versions of copyleft-next,
   designated by a distinguishing version number ("Later Versions"). Unless I
   explicitly remove the option of Distributing Covered Works under Later
   Versions, You may Distribute Covered Works under any Later Version.

   (( 12. ))??
   No Warranty

   My Work is provided "as-is", without warranty. You bear the risk of using it.
   To the extent permitted by applicable law, each Distributor of My Work
   excludes the implied warranties of title, merchantability, fitness for a
   particular purpose and non-infringement.

   (( 13. ))??
   Limitation of Liability

   To the extent permitted by applicable law, in no event will any Distributor
   of My Work be liable to You for any damages whatsoever, whether direct,
   indirect, special, incidental, or consequential damages, whether arising
   under contract, tort (including negligence), or otherwise, even where the
   Distributor knew or should have known about the possibility of such damages.

   (( 14. ))??
   Severability

   The invalidity or unenforceability of any provision of this License does not
   affect the validity or enforceability of the remainder of this License. Such
   provision is to be reformed to the minimum extent necessary to make it valid
   and enforceable.

   (( 15. ))??
   Definitions

   "Copyleft-Next Project" means the project that maintains the source code
   repository at <https:/github.com/copyleft-next/copyleft-next.git/> as of the
   release date of this License.

   "Corresponding Source" of a Covered Work in Object Code form means (i) the
   Source Code form of the Covered Work; (ii) all scripts, instructions and
   similar information that are reasonably necessary for a skilled developer to
   generate such Object Code from the Source Code provided under (i); and (iii)
   a list clearly identifying all Separate Works (other than those provided in
   compliance with (ii) that were specifically used in building and (if
   applicable) installing the Covered Work (for example, a specified proprietary
   compiler including its version number). Corresponding Source must be
   machine-readable.

   "Covered Work" means My Work or a Derived Work.

   "Derived Work" means a work of authorship that copies from, modifies, adapts,
   is based on, is a derivative work of, transforms, translates or contains all
   or part of My Work, such that copyright permission is required. The following
   are not Derived Works: (i) Mere Aggregation; (ii) a mere reproduction of My
   Work; and (iii) if My Work fails to explicitly state an expectation
   otherwise, a work that merely makes reference to My Work.

   "Distribute" means to distribute, transfer or make a copy available to
   someone else, such that copyright permission is required.

   "Distributor" means Me and anyone else who Distributes a Covered Work.

   "FSF-Free" means classified as 'free' by the Free Software Foundation.

   "GPL" means a version of the GNU General Public License or the GNU Affero
   General Public License.

   "I"/"Me"/"My" refers to the individual or legal entity that places My Work
   under this License. "You"/"Your" refers to the individual or legal entity
   exercising rights in My Work under this License. A legal entity includes each
   entity that controls, is controlled by, or is under common control with such
   legal entity. "Control" means (a) the power to direct the actions of such
   legal entity, whether by contract or otherwise, or (b) ownership of more than
   fifty percent of the outstanding shares or beneficial ownership of such legal
   entity.

   "Licensed Patents" means all patent claims licensable royalty-free by Me, now
   or in the future, that are necessarily infringed by making, using, or selling
   My Work, and excludes claims that would be infringed only as a consequence of
   further modification of My Work.

   "Mere Aggregation" means an aggregation of a Covered Work with a Separate
   Work.

   "My Work" means the particular work of authorship I license to You under this
   License.

   "Object Code" means any form of a work that is not Source Code.

   "OSI-Approved" means approved as 'Open Source' by the Open Source
   Initiative.

   "Separate Work" means a work that is separate from and independent of a
   particular Covered Work and is not by its nature an extension or enhancement
   of the Covered Work, and/or a runtime library, standard library or similar
   component that is used to generate an Object Code form of a Covered Work.

   "Source Code" means the preferred form of a work for making modifications to
   it.
//**
CC-BY-ND-1.0
https://creativecommons.org/licenses/by-nd/1.0
**//

((Creative Commons))??

Creative Commons

Attribution-NoDerivs 1.0

((
CREATIVE COMMONS CORPORATION IS NOT A LAW FIRM AND DOES NOT PROVIDE
LEGAL
SERVICES. DISTRIBUTION OF THIS DRAFT LICENSE DOES NOT CREATE AN
ATTORNEY-CLIENT RELATIONSHIP. CREATIVE COMMONS PROVIDES THIS INFORMATION
ON
AN "AS-IS" BASIS. CREATIVE COMMONS MAKES NO WARRANTIES REGARDING THE
INFORMATION PROVIDED, AND DISCLAIMS LIABILITY FOR DAMAGES RESULTING
FROM
ITS USE.
))??

((License))??

THE WORK (AS DEFINED BELOW) IS PROVIDED UNDER THE TERMS OF THIS CREATIVE COMMONS
PUBLIC LICENSE ("CCPL" OR "LICENSE").  THE WORK IS PROTECTED BY COPYRIGHT AND/OR
OTHER APPLICABLE LAW.  ANY USE OF THE WORK OTHER THAN AS AUTHORIZED UNDER THIS
LICENSE IS PROHIBITED.

BY EXERCISING ANY RIGHTS TO THE WORK PROVIDED HERE, YOU ACCEPT AND AGREE TO BE
BOUND BY THE TERMS OF THIS LICENSE.  THE LICENSOR GRANTS YOU THE RIGHTS
CONTAINED HERE IN CONSIDERATION OF YOUR ACCEPTANCE OF SUCH TERMS AND CONDITIONS.

1. Definitions

__1__
"Collective Work" means a work, such as a periodical issue, anthology or
encyclopedia, in which the Work in its entirety in unmodified form, along with a
number of other contributions, constituting separate and independent works in
themselves, are assembled into a collective whole.  A work that constitutes a
Collective Work will not be considered a Derivative Work (as defined below) for
the purposes of this License.

__1__
"Derivative Work" means a work based upon the Work or upon the Work and other
pre-existing works, such as a translation, musical arrangement, dramatization,
fictionalization, motion picture version, sound recording, art reproduction,
abridgment, condensation, or any other form in which the Work may be recast,
transformed, or adapted, except that a work that constitutes a Collective Work
will not be considered a Derivative Work for the purpose of this License.

__1__
"Licensor" means the individual or entity that offers the Work under the terms
of this License.

__1__
"Original Author" means the individual or entity who created the Work.

__1__
"Work" means the copyrightable work of authorship offered under the terms of
this License.

__1__
"You" means an individual or entity exercising rights under this License who has
not previously violated the terms of this License with respect to the Work, or
who has received express permission from the Licensor to exercise rights under
this License despite a previous violation.

2. Fair Use Rights. Nothing in this license is intended to reduce, limit, or
restrict any rights arising from fair use, first sale or other limitations on
the exclusive rights of the copyright owner under copyright law or other
applicable laws.

3. License Grant.  Subject to the terms and conditions of this License, Licensor
hereby grants You a worldwide, royalty-free, non-exclusive, perpetual (for the
duration of the applicable copyright) license to exercise the rights in the Work
as stated below:

__1__
to reproduce the Work, to incorporate the Work into one or more Collective
Works, and to reproduce the Work as incorporated in the Collective Works;

__1__
to distribute copies or phonorecords of, display publicly, perform publicly, and
perform publicly by means of a digital audio transmission the Work including as
incorporated in Collective Works;

The above rights may be exercised in all media and formats whether now known or
hereafter devised.  The above rights include the right to make such
modifications as are technically necessary to exercise the rights in other media
and formats.  All rights not expressly granted by Licensor are hereby reserved.

4. Restrictions. The license granted in Section 3 above is expressly made
subject to and limited by the following restrictions:

__1__
You may distribute, publicly display, publicly perform, or publicly digitally
perform the Work only under the terms of this License, and You must include a
copy of, or the Uniform Resource Identifier for, this License with every copy or
phonorecord of the Work You distribute, publicly display, publicly perform, or
publicly digitally perform.  You may not offer or impose any terms on the Work
that alter or restrict the terms of this License or the recipients' exercise of
the rights granted hereunder.  You may not sublicense the Work.  You must keep
intact all notices that refer to this License and to the disclaimer of
warranties. You may not distribute, publicly display, publicly perform, or
publicly digitally perform the Work with any technological measures that control
access or use of the Work in a manner inconsistent with the terms of this
License Agreement.  The above applies to the Work as incorporated in a
Collective Work, but this does not require the Collective Work apart from the
Work itself to be made subject to the terms of this License. If You create a
Collective Work, upon notice from any Licensor You must, to the extent
practicable, remove from the Collective Work any reference to such Licensor or
the Original Author, as requested.

__1__
If you distribute, publicly display, publicly perform, or publicly digitally
perform the Work or any Collective Works, You must keep intact all copyright
notices for the Work and give the Original Author credit reasonable to the
medium or means You are utilizing by conveying the name (or pseudonym if
applicable) of the Original Author if supplied; the title of the Work if
supplied.  Such credit may be implemented in any reasonable manner; provided,
however, that in the case of a Collective Work, at a minimum such credit will
appear where any other comparable authorship credit appears and in a manner at
least as prominent as such other comparable authorship credit.

5. Representations, Warranties and Disclaimer

__1__
By offering the Work for public release under this License, Licensor represents
and warrants that, to the best of Licensor's knowledge after reasonable
inquiry:

__1__
Licensor has secured all rights in the Work necessary to grant the license
rights hereunder and to permit the lawful exercise of the rights granted
hereunder without You having any obligation to pay any royalties, compulsory
license fees, residuals or any other payments;

__1__
The Work does not infringe the copyright, trademark, publicity rights, common
law rights or any other right of any third party or constitute defamation,
invasion of privacy or other tortious injury to any third party.

__1__
EXCEPT AS EXPRESSLY STATED IN THIS LICENSE OR OTHERWISE AGREED IN WRITING OR
REQUIRED BY APPLICABLE LAW, THE WORK IS LICENSED ON AN "AS IS" BASIS, WITHOUT
WARRANTIES OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT LIMITATION,
ANY WARRANTIES REGARDING THE CONTENTS OR ACCURACY OF THE WORK.

6. Limitation on Liability.  EXCEPT TO THE EXTENT REQUIRED BY APPLICABLE LAW,
AND EXCEPT FOR DAMAGES ARISING FROM LIABILITY TO A THIRD PARTY RESULTING FROM
BREACH OF THE WARRANTIES IN SECTION 5, IN NO EVENT WILL LICENSOR BE LIABLE TO
YOU ON ANY LEGAL THEORY FOR ANY SPECIAL, INCIDENTAL, CONSEQUENTIAL, PUNITIVE OR
EXEMPLARY DAMAGES ARISING OUT OF THIS LICENSE OR THE USE OF THE WORK, EVEN IF
LICENSOR HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

7. Termination

__1__
This License and the rights granted hereunder will terminate automatically upon
any breach by You of the terms of this License. Individuals or entities who have
received Collective Works from You under this License, however, will not have
their licenses terminated provided such individuals or entities remain in full
compliance with those licenses. Sections 1, 2, 5, 6, 7, and 8 will survive any
termination of this License.

__1__
Subject to the above terms and conditions, the license granted here is perpetual
(for the duration of the applicable copyright in the Work).  Notwithstanding the
above, Licensor reserves the right to release the Work under different license
terms or to stop distributing the Work at any time; provided, however that any
such election will not serve to withdraw this License (or any other license that
has been, or is required to be, granted under the terms of this License), and
this License will continue in full force and effect unless terminated as stated
above.

8. Miscellaneous

__1__
Each time You distribute or publicly digitally perform the Work or a Collective
Work, the Licensor offers to the recipient a license to the Work on the same
terms and conditions as the license granted to You under this License.

__1__
If any provision of this License is invalid or unenforceable under applicable
law, it shall not affect the validity or enforceability of the remainder of the
terms of this License, and without further action by the parties to this
agreement, such provision shall be reformed to the minimum extent necessary to
make such provision valid and enforceable.

__1__
No term or provision of this License shall be deemed waived and no breach
consented to unless such waiver or consent shall be in writing and signed by the
party to be charged with such waiver or consent.

__1__
This License constitutes the entire agreement between the parties with respect
to the Work licensed here.  There are no understandings, agreements or
representations with respect to the Work not specified here.  Licensor shall not
be bound by any additional provisions that may appear in any communication from
You. This License may not be modified without the mutual written agreement of
the Licensor and You.

((
Creative Commons is not a party to this License, and makes no warranty
whatsoever in connection with the Work.  Creative Commons will not be liable to
You or any party on any legal theory for any damages whatsoever, including
without limitation any general, special, incidental or consequential damages
arising in connection to this license.  Notwithstanding the foregoing two (2)
sentences, if Creative Commons has expressly identified itself as the Licensor
hereunder, it shall have all rights and obligations of Licensor.

Except for the limited purpose of indicating to the public that the Work is
licensed under the CCPL, neither party will use the trademark "Creative Commons"
or any related trademark or logo of Creative Commons without the prior written
consent of Creative Commons.  Any permitted use will be in compliance with
Creative Commons' then-current trademark usage guidelines, as may be published
on its website or otherwise made available upon request from time to time.

Creative Commons may be contacted at https://creativecommons.org/.
))??
//**
Open Software License 2.0
https://spdx.org/licenses/OSL-2.0.json
http://web.archive.org/web/20041020171434/http://www.rosenlaw.com/osl2.0.html
**//

((
(( The ))??
Open Software License v. 2.0 ))??

This Open Software License (the "License") applies to any original work of
authorship (the "Original Work") whose owner (the "Licensor") has placed the
following notice immediately following the copyright notice for the Original
Work:

Licensed under the Open Software License version 2.0

   (( 1) ))??
   Grant of Copyright License. Licensor hereby grants You a world-wide,
   royalty-free, non-exclusive, perpetual, sublicenseable license to do the
   following:

      (( a) ))??
      to reproduce the Original Work in copies;

      (( b) ))??
      to prepare derivative works ("Derivative Works") based upon the Original
      Work;

      (( c) ))??
      to distribute copies of the Original Work and Derivative Works to the
      public, with the proviso that copies of Original Work or Derivative Works
      that You distribute shall be licensed under the Open Software License;

      (( d) ))??
      to perform the Original Work publicly; and

      (( e) ))??
      to display the Original Work publicly.

   (( 2) ))??
   Grant of Patent License. Licensor hereby grants You a world-wide,
   royalty-free, non-exclusive, perpetual, sublicenseable license, under patent
   claims owned or controlled by the Licensor that are embodied in the Original
   Work as furnished by the Licensor, to make, use, sell and offer for sale the
   Original Work and Derivative Works.

   (( 3) ))??
   Grant of Source Code License. The term "Source Code" means the preferred form
   of the Original Work for making modifications to it and all available
   documentation describing how to modify the Original Work. Licensor hereby
   agrees to provide a machine-readable copy of the Source Code of the Original
   Work along with each copy of the Original Work that Licensor distributes.
   Licensor reserves the right to satisfy this obligation by placing a
   machine-readable copy of the Source Code in an information repository
   reasonably calculated to permit inexpensive and convenient access by You for
   as long as Licensor continues to distribute the Original Work, and by
   publishing the address of that information repository in a notice immediately
   following the copyright notice that applies to the Original Work.

   (( 4) ))??
   Exclusions From License Grant. Neither the names of Licensor, nor the names
   of any contributors to the Original Work, nor any of their trademarks or
   service marks, may be used to endorse or promote products derived from this
   Original Work without express prior written permission of the Licensor.
   Nothing in this License shall be deemed to grant any rights to trademarks,
   copyrights, patents, trade secrets or any other intellectual property of
   Licensor except as expressly stated herein. No patent license is granted to
   make, use, sell or offer to sell embodiments of any patent claims other than
   the licensed claims defined in Section 2. No right is granted to the
   trademarks of Licensor even if such marks are included in the Original Work.
   Nothing in this License shall be interpreted to prohibit Licensor from
   licensing under different terms from this License any Original Work that
   Licensor otherwise would have a right to license.

   (( 5) ))??
   External Deployment. The term "External Deployment" means the use or
   distribution of the Original Work or Derivative Works in any way such that
   the Original Work or Derivative Works may be used by anyone other than You,
   whether the Original Work or Derivative Works are distributed to those
   persons or made available as an application intended for use over a computer
   network. As an express condition for the grants of license hereunder, You
   agree that any External Deployment by You of a Derivative Work shall be
   deemed a distribution and shall be licensed to all under the terms of this
   License, as prescribed in section 1(c) herein.

   (( 6) ))??
   Attribution Rights. You must retain, in the Source Code of any Derivative
   Works that You create, all copyright, patent or trademark notices from the
   Source Code of the Original Work, as well as any notices of licensing and any
   descriptive text identified therein as an "Attribution Notice." You must
   cause the Source Code for any Derivative Works that You create to carry a
   prominent Attribution Notice reasonably calculated to inform recipients that
   You have modified the Original Work.

   (( 7) ))??
   Warranty of Provenance and Disclaimer of Warranty. Licensor warrants that the
   copyright in and to the Original Work and the patent rights granted herein by
   Licensor are owned by the Licensor or are sublicensed to You under the terms
   of this License with the permission of the contributor(s) of those copyrights
   and patent rights. Except as expressly stated in the immediately proceeding
   sentence, the Original Work is provided under this License on an "AS IS"
   BASIS and WITHOUT WARRANTY, either express or implied, including, without
   limitation, the warranties of NON-INFRINGEMENT, MERCHANTABILITY or FITNESS
   FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY OF THE ORIGINAL
   WORK IS WITH YOU. This DISCLAIMER OF WARRANTY constitutes an essential part
   of this License. No license to Original Work is granted hereunder except
   under this disclaimer.

   (( 8) ))??
   Limitation of Liability. Under no circumstances and under no legal theory,
   whether in tort (including negligence), contract, or otherwise, shall the
   Licensor be liable to any person for any direct, indirect, special,
   incidental, or consequential damages of any character arising as a result of
   this License or the use of the Original Work including, without limitation,
   damages for loss of goodwill, work stoppage, computer failure or malfunction,
   or any and all other commercial damages or losses. This limitation of
   liability shall not apply to liability for death or personal injury resulting
   from Licensor's negligence to the extent applicable law prohibits such
   limitation. Some jurisdictions do not allow the exclusion or limitation of
   incidental or consequential damages, so this exclusion and limitation may not
   apply to You.

   (( 9) ))??
   Acceptance and Termination. If You distribute copies of the Original Work or
   a Derivative Work, You must make a reasonable effort under the circumstances
   to obtain the express assent of recipients to the terms of this License.
   Nothing else but this License (or another written agreement between Licensor
   and You) grants You permission to create Derivative Works based upon the
   Original Work or to exercise any of the rights granted in Section 1 herein,
   and any attempt to do so except under the terms of this License (or another
   written agreement between Licensor and You) is expressly prohibited by U.S.
   copyright law, the equivalent laws of other countries, and by international
   treaty. Therefore, by exercising any of the rights granted to You in Section
   1 herein, You indicate Your acceptance of this License and all of its terms
   and conditions. This License shall terminate immediately and you may no
   longer exercise any of the rights granted to You by this License upon Your
   failure to honor the proviso in Section 1(c) herein.

   (( 10) ))??
   Termination for Patent Action. This License shall terminate automatically and
   You may no longer exercise any of the rights granted to You by this License
   as of the date You commence an action, including a cross-claim or
   counterclaim, for patent infringement (i) against Licensor with respect to a
   patent applicable to software or (ii) against any entity with respect to a
   patent applicable to the Original Work (but excluding combinations of the
   Original Work with other software or hardware).

   (( 11) ))??
   Jurisdiction, Venue and Governing Law. Any action or suit relating to this
   License may be brought only in the courts of a jurisdiction wherein the
   Licensor resides or in which Licensor conducts its primary business, and
   under the laws of that jurisdiction excluding its conflict-of-law provisions.
   The application of the United Nations Convention on Contracts for the
   International Sale of Goods is expressly excluded. Any use of the Original
   Work outside the scope of this License or after its termination shall be
   subject to the requirements and penalties of the U.S. Copyright Act, 17
   U.S.C. 101 et seq., the equivalent laws of other countries, and international
   treaty. This section shall survive the termination of this License.

   (( 12) ))??
   Attorneys Fees. In any action to enforce the terms of this License or seeking
   damages relating thereto, the prevailing party shall be entitled to recover
   its costs and expenses, including, without limitation, reasonable attorneys'
   fees and costs incurred in connection with such action, including any appeal
   of such action. This section shall survive the termination of this License.

   (( 13) ))??
   Miscellaneous. This License represents the complete agreement concerning the
   subject matter hereof. If any provision of this License is held to be
   unenforceable, such provision shall be reformed only to the extent necessary
   to make it enforceable.

   (( 14) ))??
   Definition of "You" in This License. "You" throughout this License, whether
   in upper or lower case, means an individual or a legal entity exercising
   rights under, and complying with all of the terms of, this License. For legal
   entities, "You" includes any entity that controls, is controlled by, or is
   under common control with you. For purposes of this definition, "control"
   means (i) the power, direct or indirect, to cause the direction or management
   of such entity, whether by contract or otherwise, or (ii) ownership of fifty
   percent (50%) or more of the outstanding shares, or (iii) beneficial
   ownership of such entity.

   (( 15) ))??
   Right to Use. You may use the Original Work in all ways not otherwise
   restricted or conditioned by this License or by law, and Licensor promises
   not to interfere with or be responsible for such uses by You.

This license is Copyright (C) 2003 Lawrence E. Rosen. All rights reserved.
Permission is hereby granted to copy and distribute this license without
modification. This license may not be modified without the express written
permission of its copyright owner.
//**
Open Software License 2.1
https://spdx.org/licenses/OSL-2.1.json
http://web.archive.org/web/20050212003940/http://www.rosenlaw.com/osl21.htm
https://opensource.org/licenses/OSL-2.1
**//

(( The Open Software Licensev. 2.1 ))??

This Open Software License (the "License") applies to any original work of
authorship (the "Original Work") whose owner (the "Licensor") has placed the
following notice immediately following the copyright notice for the Original
Work:

Licensed under the Open Software License version 2.1

   (( 1) ))??
   Grant of Copyright License. Licensor hereby grants You a world-wide,
   royalty-free, non-exclusive, perpetual, sublicenseable license to do the
   following:

      (( a) ))??
      to reproduce the Original Work in copies;

      (( b) ))??
      to prepare derivative works ("Derivative Works") based upon the Original
      Work;

      (( c) ))??
      to distribute copies of the Original Work and Derivative Works to the
      public, with the proviso that copies of Original Work or Derivative Works
      that You distribute shall be licensed under the Open Software License;

      (( d) ))??
      to perform the Original Work publicly; and

      (( e) ))??
      to display the Original Work publicly.

   (( 2) ))??
   Grant of Patent License. Licensor hereby grants You a world-wide,
   royalty-free, non-exclusive, perpetual, sublicenseable license, under patent
   claims owned or controlled by the Licensor that are embodied in the Original
   Work as furnished by the Licensor, to make, use, sell and offer for sale the
   Original Work and Derivative Works.

   (( 3) ))??
   Grant of Source Code License. The term "Source Code" means the preferred form
   of the Original Work for making modifications to it and all available
   documentation describing how to modify the Original Work. Licensor hereby
   agrees to provide a machine-readable copy of the Source Code of the Original
   Work along with each copy of the Original Work that Licensor distributes.
   Licensor reserves the right to satisfy this obligation by placing a
   machine-readable copy of the Source Code in an information repository
   reasonably calculated to permit inexpensive and convenient access by You for
   as long as Licensor continues to distribute the Original Work, and by
   publishing the address of that information repository in a notice immediately
   following the copyright notice that applies to the Original Work.

   (( 4) ))??
   Exclusions From License Grant. Neither the names of Licensor, nor the names
   of any contributors to the Original Work, nor any of their trademarks or
   service marks, may be used to endorse or promote products derived from this
   Original Work without express prior written permission of the Licensor.
   Nothing in this License shall be deemed to grant any rights to trademarks,
   copyrights, patents, trade secrets or any other intellectual property of
   Licensor except as expressly stated herein. No patent license is granted to
   make, use, sell or offer to sell embodiments of any patent claims other than
   the licensed claims defined in Section 2. No right is granted to the
   trademarks of Licensor even if such marks are included in the Original Work.
   Nothing in this License shall be interpreted to prohibit Licensor from
   licensing under different terms from this License any Original Work that
   Licensor otherwise would have a right to license.

   (( 5) ))??
   External Deployment. The term "External Deployment" means the use or
   distribution of the Original Work or Derivative Works in any way such that
   the Original Work or Derivative Works may be used by anyone other than You,
   whether the Original Work or Derivative Works are distributed to those
   persons or made available as an application intended for use over a computer
   network. As an express condition for the grants of license hereunder, You
   agree that any External Deployment by You of a Derivative Work shall be
   deemed a distribution and shall be licensed to all under the terms of this
   License, as prescribed in section 1(c) herein.

   (( 6) ))??
   Attribution Rights. You must retain, in the Source Code of any Derivative
   Works that You create, all copyright, patent or trademark notices from the
   Source Code of the Original Work, as well as any notices of licensing and any
   descriptive text identified therein as an "Attribution Notice." You must
   cause the Source Code for any Derivative Works that You create to carry a
   prominent Attribution Notice reasonably calculated to inform recipients that
   You have modified the Original Work.

   (( 7) ))??
   Warranty of Provenance and Disclaimer of Warranty. Licensor warrants that the
   copyright in and to the Original Work and the patent rights granted herein by
   Licensor are owned by the Licensor or are sublicensed to You under the terms
   of this License with the permission of the contributor(s) of those copyrights
   and patent rights. Except as expressly stated in the immediately proceeding
   sentence, the Original Work is provided under this License on an "AS IS"
   BASIS and WITHOUT WARRANTY, either express or implied, including, without
   limitation, the warranties of NON-INFRINGEMENT, MERCHANTABILITY or FITNESS
   FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY OF THE ORIGINAL
   WORK IS WITH YOU. This DISCLAIMER OF WARRANTY constitutes an essential part
   of this License. No license to Original Work is granted hereunder except
   under this disclaimer.

   (( 8) ))??
   Limitation of Liability. Under no circumstances and under no legal theory,
   whether in tort (including negligence), contract, or otherwise, shall the
   Licensor be liable to any person for any direct, indirect, special,
   incidental, or consequential damages of any character arising as a result of
   this License or the use of the Original Work including, without limitation,
   damages for loss of goodwill, work stoppage, computer failure or malfunction,
   or any and all other commercial damages or losses. This limitation of
   liability shall not apply to liability for death or personal injury resulting
   from Licensor's negligence to the extent applicable law prohibits such
   limitation. Some jurisdictions do not allow the exclusion or limitation of
   incidental or consequential damages, so this exclusion and limitation may not
   apply to You.

   (( 9) ))??
   Acceptance and Termination. If You distribute copies of the Original Work or
   a Derivative Work, You must make a reasonable effort under the circumstances
   to obtain the express assent of recipients to the terms of this License.
   Nothing else but this License (or another written agreement between Licensor
   and You) grants You permission to create Derivative Works based upon the
   Original Work or to exercise any of the rights granted in Section 1 herein,
   and any attempt to do so except under the terms of this License (or another
   written agreement between Licensor and You) is expressly prohibited by U.S.
   copyright law, the equivalent laws of other countries, and by international
   treaty. Therefore, by exercising any of the rights granted to You in Section
   1 herein, You indicate Your acceptance of this License and all of its terms
   and conditions. This License shall terminate immediately and you may no
   longer exercise any of the rights granted to You by this License upon Your
   failure to honor the proviso in Section 1(c) herein.

   (( 10) ))??
   Termination for Patent Action. This License shall terminate automatically and
   You may no longer exercise any of the rights granted to You by this License
   as of the date You commence an action, including a cross-claim or
   counterclaim, against Licensor or any licensee alleging that the Original
   Work infringes a patent. This termination provision shall not apply for an
   action alleging patent infringement by combinations of the Original Work with
   other software or hardware.

   (( 11) ))??
   Jurisdiction, Venue and Governing Law. Any action or suit relating to this
   License may be brought only in the courts of a jurisdiction wherein the
   Licensor resides or in which Licensor conducts its primary business, and
   under the laws of that jurisdiction excluding its conflict-of-law provisions.
   The application of the United Nations Convention on Contracts for the
   International Sale of Goods is expressly excluded. Any use of the Original
   Work outside the scope of this License or after its termination shall be
   subject to the requirements and penalties of the U.S. Copyright Act, 17
   U.S.C. § 101 et seq., the equivalent laws of other countries, and
   international treaty. This section shall survive the termination of this
   License.

   (( 12) ))??
   Attorneys Fees. In any action to enforce the terms of this License or seeking
   damages relating thereto, the prevailing party shall be entitled to recover
   its costs and expenses, including, without limitation, reasonable attorneys'
   fees and costs incurred in connection with such action, including any appeal
   of such action. This section shall survive the termination of this License.

   (( 13) ))??
   Miscellaneous. This License represents the complete agreement concerning the
   subject matter hereof. If any provision of this License is held to be
   unenforceable, such provision shall be reformed only to the extent necessary
   to make it enforceable.

   (( 14) ))??
   Definition of "You" in This License. "You" throughout this License, whether
   in upper or lower case, means an individual or a legal entity exercising
   rights under, and complying with all of the terms of, this License. For legal
   entities, "You" includes any entity that controls, is controlled by, or is
   under common control with you. For purposes of this definition, "control"
   means (i) the power, direct or indirect, to cause the direction or management
   of such entity, whether by contract or otherwise, or (ii) ownership of fifty
   percent (50%) or more of the outstanding shares, or (iii) beneficial
   ownership of such entity.

   (( 15) ))??
   Right to Use. You may use the Original Work in all ways not otherwise
   restricted or conditioned by this License or by law, and Licensor promises
   not to interfere with or be responsible for such uses by You.

This license is Copyright (C) 2003-2004 Lawrence E. Rosen. All rights reserved.
Permission is hereby granted to copy and distribute this license without
modification. This license may not be modified without the express written
permission of its copyright owner.
# powershell completion for %-36[1]s -*- shell-script -*-

function __%[1]s_debug {
    if ($env:BASH_COMP_DEBUG_FILE) {
        "$args" | Out-File -Append -FilePath "$env:BASH_COMP_DEBUG_FILE"
    }
}

filter __%[1]s_escapeStringWithSpecialChars {
    $_ -replace '\s|#|@|\$|;|,|''|\{|\}|\(|\)|"|`|\||<|>|&','`$&'
}

[scriptblock]${__%[2]sCompleterBlock} = {
    param(
            $WordToComplete,
            $CommandAst,
            $CursorPosition
        )

    # Get the current command line and convert into a string
    $Command = $CommandAst.CommandElements
    $Command = "$Command"

    __%[1]s_debug ""
    __%[1]s_debug "========= starting completion logic =========="
    __%[1]s_debug "WordToComplete: $WordToComplete Command: $Command CursorPosition: $CursorPosition"

    # The user could have moved the cursor backwards on the command-line.
    # We need to trigger completion from the $CursorPosition location, so we need
    # to truncate the command-line ($Command) up to the $CursorPosition location.
    # Make sure the $Command is longer then the $CursorPosition before we truncate.
    # This happens because the $Command does not include the last space.
    if ($Command.Length -gt $CursorPosition) {
        $Command=$Command.Substring(0,$CursorPosition)
    }
    __%[1]s_debug "Truncated command: $Command"

    $ShellCompDirectiveError=%[4]d
    $ShellCompDirectiveNoSpace=%[5]d
    $ShellCompDirectiveNoFileComp=%[6]d
    $ShellCompDirectiveFilterFileExt=%[7]d
    $ShellCompDirectiveFilterDirs=%[8]d
    $ShellCompDirectiveKeepOrder=%[9]d

    # Prepare the command to request completions for the program.
    # Split the command at the first space to separate the program and arguments.
    $Program,$Arguments = $Command.Split(" ",2)

    $RequestComp="$Program %[3]s $Arguments"
    __%[1]s_debug "RequestComp: $RequestComp"

    # we cannot use $WordToComplete because it
    # has the wrong values if the cursor was moved
    # so use the last argument
    if ($WordToComplete -ne "" ) {
        $WordToComplete = $Arguments.Split(" ")[-1]
    }
    __%[1]s_debug "New WordToComplete: $WordToComplete"


    # Check for flag with equal sign
    $IsEqualFlag = ($WordToComplete -Like "--*=*" )
    if ( $IsEqualFlag ) {
        __%[1]s_debug "Completing equal sign flag"
        # Remove the flag part
        $Flag,$WordToComplete = $WordToComplete.Split("=",2)
    }

    if ( $WordToComplete -eq "" -And ( -Not $IsEqualFlag )) {
        # If the last parameter is complete (there is a space following it)
        # We add an extra empty parameter so we can indicate this to the go method.
        __%[1]s_debug "Adding extra empty parameter"
        # PowerShell 7.2+ changed the way how the arguments are passed to executables,
        # so for pre-7.2 or when Legacy argument passing is enabled we need to use
        # `"`" to pass an empty argument, a "" or '' does not work!!!
        if ($PSVersionTable.PsVersion -lt [version]'7.2.0' -or
            ($PSVersionTable.PsVersion -lt [version]'7.3.0' -and -not [ExperimentalFeature]::IsEnabled("PSNativeCommandArgumentPassing")) -or
            (($PSVersionTable.PsVersion -ge [version]'7.3.0' -or [ExperimentalFeature]::IsEnabled("PSNativeCommandArgumentPassing")) -and
              $PSNativeCommandArgumentPassing -eq 'Legacy')) {
             $RequestComp="$RequestComp" + ' `"`"'
        } else {
             $RequestComp="$RequestComp" + ' ""'
        }
    }

    __%[1]s_debug "Calling $RequestComp"
    # First disable ActiveHelp which is not supported for Powershell
    ${env:%[10]s}=0

    #call the command store the output in $out and redirect stderr and stdout to null
    # $Out is an array contains each line per element
    Invoke-Expression -OutVariable out "$RequestComp" 2>&1 | Out-Null

    # get directive from last line
    [int]$Directive = $Out[-1].TrimStart(':')
    if ($Directive -eq "") {
        # There is no directive specified
        $Directive = 0
    }
    __%[1]s_debug "The completion directive is: $Directive"

    # remove directive (last element) from out
    $Out = $Out | Where-Object { $_ -ne $Out[-1] }
    __%[1]s_debug "The completions are: $Out"

    if (($Directive -band $ShellCompDirectiveError) -ne 0 ) {
        # Error code.  No completion.
        __%[1]s_debug "Received error from custom completion go code"
        return
    }

    $Longest = 0
    [Array]$Values = $Out | ForEach-Object {
        #Split the output in name and description
        $Name, $Description = $_.Split("`t",2)
        __%[1]s_debug "Name: $Name Description: $Description"

        # Look for the longest completion so that we can format things nicely
        if ($Longest -lt $Name.Length) {
            $Longest = $Name.Length
        }

        # Set the description to a one space string if there is none set.
        # This is needed because the CompletionResult does not accept an empty string as argument
        if (-Not $Description) {
            $Description = " "
        }
        New-Object -TypeName PSCustomObject -Property @{
            Name = "$Name"
            Description = "$Description"
        }
    }


    $Space = " "
    if (($Directive -band $ShellCompDirectiveNoSpace) -ne 0 ) {
        # remove the space here
        __%[1]s_debug "ShellCompDirectiveNoSpace is called"
        $Space = ""
    }

    if ((($Directive -band $ShellCompDirectiveFilterFileExt) -ne 0 ) -or
       (($Directive -band $ShellCompDirectiveFilterDirs) -ne 0 ))  {
        __%[1]s_debug "ShellCompDirectiveFilterFileExt ShellCompDirectiveFilterDirs are not supported"

        # return here to prevent the completion of the extensions
        return
    }

    $Values = $Values | Where-Object {
        # filter the result
        $_.Name -like "$WordToComplete*"

        # Join the flag back if we have an equal sign flag
        if ( $IsEqualFlag ) {
            __%[1]s_debug "Join the equal sign flag back to the completion value"
            $_.Name = $Flag + "=" + $_.Name
        }
    }

    # we sort the values in ascending order by name if keep order isn't passed
    if (($Directive -band $ShellCompDirectiveKeepOrder) -eq 0 ) {
        $Values = $Values | Sort-Object -Property Name
    }

    if (($Directive -band $ShellCompDirectiveNoFileComp) -ne 0 ) {
        __%[1]s_debug "ShellCompDirectiveNoFileComp is called"

        if ($Values.Length -eq 0) {
            # Just print an empty string here so the
            # shell does not start to complete paths.
            # We cannot use CompletionResult here because
            # it does not accept an empty string as argument.
            ""
            return
        }
    }

    # Get the current mode
    $Mode = (Get-PSReadLineKeyHandler | Where-Object {$_.Key -eq "Tab" }).Function
    __%[1]s_debug "Mode: $Mode"

    $Values | ForEach-Object {

        # store temporary because switch will overwrite $_
        $comp = $_

        # PowerShell supports three different completion modes
        # - TabCompleteNext (default windows style - on each key press the next option is displayed)
        # - Complete (works like bash)
        # - MenuComplete (works like zsh)
        # You set the mode with Set-PSReadLineKeyHandler -Key Tab -Function <mode>

        # CompletionResult Arguments:
        # 1) CompletionText text to be used as the auto completion result
        # 2) ListItemText   text to be displayed in the suggestion list
        # 3) ResultType     type of completion result
        # 4) ToolTip        text for the tooltip with details about the object

        switch ($Mode) {

            # bash like
            "Complete" {

                if ($Values.Length -eq 1) {
                    __%[1]s_debug "Only one completion left"

                    # insert space after value
                    $CompletionText = $($comp.Name | __%[1]s_escapeStringWithSpecialChars) + $Space
                    if ($ExecutionContext.SessionState.LanguageMode -eq "FullLanguage"){
                        [System.Management.Automation.CompletionResult]::new($CompletionText, "$($comp.Name)", 'ParameterValue', "$($comp.Description)")
                    } else {
                        $CompletionText
                    }

                } else {
                    # Add the proper number of spaces to align the descriptions
                    while($comp.Name.Length -lt $Longest) {
                        $comp.Name = $comp.Name + " "
                    }

                    # Check for empty description and only add parentheses if needed
                    if ($($comp.Description) -eq " " ) {
                        $Description = ""
                    } else {
                        $Description = "  ($($comp.Description))"
                    }

                    $CompletionText = "$($comp.Name)$Description"
                    if ($ExecutionContext.SessionState.LanguageMode -eq "FullLanguage"){
                        [System.Management.Automation.CompletionResult]::new($CompletionText, "$($comp.Name)$Description", 'ParameterValue', "$($comp.Description)")
                    } else {
                        $CompletionText
                    }
                }
             }

            # zsh like
            "MenuComplete" {
                # insert space after value
                # MenuComplete will automatically show the ToolTip of
                # the highlighted value at the bottom of the suggestions.

                $CompletionText = $($comp.Name | __%[1]s_escapeStringWithSpecialChars) + $Space
                if ($ExecutionContext.SessionState.LanguageMode -eq "FullLanguage"){
                    [System.Management.Automation.CompletionResult]::new($CompletionText, "$($comp.Name)", 'ParameterValue', "$($comp.Description)")
                } else {
                    $CompletionText
                }
            }

            # TabCompleteNext and in case we get something unknown
            Default {
                # Like MenuComplete but we don't want to add a space here because
                # the user need to press space anyway to get the completion.
                # Description will not be shown because that's not possible with TabCompleteNext

                $CompletionText = $($comp.Name | __%[1]s_escapeStringWithSpecialChars)
                if ($ExecutionContext.SessionState.LanguageMode -eq "FullLanguage"){
                    [System.Management.Automation.CompletionResult]::new($CompletionText, "$($comp.Name)", 'ParameterValue', "$($comp.Description)")
                } else {
                    $CompletionText
                }
            }
        }

    }
}

Register-ArgumentCompleter -CommandName '%[1]s' -ScriptBlock ${__%[2]sCompleterBlock}
//**
Frameworx Open License 1.0
https://spdx.org/licenses/Frameworx-1.0.json
https://opensource.org/licenses/Frameworx-1.0
**//

(( THE FRAMEWORX OPEN LICENSE 1.0 ))??

This License Agreement, The Frameworx Open License 1.0, has been entered into
between The Frameworx Company and you, the licensee hereunder, effective as of
Your acceptance of the Frameworx Code Base or an Downstream Distribution (each
as defined below).

AGREEMENT BACKGROUND

The Frameworx Company is committed to the belief that open source software
results in better quality, greater technical and product innovation in the
market place and a more empowered and productive developer and end-user
community. Our objective is to ensure that the Frameworx Code Base, and the
source code for improvements and innovations to it, remain free and open to the
community.To further these beliefs and objectives, we are distributing the
Frameworx Code Base, without royalties and in source code form, to the community
pursuant to this License Agreement.

AGREEMENT TERMS

The Frameworx Company and You have agreed as follows:

   (( 1. ))??
   Definitions.The following terms have the following respective meanings:

      (( (a) ))??
      Frameworx Code Base means the software developed by The Frameworx Company
      and made available under this License Agreement

      (( (b) ))??
      Downstream Distribution means any direct or indirect release, distribution
      or remote availability of software (i) that directly or indirectly
      contains, or depends for its intended functioning on, the Frameworx Code
      Base or any portion or element thereof and (ii) in which rights to use and
      distribute such Frameworx Code Base software depend, directly or
      indirectly, on the License provided in Section 2 below.

      (( c ))??
      "Source Code" to any software means the preferred form for making
      modifications to that software, including any associated documentation,
      interface definition files and compilation or installation scripts, or any
      version thereof that has been compressed or archived, and can be
      reconstituted, using an appropriate and generally available archival or
      compression technology.

      (( (d) ))??
      Value-Added Services means any commercial or fee-based software-related
      service, including without limitation: system or application development
      or consulting; technical or end-user support or training; distribution
      maintenance, configuration or versioning; or outsourced, hosted or
      network-based application services.

   (( 2. ))??
   License Grant. Subject to the terms and conditions hereof, The Frameworx
   Company hereby grants You a non-exclusive license (the License), subject to
   third party intellectual property claims, and for no fee other than a nominal
   charge reflecting the costs of physical distribution, to:

      (( (a) ))??
      use the Frameworx Code Base, in either Source Code or machine-readable
      form;

      (( (b) ))??
      make modifications, additions and deletions to the content or structure of
      the Frameworx Code Base; or

      (( c ))??
      create larger works or derivative works including the Frameworx Code Base
      or any portion or element thereof; and

      (( (d) ))??
      release, distribute or make available, either generally or to any specific
      third-party, any of the foregoing in Source Code or binary form.

   (( 3. ))??
   License Conditions. The grant of the License under Section 1 hereof, and your
   exercise of all rights in connection with this License Agreement, will remain
   subject to the following terms and conditions, as well as to the other
   provisions hereof:

      (( (a) ))??
      Complete Source Code for any Downstream Distribution directly or
      indirectly made by You that contains, or depends for its intended
      functionality on, the Frameworx Code Base, or any portion or element
      thereof, shall be made freely available to all users thereof on terms and
      conditions no more restrictive, and no less favorable for any user
      (including, without limitation, with regard to Source Code availability
      and royalty-free use) than those terms and conditions provided in this
      License Agreement.

      (( (b) ))??
      Any Value-Added Services that you offer or provide, directly or
      indirectly, in relation to any Downstream Distribution shall be offered
      and provided on commercial terms that are reasonably commensurate to the
      fair market value of such Value-Added Services. In addition, the terms and
      conditions on which any such Value Added Services are so offered or
      provided shall be consistent with, and shall fully support, the intent and
      purpose of this License Agreement.

      (( c ))??
      All Downstream Distributions shall:

         (( (i) ))??
         include all portions and elements of the Frameworx Code Base required
         to build the Source Code of such Downstream Distribution into a fully
         functional machine-executable system, or additional build scripts or
         comparable software necessary and sufficient for such purposes;

         (( (ii) ))??
         include, in each file containing any portion or element of the
         Frameworx Code Base, the following identifying legend: This file
         contains software that has been made available under The Frameworx Open
         License 1.0. Use and distribution hereof are subject to the
         restrictions set forth therein.

         (( (iii) ))??
         include all other copyright notices, authorship credits, warranty
         disclaimers (including that provided in Section 6 below), legends,
         documentation, annotations and comments contained in the Frameworx Code
         Base as provided to You hereunder;

         (( (iv) ))??
         contain an unaltered copy of the html file named
         frameworx_community_invitation.html included within the Frameworx Code
         Base that acknowledges new users and provides them with information on
         the Frameworx Code Base community;

         (( (v) ))??
         contain an unaltered copy of the text file named
         the_frameworx_license.txt included within the Frameworx Code Base that
         includes a text copy of the form of this License Agreement; and

         (( (vi) ))??
         prominently display to any viewer or user of the Source Code of such
         Open Downstream Distribution, in the place and manner normally used for
         such displays, the following legend:

   Source code licensed under from The Frameworx Company is contained herein,
   and such source code has been obtained either under The Frameworx Open
   License, or another license granted by The Frameworx Company. Use and
   distribution hereof is subject to the restrictions provided in the relevant
   such license and to the copyrights of the licensor thereunder. A copy of The
   Frameworx Open License is provided in a file named the_frameworx_license.txt
   and included herein, and may also be available for inspection at
   http:/www.frameworx.com.

   (( 4. ))??
   Restrictions on Open Downstream Distributions. Each Downstream Distribution
   made by You, and by any party directly or indirectly obtaining rights to the
   Frameworx Code Base through You, shall be made subject to a license grant or
   agreement to the extent necessary so that each distributee under that
   Downstream Distribution will be subject to the same restrictions on
   re-distribution and use as are binding on You hereunder. You may satisfy this
   licensing requirement either by:

      (( (a) ))??
      requiring as a condition to any Downstream Distribution made by you, or by
      any direct or indirect distributee of Your Downstream Distribution (or any
      portion or element thereof), that each distributee under the relevant
      Downstream Distribution obtain a direct license (on the same terms and
      conditions as those in this License Agreement) from The Frameworx Company;
      or

      (( (b) ))??
      sub-licensing all (and not less than all) of Your rights and obligations
      hereunder to that distributee, including (without limitation) Your
      obligation to require distributees to be bound by license restrictions as
      contemplated by this Section 4 above.

   The Frameworx Company hereby grants to you all rights to sub-license your
   rights hereunder as necessary to fully effect the intent and purpose of this
   Section 4 above, provided, however, that your rights and obligations
   hereunder shall be unaffected by any such sublicensing. In addition, The
   Frameworx Company expressly retains all rights to take all appropriate action
   (including legal action) against any such direct or indirect sub-licensee to
   ensure its full compliance with the intent and purposes of this License
   Agreement.

   (( 5. ))??
   Intellectual Property. Except as expressly provided herein, this License
   Agreement preserves and respects Your and The Frameworx Companys respective
   intellectual property rights, including, in the case of The Frameworx
   Company, its copyrights and patent rights relating to the Frameworx Code
   Base.

   (( 6. ))??
   Warranty Disclaimer. THE SOFTWARE LICENSED HEREUNDER IS PROVIDED ``AS IS.''
   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND
   NON-INFRINGEMENT, ARE HEREBY DISCLAIMED. IN NO EVENT SHALL THE LICENSOR OF
   THIS SOFTWARE, BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
   EXEMPLARY, OR CONSEQUENTIAL DAMAGES INCLUDING (BUT NOT LIMITED TO)
   PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
   OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
   WHETHER IN CONTRACT, STRICT LIABILITY OR TORT (INCLUDING NEGLIGENCE OR
   OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
   ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

   (( 7. ))??
   License Violation. The License, and all of your rights thereunder, shall be
   deemed automatically terminated and void as of any Downstream Distribution
   directly or indirectly made or facilitated by You that violates the
   provisions of this License Agreement, provided, however, that this License
   Agreement shall survive any such termination in order to remedy the effects
   of such violation. This License Agreement shall be binding on the legal
   successors and assigns of the parties hereto.

   Your agreement to the foregoing as of the date hereof has been evidenced by
   your acceptance of the relevant software distribution hereunder.

   (( (C) THE FRAMEWORX COMPANY 2003 ))??
//**
Academic Free License v3.0
https://spdx.org/licenses/AFL-3.0.json
http://www.rosenlaw.com/AFL3.0.htm
https://opensource.org/licenses/afl-3.0
**//

(( Academic Free License ("AFL") v. 3.0 ))??

((
This Academic Free License (the "License") applies to any original work of
authorship (the "Original Work") whose owner (the "Licensor") has placed the
following licensing notice adjacent to the copyright notice for the Original
Work:
))??

(( Licensed under the Academic Free License version 3.0 ))??

   (( 1) ))??
   Grant of Copyright License. Licensor grants You a worldwide, royalty-free,
   non-exclusive, sublicensable license, for the duration of the copyright, to
   do the following:

      (( a) || 1. ))??
      to reproduce the Original Work in copies, either alone or as part of a
      collective work;

      (( b) || 2. ))??
      to translate, adapt, alter, transform, modify, or arrange the Original
      Work, thereby creating derivative works ("Derivative Works") based upon
      the Original Work;

      (( c) || 3. ))??
      to distribute or communicate copies of the Original Work and Derivative
      Works to the public, under any license of your choice that does not
      contradict the terms and conditions, including Licensor's reserved rights
      and remedies, in this Academic Free License;

      (( d) || 4. ))??
      to perform the Original Work publicly; and

      (( e) || 5. ))??
      to display the Original Work publicly.

   (( 2) ))??
   Grant of Patent License. Licensor grants You a worldwide, royalty-free,
   non-exclusive, sublicensable license, under patent claims owned or controlled
   by the Licensor that are embodied in the Original Work as furnished by the
   Licensor, for the duration of the patents, to make, use, sell, offer for
   sale, have made, and import the Original Work and Derivative Works.

   (( 3) ))??
   Grant of Source Code License. The term "Source Code" means the preferred form
   of the Original Work for making modifications to it and all available
   documentation describing how to modify the Original Work. Licensor agrees to
   provide a machine-readable copy of the Source Code of the Original Work along
   with each copy of the Original Work that Licensor distributes. Licensor
   reserves the right to satisfy this obligation by placing a machine-readable
   copy of the Source Code in an information repository reasonably calculated to
   permit inexpensive and convenient access by You for as long as Licensor
   continues to distribute the Original Work.

   (( 4) ))??
   Exclusions From License Grant. Neither the names of Licensor, nor the names
   of any contributors to the Original Work, nor any of their trademarks or
   service marks, may be used to endorse or promote products derived from this
   Original Work without express prior permission of the Licensor. Except as
   expressly stated herein, nothing in this License grants any license to
   Licensor's trademarks, copyrights, patents, trade secrets or any other
   intellectual property. No patent license is granted to make, use, sell, offer
   for sale, have made, or import embodiments of any patent claims other than
   the licensed claims defined in Section 2. No license is granted to the
   trademarks of Licensor even if such marks are included in the Original Work.
   Nothing in this License shall be interpreted to prohibit Licensor from
   licensing under terms different from this License any Original Work that
   Licensor otherwise would have a right to license.

   (( 5) ))??
   External Deployment. The term "External Deployment" means the use,
   distribution, or communication of the Original Work or Derivative Works in
   any way such that the Original Work or Derivative Works may be used by anyone
   other than You, whether those works are distributed or communicated to those
   persons or made available as an application intended for use over a network.
   As an express condition for the grants of license hereunder, You must treat
   any External Deployment by You of the Original Work or a Derivative Work as a
   distribution under section 1(c).

   (( 6) ))??
   Attribution Rights. You must retain, in the Source Code of any Derivative
   Works that You create, all copyright, patent, or trademark notices from the
   Source Code of the Original Work, as well as any notices of licensing and any
   descriptive text identified therein as an "Attribution Notice." You must
   cause the Source Code for any Derivative Works that You create to carry a
   prominent Attribution Notice reasonably calculated to inform recipients that
   You have modified the Original Work.

   (( 7) ))??
   Warranty of Provenance and Disclaimer of Warranty. Licensor warrants that the
   copyright in and to the Original Work and the patent rights granted herein by
   Licensor are owned by the Licensor or are sublicensed to You under the terms
   of this License with the permission of the contributor(s) of those copyrights
   and patent rights. Except as expressly stated in the immediately preceding
   sentence, the Original Work is provided under this License on an "AS IS"
   BASIS and WITHOUT WARRANTY, either express or implied, including, without
   limitation, the warranties of non-infringement, merchantability or fitness
   for a particular purpose. THE ENTIRE RISK AS TO THE QUALITY OF THE ORIGINAL
   WORK IS WITH YOU. This DISCLAIMER OF WARRANTY constitutes an essential part
   of this License. No license to the Original Work is granted by this License
   except under this disclaimer.

   (( 8) ))??
   Limitation of Liability. Under no circumstances and under no legal theory,
   whether in tort (including negligence), contract, or otherwise, shall the
   Licensor be liable to anyone for any indirect, special, incidental, or
   consequential damages of any character arising as a result of this License or
   the use of the Original Work including, without limitation, damages for loss
   of goodwill, work stoppage, computer failure or malfunction, or any and all
   other commercial damages or losses. This limitation of liability shall not
   apply to the extent applicable law prohibits such limitation.

   (( 9) ))??
   Acceptance and Termination. If, at any time, You expressly assented to this
   License, that assent indicates your clear and irrevocable acceptance of this
   License and all of its terms and conditions. If You distribute or communicate
   copies of the Original Work or a Derivative Work, You must make a reasonable
   effort under the circumstances to obtain the express assent of recipients to
   the terms of this License. This License conditions your rights to undertake
   the activities listed in Section 1, including your right to create Derivative
   Works based upon the Original Work, and doing so without honoring these terms
   and conditions is prohibited by copyright law and international treaty.
   Nothing in this License is intended to affect copyright exceptions and
   limitations (including "fair use" or "fair dealing"). This License shall
   terminate immediately and You may no longer exercise any of the rights
   granted to You by this License upon your failure to honor the conditions in
   Section 1(c).

   (( 10) ))??
   Termination for Patent Action. This License shall terminate automatically and
   You may no longer exercise any of the rights granted to You by this License
   as of the date You commence an action, including a cross-claim or
   counterclaim, against Licensor or any licensee alleging that the Original
   Work infringes a patent. This termination provision shall not apply for an
   action alleging patent infringement by combinations of the Original Work with
   other software or hardware.

   (( 11) ))??
   Jurisdiction, Venue and Governing Law. Any action or suit relating to this
   License may be brought only in the courts of a jurisdiction wherein the
   Licensor resides or in which Licensor conducts its primary business, and
   under the laws of that jurisdiction excluding its conflict-of-law provisions.
   The application of the United Nations Convention on Contracts for the
   International Sale of Goods is expressly excluded. Any use of the Original
   Work outside the scope of this License or after its termination shall be
   subject to the requirements and penalties of copyright or patent law in the
   appropriate jurisdiction. This section shall survive the termination of this
   License.

   (( 12) ))??
   Attorneys' Fees. In any action to enforce the terms of this License or
   seeking damages relating thereto, the prevailing party shall be entitled to
   recover its costs and expenses, including, without limitation, reasonable
   attorneys' fees and costs incurred in connection with such action, including
   any appeal of such action. This section shall survive the termination of this
   License.

   (( 13) ))??
   Miscellaneous. If any provision of this License is held to be unenforceable,
   such provision shall be reformed only to the extent necessary to make it
   enforceable.

   (( 14) ))??
   Definition of "You" in This License. "You" throughout this License, whether
   in upper or lower case, means an individual or a legal entity exercising
   rights under, and complying with all of the terms of, this License. For legal
   entities, "You" includes any entity that controls, is controlled by, or is
   under common control with you. For purposes of this definition, "control"
   means (i) the power, direct or indirect, to cause the direction or management
   of such entity, whether by contract or otherwise, or (ii) ownership of fifty
   percent (50%) or more of the outstanding shares, or (iii) beneficial
   ownership of such entity.

   (( 15) ))??
   Right to Use. You may use the Original Work in all ways not otherwise
   restricted or conditioned by this License or by law, and Licensor promises
   not to interfere with or be responsible for such uses by You.

   (( 16) ))??
   Modification of This License. This License is Copyright © 2005 Lawrence
   Rosen. Permission is granted to copy, distribute, or communicate this License
   without modification. Nothing in this License permits You to modify this
   License as applied to the Original Work or to Derivative Works. However, You
   may modify the text of this License and copy, distribute or communicate your
   modified version (the "Modified License") and apply it to other original
   works of authorship subject to the following conditions: (i) You may not
   indicate in any way that your Modified License is the "Academic Free License"
   or "AFL" and you may not use those names in the name of your Modified
   License; (ii) You must replace the notice specified in the first paragraph
   above with the notice "Licensed under <insert your license name here>" or
   with a notice of your own that is not confusingly similar to the notice in
   this License; and (iii) You may not claim that your original works are open
   source software unless your Modified License has been approved by Open Source
   Initiative (OSI) and You comply with its license review and certification
   process.
//**
Open Software License 3.0
https://spdx.org/licenses/OSL-3.0.json
https://web.archive.org/web/20120101081418/http://rosenlaw.com:80/OSL3.0.htm
https://opensource.org/licenses/OSL-3.0
**//

((
	((The))??
	Open Software License
	((v.))??
	3.0
	(OSL-3.0)
))??

This Open Software License (the "License") applies to any original work of
authorship (the "Original Work") whose owner (the "Licensor") has placed the
following licensing notice adjacent to the copyright notice for the Original
Work:

Licensed under the Open Software License version 3.0

   (( 1) ))??
   Grant of Copyright License. Licensor grants You a worldwide, royalty-free,
   non-exclusive, sublicensable license, for the duration of the copyright, to
   do the following:

      (( a) || 1 ))??
      to reproduce the Original Work in copies, either alone or as part of a
      collective work;

      (( b) || 2 ))??
      to translate, adapt, alter, transform, modify, or arrange the Original
      Work, thereby creating derivative works ("Derivative Works") based upon
      the Original Work;

      (( c) || 3 ))??
      to distribute or communicate copies of the Original Work and Derivative
      Works to the public, with the proviso that copies of Original Work or
      Derivative Works that You distribute or communicate shall be licensed
      under this Open Software License;

      (( d) || 4 ))??
      to perform the Original Work publicly; and

      (( e) || 5 ))??
      to display the Original Work publicly.

   (( 2) ))??
   Grant of Patent License. Licensor grants You a worldwide, royalty-free,
   non-exclusive, sublicensable license, under patent claims owned or controlled
   by the Licensor that are embodied in the Original Work as furnished by the
   Licensor, for the duration of the patents, to make, use, sell, offer for
   sale, have made, and import the Original Work and Derivative Works.

   (( 3) ))??
   Grant of Source Code License. The term "Source Code" means the preferred form
   of the Original Work for making modifications to it and all available
   documentation describing how to modify the Original Work. Licensor agrees to
   provide a machine-readable copy of the Source Code of the Original Work along
   with each copy of the Original Work that Licensor distributes. Licensor
   reserves the right to satisfy this obligation by placing a machine-readable
   copy of the Source Code in an information repository reasonably calculated to
   permit inexpensive and convenient access by You for as long as Licensor
   continues to distribute the Original Work.

   (( 4) ))??
   Exclusions From License Grant. Neither the names of Licensor, nor the names
   of any contributors to the Original Work, nor any of their trademarks or
   service marks, may be used to endorse or promote products derived from this
   Original Work without express prior permission of the Licensor. Except as
   expressly stated herein, nothing in this License grants any license to
   Licensor's trademarks, copyrights, patents, trade secrets or any other
   intellectual property. No patent license is granted to make, use, sell, offer
   for sale, have made, or import embodiments of any patent claims other than
   the licensed claims defined in Section 2. No license is granted to the
   trademarks of Licensor even if such marks are included in the Original Work.
   Nothing in this License shall be interpreted to prohibit Licensor from
   licensing under terms different from this License any Original Work that
   Licensor otherwise would have a right to license.

   (( 5) ))??
   External Deployment. The term "External Deployment" means the use,
   distribution, or communication of the Original Work or Derivative Works in
   any way such that the Original Work or Derivative Works may be used by anyone
   other than You, whether those works are distributed or communicated to those
   persons or made available as an application intended for use over a network.
   As an express condition for the grants of license hereunder, You must treat
   any External Deployment by You of the Original Work or a Derivative Work as a
   distribution under section 1(c).

   (( 6) ))??
   Attribution Rights. You must retain, in the Source Code of any Derivative
   Works that You create, all copyright, patent, or trademark notices from the
   Source Code of the Original Work, as well as any notices of licensing and any
   descriptive text identified therein as an "Attribution Notice." You must
   cause the Source Code for any Derivative Works that You create to carry a
   prominent Attribution Notice reasonably calculated to inform recipients that
   You have modified the Original Work.

   (( 7) ))??
   Warranty of Provenance and Disclaimer of Warranty. Licensor warrants that the
   copyright in and to the Original Work and the patent rights granted herein by
   Licensor are owned by the Licensor or are sublicensed to You under the terms
   of this License with the permission of the contributor(s) of those copyrights
   and patent rights. Except as expressly stated in the immediately preceding
   sentence, the Original Work is provided under this License on an "AS IS"
   BASIS and WITHOUT WARRANTY, either express or implied, including, without
   limitation, the warranties of non-infringement, merchantability or fitness
   for a particular purpose. THE ENTIRE RISK AS TO THE QUALITY OF THE ORIGINAL
   WORK IS WITH YOU. This DISCLAIMER OF WARRANTY constitutes an essential part
   of this License. No license to the Original Work is granted by this License
   except under this disclaimer.

   (( 8) ))??
   Limitation of Liability. Under no circumstances and under no legal theory,
   whether in tort (including negligence), contract, or otherwise, shall the
   Licensor be liable to anyone for any indirect, special, incidental, or
   consequential damages of any character arising as a result of this License or
   the use of the Original Work including, without limitation, damages for loss
   of goodwill, work stoppage, computer failure or malfunction, or any and all
   other commercial damages or losses. This limitation of liability shall not
   apply to the extent applicable law prohibits such limitation.

   (( 9) ))??
   Acceptance and Termination. If, at any time, You expressly assented to this
   License, that assent indicates your clear and irrevocable acceptance of this
   License and all of its terms and conditions. If You distribute or communicate
   copies of the Original Work or a Derivative Work, You must make a reasonable
   effort under the circumstances to obtain the express assent of recipients to
   the terms of this License. This License conditions your rights to undertake
   the activities listed in Section 1, including your right to create Derivative
   Works based upon the Original Work, and doing so without honoring these terms
   and conditions is prohibited by copyright law and international treaty.
   Nothing in this License is intended to affect copyright exceptions and
   limitations (including "fair use" or "fair dealing"). This License shall
   terminate immediately and You may no longer exercise any of the rights
   granted to You by this License upon your failure to honor the conditions in
   Section 1(c).

   (( 10) ))??
   Termination for Patent Action. This License shall terminate automatically and
   You may no longer exercise any of the rights granted to You by this License
   as of the date You commence an action, including a cross-claim or
   counterclaim, against Licensor or any licensee alleging that the Original
   Work infringes a patent. This termination provision shall not apply for an
   action alleging patent infringement by combinations of the Original Work with
   other software or hardware.

   (( 11) ))??
   Jurisdiction, Venue and Governing Law. Any action or suit relating to this
   License may be brought only in the courts of a jurisdiction wherein the
   Licensor resides or in which Licensor conducts its primary business, and
   under the laws of that jurisdiction excluding its conflict-of-law provisions.
   The application of the United Nations Convention on Contracts for the
   International Sale of Goods is expressly excluded. Any use of the Original
   Work outside the scope of this License or after its termination shall be
   subject to the requirements and penalties of copyright or patent law in the
   appropriate jurisdiction. This section shall survive the termination of this
   License.

   (( 12) ))??
   Attorneys' Fees. In any action to enforce the terms of this License or
   seeking damages relating thereto, the prevailing party shall be entitled to
   recover its costs and expenses, including, without limitation, reasonable
   attorneys' fees and costs incurred in connection with such action, including
   any appeal of such action. This section shall survive the termination of this
   License.

   (( 13) ))??
   Miscellaneous. If any provision of this License is held to be unenforceable,
   such provision shall be reformed only to the extent necessary to make it
   enforceable.

   (( 14) ))??
   Definition of "You" in This License. "You" throughout this License, whether
   in upper or lower case, means an individual or a legal entity exercising
   rights under, and complying with all of the terms of, this License. For legal
   entities, "You" includes any entity that controls, is controlled by, or is
   under common control with you. For purposes of this definition, "control"
   means (i) the power, direct or indirect, to cause the direction or management
   of such entity, whether by contract or otherwise, or (ii) ownership of fifty
   percent (50%) or more of the outstanding shares, or (iii) beneficial
   ownership of such entity.

   (( 15) ))??
   Right to Use. You may use the Original Work in all ways not otherwise
   restricted or conditioned by this License or by law, and Licensor promises
   not to interfere with or be responsible for such uses by You.

   (( 16) ))??
   Modification of This License. This License is Copyright (c) 2005 Lawrence
   Rosen. Permission is granted to copy, distribute, or communicate this License
   without modification. Nothing in this License permits You to modify this
   License as applied to the Original Work or to Derivative Works. However, You
   may modify the text of this License and copy, distribute or communicate your
   modified version (the "Modified License") and apply it to other original
   works of authorship subject to the following conditions: (i) You may not
   indicate in any way that your Modified License is the "Open Software License"
   or "OSL" and you may not use those names in the name of your Modified
   License; (ii) You must replace the notice specified in the first paragraph
   above with the notice "Licensed under <insert your license name here>" or
   with a notice of your own that is not confusingly similar to the notice in
   this License; and (iii) You may not claim that your original works are open
   source software unless your Modified License has been approved by Open Source
   Initiative (OSI) and You comply with its license review and certification
   process.
//**
OCLC Research Public License 2.0
https://spdx.org/licenses/OCLC-2.0.json
http://www.oclc.org/research/activities/software/license/v2final.htm
https://opensource.org/licenses/OCLC-2.0
**//

(( OCLC Research Public License 2.0
Terms & Conditions Of Use
May, 2002

(( Copyright __20__ ))??
))??

PLEASE READ THIS DOCUMENT CAREFULLY. BY DOWNLOADING OR USING THE CODE BASE
AND/OR DOCUMENTATION ACCOMPANYING THIS LICENSE (THE "License"), YOU AGREE TO THE
FOLLOWING TERMS AND CONDITIONS OF THIS LICENSE.

Section 1. Your Rights

Subject to these terms and conditions of this License, the OCLC Office of
Research (the "Original Contributor") and each subsequent contributor
(collectively with the Original Contributor, the "Contributors") hereby grant
you a non-exclusive, worldwide, no-charge, transferable license to execute,
prepare derivative works of, and distribute (internally and externally), for
commercial and noncommercial purposes, the original code contributed by Original
Contributor and all Modifications (collectively called the "Program").

Section 2. Definitions

A "Modification" to the Program is any addition to or deletion from the contents
of any file of the Program and any new file that contains any part of the
Program. If you make a Modification and distribute the Program externally you
are a "Contributor." The distribution of the Program must be under the terms of
this license including those in Section 3 below.

A "Combined Work" results from combining and integrating all or parts of the
Program with other code. A Combined Work may be thought of as having multiple
parents or being result of multiple lines of code development.

Section 3. Distribution Licensing Terms

   (( A. ))??
   General Requirements

   Except as necessary to recognize third-party rights or third-party
   restriction (see below), a distribution of the Program in any of the forms
   listed below must not put any further restrictions on the recipient's
   exercise of the rights granted herein.

   As a Contributor, you represent that your Modification(s) are your original
   creation(s) and, to the best of your knowledge, no third party has any claim
   (including but not limited to intellectual property claims) relating to your
   Modification(s). You represent that each of your Modifications includes
   complete details of any third-party right or other third-party restriction
   associated with any part of your Modification (including a copy of any
   applicable license agreement).

   The Program must be distributed without charge beyond the costs of physically
   transferring the files to the recipient.

   This Warranty Disclaimer/Limitation of Liability must be prominently
   displayed with every distribution of the Program in any form:

   YOU AGREE THAT THE PROGRAM IS PROVIDED AS-IS, WITHOUT WARRANTY OF ANY KIND
   (EITHER EXPRESS OR IMPLIED). ACCORDINGLY, OCLC MAKES NO WARRANTIES,
   REPRESENTATIONS OR GUARANTEES, EITHER EXPRESS OR IMPLIED, AND DISCLAIMS ALL
   SUCH WARRANTIES, REPRESENTATIONS OR GUARANTEES, INCLUDING, WITHOUT
   LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR ANY
   PARTICULAR PURPOSE, AS TO: (A) THE FUNCTIONALITY OR NONINFRINGEMENT OF
   PROGRAM, ANY MODIFICATION, A COMBINED WORK OR AN AGGREGATE WORK; OR (B) THE
   RESULTS OF ANY PROJECT UNDERTAKEN USING THE PROGRAM, ANY MODIFICATION, A
   COMBINED WORK OR AN AGGREGATE WORK. IN NO EVENT SHALL THE CONTRIBUTORS BE
   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
   CONSEQUENTIAL OR ANY OTHER DAMAGES (INCLUDING, BUT NOT LIMITED TO,
   PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
   OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
   WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
   OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THE PROGRAM, EVEN IF ADVISED
   OF THE POSSIBILITY OF SUCH DAMAGES. YOU HEREBY WAIVE ANY CLAIMS FOR DAMAGES
   OF ANY KIND AGAINST CONTRIBUTORS WHICH MAY RESULT FROM YOUR USE OF THE
   PROGRAM.

   (( B. ))??
   Requirements for a Distribution of Modifiable Code

   If you distribute the Program in a form to which the recipient can make
   Modifications (e.g. source code), the terms of this license apply to use by
   recipient. In addition, each source and data file of the Program and any
   Modification you distribute must contain the following notice:

   Copyright (c) __20__
   All rights reserved.

   The contents of this file, as updated from time to time
   by the OCLC Office of Research, are subject to OCLC Research Public License
   Version 2.0 (the "License"); you may not use this file except in compliance with
   the License. You may obtain a current copy of the License at
   http:/purl.oclc.org/oclc/research/ORPL/. Software distributed under the License
   is distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
   or implied. See the License for the specific language governing rights and
   limitations under the License. This software consists of voluntary contributions
   made by many individuals on behalf of OCLC Research. For more information on
   OCLC Research, please see http:/www.oclc.org/research/.

   The Original Code is ____.
   The Initial Developer of the Original Code is ____.
   Portions created by ____ are Copyright (C) ____. All Rights Reserved.
   Contributor(s): ____.

   (( C. ))??
   Requirements for a Distribution of Non-modifiable Code

   If you distribute the Program in a form to which the recipient cannot make
   Modifications (e.g. object code), the terms of this license apply to use by
   recipient and you must include the following statement in appropriate and
   conspicuous locations:

   "Copyright (c) 2000- (insert then current year) OCLC Online Computer Library
   Center, Inc. and other contributors. All rights reserved."

   In addition, the source code must be included with the object code
   distribution or the distributor must provide the source code to the recipient
   upon request.

   (( D. ))??
   Requirements for a Combined Work Distribution

   Distributions of Combined Works are subject to the terms of this license and
   must be made at no charge to the recipient beyond the costs of physically
   transferring the files to recipient.

   A Combined Work may be distributed as either modifiable or non-modifiable
   code. The requirements of Section 3.B or 3.C above (as appropriate) apply to
   such distributions.

   An "Aggregate Work" is when the Program exists, without integration, with
   other programs on a storage medium. This License does not apply to portions
   of an Aggregate Work which are not covered by the definition of "Program"
   provided in this License. You are not forbidden from selling an Aggregate
   Work. However, the Program contained in an Aggregate Work is subject to this
   License. Also, should the Program be extracted from an Aggregate Work, this
   License applies to any use of the Program apart from the Aggregate Work.

   Section 4. License Grant

   For purposes of permitting use of your Modifications by OCLC and other
   licensees hereunder, you hereby grant to OCLC and such other licensees the
   non-exclusive, worldwide, royalty-free, transferable, sublicenseable license
   to execute, copy, alter, delete, modify, adapt, change, revise, enhance,
   develop, publicly display, distribute (internally and externally) and/or
   create derivative works based on your Modifications (and derivative works
   thereof) in accordance with these Terms. This Section 4 shall survive
   termination of this License for any reason.

Section 5. Termination of Rights

This non-exclusive license (with respect to the grant from a particular
Contributor) automatically terminates for any entity that initiates legal action
for intellectual property infringement (with respect to the Program) against
such Contributor as of the initiation of such action.

If you fail to comply with this License, your rights (but not your obligations)
under this License shall terminate automatically unless you cure such breach
within thirty (30) days of becoming aware of the noncompliance. All sublicenses
granted by you which preexist such termination and are properly granted shall
survive such termination.

Section 6. Other Terms

Except for the copyright notices required above, you may not use any trademark
of any of the Contributors without the prior written consent of the relevant
Contributor. You agree not to remove, alter or obscure any copyright or other
proprietary rights notice contained in the Program.

All transfers of the Program or any part thereof shall be made in compliance
with U.S. import/export regulations or other restrictions of the U.S. Department
of Commerce, as well as other similar trade or commerce restrictions which might
apply.

Any patent obtained by any party covering the Program or any part thereof must
include a provision providing for the free, perpetual and unrestricted
commercial and noncommercial use by any third party.

If, as a consequence of a court judgment or settlement relating to intellectual
property infringement or any other cause of action, conditions are imposed on
you that contradict the conditions of this License, such conditions do not
excuse you from compliance with this License. If you cannot distribute the
Program so as to simultaneously satisfy your obligations under this License and
such other conditions, you may not distribute the Program at all. For example,
if a patent license would not permit royalty-free redistribution of the Program
by all those who receive copies directly or indirectly through you, you could
not satisfy both the patent license and this License, and you would be required
to refrain entirely from distribution of the Program.

If you learn of a third party claim or other restriction relating to a Program
you have already distributed you shall promptly redo your Program to address the
issue and take all reasonable steps to inform those who may have received the
Program at issue. An example of an appropriate reasonable step to inform would
be posting an announcement on an appropriate web bulletin board.

The provisions of this License are deemed to be severable, and the invalidity or
unenforceability of any provision shall not affect or impair the remaining
provisions which shall continue in full force and effect. In substitution for
any provision held unlawful, there shall be substituted a provision of similar
import reflecting the original intent of the parties hereto to the extent
permissible under law.

The Original Contributor from time to time may change this License, and the
amended license will apply to all copies of the Program downloaded after the new
license is posted. This License grants only the rights expressly stated herein
and provides you with no implied rights or licenses to the intellectual property
of any Contributor.

This License is the complete and exclusive statement of the agreement between
the parties concerning the subject matter hereof and may not be amended except
by the written agreement of the parties. This License shall be governed by and
construed in accordance with the laws of the State of Ohio and the United States
of America, without regard to principles of conflicts of law.
//**
Upstream Compatibility License v1.0
https://spdx.org/licenses/UCL-1.0.json
https://opensource.org/licenses/UCL-1.0
**//

(( Upstream Compatibility License v. 1.0 (UCL-1.0) ))??

This Upstream Compatibility License (the "License") applies to any original work
of authorship (the "Original Work") whose owner (the "Licensor") has placed the
following licensing notice adjacent to the copyright notice for the Original
Work:

Licensed under the Upstream Compatibility License 1.0

   (( 1) ))??
   Grant of Copyright License. Licensor grants You a worldwide, royalty-free,
   non-exclusive, sublicensable license, for the duration of the copyright, to
   do the following:

      (( a) ))??
      to reproduce the Original Work in copies, either alone or as part of a
      collective work;

      (( b) ))??
      to translate, adapt, alter, transform, modify, or arrange the Original
      Work, thereby creating derivative works ("Derivative Works") based upon
      the Original Work;

      (( c) ))??
      to distribute or communicate copies of the Original Work and Derivative
      Works to the public, with the proviso that copies of Original Work You
      distribute or communicate shall be licensed under this Upstream
      Compatibility License and all Derivative Work You distribute or
      communicate shall be licensed under both this Upstream Compatibility
      License and the Apache License 2.0 or later;

      (( d) ))??
      to perform the Original Work publicly; and

      (( e) ))??
      to display the Original Work publicly.

   (( 2) ))??
   Grant of Patent License. Licensor grants You a worldwide, royalty-free,
   non-exclusive, sublicensable license, under patent claims owned or controlled
   by the Licensor that are embodied in the Original Work as furnished by the
   Licensor, for the duration of the patents, to make, use, sell, offer for
   sale, have made, and import the Original Work and Derivative Works.

   (( 3) ))??
   Grant of Source Code License. The term "Source Code" means the preferred form
   of the Original Work for making modifications to it and all available
   documentation describing how to modify the Original Work. Licensor agrees to
   provide a machine-readable copy of the Source Code of the Original Work along
   with each copy of the Original Work that Licensor distributes. Licensor
   reserves the right to satisfy this obligation by placing a machine-readable
   copy of the Source Code in an information repository reasonably calculated to
   permit inexpensive and convenient access by You for as long as Licensor
   continues to distribute the Original Work.

   (( 4) ))??
   Exclusions From License Grant. Neither the names of Licensor, nor the names
   of any contributors to the Original Work, nor any of their trademarks or
   service marks, may be used to endorse or promote products derived from this
   Original Work without express prior permission of the Licensor. Except as
   expressly stated herein, nothing in this License grants any license to
   Licensor's trademarks, copyrights, patents, trade secrets or any other
   intellectual property. No patent license is granted to make, use, sell, offer
   for sale, have made, or import embodiments of any patent claims other than
   the licensed claims defined in Section 2. No license is granted to the
   trademarks of Licensor even if such marks are included in the Original Work.
   Nothing in this License shall be interpreted to prohibit Licensor from
   licensing under terms different from this License any Original Work that
   Licensor otherwise would have a right to license.

   (( 5) ))??
   External Deployment. The term "External Deployment" means the use,
   distribution, or communication of the Original Work or Derivative Works in
   any way such that the Original Work or Derivative Works may be used by anyone
   other than You, whether those works are distributed or communicated to those
   persons or made available as an application intended for use over a network.
   As an express condition for the grants of license hereunder, You must treat
   any External Deployment by You of the Original Work or a Derivative Work as a
   distribution under section 1(c).

   (( 6) ))??
   Attribution Rights. You must retain, in the Source Code of any Derivative
   Works that You create, all copyright, patent, or trademark notices from the
   Source Code of the Original Work, as well as any notices of licensing and any
   descriptive text identified therein as an "Attribution Notice." You must
   cause the Source Code for any Derivative Works that You create to carry a
   prominent Attribution Notice reasonably calculated to inform recipients that
   You have modified the Original Work.

   (( 7) ))??
   Warranty of Provenance and Disclaimer of Warranty. Licensor warrants that the
   copyright in and to the Original Work and the patent rights granted herein by
   Licensor are owned by the Licensor or are sublicensed to You under the terms
   of this License with the permission of the contributor(s) of those copyrights
   and patent rights. Except as expressly stated in the immediately preceding
   sentence, the Original Work is provided under this License on an "AS IS"
   BASIS and WITHOUT WARRANTY, either express or implied, including, without
   limitation, the warranties of non-infringement, merchantability or fitness
   for a particular purpose. THE ENTIRE RISK AS TO THE QUALITY OF THE ORIGINAL
   WORK IS WITH YOU. This DISCLAIMER OF WARRANTY constitutes an essential part
   of this License. No license to the Original Work is granted by this License
   except under this disclaimer.

   (( 8) ))??
   Limitation of Liability. Under no circumstances and under no legal theory,
   whether in tort (including negligence), contract, or otherwise, shall the
   Licensor be liable to anyone for any indirect, special, incidental, or
   consequential damages of any character arising as a result of this License or
   the use of the Original Work including, without limitation, damages for loss
   of goodwill, work stoppage, computer failure or malfunction, or any and all
   other commercial damages or losses. This limitation of liability shall not
   apply to the extent applicable law prohibits such limitation.

   (( 9) ))??
   Acceptance and Termination. If, at any time, You expressly assented to this
   License, that assent indicates your clear and irrevocable acceptance of this
   License and all of its terms and conditions. If You distribute or communicate
   copies of the Original Work or a Derivative Work, You must make a reasonable
   effort under the circumstances to obtain the express assent of recipients to
   the terms of this License. This License conditions your rights to undertake
   the activities listed in Section 1, including your right to create Derivative
   Works based upon the Original Work, and doing so without honoring these terms
   and conditions is prohibited by copyright law and international treaty.
   Nothing in this License is intended to affect copyright exceptions and
   limitations (including "fair use" or "fair dealing"). This License shall
   terminate immediately and You may no longer exercise any of the rights
   granted to You by this License upon your failure to honor the conditions in
   Section 1(c).

   (( 10) ))??
   Termination for Patent Action. This License shall terminate automatically and
   You may no longer exercise any of the rights granted to You by this License
   as of the date You commence an action, including a cross-claim or
   counterclaim, against Licensor or any licensee alleging that the Original
   Work infringes a patent. This termination provision shall not apply for an
   action alleging patent infringement by combinations of the Original Work with
   other software or hardware.

   (( 11) ))??
   Jurisdiction, Venue and Governing Law. Any action or suit relating to this
   License may be brought only in the courts of a jurisdiction wherein the
   Licensor resides or in which Licensor conducts its primary business, and
   under the laws of that jurisdiction excluding its conflict-of-law provisions.
   The application of the United Nations Convention on Contracts for the
   International Sale of Goods is expressly excluded. Any use of the Original
   Work outside the scope of this License or after its termination shall be
   subject to the requirements and penalties of copyright or patent law in the
   appropriate jurisdiction. This section shall survive the termination of this
   License.

   (( 12) ))??
   Attorneys' Fees. In any action to enforce the terms of this License or
   seeking damages relating thereto, the prevailing party shall be entitled to
   recover its costs and expenses, including, without limitation, reasonable
   attorneys' fees and costs incurred in connection with such action, including
   any appeal of such action. This section shall survive the termination of this
   License.

   (( 13) ))??
   Miscellaneous. If any provision of this License is held to be unenforceable,
   such provision shall be reformed only to the extent necessary to make it
   enforceable.

   (( 14) ))??
   Definition of "You" in This License. "You" throughout this License, whether
   in upper or lower case, means an individual or a legal entity exercising
   rights under, and complying with all of the terms of, this License. For legal
   entities, "You" includes any entity that controls, is controlled by, or is
   under common control with you. For purposes of this definition, "control"
   means (i) the power, direct or indirect, to cause the direction or management
   of such entity, whether by contract or otherwise, or (ii) ownership of fifty
   percent (50%) or more of the outstanding shares, or (iii) beneficial
   ownership of such entity.

   (( 15) ))??
   Right to Use. You may use the Original Work in all ways not otherwise
   restricted or conditioned by this License or by law, and Licensor promises
   not to interfere with or be responsible for such uses by You.

   (( 16) ))??
   Modification of This License. This License is Copyright (c) 2005 Lawrence
   Rosen and Copyright (c) 2017 Nigel Tzeng. Permission is granted to copy,
   distribute, or communicate this License without modification. Nothing in this
   License permits You to modify this License as applied to the Original Work or
   to Derivative Works. However, You may modify the text of this License and
   copy, distribute or communicate your modified version (the "Modified
   License") and apply it to other original works of authorship subject to the
   following conditions: (i) You may not indicate in any way that your Modified
   License is the "Open Software License" or "OSL" or the "Upstream
   Compatibility License" or "UCL" and you may not use those names in the name
   of your Modified License; (ii) You must replace the notice specified in the
   first paragraph above with the notice "Licensed under
   (( <insert your license name here> ))??
   " or with a notice of your own that is not confusingly similar to the notice
   in this License; and (iii) You may not claim that your original works are
   open source software unless your Modified License has been approved by Open
   Source Initiative (OSI) and You comply with its license review and
   certification process.
//**
CC-BY-1.0
https://creativecommons.org/licenses/by/1.0
**//

((Creative Commons))??

Creative Commons

Attribution 1.0

((
CREATIVE COMMONS CORPORATION IS NOT A LAW FIRM AND DOES NOT PROVIDE
LEGAL
SERVICES. DISTRIBUTION OF THIS DRAFT LICENSE DOES NOT CREATE AN
ATTORNEY-CLIENT RELATIONSHIP. CREATIVE COMMONS PROVIDES THIS INFORMATION
ON
AN "AS-IS" BASIS. CREATIVE COMMONS MAKES NO WARRANTIES REGARDING THE
INFORMATION PROVIDED, AND DISCLAIMS LIABILITY FOR DAMAGES RESULTING
FROM
ITS USE.
))??

((License))??

THE WORK (AS DEFINED BELOW) IS PROVIDED UNDER THE TERMS OF THIS CREATIVE COMMONS
PUBLIC LICENSE ("CCPL" OR "LICENSE").  THE WORK IS PROTECTED BY COPYRIGHT AND/OR
OTHER APPLICABLE LAW.  ANY USE OF THE WORK OTHER THAN AS AUTHORIZED UNDER THIS
LICENSE IS PROHIBITED.

BY EXERCISING ANY RIGHTS TO THE WORK PROVIDED HERE, YOU ACCEPT AND AGREE TO BE
BOUND BY THE TERMS OF THIS LICENSE.  THE LICENSOR GRANTS YOU THE RIGHTS
CONTAINED HERE IN CONSIDERATION OF YOUR ACCEPTANCE OF SUCH TERMS AND CONDITIONS.

1. Definitions

__1__
"Collective Work" means a work, such as a periodical issue, anthology or
encyclopedia, in which the Work in its entirety in unmodified form, along with a
number of other contributions, constituting separate and independent works in
themselves, are assembled into a collective whole.  A work that constitutes a
Collective Work will not be considered a Derivative Work (as defined below) for
the purposes of this License.

__1__
"Derivative Work" means a work based upon the Work or upon the Work and other
pre-existing works, such as a translation, musical arrangement, dramatization,
fictionalization, motion picture version, sound recording, art reproduction,
abridgment, condensation, or any other form in which the Work may be recast,
transformed, or adapted, except that a work that constitutes a Collective Work
will not be considered a Derivative Work for the purpose of this License.

__1__
"Licensor" means the individual or entity that offers the Work under the terms
of this License.

__1__
"Original Author" means the individual or entity who created the Work.

__1__
"Work" means the copyrightable work of authorship offered under the terms of
this License.

__1__
"You" means an individual or entity exercising rights under this License who has
not previously violated the terms of this License with respect to the Work, or
who has received express permission from the Licensor to exercise rights under
this License despite a previous violation.

2. Fair Use Rights. Nothing in this license is intended to reduce, limit, or
restrict any rights arising from fair use, first sale or other limitations on
the exclusive rights of the copyright owner under copyright law or other
applicable laws.

3. License Grant.  Subject to the terms and conditions of this License, Licensor
hereby grants You a worldwide, royalty-free, non-exclusive, perpetual (for the
duration of the applicable copyright) license to exercise the rights in the Work
as stated below:

__1__
to reproduce the Work, to incorporate the Work into one or more Collective
Works, and to reproduce the Work as incorporated in the Collective Works;

__1__
to create and reproduce Derivative Works;

__1__
to distribute copies or phonorecords of, display publicly, perform publicly, and
perform publicly by means of a digital audio transmission the Work including as
incorporated in Collective Works;

__1__
to distribute copies or phonorecords of, display publicly, perform publicly, and
perform publicly by means of a digital audio transmission Derivative Works;

The above rights may be exercised in all media and formats whether now known or
hereafter devised.  The above rights include the right to make such
modifications as are technically necessary to exercise the rights in other media
and formats.  All rights not expressly granted by Licensor are hereby reserved.

4. Restrictions. The license granted in Section 3 above is expressly made
subject to and limited by the following restrictions:

__1__
You may distribute, publicly display, publicly perform, or publicly digitally
perform the Work only under the terms of this License, and You must include a
copy of, or the Uniform Resource Identifier for, this License with every copy or
phonorecord of the Work You distribute, publicly display, publicly perform, or
publicly digitally perform.  You may not offer or impose any terms on the Work
that alter or restrict the terms of this License or the recipients' exercise of
the rights granted hereunder.  You may not sublicense the Work.  You must keep
intact all notices that refer to this License and to the disclaimer of
warranties. You may not distribute, publicly display, publicly perform, or
publicly digitally perform the Work with any technological measures that control
access or use of the Work in a manner inconsistent with the terms of this
License Agreement.  The above applies to the Work as incorporated in a
Collective Work, but this does not require the Collective Work apart from the
Work itself to be made subject to the terms of this License. If You create a
Collective Work, upon notice from any Licensor You must, to the extent
practicable, remove from the Collective Work any reference to such Licensor or
the Original Author, as requested.  If You create a Derivative Work, upon notice
from any Licensor You must, to the extent practicable, remove from the
Derivative Work any reference to such Licensor or the Original Author, as
requested.

__1__
If you distribute, publicly display, publicly perform, or publicly digitally
perform the Work or any Derivative Works or Collective Works, You must keep
intact all copyright notices for the Work and give the Original Author credit
reasonable to the medium or means You are utilizing by conveying the name (or
pseudonym if applicable) of the Original Author if supplied; the title of the
Work if supplied; in the case of a Derivative Work, a credit identifying the use
of the Work in the Derivative Work (e.g., "French translation of the Work by
Original Author," or "Screenplay based on original Work by Original Author").
Such credit may be implemented in any reasonable manner; provided, however, that
in the case of a Derivative Work or Collective Work, at a minimum such credit
will appear where any other comparable authorship credit appears and in a manner
at least as prominent as such other comparable authorship credit.

5. Representations, Warranties and Disclaimer

__1__
By offering the Work for public release under this License, Licensor represents
and warrants that, to the best of Licensor's knowledge after reasonable
inquiry:

__1__
Licensor has secured all rights in the Work necessary to grant the license
rights hereunder and to permit the lawful exercise of the rights granted
hereunder without You having any obligation to pay any royalties, compulsory
license fees, residuals or any other payments;

__1__
The Work does not infringe the copyright, trademark, publicity rights, common
law rights or any other right of any third party or constitute defamation,
invasion of privacy or other tortious injury to any third party.

__1__
EXCEPT AS EXPRESSLY STATED IN THIS LICENSE OR OTHERWISE AGREED IN WRITING OR
REQUIRED BY APPLICABLE LAW, THE WORK IS LICENSED ON AN "AS IS" BASIS, WITHOUT
WARRANTIES OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT LIMITATION,
ANY WARRANTIES REGARDING THE CONTENTS OR ACCURACY OF THE WORK.

6. Limitation on Liability.  EXCEPT TO THE EXTENT REQUIRED BY APPLICABLE LAW,
AND EXCEPT FOR DAMAGES ARISING FROM LIABILITY TO A THIRD PARTY RESULTING FROM
BREACH OF THE WARRANTIES IN SECTION 5, IN NO EVENT WILL LICENSOR BE LIABLE TO
YOU ON ANY LEGAL THEORY FOR ANY SPECIAL, INCIDENTAL, CONSEQUENTIAL, PUNITIVE OR
EXEMPLARY DAMAGES ARISING OUT OF THIS LICENSE OR THE USE OF THE WORK, EVEN IF
LICENSOR HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

7. Termination

__1__
This License and the rights granted hereunder will terminate automatically upon
any breach by You of the terms of this License. Individuals or entities who have
received Derivative Works or Collective Works from You under this License,
however, will not have their licenses terminated provided such individuals or
entities remain in full compliance with those licenses. Sections 1, 2, 5, 6, 7,
and 8 will survive any termination of this License.

__1__
Subject to the above terms and conditions, the license granted here is perpetual
(for the duration of the applicable copyright in the Work).  Notwithstanding the
above, Licensor reserves the right to release the Work under different license
terms or to stop distributing the Work at any time; provided, however that any
such election will not serve to withdraw this License (or any other license that
has been, or is required to be, granted under the terms of this License), and
this License will continue in full force and effect unless terminated as stated
above.

8. Miscellaneous

__1__
Each time You distribute or publicly digitally perform the Work or a Collective
Work, the Licensor offers to the recipient a license to the Work on the same
terms and conditions as the license granted to You under this License.

__1__
Each time You distribute or publicly digitally perform a Derivative Work,
Licensor offers to the recipient a license to the original Work on the same
terms and conditions as the license granted to You under this License.

__1__
If any provision of this License is invalid or unenforceable under applicable
law, it shall not affect the validity or enforceability of the remainder of the
terms of this License, and without further action by the parties to this
agreement, such provision shall be reformed to the minimum extent necessary to
make such provision valid and enforceable.

__1__
No term or provision of this License shall be deemed waived and no breach
consented to unless such waiver or consent shall be in writing and signed by the
party to be charged with such waiver or consent.

__1__
This License constitutes the entire agreement between the parties with respect
to the Work licensed here.  There are no understandings, agreements or
representations with respect to the Work not specified here.  Licensor shall not
be bound by any additional provisions that may appear in any communication from
You. This License may not be modified without the mutual written agreement of
the Licensor and You.

((
Creative Commons is not a party to this License, and makes no warranty
whatsoever in connection with the Work.  Creative Commons will not be liable to
You or any party on any legal theory for any damages whatsoever, including
without limitation any general, special, incidental or consequential damages
arising in connection to this license.  Notwithstanding the foregoing two (2)
sentences, if Creative Commons has expressly identified itself as the Licensor
hereunder, it shall have all rights and obligations of Licensor.

Except for the limited purpose of indicating to the public that the Work is
licensed under the CCPL, neither party will use the trademark "Creative Commons"
or any related trademark or logo of Creative Commons without the prior written
consent of Creative Commons.  Any permitted use will be in compliance with
Creative Commons' then-current trademark usage guidelines, as may be published
on its website or otherwise made available upon request from time to time.

Creative Commons may be contacted at https://creativecommons.org/.
))??
//**
Solderpad Hardware License v0.5
https://spdx.org/licenses/SHL-0.5.json
https://solderpad.org/licenses/SHL-0.5/
**//

SOLDERPAD HARDWARE LICENSE version 0.5

This license is based closely on the Apache License Version 2.0, but is not
approved or endorsed by the Apache Foundation. A copy of the non-modified Apache
License 2.0 can be found at http:/www.apache.org/licenses/LICENSE-2.0.

As this license is not currently OSI or FSF approved, the Licensor permits any
Work licensed under this License, at the option of the Licensee, to be treated
as licensed under the Apache License Version 2.0 (which is so approved).

This License is licensed under the terms of this License and in particular
clause 7 below (Disclaimer of Warranties) applies in relation to its use.

TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION

1. Definitions.

"License" shall mean the terms and conditions for use, reproduction, and
distribution as defined by Sections 1 through 9 of this document.

"Licensor" shall mean the Rights owner or entity authorized by the Rights owner
that is granting the License.

"Legal Entity" shall mean the union of the acting entity and all other entities
that control, are controlled by, or are under common control with that entity.
For the purposes of this definition, "control" means (i) the power, direct or
indirect, to cause the direction or management of such entity, whether by
contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the
outstanding shares, or (iii) beneficial ownership of such entity.

"You" (or "Your") shall mean an individual or Legal Entity exercising
permissions granted by this License.

"Rights" means copyright and any similar right including design right (whether
registered or unregistered), semiconductor topography (mask) rights and database
extraction rights (but excluding Patents and Trademarks).

"Source" form shall mean the preferred form for making modifications, including
but not limited to source code, net lists, board layouts, CAD files,
documentation source, and configuration files.

"Object" form shall mean any form resulting from mechanical transformation or
translation of a Source form, including but not limited to compiled object code,
generated documentation, the instantiation of a hardware design and conversions
to other media types, including intermediate forms such as bytecodes, FPGA
bitstreams, artwork and semiconductor topographies (mask works).

"Work" shall mean the work of authorship, whether in Source form or other Object
form, made available under the License, as indicated by a Rights notice that is
included in or attached to the work (an example is provided in the Appendix
below).

"Derivative Works" shall mean any work, whether in Source or Object form, that
is based on (or derived from) the Work and for which the editorial revisions,
annotations, elaborations, or other modifications represent, as a whole, an
original work of authorship. For the purposes of this License, Derivative Works
shall not include works that remain separable from, or merely link (or bind by
name) or physically connect to or interoperate with the interfaces of, the Work
and Derivative Works thereof.

"Contribution" shall mean any design or work of authorship, including the
original version of the Work and any modifications or additions to that Work or
Derivative Works thereof, that is intentionally submitted to Licensor for
inclusion in the Work by the Rights owner or by an individual or Legal Entity
authorized to submit on behalf of the Rights owner. For the purposes of this
definition, "submitted" means any form of electronic, verbal, or written
communication sent to the Licensor or its representatives, including but not
limited to communication on electronic mailing lists, source code control
systems, and issue tracking systems that are managed by, or on behalf of, the
Licensor for the purpose of discussing and improving the Work, but excluding
communication that is conspicuously marked or otherwise designated in writing by
the Rights owner as "Not a Contribution."

"Contributor" shall mean Licensor and any individual or Legal Entity on behalf
of whom a Contribution has been received by Licensor and subsequently
incorporated within the Work.

2. Grant of License. Subject to the terms and conditions of this License, each
Contributor hereby grants to You a perpetual, worldwide, non-exclusive,
no-charge, royalty-free, irrevocable license under the Rights to reproduce,
prepare Derivative Works of, publicly display, publicly perform, sublicense, and
distribute the Work and such Derivative Works in Source or Object form and do
anything in relation to the Work as if the Rights did not exist.

3. Grant of Patent License. Subject to the terms and conditions of this License,
each Contributor hereby grants to You a perpetual, worldwide, non-exclusive,
no-charge, royalty-free, irrevocable (except as stated in this section) patent
license to make, have made, use, offer to sell, sell, import, and otherwise
transfer the Work, where such license applies only to those patent claims
licensable by such Contributor that are necessarily infringed by their
Contribution(s) alone or by combination of their Contribution(s) with the Work
to which such Contribution(s) was submitted. If You institute patent litigation
against any entity (including a cross-claim or counterclaim in a lawsuit)
alleging that the Work or a Contribution incorporated within the Work
constitutes direct or contributory patent infringement, then any patent licenses
granted to You under this License for that Work shall terminate as of the date
such litigation is filed.

4. Redistribution. You may reproduce and distribute copies of the Work or
Derivative Works thereof in any medium, with or without modifications, and in
Source or Object form, provided that You meet the following conditions:

You must give any other recipients of the Work or Derivative Works a copy of
this License; and

You must cause any modified files to carry prominent notices stating that You
changed the files; and

You must retain, in the Source form of any Derivative Works that You distribute,
all copyright, patent, trademark, and attribution notices from the Source form
of the Work, excluding those notices that do not pertain to any part of the
Derivative Works; and

If the Work includes a "NOTICE" text file as part of its distribution, then any
Derivative Works that You distribute must include a readable copy of the
attribution notices contained within such NOTICE file, excluding those notices
that do not pertain to any part of the Derivative Works, in at least one of the
following places: within a NOTICE text file distributed as part of the
Derivative Works; within the Source form or documentation, if provided along
with the Derivative Works; or, within a display generated by the Derivative
Works, if and wherever such third-party notices normally appear. The contents of
the NOTICE file are for informational purposes only and do not modify the
License. You may add Your own attribution notices within Derivative Works that
You distribute, alongside or as an addendum to the NOTICE text from the Work,
provided that such additional attribution notices cannot be construed as
modifying the License. You may add Your own copyright statement to Your
modifications and may provide additional or different license terms and
conditions for use, reproduction, or distribution of Your modifications, or for
any such Derivative Works as a whole, provided Your use, reproduction, and
distribution of the Work otherwise complies with the conditions stated in this
License.

5. Submission of Contributions. Unless You explicitly state otherwise, any
Contribution intentionally submitted for inclusion in the Work by You to the
Licensor shall be under the terms and conditions of this License, without any
additional terms or conditions. Notwithstanding the above, nothing herein shall
supersede or modify the terms of any separate license agreement you may have
executed with Licensor regarding such Contributions.

6. Trademarks. This License does not grant permission to use the trade names,
trademarks, service marks, or product names of the Licensor, except as required
for reasonable and customary use in describing the origin of the Work and
reproducing the content of the NOTICE file.

7. Disclaimer of Warranty. Unless required by applicable law or agreed to in
writing, Licensor provides the Work (and each Contributor provides its
Contributions) on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, either express or implied, including, without limitation, any warranties
or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A
PARTICULAR PURPOSE. You are solely responsible for determining the
appropriateness of using or redistributing the Work and assume any risks
associated with Your exercise of permissions under this License.

8. Limitation of Liability. In no event and under no legal theory, whether in
tort (including negligence), contract, or otherwise, unless required by
applicable law (such as deliberate and grossly negligent acts) or agreed to in
writing, shall any Contributor be liable to You for damages, including any
direct, indirect, special, incidental, or consequential damages of any character
arising as a result of this License or out of the use or inability to use the
Work (including but not limited to damages for loss of goodwill, work stoppage,
computer failure or malfunction, or any and all other commercial damages or
losses), even if such Contributor has been advised of the possibility of such
damages.

9. Accepting Warranty or Additional Liability. While redistributing the Work or
Derivative Works thereof, You may choose to offer, and charge a fee for,
acceptance of support, warranty, indemnity, or other liability obligations
and/or rights consistent with this License. However, in accepting such
obligations, You may act only on Your own behalf and on Your sole
responsibility, not on behalf of any other Contributor, and only if You agree to
indemnify, defend, and hold each Contributor harmless for any liability incurred
by, or claims asserted against, such Contributor by reason of your accepting any
such warranty or additional liability.

END OF TERMS AND CONDITIONS

APPENDIX: How to apply this license to your work

To apply this license to your work, attach the following boilerplate notice,
with the fields enclosed by brackets "[]" replaced with your own identifying
information. (Don't include the brackets!) The text should be enclosed in the
appropriate comment syntax for the file format. We also recommend that a file or
class name and description of purpose be included on the same "printed page" as
the copyright notice for easier identification within third-party archives.

Copyright [yyyy] [name of copyright owner] Copyright and related rights are
licensed under the Solderpad Hardware License, Version 0.5 (the "License"); you
may not use this file except in compliance with the License. You may obtain a
copy of the License at http:/solderpad.org/licenses/SHL-0.5. Unless required by
applicable law or agreed to in writing, software, hardware and materials
distributed under this License is distributed on an "AS IS" BASIS, WITHOUT
WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License
for the specific language governing permissions and limitations under the
License.
//**
CC-BY-ND-2.0
https://creativecommons.org/licenses/by-nd/2.0
**//

((Creative Commons))??

Creative Commons

Attribution-NoDerivs 2.0

((
CREATIVE COMMONS CORPORATION IS NOT A LAW FIRM AND DOES NOT PROVIDE
LEGAL
SERVICES. DISTRIBUTION OF THIS LICENSE DOES NOT CREATE AN
ATTORNEY-CLIENT RELATIONSHIP. CREATIVE COMMONS PROVIDES THIS INFORMATION
ON
AN "AS-IS" BASIS. CREATIVE COMMONS MAKES NO WARRANTIES REGARDING THE
INFORMATION PROVIDED, AND DISCLAIMS LIABILITY FOR DAMAGES RESULTING
FROM
ITS USE.
))??

((License))??

THE WORK (AS DEFINED BELOW) IS PROVIDED UNDER THE TERMS OF THIS CREATIVE COMMONS
PUBLIC LICENSE ("CCPL" OR "LICENSE").  THE WORK IS PROTECTED BY COPYRIGHT AND/OR
OTHER APPLICABLE LAW.  ANY USE OF THE WORK OTHER THAN AS AUTHORIZED UNDER THIS
LICENSE OR COPYRIGHT LAW IS PROHIBITED.

BY EXERCISING ANY RIGHTS TO THE WORK PROVIDED HERE, YOU ACCEPT AND AGREE TO BE
BOUND BY THE TERMS OF THIS LICENSE.  THE LICENSOR GRANTS YOU THE RIGHTS
CONTAINED HERE IN CONSIDERATION OF YOUR ACCEPTANCE OF SUCH TERMS AND CONDITIONS.

1. Definitions

__1__
"Collective Work" means a work, such as a periodical issue, anthology or
encyclopedia, in which the Work in its entirety in unmodified form, along with a
number of other contributions, constituting separate and independent works in
themselves, are assembled into a collective whole.  A work that constitutes a
Collective Work will not be considered a Derivative Work (as defined below) for
the purposes of this License.

__1__
"Derivative Work" means a work based upon the Work or upon the Work and other
pre-existing works, such as a translation, musical arrangement, dramatization,
fictionalization, motion picture version, sound recording, art reproduction,
abridgment, condensation, or any other form in which the Work may be recast,
transformed, or adapted, except that a work that constitutes a Collective Work
will not be considered a Derivative Work for the purpose of this License. For
the avoidance of doubt, where the Work is a musical composition or sound
recording, the synchronization of the Work in timed-relation with a moving image
("synching") will be considered a Derivative Work for the purpose of this
License.

__1__
"Licensor" means the individual or entity that offers the Work under the terms
of this License.

__1__
"Original Author" means the individual or entity who created the Work.

__1__
"Work" means the copyrightable work of authorship offered under the terms of
this License.

__1__
"You" means an individual or entity exercising rights under this License who has
not previously violated the terms of this License with respect to the Work, or
who has received express permission from the Licensor to exercise rights under
this License despite a previous violation.

2. Fair Use Rights. Nothing in this license is intended to reduce, limit, or
restrict any rights arising from fair use, first sale or other limitations on
the exclusive rights of the copyright owner under copyright law or other
applicable laws.

3. License Grant.  Subject to the terms and conditions of this License, Licensor
hereby grants You a worldwide, royalty-free, non-exclusive, perpetual (for the
duration of the applicable copyright) license to exercise the rights in the Work
as stated below:

__1__
to reproduce the Work, to incorporate the Work into one or more Collective
Works, and to reproduce the Work as incorporated in the Collective Works;

__1__
to distribute copies or phonorecords of, display publicly, perform publicly, and
perform publicly by means of a digital audio transmission the Work including as
incorporated in Collective Works.

__1__
For the avoidance of doubt, where the work is a musical composition:

__1__ Performance Royalties Under Blanket Licenses. Licensor waives the
exclusive right to collect, whether individually or via a performance rights
society (e.g. ASCAP, BMI, SESAC), royalties for the public performance or public
digital performance (e.g. webcast) of the Work.

__1__ Mechanical Rights and Statutory Royalties. Licensor waives the exclusive
right to collect, whether individually or via a music rights society or
designated agent (e.g. Harry Fox Agency), royalties for any phonorecord You
create from the Work ("cover version") and distribute, subject to the compulsory
license created by 17 USC Section 115 of the US Copyright Act (or the equivalent
in other jurisdictions).

__1__ Webcasting Rights and Statutory Royalties. For the avoidance of doubt,
where the Work is a sound recording, Licensor waives the exclusive right to
collect, whether individually or via a performance-rights society (e.g.
SoundExchange), royalties for the public digital performance (e.g. webcast) of
the Work, subject to the compulsory license created by 17 USC Section 114 of the
US Copyright Act (or the equivalent in other jurisdictions).

The above rights may be exercised in all media and formats whether now known or
hereafter devised.  The above rights include the right to make such
modifications as are technically necessary to exercise the rights in other media
and formats, but otherwise you have no rights to make Derivative Works.  All
rights not expressly granted by Licensor are hereby reserved.

4. Restrictions.The license granted in Section 3 above is expressly made subject
to and limited by the following restrictions:

__1__
You may distribute, publicly display, publicly perform, or publicly digitally
perform the Work only under the terms of this License, and You must include a
copy of, or the Uniform Resource Identifier for, this License with every copy or
phonorecord of the Work You distribute, publicly display, publicly perform, or
publicly digitally perform.  You may not offer or impose any terms on the Work
that alter or restrict the terms of this License or the recipients' exercise of
the rights granted hereunder.  You may not sublicense the Work.  You must keep
intact all notices that refer to this License and to the disclaimer of
warranties. You may not distribute, publicly display, publicly perform, or
publicly digitally perform the Work with any technological measures that control
access or use of the Work in a manner inconsistent with the terms of this
License Agreement.  The above applies to the Work as incorporated in a
Collective Work, but this does not require the Collective Work apart from the
Work itself to be made subject to the terms of this License. If You create a
Collective Work, upon notice from any Licensor You must, to the extent
practicable, remove from the Collective Work any reference to such Licensor or
the Original Author, as requested.

__1__
If you distribute, publicly display, publicly perform, or publicly digitally
perform the Work or Collective Works, You must keep intact all copyright notices
for the Work and give the Original Author credit reasonable to the medium or
means You are utilizing by conveying the name (or pseudonym if applicable) of
the Original Author if supplied; the title of the Work if supplied; and to the
extent reasonably practicable, the Uniform Resource Identifier, if any, that
Licensor specifies to be associated with the Work, unless such URI does not
refer to the copyright notice or licensing information for the Work. Such credit
may be implemented in any reasonable manner; provided, however, that in the case
of a Collective Work, at a minimum such credit will appear where any other
comparable authorship credit appears and in a manner at least as prominent as
such other comparable authorship credit.

5. Representations, Warranties and Disclaimer

UNLESS OTHERWISE MUTUALLY AGREED TO BY THE PARTIES IN WRITING, LICENSOR OFFERS
THE WORK AS-IS AND MAKES NO REPRESENTATIONS OR WARRANTIES OF ANY KIND CONCERNING
THE MATERIALS, EXPRESS, IMPLIED, STATUTORY OR OTHERWISE, INCLUDING, WITHOUT
LIMITATION, WARRANTIES OF TITLE, MERCHANTIBILITY, FITNESS FOR A PARTICULAR
PURPOSE, NONINFRINGEMENT, OR THE ABSENCE OF LATENT OR OTHER DEFECTS, ACCURACY,
OR THE PRESENCE OF ABSENCE OF ERRORS, WHETHER OR NOT DISCOVERABLE. SOME
JURISDICTIONS DO NOT ALLOW THE EXCLUSION OF IMPLIED WARRANTIES, SO SUCH
EXCLUSION MAY NOT APPLY TO YOU.

6. Limitation on Liability.  EXCEPT TO THE EXTENT REQUIRED BY APPLICABLE LAW, IN
NO EVENT WILL LICENSOR BE LIABLE TO YOU ON ANY LEGAL THEORY FOR ANY SPECIAL,
INCIDENTAL, CONSEQUENTIAL, PUNITIVE OR EXEMPLARY DAMAGES ARISING OUT OF THIS
LICENSE OR THE USE OF THE WORK, EVEN IF LICENSOR HAS BEEN ADVISED OF THE
POSSIBILITY OF SUCH DAMAGES.

7. Termination

__1__
This License and the rights granted hereunder will terminate automatically upon
any breach by You of the terms of this License. Individuals or entities who have
received Collective Works from You under this License, however, will not have
their licenses terminated provided such individuals or entities remain in full
compliance with those licenses. Sections 1, 2, 5, 6, 7, and 8 will survive any
termination of this License.

__1__
Subject to the above terms and conditions, the license granted here is perpetual
(for the duration of the applicable copyright in the Work).  Notwithstanding the
above, Licensor reserves the right to release the Work under different license
terms or to stop distributing the Work at any time; provided, however that any
such election will not serve to withdraw this License (or any other license that
has been, or is required to be, granted under the terms of this License), and
this License will continue in full force and effect unless terminated as stated
above.

8. Miscellaneous

__1__
Each time You distribute or publicly digitally perform the Work, the Licensor
offers to the recipient a license to the Work on the same terms and conditions
as the license granted to You under this License.

__1__
If any provision of this License is invalid or unenforceable under applicable
law, it shall not affect the validity or enforceability of the remainder of the
terms of this License, and without further action by the parties to this
agreement, such provision shall be reformed to the minimum extent necessary to
make such provision valid and enforceable.

__1__
No term or provision of this License shall be deemed waived and no breach
consented to unless such waiver or consent shall be in writing and signed by the
party to be charged with such waiver or consent.

__1__
This License constitutes the entire agreement between the parties with respect
to the Work licensed here.  There are no understandings, agreements or
representations with respect to the Work not specified here.  Licensor shall not
be bound by any additional provisions that may appear in any communication from
You. This License may not be modified without the mutual written agreement of
the Licensor and You.

((
Creative Commons is not a party to this License, and makes no warranty
whatsoever in connection with the Work.  Creative Commons will not be liable to
You or any party on any legal theory for any damages whatsoever, including
without limitation any general, special, incidental or consequential damages
arising in connection to this license.  Notwithstanding the foregoing two (2)
sentences, if Creative Commons has expressly identified itself as the Licensor
hereunder, it shall have all rights and obligations of Licensor.

Except for the limited purpose of indicating to the public that the Work is
licensed under the CCPL, neither party will use the trademark "Creative Commons"
or any related trademark or logo of Creative Commons without the prior written
consent of Creative Commons.  Any permitted use will be in compliance with
Creative Commons' then-current trademark usage guidelines, as may be published
on its website or otherwise made available upon request from time to time.

Creative Commons may be contacted at https://creativecommons.org/.
))??
//**
Community Data License Agreement Permissive 1.0
https://spdx.org/licenses/CDLA-Permissive-1.0.json
https://cdla.io/permissive-1-0
**//

(( Community Data License Agreement - Permissive - Version 1.0 ))??

This is the Community Data License Agreement - Permissive, Version 1.0
("Agreement"). Data is provided to You under this Agreement by each of the Data
Providers. Your exercise of any of the rights and permissions granted below
constitutes Your acceptance and agreement to be bound by the terms and
conditions of this Agreement.

The benefits that each Data Provider receives from making Data available and
that You receive from Data or otherwise under these terms and conditions shall
be deemed sufficient consideration for the formation of this Agreement.
Accordingly, Data Provider(s) and You (the "Parties") agree as follows:

   (( Section 1. ))??
   Definitions

      (( 1.1 ))??
      "Add" means to supplement Data with Your own or someone else's Data,
      resulting in Your "Additions." Additions do not include Results.

      (( 1.2 ))??
      "Computational Use" means Your analysis (through the use of computational
      devices or otherwise) or other interpretation of Data. By way of example
      and not limitation, "Computational Use" includes the application of any
      computational analytical technique, the purpose of which is the analysis
      of any Data in digital form to generate information about Data such as
      patterns, trends, correlations, inferences, insights and attributes.

      (( 1.3 ))??
      "Data" means the information (including copyrightable information, such as
      images or text), collectively or individually, whether created or gathered
      by a Data Provider or an Entity acting on its behalf, to which rights are
      granted under this Agreement.

      (( 1.4 ))??
      "Data Provider" means any Entity (including any employee or contractor of
      such Entity authorized to Publish Data on behalf of such Entity) that
      Publishes Data under this Agreement prior to Your Receiving it.

      (( 1.5 ))??
      "Enhanced Data" means the subset of Data that You Publish and that is
      composed of (a) Your Additions and/or (b) Modifications to Data You have
      received under this Agreement.

      (( 1.6 ))??
      "Entity" means any natural person or organization that exists under the
      laws of the jurisdiction in which it is organized, together with all other
      entities that control, are controlled by, or are under common control with
      that entity. For the purposes of this definition, "control" means (a) the
      power, directly or indirectly, to cause the direction or management of
      such entity, whether by contract or otherwise, (b) the ownership of more
      than fifty percent (50%) of the outstanding shares or securities, (c) the
      beneficial ownership of such entity or, (d) the ability to appoint,
      whether by agreement or right, the majority of directors of an Entity.

      (( 1.7 ))??
      "Modify" means to delete, erase, correct or re-arrange Data, resulting in
      "Modifications." Modifications do not include Results.

      (( 1.8 ))??
      "Publish" means to make all or a subset of Data (including Your Enhanced
      Data) available in any manner which enables its Use, including by
      providing a copy on physical media or remote access. For any form of
      Entity, that is to make the Data available to any individual who is not
      employed by that Entity or engaged as a contractor or agent to perform
      work on that Entity's behalf. A "Publication" occurs each time You Publish
      Data.

      (( 1.9 ))??
      "Receive" or "Receives" means to have been given access to Data, locally
      or remotely.

      (( 1.10 ))??
      "Results" means the outcomes or outputs that You obtain from Your
      Computational Use of Data. Results shall not include more than a de
      minimis portion of the Data on which the Computational Use is based.

      (( 1.11 ))??
      "Sui Generis Database Rights" means rights, other than copyright,
      resulting from Directive 96/9/EC of the European Parliament and of the
      Council of 11 March 1996 on the legal protection of databases, as amended
      and/or succeeded, as well as other equivalent rights anywhere in the
      world.

      (( 1.12 ))??
      "Use" means using Data (including accessing, copying, studying, reviewing,
      adapting, analyzing, evaluating, or making Computational Use of it),
      either by machines or humans, or a combination of both.

      (( 1.13 ))??
      "You" or "Your" means any Entity that Receives Data under this Agreement.

   (( Section 2. ))??
   Right and License to Use and to Publish

      (( 2.1 ))??
      Subject to the conditions set forth in Section 3 of this Agreement, Data
      Provider(s) hereby grant(s) to You a worldwide, non-exclusive, irrevocable
      (except as provided in Section 5) right to: (a) Use Data; and (b) Publish
      Data.

      (( 2.2 ))??
      To the extent that the Data or the coordination, selection or arrangement
      of Data is protected or protectable under copyright, Sui Generis Database
      Rights, or other law, Data Provider(s) further agree(s) that such Data or
      coordination, selection or arrangement is hereby licensed to You and to
      anyone else who Receives Data under this Agreement for Use and
      Publication, subject to the conditions set forth in Section 3 of this
      Agreement.

      (( 2.3 ))??
      Except for these rights and licenses expressly granted, no other
      intellectual property rights are granted or should be implied.

   (( Section 3. ))??
   Conditions on Rights Granted

      (( 3.1 ))??
      If You Publish Data You Receive or Enhanced Data:

         (( (a) ))??
         You may do so under a license of Your choice provided that You give
         anyone who Receives the Data from You the text of this Agreement, the
         name of this Agreement and/or a hyperlink or other method reasonably
         likely to provide a copy of the text of this Agreement; and

         (( (b) ))??
         You must cause any Data files containing Enhanced Data to carry
         prominent notices that You have changed those files; and

         (( c ))??
         If You Publish Data You Receive, You must preserve all credit or
         attribution to the Data Provider(s). Such retained credit or
         attribution includes any of the following to the extent they exist in
         Data as You have Received it: legal notices or metadata; identification
         of the Data Provider(s); or hyperlinks to Data to the extent it is
         practical to do so.

      (( 3.2 ))??
      You may provide additional or different license terms and conditions for
      use, reproduction, or distribution of that Enhanced Data, or for any
      combination of Data and Enhanced Data as a whole, provided that Your Use
      and Publication of that combined Data otherwise complies with the
      conditions stated in this License.

      (( 3.3 ))??
      You and each Data Provider agree that Enhanced Data shall not be
      considered a work of joint authorship by virtue of its relationship to
      Data licensed under this Agreement and shall not require either any
      obligation of accounting to or the consent of any Data Provider.

      (( 3.4 ))??
      This Agreement imposes no obligations or restrictions on Your Use or
      Publication of Results.

   (( Section 4. ))??
   Data Provider(s)' Representations

      (( 4.1 ))??
      Each Data Provider represents that the Data Provider has exercised
      reasonable care, to assure that: (a) the Data it Publishes was created or
      generated by it or was obtained from others with the right to Publish the
      Data under this Agreement; and (b) Publication of such Data does not
      violate any privacy or confidentiality obligation undertaken by the Data
      Provider.

   (( Section 5. ))??
   Termination

      (( 5.1 ))??
      All of Your rights under this Agreement will terminate, and Your right to
      Receive, Use or Publish the Data will be revoked or modified if You
      materially fail to comply with the terms and conditions of this Agreement
      and You do not cure such failure in a reasonable period of time after
      becoming aware of such noncompliance. If Your rights under this Agreement
      terminate, You agree to cease Receipt, Use and Publication of Data.
      However, Your obligations and any rights and permissions granted by You
      under this Agreement relating to Data that You Published prior to such
      termination will continue and survive.

      (( 5.2 ))??
      If You institute litigation against a Data Provider or anyone else who
      Receives the Data (including a cross-claim in a lawsuit) based on the
      Data, other than a claim asserting breach of this Agreement, then any
      rights previously granted to You to Receive, Use and Publish Data under
      this Agreement will terminate as of the date such litigation is filed.

   (( Section 6. ))??
   Disclaimer of Warranties and Limitation of Liability

      (( 6.1 ))??
      EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE DATA (INCLUDING
      ENHANCED DATA) IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR
      CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT
      LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
      MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.

      (( 6.2 ))??
      NEITHER YOU NOR ANY DATA PROVIDERS SHALL HAVE ANY LIABILITY FOR ANY
      DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
      (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY
      THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
      (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OR
      DISTRIBUTION OF THE DATA OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER,
      EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

   (( Section 7. ))??
   Miscellaneous

      (( 7.1 ))??
      You agree that it is solely Your responsibility to comply with all
      applicable laws with regard to Your Use or Publication of Data, including
      any applicable privacy, data protection, security and export laws. You
      agree to take reasonable steps to assist a Data Provider fulfilling
      responsibilities to comply with applicable laws with regard to Use or
      Publication of Data Received hereunder.

      (( 7.2 ))??
      You and Data Provider(s), collectively and individually, waive and/or
      agree not to assert, to the extent permitted by law, any moral rights You
      or they hold in Data.

      (( 7.3 ))??
      This Agreement confers no rights or remedies upon any person or entity
      other than the Parties and their respective heirs, executors, successors
      and assigns.

      (( 7.4 ))??
      The Data Provider(s) reserve no right or expectation of privacy, data
      protection or confidentiality in any Data that they Publish under this
      Agreement. If You choose to Publish Data under this Agreement, You
      similarly do so with no reservation or expectation of any rights of
      privacy or confidentiality in that Data.

      (( 7.5 ))??
      The Community Data License Agreement workgroup under The Linux Foundation
      is the steward of this Agreement ("Steward"). No one other than the
      Steward has the right to modify or publish new versions of this Agreement.
      Each version will be given a distinguishing version number. You may Use
      and Publish Data Received hereunder under the terms of the version of the
      Agreement under which You originally Received the Data, or under the terms
      of any subsequent version published by the Steward.
//**
Educational Community License v2.0
https://spdx.org/licenses/ECL-2.0.json
https://opensource.org/licenses/ECL-2.0
**//

(( Educational Community License

Version 2.0, April 2007 ))??

(( http:/www.osedu.org/licenses/

The Educational Community License version 2.0 ("ECL") consists of the Apache 2.0
license, modified to change the scope of the patent grant in section 3 to be
specific to the needs of the education communities using this license. The
original Apache 2.0 license can be found at:
http:/www.apache.org/licenses/LICENSE-2.0 ))??

TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION

   (( 1. ))??
   Definitions.

      "License" shall mean the terms and conditions for use, reproduction, and
      distribution as defined by Sections 1 through 9 of this document.

      "Licensor" shall mean the copyright owner or entity authorized by the
      copyright owner that is granting the License.

      "Legal Entity" shall mean the union of the acting entity and all other
      entities that control, are controlled by, or are under common control with
      that entity. For the purposes of this definition, "control" means (i) the
      power, direct or indirect, to cause the direction or management of such
      entity, whether by contract or otherwise, or (ii) ownership of fifty
      percent (50%) or more of the outstanding shares, or (iii) beneficial
      ownership of such entity.

      "You" (or "Your") shall mean an individual or Legal Entity exercising
      permissions granted by this License.

      "Source" form shall mean the preferred form for making modifications,
      including but not limited to software source code, documentation source,
      and configuration files.

      "Object" form shall mean any form resulting from mechanical transformation
      or translation of a Source form, including but not limited to compiled
      object code, generated documentation, and conversions to other media
      types.

      "Work" shall mean the work of authorship, whether in Source or Object
      form, made available under the License, as indicated by a copyright notice
      that is included in or attached to the work (an example is provided in the
      Appendix below).

      "Derivative Works" shall mean any work, whether in Source or Object form,
      that is based on (or derived from) the Work and for which the editorial
      revisions, annotations, elaborations, or other modifications represent, as
      a whole, an original work of authorship. For the purposes of this License,
      Derivative Works shall not include works that remain separable from, or
      merely link (or bind by name) to the interfaces of, the Work and
      Derivative Works thereof.

      "Contribution" shall mean any work of authorship, including the original
      version of the Work and any modifications or additions to that Work or
      Derivative Works thereof, that is intentionally submitted to Licensor for
      inclusion in the Work by the copyright owner or by an individual or Legal
      Entity authorized to submit on behalf of the copyright owner. For the
      purposes of this definition, "submitted" means any form of electronic,
      verbal, or written communication sent to the Licensor or its
      representatives, including but not limited to communication on electronic
      mailing lists, source code control systems, and issue tracking systems
      that are managed by, or on behalf of, the Licensor for the purpose of
      discussing and improving the Work, but excluding communication that is
      conspicuously marked or otherwise designated in writing by the copyright
      owner as "Not a Contribution."

      "Contributor" shall mean Licensor and any individual or Legal Entity on
      behalf of whom a Contribution has been received by Licensor and
      subsequently incorporated within the Work.

   (( 2. ))??
   Grant of Copyright License.

   Subject to the terms and conditions of this License, each Contributor hereby
   grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free,
   irrevocable copyright license to reproduce, prepare Derivative Works of,
   publicly display, publicly perform, sublicense, and distribute the Work and
   such Derivative Works in Source or Object form.

   (( 3. ))??
   Grant of Patent License.

   Subject to the terms and conditions of this License, each Contributor hereby
   grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free,
   irrevocable (except as stated in this section) patent license to make, have
   made, use, offer to sell, sell, import, and otherwise transfer the Work,
   where such license applies only to those patent claims licensable by such
   Contributor that are necessarily infringed by their Contribution(s) alone or
   by combination of their Contribution(s) with the Work to which such
   Contribution(s) was submitted. If You institute patent litigation against any
   entity (including a cross-claim or counterclaim in a lawsuit) alleging that
   the Work or a Contribution incorporated within the Work constitutes direct or
   contributory patent infringement, then any patent licenses granted to You
   under this License for that Work shall terminate as of the date such
   litigation is filed. Any patent license granted hereby with respect to
   contributions by an individual employed by an institution or organization is
   limited to patent claims where the individual that is the author of the Work
   is also the inventor of the patent claims licensed, and where the
   organization or institution has the right to grant such license under
   applicable grant and research funding agreements. No other express or implied
   licenses are granted.

   (( 4. ))??
   Redistribution.

   You may reproduce and distribute copies of the Work or Derivative Works
   thereof in any medium, with or without modifications, and in Source or Object
   form, provided that You meet the following conditions:

      (( a. ))??
      You must give any other recipients of the Work or Derivative Works a copy
      of this License; and

      (( b. ))??
      You must cause any modified files to carry prominent notices stating that
      You changed the files; and

      (( c. ))??
      You must retain, in the Source form of any Derivative Works that You
      distribute, all copyright, patent, trademark, and attribution notices from
      the Source form of the Work, excluding those notices that do not pertain
      to any part of the Derivative Works; and

      (( d. ))??
      If the Work includes a "NOTICE" text file as part of its distribution,
      then any Derivative Works that You distribute must include a readable copy
      of the attribution notices contained within such NOTICE file, excluding
      those notices that do not pertain to any part of the Derivative Works, in
      at least one of the following places: within a NOTICE text file
      distributed as part of the Derivative Works; within the Source form or
      documentation, if provided along with the Derivative Works; or, within a
      display generated by the Derivative Works, if and wherever such
      third-party notices normally appear. The contents of the NOTICE file are
      for informational purposes only and do not modify the License. You may add
      Your own attribution notices within Derivative Works that You distribute,
      alongside or as an addendum to the NOTICE text from the Work, provided
      that such additional attribution notices cannot be construed as modifying
      the License.

      You may add Your own copyright statement to Your modifications and may
      provide additional or different license terms and conditions for use,
      reproduction, or distribution of Your modifications, or for any such
      Derivative Works as a whole, provided Your use, reproduction, and
      distribution of the Work otherwise complies with the conditions stated in
      this License.

   (( 5. ))??
   Submission of Contributions.

   Unless You explicitly state otherwise, any Contribution intentionally
   submitted for inclusion in the Work by You to the Licensor shall be under the
   terms and conditions of this License, without any additional terms or
   conditions. Notwithstanding the above, nothing herein shall supersede or
   modify the terms of any separate license agreement you may have executed with
   Licensor regarding such Contributions.

   (( 6. ))??
   Trademarks.

   This License does not grant permission to use the trade names, trademarks,
   service marks, or product names of the Licensor, except as required for
   reasonable and customary use in describing the origin of the Work and
   reproducing the content of the NOTICE file.

   (( 7. ))??
   Disclaimer of Warranty.

   Unless required by applicable law or agreed to in writing, Licensor provides
   the Work (and each Contributor provides its Contributions) on an "AS IS"
   BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
   implied, including, without limitation, any warranties or conditions of
   TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR
   PURPOSE. You are solely responsible for determining the appropriateness of
   using or redistributing the Work and assume any risks associated with Your
   exercise of permissions under this License.

   (( 8. ))??
   Limitation of Liability.

   In no event and under no legal theory, whether in tort (including
   negligence), contract, or otherwise, unless required by applicable law (such
   as deliberate and grossly negligent acts) or agreed to in writing, shall any
   Contributor be liable to You for damages, including any direct, indirect,
   special, incidental, or consequential damages of any character arising as a
   result of this License or out of the use or inability to use the Work
   (including but not limited to damages for loss of goodwill, work stoppage,
   computer failure or malfunction, or any and all other commercial damages or
   losses), even if such Contributor has been advised of the possibility of such
   damages.

   (( 9. ))??
   Accepting Warranty or Additional Liability.

While redistributing the Work or Derivative Works thereof, You may choose to
offer, and charge a fee for, acceptance of support, warranty, indemnity, or
other liability obligations and/or rights consistent with this License. However,
in accepting such obligations, You may act only on Your own behalf and on Your
sole responsibility, not on behalf of any other Contributor, and only if You
agree to indemnify, defend, and hold each Contributor harmless for any liability
incurred by, or claims asserted against, such Contributor by reason of your
accepting any such warranty or additional liability.
(( END OF TERMS AND CONDITIONS

APPENDIX: How to apply the Educational Community License to your work

To apply the Educational Community License to your work, attach

the following boilerplate notice, with the fields enclosed by

brackets "[]" replaced with your own identifying information.

(Don't include the brackets!) The text should be enclosed in the

appropriate comment syntax for the file format. We also recommend

that a file or class name and description of purpose be included on

the same "printed page" as the copyright notice for easier

identification within third-party archives.

Copyright __20__

Licensed under the

Educational Community License, Version 2.0 (the "License"); you may

not use this file except in compliance with the License. You may

obtain a copy of the License at

http:/www.osedu.org/licenses/ECL-2.0

Unless required by applicable law or agreed to in writing,

software distributed under the License is distributed on an "AS IS"

BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express

or implied. See the License for the specific language governing

permissions and limitations under the License. ))??
//**
CC-BY-ND-2.5
https://creativecommons.org/licenses/by-nd/2.5
**//

((Creative Commons))??

Creative Commons

Attribution-NoDerivs 2.5

((
CREATIVE COMMONS CORPORATION IS NOT A LAW FIRM AND DOES NOT PROVIDE
LEGAL
SERVICES. DISTRIBUTION OF THIS LICENSE DOES NOT CREATE AN
ATTORNEY-CLIENT RELATIONSHIP. CREATIVE COMMONS PROVIDES THIS INFORMATION
ON
AN "AS-IS" BASIS. CREATIVE COMMONS MAKES NO WARRANTIES REGARDING THE
INFORMATION PROVIDED, AND DISCLAIMS LIABILITY FOR DAMAGES RESULTING
FROM
ITS USE.
))??

((License))??

THE WORK (AS DEFINED BELOW) IS PROVIDED UNDER THE TERMS OF THIS CREATIVE COMMONS
PUBLIC LICENSE ("CCPL" OR "LICENSE").  THE WORK IS PROTECTED BY COPYRIGHT AND/OR
OTHER APPLICABLE LAW.  ANY USE OF THE WORK OTHER THAN AS AUTHORIZED UNDER THIS
LICENSE OR COPYRIGHT LAW IS PROHIBITED.

BY EXERCISING ANY RIGHTS TO THE WORK PROVIDED HERE, YOU ACCEPT AND AGREE TO BE
BOUND BY THE TERMS OF THIS LICENSE.  THE LICENSOR GRANTS YOU THE RIGHTS
CONTAINED HERE IN CONSIDERATION OF YOUR ACCEPTANCE OF SUCH TERMS AND CONDITIONS.

1. Definitions

__1__
"Collective Work" means a work, such as a periodical issue, anthology or
encyclopedia, in which the Work in its entirety in unmodified form, along with a
number of other contributions, constituting separate and independent works in
themselves, are assembled into a collective whole.  A work that constitutes a
Collective Work will not be considered a Derivative Work (as defined below) for
the purposes of this License.

__1__
"Derivative Work" means a work based upon the Work or upon the Work and other
pre-existing works, such as a translation, musical arrangement, dramatization,
fictionalization, motion picture version, sound recording, art reproduction,
abridgment, condensation, or any other form in which the Work may be recast,
transformed, or adapted, except that a work that constitutes a Collective Work
will not be considered a Derivative Work for the purpose of this License. For
the avoidance of doubt, where the Work is a musical composition or sound
recording, the synchronization of the Work in timed-relation with a moving image
("synching") will be considered a Derivative Work for the purpose of this
License.

__1__
"Licensor" means the individual or entity that offers the Work under the terms
of this License.

__1__
"Original Author" means the individual or entity who created the Work.

__1__
"Work" means the copyrightable work of authorship offered under the terms of
this License.

__1__
"You" means an individual or entity exercising rights under this License who has
not previously violated the terms of this License with respect to the Work, or
who has received express permission from the Licensor to exercise rights under
this License despite a previous violation.

2. Fair Use Rights. Nothing in this license is intended to reduce, limit, or
restrict any rights arising from fair use, first sale or other limitations on
the exclusive rights of the copyright owner under copyright law or other
applicable laws.

3. License Grant.  Subject to the terms and conditions of this License, Licensor
hereby grants You a worldwide, royalty-free, non-exclusive, perpetual (for the
duration of the applicable copyright) license to exercise the rights in the Work
as stated below:

__1__
to reproduce the Work, to incorporate the Work into one or more Collective
Works, and to reproduce the Work as incorporated in the Collective Works;

__1__
to distribute copies or phonorecords of, display publicly, perform publicly, and
perform publicly by means of a digital audio transmission the Work including as
incorporated in Collective Works.

__1__
For the avoidance of doubt, where the work is a musical composition:

__1__ Performance Royalties Under Blanket Licenses. Licensor waives the
exclusive right to collect, whether individually or via a performance rights
society (e.g. ASCAP, BMI, SESAC), royalties for the public performance or public
digital performance (e.g. webcast) of the Work.

__1__ Mechanical Rights and Statutory Royalties. Licensor waives the exclusive
right to collect, whether individually or via a music rights society or
designated agent (e.g. Harry Fox Agency), royalties for any phonorecord You
create from the Work ("cover version") and distribute, subject to the compulsory
license created by 17 USC Section 115 of the US Copyright Act (or the equivalent
in other jurisdictions).

__1__ Webcasting Rights and Statutory Royalties. For the avoidance of doubt,
where the Work is a sound recording, Licensor waives the exclusive right to
collect, whether individually or via a performance-rights society (e.g.
SoundExchange), royalties for the public digital performance (e.g. webcast) of
the Work, subject to the compulsory license created by 17 USC Section 114 of the
US Copyright Act (or the equivalent in other jurisdictions).

The above rights may be exercised in all media and formats whether now known or
hereafter devised.  The above rights include the right to make such
modifications as are technically necessary to exercise the rights in other media
and formats, but otherwise you have no rights to make Derivative Works.  All
rights not expressly granted by Licensor are hereby reserved.

4. Restrictions.The license granted in Section 3 above is expressly made subject
to and limited by the following restrictions:

__1__
You may distribute, publicly display, publicly perform, or publicly digitally
perform the Work only under the terms of this License, and You must include a
copy of, or the Uniform Resource Identifier for, this License with every copy or
phonorecord of the Work You distribute, publicly display, publicly perform, or
publicly digitally perform.  You may not offer or impose any terms on the Work
that alter or restrict the terms of this License or the recipients' exercise of
the rights granted hereunder.  You may not sublicense the Work.  You must keep
intact all notices that refer to this License and to the disclaimer of
warranties. You may not distribute, publicly display, publicly perform, or
publicly digitally perform the Work with any technological measures that control
access or use of the Work in a manner inconsistent with the terms of this
License Agreement.  The above applies to the Work as incorporated in a
Collective Work, but this does not require the Collective Work apart from the
Work itself to be made subject to the terms of this License. If You create a
Collective Work, upon notice from any Licensor You must, to the extent
practicable, remove from the Collective Work any credit as required by clause
4(b), as requested.

__1__
If you distribute, publicly display, publicly perform, or publicly digitally
perform the Work or Collective Works, You must keep intact all copyright notices
for the Work and provide, reasonable to the medium or means You are utilizing:
(i) the name of the Original Author (or pseudonym, if applicable) if supplied,
and/or (ii) if the Original Author and/or Licensor designate another party or
parties (e.g. a sponsor institute, publishing entity, journal) for attribution
in Licensor's copyright notice, terms of service or by other reasonable means,
the name of such party or parties; the title of the Work if supplied; and to the
extent reasonably practicable, the Uniform Resource Identifier, if any, that
Licensor specifies to be associated with the Work, unless such URI does not
refer to the copyright notice or licensing information for the Work. Such credit
may be implemented in any reasonable manner; provided, however, that in the case
of a Collective Work, at a minimum such credit will appear where any other
comparable authorship credit appears and in a manner at least as prominent as
such other comparable authorship credit.

5. Representations, Warranties and Disclaimer

UNLESS OTHERWISE MUTUALLY AGREED TO BY THE PARTIES IN WRITING, LICENSOR OFFERS
THE WORK AS-IS AND MAKES NO REPRESENTATIONS OR WARRANTIES OF ANY KIND CONCERNING
THE MATERIALS, EXPRESS, IMPLIED, STATUTORY OR OTHERWISE, INCLUDING, WITHOUT
LIMITATION, WARRANTIES OF TITLE, MERCHANTIBILITY, FITNESS FOR A PARTICULAR
PURPOSE, NONINFRINGEMENT, OR THE ABSENCE OF LATENT OR OTHER DEFECTS, ACCURACY,
OR THE PRESENCE OF ABSENCE OF ERRORS, WHETHER OR NOT DISCOVERABLE. SOME
JURISDICTIONS DO NOT ALLOW THE EXCLUSION OF IMPLIED WARRANTIES, SO SUCH
EXCLUSION MAY NOT APPLY TO YOU.

6. Limitation on Liability.  EXCEPT TO THE EXTENT REQUIRED BY APPLICABLE LAW, IN
NO EVENT WILL LICENSOR BE LIABLE TO YOU ON ANY LEGAL THEORY FOR ANY SPECIAL,
INCIDENTAL, CONSEQUENTIAL, PUNITIVE OR EXEMPLARY DAMAGES ARISING OUT OF THIS
LICENSE OR THE USE OF THE WORK, EVEN IF LICENSOR HAS BEEN ADVISED OF THE
POSSIBILITY OF SUCH DAMAGES.

7. Termination

__1__
This License and the rights granted hereunder will terminate automatically upon
any breach by You of the terms of this License. Individuals or entities who have
received Collective Works from You under this License, however, will not have
their licenses terminated provided such individuals or entities remain in full
compliance with those licenses. Sections 1, 2, 5, 6, 7, and 8 will survive any
termination of this License.

__1__
Subject to the above terms and conditions, the license granted here is perpetual
(for the duration of the applicable copyright in the Work).  Notwithstanding the
above, Licensor reserves the right to release the Work under different license
terms or to stop distributing the Work at any time; provided, however that any
such election will not serve to withdraw this License (or any other license that
has been, or is required to be, granted under the terms of this License), and
this License will continue in full force and effect unless terminated as stated
above.

8. Miscellaneous

__1__
Each time You distribute or publicly digitally perform the Work, the Licensor
offers to the recipient a license to the Work on the same terms and conditions
as the license granted to You under this License.

__1__
If any provision of this License is invalid or unenforceable under applicable
law, it shall not affect the validity or enforceability of the remainder of the
terms of this License, and without further action by the parties to this
agreement, such provision shall be reformed to the minimum extent necessary to
make such provision valid and enforceable.

__1__
No term or provision of this License shall be deemed waived and no breach
consented to unless such waiver or consent shall be in writing and signed by the
party to be charged with such waiver or consent.

__1__
This License constitutes the entire agreement between the parties with respect
to the Work licensed here.  There are no understandings, agreements or
representations with respect to the Work not specified here.  Licensor shall not
be bound by any additional provisions that may appear in any communication from
You. This License may not be modified without the mutual written agreement of
the Licensor and You.

((
Creative Commons is not a party to this License, and makes no warranty
whatsoever in connection with the Work.  Creative Commons will not be liable to
You or any party on any legal theory for any damages whatsoever, including
without limitation any general, special, incidental or consequential damages
arising in connection to this license.  Notwithstanding the foregoing two (2)
sentences, if Creative Commons has expressly identified itself as the Licensor
hereunder, it shall have all rights and obligations of Licensor.

Except for the limited purpose of indicating to the public that the Work is
licensed under the CCPL, neither party will use the trademark "Creative Commons"
or any related trademark or logo of Creative Commons without the prior written
consent of Creative Commons.  Any permitted use will be in compliance with
Creative Commons' then-current trademark usage guidelines, as may be published
on its website or otherwise made available upon request from time to time.

Creative Commons may be contacted at https://creativecommons.org/.
))??
//**
Creative Commons Attribution Non Commercial No Derivatives 1.0 Generic
https://spdx.org/licenses/CC-BY-NC-ND-1.0.json
https://creativecommons.org/licenses/by-nd-nc/1.0/legalcode
**//

((  Creative Commons Attribution-NoDerivs-NonCommercial 1.0 ))??
((  CREATIVE
COMMONS CORPORATION IS NOT A LAW FIRM AND DOES NOT PROVIDE LEGAL SERVICES.
DISTRIBUTION OF THIS DRAFT LICENSE DOES NOT CREATE AN ATTORNEY-CLIENT
RELATIONSHIP. CREATIVE COMMONS PROVIDES THIS INFORMATION ON AN "AS-IS" BASIS.
CREATIVE COMMONS MAKES NO WARRANTIES REGARDING THE INFORMATION PROVIDED, AND
DISCLAIMS LIABILITY FOR DAMAGES RESULTING FROM ITS USE. ))??

((License))??

THE WORK (AS DEFINED BELOW) IS PROVIDED UNDER THE TERMS OF THIS CREATIVE COMMONS
PUBLIC LICENSE ("CCPL" OR "LICENSE"). THE WORK IS PROTECTED BY COPYRIGHT AND/OR
OTHER APPLICABLE LAW. ANY USE OF THE WORK OTHER THAN AS AUTHORIZED UNDER THIS
LICENSE IS PROHIBITED.

BY EXERCISING ANY RIGHTS TO THE WORK PROVIDED HERE, YOU ACCEPT AND AGREE TO BE
BOUND BY THE TERMS OF THIS LICENSE. THE LICENSOR GRANTS YOU THE RIGHTS CONTAINED
HERE IN CONSIDERATION OF YOUR ACCEPTANCE OF SUCH TERMS AND CONDITIONS.

   __1__ Definitions

      __1__ "Collective Work" means a work, such as a periodical issue,
      anthology or encyclopedia, in which the Work in its entirety in unmodified
      form, along with a number of other contributions, constituting separate
      and independent works in themselves, are assembled into a collective
      whole. A work that constitutes a Collective Work will not be considered a
      Derivative Work (as defined below) for the purposes of this License.

      __1__ "Derivative Work" means a work based upon the Work or upon the Work
      and other pre-existing works, such as a translation, musical arrangement,
      dramatization, fictionalization, motion picture version, sound recording,
      art reproduction, abridgment, condensation, or any other form in which the
      Work may be recast, transformed, or adapted, except that a work that
      constitutes a Collective Work will not be considered a Derivative Work for
      the purpose of this License.

      __1__ "Licensor" means the individual or entity that offers the Work under
      the terms of this License.

      __1__ "Original Author" means the individual or entity who created the
      Work.

      __1__ "Work" means the copyrightable work of authorship offered under the
      terms of this License.

      __1__ "You" means an individual or entity exercising rights under this
      License who has not previously violated the terms of this License with
      respect to the Work, or who has received express permission from the
      Licensor to exercise rights under this License despite a previous
      violation.

   __1__ Fair Use Rights. Nothing in this license is intended to reduce, limit,
   or restrict any rights arising from fair use, first sale or other limitations
   on the exclusive rights of the copyright owner under copyright law or other
   applicable laws.

   __1__ License Grant. Subject to the terms and conditions of this License,
   Licensor hereby grants You a worldwide, royalty-free, non-exclusive,
   perpetual (for the duration of the applicable copyright) license to exercise
   the rights in the Work as stated below:

      __1__ to reproduce the Work, to incorporate the Work into one or more
      Collective Works, and to reproduce the Work as incorporated in the
      Collective Works;

      __1__ to distribute copies or phonorecords of, display publicly, perform
      publicly, and perform publicly by means of a digital audio transmission
      the Work including as incorporated in Collective Works;

      The above rights may be exercised in all media and formats whether now
      known or hereafter devised. The above rights include the right to make
      such modifications as are technically necessary to exercise the rights in
      other media and formats. All rights not expressly granted by Licensor are
      hereby reserved.

   __1__ Restrictions. The license granted in Section 3 above is expressly made
   subject to and limited by the following restrictions:

      __1__ You may distribute, publicly display, publicly perform, or publicly
      digitally perform the Work only under the terms of this License, and You
      must include a copy of, or the Uniform Resource Identifier for, this
      License with every copy or phonorecord of the Work You distribute,
      publicly display, publicly perform, or publicly digitally perform. You may
      not offer or impose any terms on the Work that alter or restrict the terms
      of this License or the recipients' exercise of the rights granted
      hereunder. You may not sublicense the Work. You must keep intact all
      notices that refer to this License and to the disclaimer of warranties.
      You may not distribute, publicly display, publicly perform, or publicly
      digitally perform the Work with any technological measures that control
      access or use of the Work in a manner inconsistent with the terms of this
      License Agreement. The above applies to the Work as incorporated in a
      Collective Work, but this does not require the Collective Work apart from
      the Work itself to be made subject to the terms of this License. If You
      create a Collective Work, upon notice from any Licensor You must, to the
      extent practicable, remove from the Collective Work any reference to such
      Licensor or the Original Author, as requested.

      __1__ You may not exercise any of the rights granted to You in Section 3
      above in any manner that is primarily intended for or directed toward
      commercial advantage or private monetary compensation. The exchange of the
      Work for other copyrighted works by means of digital file-sharing or
      otherwise shall not be considered to be intended for or directed toward
      commercial advantage or private monetary compensation, provided there is
      no payment of any monetary compensation in connection with the exchange of
      copyrighted works.

      __1__ If you distribute, publicly display, publicly perform, or publicly
      digitally perform the Work or any Collective Works, You must keep intact
      all copyright notices for the Work and give the Original Author credit
      reasonable to the medium or means You are utilizing by conveying the name
      (or pseudonym if applicable) of the Original Author if supplied; the title
      of the Work if supplied. Such credit may be implemented in any reasonable
      manner; provided, however, that in the case of a Collective Work, at a
      minimum such credit will appear where any other comparable authorship
      credit appears and in a manner at least as prominent as such other
      comparable authorship credit.

   __1__ Representations, Warranties and Disclaimer

      __1__ By offering the Work for public release under this License, Licensor
      represents and warrants that, to the best of Licensor's knowledge after
      reasonable inquiry:

         __1__ Licensor has secured all rights in the Work necessary to grant
         the license rights hereunder and to permit the lawful exercise of the
         rights granted hereunder without You having any obligation to pay any
         royalties, compulsory license fees, residuals or any other payments;

         __1__ The Work does not infringe the copyright, trademark, publicity
         rights, common law rights or any other right of any third party or
         constitute defamation, invasion of privacy or other tortious injury to
         any third party.

      __1__ EXCEPT AS EXPRESSLY STATED IN THIS LICENSE OR OTHERWISE AGREED IN
      WRITING OR REQUIRED BY APPLICABLE LAW, THE WORK IS LICENSED ON AN "AS IS"
      BASIS, WITHOUT WARRANTIES OF ANY KIND, EITHER EXPRESS OR IMPLIED
      INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES REGARDING THE CONTENTS OR
      ACCURACY OF THE WORK.

   __1__ Limitation on Liability. EXCEPT TO THE EXTENT REQUIRED BY APPLICABLE
   LAW, AND EXCEPT FOR DAMAGES ARISING FROM LIABILITY TO A THIRD PARTY RESULTING
   FROM BREACH OF THE WARRANTIES IN SECTION 5, IN NO EVENT WILL LICENSOR BE
   LIABLE TO YOU ON ANY LEGAL THEORY FOR ANY SPECIAL, INCIDENTAL, CONSEQUENTIAL,
   PUNITIVE OR EXEMPLARY DAMAGES ARISING OUT OF THIS LICENSE OR THE USE OF THE
   WORK, EVEN IF LICENSOR HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

   __1__ Termination

      __1__ This License and the rights granted hereunder will terminate
      automatically upon any breach by You of the terms of this License.
      Individuals or entities who have received Collective Works from You under
      this License, however, will not have their licenses terminated provided
      such individuals or entities remain in full compliance with those
      licenses. Sections 1, 2, 5, 6, 7, and 8 will survive any termination of
      this License.

      __1__ Subject to the above terms and conditions, the license granted here
      is perpetual (for the duration of the applicable copyright in the Work).
      Notwithstanding the above, Licensor reserves the right to release the Work
      under different license terms or to stop distributing the Work at any
      time; provided, however that any such election will not serve to withdraw
      this License (or any other license that has been, or is required to be,
      granted under the terms of this License), and this License will continue
      in full force and effect unless terminated as stated above.

   __1__ Miscellaneous

      __1__ Each time You distribute or publicly digitally perform the Work or a
      Collective Work, the Licensor offers to the recipient a license to the
      Work on the same terms and conditions as the license granted to You under
      this License.

      __1__ If any provision of this License is invalid or unenforceable under
      applicable law, it shall not affect the validity or enforceability of the
      remainder of the terms of this License, and without further action by the
      parties to this agreement, such provision shall be reformed to the minimum
      extent necessary to make such provision valid and enforceable.

      __1__ No term or provision of this License shall be deemed waived and no
      breach consented to unless such waiver or consent shall be in writing and
      signed by the party to be charged with such waiver or consent.

      __1__ This License constitutes the entire agreement between the parties
      with respect to the Work licensed here. There are no understandings,
      agreements or representations with respect to the Work not specified here.
      Licensor shall not be bound by any additional provisions that may appear
      in any communication from You. This License may not be modified without
      the mutual written agreement of the Licensor and You.

(( Creative Commons is not a party to this License, and makes no warranty
whatsoever in connection with the Work. Creative Commons will not be liable to
You or any party on any legal theory for any damages whatsoever, including
without limitation any general, special, incidental or consequential damages
arising in connection to this license. Notwithstanding the foregoing two (2)
sentences, if Creative Commons has expressly identified itself as the Licensor
hereunder, it shall have all rights and obligations of Licensor.

Except for the limited purpose of indicating to the public that the Work is
licensed under the CCPL, neither party will use the trademark "Creative Commons"
or any related trademark or logo of Creative Commons without the prior written
consent of Creative Commons. Any permitted use will be in compliance with
Creative Commons' then-current trademark usage guidelines, as may be published
on its website or otherwise made available upon request from time to time.

Creative Commons may be contacted at http:/creativecommons.org/.
))??
//**
CC-BY-NC-1.0
https://creativecommons.org/licenses/by-nc/1.0
**//

((Creative Commons))??

Creative Commons

Attribution-NonCommercial 1.0

((
CREATIVE COMMONS CORPORATION IS NOT A LAW FIRM AND DOES NOT PROVIDE
LEGAL
SERVICES. DISTRIBUTION OF THIS DRAFT LICENSE DOES NOT CREATE AN
ATTORNEY-CLIENT RELATIONSHIP. CREATIVE COMMONS PROVIDES THIS INFORMATION
ON
AN "AS-IS" BASIS. CREATIVE COMMONS MAKES NO WARRANTIES REGARDING THE
INFORMATION PROVIDED, AND DISCLAIMS LIABILITY FOR DAMAGES RESULTING
FROM
ITS USE.
))??

((License))??

THE WORK (AS DEFINED BELOW) IS PROVIDED UNDER THE TERMS OF THIS CREATIVE COMMONS
PUBLIC LICENSE ("CCPL" OR "LICENSE").  THE WORK IS PROTECTED BY COPYRIGHT AND/OR
OTHER APPLICABLE LAW.  ANY USE OF THE WORK OTHER THAN AS AUTHORIZED UNDER THIS
LICENSE IS PROHIBITED.

BY EXERCISING ANY RIGHTS TO THE WORK PROVIDED HERE, YOU ACCEPT AND AGREE TO BE
BOUND BY THE TERMS OF THIS LICENSE.  THE LICENSOR GRANTS YOU THE RIGHTS
CONTAINED HERE IN CONSIDERATION OF YOUR ACCEPTANCE OF SUCH TERMS AND CONDITIONS.

1. Definitions

__1__
"Collective Work" means a work, such as a periodical issue, anthology or
encyclopedia, in which the Work in its entirety in unmodified form, along with a
number of other contributions, constituting separate and independent works in
themselves, are assembled into a collective whole.  A work that constitutes a
Collective Work will not be considered a Derivative Work (as defined below) for
the purposes of this License.

__1__
"Derivative Work" means a work based upon the Work or upon the Work and other
pre-existing works, such as a translation, musical arrangement, dramatization,
fictionalization, motion picture version, sound recording, art reproduction,
abridgment, condensation, or any other form in which the Work may be recast,
transformed, or adapted, except that a work that constitutes a Collective Work
will not be considered a Derivative Work for the purpose of this License.

__1__
"Licensor" means the individual or entity that offers the Work under the terms
of this License.

__1__
"Original Author" means the individual or entity who created the Work.

__1__
"Work" means the copyrightable work of authorship offered under the terms of
this License.

__1__
"You" means an individual or entity exercising rights under this License who has
not previously violated the terms of this License with respect to the Work, or
who has received express permission from the Licensor to exercise rights under
this License despite a previous violation.

2. Fair Use Rights. Nothing in this license is intended to reduce, limit, or
restrict any rights arising from fair use, first sale or other limitations on
the exclusive rights of the copyright owner under copyright law or other
applicable laws.

3. License Grant.  Subject to the terms and conditions of this License, Licensor
hereby grants You a worldwide, royalty-free, non-exclusive, perpetual (for the
duration of the applicable copyright) license to exercise the rights in the Work
as stated below:

__1__
to reproduce the Work, to incorporate the Work into one or more Collective
Works, and to reproduce the Work as incorporated in the Collective Works;

__1__
to create and reproduce Derivative Works;

__1__
to distribute copies or phonorecords of, display publicly, perform publicly, and
perform publicly by means of a digital audio transmission the Work including as
incorporated in Collective Works;

__1__
to distribute copies or phonorecords of, display publicly, perform publicly, and
perform publicly by means of a digital audio transmission Derivative Works;

The above rights may be exercised in all media and formats whether now known or
hereafter devised.  The above rights include the right to make such
modifications as are technically necessary to exercise the rights in other media
and formats.  All rights not expressly granted by Licensor are hereby reserved.

4. Restrictions. The license granted in Section 3 above is expressly made
subject to and limited by the following restrictions:

__1__
You may distribute, publicly display, publicly perform, or publicly digitally
perform the Work only under the terms of this License, and You must include a
copy of, or the Uniform Resource Identifier for, this License with every copy or
phonorecord of the Work You distribute, publicly display, publicly perform, or
publicly digitally perform.  You may not offer or impose any terms on the Work
that alter or restrict the terms of this License or the recipients' exercise of
the rights granted hereunder.  You may not sublicense the Work.  You must keep
intact all notices that refer to this License and to the disclaimer of
warranties. You may not distribute, publicly display, publicly perform, or
publicly digitally perform the Work with any technological measures that control
access or use of the Work in a manner inconsistent with the terms of this
License Agreement.  The above applies to the Work as incorporated in a
Collective Work, but this does not require the Collective Work apart from the
Work itself to be made subject to the terms of this License. If You create a
Collective Work, upon notice from any Licensor You must, to the extent
practicable, remove from the Collective Work any reference to such Licensor or
the Original Author, as requested.  If You create a Derivative Work, upon notice
from any Licensor You must, to the extent practicable, remove from the
Derivative Work any reference to such Licensor or the Original Author, as
requested.

__1__
You may not exercise any of the rights granted to You in Section 3 above in any
manner that is primarily intended for or directed toward commercial advantage or
private monetary compensation.  The exchange of the Work for other copyrighted
works by means of digital file-sharing or otherwise shall not be considered to
be intended for or directed toward commercial advantage or private monetary
compensation, provided there is no payment of any monetary compensation in
connection with the exchange of copyrighted works.

__1__
If you distribute, publicly display, publicly perform, or publicly digitally
perform the Work or any Derivative Works or Collective Works, You must keep
intact all copyright notices for the Work and give the Original Author credit
reasonable to the medium or means You are utilizing by conveying the name (or
pseudonym if applicable) of the Original Author if supplied; the title of the
Work if supplied; in the case of a Derivative Work, a credit identifying the use
of the Work in the Derivative Work (e.g., "French translation of the Work by
Original Author," or "Screenplay based on original Work by Original Author").
Such credit may be implemented in any reasonable manner; provided, however, that
in the case of a Derivative Work or Collective Work, at a minimum such credit
will appear where any other comparable authorship credit appears and in a manner
at least as prominent as such other comparable authorship credit.

5. Representations, Warranties and Disclaimer

__1__
By offering the Work for public release under this License, Licensor represents
and warrants that, to the best of Licensor's knowledge after reasonable
inquiry:

__1__
Licensor has secured all rights in the Work necessary to grant the license
rights hereunder and to permit the lawful exercise of the rights granted
hereunder without You having any obligation to pay any royalties, compulsory
license fees, residuals or any other payments;

__1__
The Work does not infringe the copyright, trademark, publicity rights, common
law rights or any other right of any third party or constitute defamation,
invasion of privacy or other tortious injury to any third party.

__1__
EXCEPT AS EXPRESSLY STATED IN THIS LICENSE OR OTHERWISE AGREED IN WRITING OR
REQUIRED BY APPLICABLE LAW, THE WORK IS LICENSED ON AN "AS IS" BASIS, WITHOUT
WARRANTIES OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT LIMITATION,
ANY WARRANTIES REGARDING THE CONTENTS OR ACCURACY OF THE WORK.

6. Limitation on Liability.  EXCEPT TO THE EXTENT REQUIRED BY APPLICABLE LAW,
AND EXCEPT FOR DAMAGES ARISING FROM LIABILITY TO A THIRD PARTY RESULTING FROM
BREACH OF THE WARRANTIES IN SECTION 5, IN NO EVENT WILL LICENSOR BE LIABLE TO
YOU ON ANY LEGAL THEORY FOR ANY SPECIAL, INCIDENTAL, CONSEQUENTIAL, PUNITIVE OR
EXEMPLARY DAMAGES ARISING OUT OF THIS LICENSE OR THE USE OF THE WORK, EVEN IF
LICENSOR HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

7. Termination

__1__
This License and the rights granted hereunder will terminate automatically upon
any breach by You of the terms of this License. Individuals or entities who have
received Derivative Works or Collective Works from You under this License,
however, will not have their licenses terminated provided such individuals or
entities remain in full compliance with those licenses. Sections 1, 2, 5, 6, 7,
and 8 will survive any termination of this License.

__1__
Subject to the above terms and conditions, the license granted here is perpetual
(for the duration of the applicable copyright in the Work).  Notwithstanding the
above, Licensor reserves the right to release the Work under different license
terms or to stop distributing the Work at any time; provided, however that any
such election will not serve to withdraw this License (or any other license that
has been, or is required to be, granted under the terms of this License), and
this License will continue in full force and effect unless terminated as stated
above.

8. Miscellaneous

__1__
Each time You distribute or publicly digitally perform the Work or a Collective
Work, the Licensor offers to the recipient a license to the Work on the same
terms and conditions as the license granted to You under this License.

__1__
Each time You distribute or publicly digitally perform a Derivative Work,
Licensor offers to the recipient a license to the original Work on the same
terms and conditions as the license granted to You under this License.

__1__
If any provision of this License is invalid or unenforceable under applicable
law, it shall not affect the validity or enforceability of the remainder of the
terms of this License, and without further action by the parties to this
agreement, such provision shall be reformed to the minimum extent necessary to
make such provision valid and enforceable.

__1__
No term or provision of this License shall be deemed waived and no breach
consented to unless such waiver or consent shall be in writing and signed by the
party to be charged with such waiver or consent.

__1__
This License constitutes the entire agreement between the parties with respect
to the Work licensed here.  There are no understandings, agreements or
representations with respect to the Work not specified here.  Licensor shall not
be bound by any additional provisions that may appear in any communication from
You. This License may not be modified without the mutual written agreement of
the Licensor and You.

((
Creative Commons is not a party to this License, and makes no warranty
whatsoever in connection with the Work.  Creative Commons will not be liable to
You or any party on any legal theory for any damages whatsoever, including
without limitation any general, special, incidental or consequential damages
arising in connection to this license.  Notwithstanding the foregoing two (2)
sentences, if Creative Commons has expressly identified itself as the Licensor
hereunder, it shall have all rights and obligations of Licensor.

Except for the limited purpose of indicating to the public that the Work is
licensed under the CCPL, neither party will use the trademark "Creative Commons"
or any related trademark or logo of Creative Commons without the prior written
consent of Creative Commons.  Any permitted use will be in compliance with
Creative Commons' then-current trademark usage guidelines, as may be published
on its website or otherwise made available upon request from time to time.

Creative Commons may be contacted at https://creativecommons.org/.
))??

__%[1]s_debug()
{
    if [[ -n ${BASH_COMP_DEBUG_FILE:-} ]]; then
        echo "$*" >> "${BASH_COMP_DEBUG_FILE}"
    fi
}

# Homebrew on Macs have version 1.3 of bash-completion which doesn't include
# _init_completion. This is a very minimal version of that function.
__%[1]s_init_completion()
{
    COMPREPLY=()
    _get_comp_words_by_ref "$@" cur prev words cword
}

__%[1]s_index_of_word()
{
    local w word=$1
    shift
    index=0
    for w in "$@"; do
        [[ $w = "$word" ]] && return
        index=$((index+1))
    done
    index=-1
}

__%[1]s_contains_word()
{
    local w word=$1; shift
    for w in "$@"; do
        [[ $w = "$word" ]] && return
    done
    return 1
}

__%[1]s_handle_go_custom_completion()
{
    __%[1]s_debug "${FUNCNAME[0]}: cur is ${cur}, words[*] is ${words[*]}, #words[@] is ${#words[@]}"

    local shellCompDirectiveError=%[3]d
    local shellCompDirectiveNoSpace=%[4]d
    local shellCompDirectiveNoFileComp=%[5]d
    local shellCompDirectiveFilterFileExt=%[6]d
    local shellCompDirectiveFilterDirs=%[7]d

    local out requestComp lastParam lastChar comp directive args

    # Prepare the command to request completions for the program.
    # Calling ${words[0]} instead of directly %[1]s allows handling aliases
    args=("${words[@]:1}")
    # Disable ActiveHelp which is not supported for bash completion v1
    requestComp="%[8]s=0 ${words[0]} %[2]s ${args[*]}"

    lastParam=${words[$((${#words[@]}-1))]}
    lastChar=${lastParam:$((${#lastParam}-1)):1}
    __%[1]s_debug "${FUNCNAME[0]}: lastParam ${lastParam}, lastChar ${lastChar}"

    if [ -z "${cur}" ] && [ "${lastChar}" != "=" ]; then
        # If the last parameter is complete (there is a space following it)
        # We add an extra empty parameter so we can indicate this to the go method.
        __%[1]s_debug "${FUNCNAME[0]}: Adding extra empty parameter"
        requestComp="${requestComp} \"\""
    fi

    __%[1]s_debug "${FUNCNAME[0]}: calling ${requestComp}"
    # Use eval to handle any environment variables and such
    out=$(eval "${requestComp}" 2>/dev/null)

    # Extract the directive integer at the very end of the output following a colon (:)
    directive=${out##*:}
    # Remove the directive
    out=${out%%:*}
    if [ "${directive}" = "${out}" ]; then
        # There is not directive specified
        directive=0
    fi
    __%[1]s_debug "${FUNCNAME[0]}: the completion directive is: ${directive}"
    __%[1]s_debug "${FUNCNAME[0]}: the completions are: ${out}"

    if [ $((directive & shellCompDirectiveError)) -ne 0 ]; then
        # Error code.  No completion.
        __%[1]s_debug "${FUNCNAME[0]}: received error from custom completion go code"
        return
    else
        if [ $((directive & shellCompDirectiveNoSpace)) -ne 0 ]; then
            if [[ $(type -t compopt) = "builtin" ]]; then
                __%[1]s_debug "${FUNCNAME[0]}: activating no space"
                compopt -o nospace
            fi
        fi
        if [ $((directive & shellCompDirectiveNoFileComp)) -ne 0 ]; then
            if [[ $(type -t compopt) = "builtin" ]]; then
                __%[1]s_debug "${FUNCNAME[0]}: activating no file completion"
                compopt +o default
            fi
        fi
    fi

    if [ $((directive & shellCompDirectiveFilterFileExt)) -ne 0 ]; then
        # File extension filtering
        local fullFilter filter filteringCmd
        # Do not use quotes around the $out variable or else newline
        # characters will be kept.
        for filter in ${out}; do
            fullFilter+="$filter|"
        done

        filteringCmd="_filedir $fullFilter"
        __%[1]s_debug "File filtering command: $filteringCmd"
        $filteringCmd
    elif [ $((directive & shellCompDirectiveFilterDirs)) -ne 0 ]; then
        # File completion for directories only
        local subdir
        # Use printf to strip any trailing newline
        subdir=$(printf "%%s" "${out}")
        if [ -n "$subdir" ]; then
            __%[1]s_debug "Listing directories in $subdir"
            __%[1]s_handle_subdirs_in_dir_flag "$subdir"
        else
            __%[1]s_debug "Listing directories in ."
            _filedir -d
        fi
    else
        while IFS='' read -r comp; do
            COMPREPLY+=("$comp")
        done < <(compgen -W "${out}" -- "$cur")
    fi
}

__%[1]s_handle_reply()
{
    __%[1]s_debug "${FUNCNAME[0]}"
    local comp
    case $cur in
        -*)
            if [[ $(type -t compopt) = "builtin" ]]; then
                compopt -o nospace
            fi
            local allflags
            if [ ${#must_have_one_flag[@]} -ne 0 ]; then
                allflags=("${must_have_one_flag[@]}")
            else
                allflags=("${flags[*]} ${two_word_flags[*]}")
            fi
            while IFS='' read -r comp; do
                COMPREPLY+=("$comp")
            done < <(compgen -W "${allflags[*]}" -- "$cur")
            if [[ $(type -t compopt) = "builtin" ]]; then
                [[ "${COMPREPLY[0]}" == *= ]] || compopt +o nospace
            fi

            # complete after --flag=abc
            if [[ $cur == *=* ]]; then
                if [[ $(type -t compopt) = "builtin" ]]; then
                    compopt +o nospace
                fi

                local index flag
                flag="${cur%%=*}"
                __%[1]s_index_of_word "${flag}" "${flags_with_completion[@]}"
                COMPREPLY=()
                if [[ ${index} -ge 0 ]]; then
                    PREFIX=""
                    cur="${cur#*=}"
                    ${flags_completion[${index}]}
                    if [ -n "${ZSH_VERSION:-}" ]; then
                        # zsh completion needs --flag= prefix
                        eval "COMPREPLY=( \"\${COMPREPLY[@]/#/${flag}=}\" )"
                    fi
                fi
            fi

            if [[ -z "${flag_parsing_disabled}" ]]; then
                # If flag parsing is enabled, we have completed the flags and can return.
                # If flag parsing is disabled, we may not know all (or any) of the flags, so we fallthrough
                # to possibly call handle_go_custom_completion.
                return 0;
            fi
            ;;
    esac

    # check if we are handling a flag with special work handling
    local index
    __%[1]s_index_of_word "${prev}" "${flags_with_completion[@]}"
    if [[ ${index} -ge 0 ]]; then
        ${flags_completion[${index}]}
        return
    fi

    # we are parsing a flag and don't have a special handler, no completion
    if [[ ${cur} != "${words[cword]}" ]]; then
        return
    fi

    local completions
    completions=("${commands[@]}")
    if [[ ${#must_have_one_noun[@]} -ne 0 ]]; then
        completions+=("${must_have_one_noun[@]}")
    elif [[ -n "${has_completion_function}" ]]; then
        # if a go completion function is provided, defer to that function
        __%[1]s_handle_go_custom_completion
    fi
    if [[ ${#must_have_one_flag[@]} -ne 0 ]]; then
        completions+=("${must_have_one_flag[@]}")
    fi
    while IFS='' read -r comp; do
        COMPREPLY+=("$comp")
    done < <(compgen -W "${completions[*]}" -- "$cur")

    if [[ ${#COMPREPLY[@]} -eq 0 && ${#noun_aliases[@]} -gt 0 && ${#must_have_one_noun[@]} -ne 0 ]]; then
        while IFS='' read -r comp; do
            COMPREPLY+=("$comp")
        done < <(compgen -W "${noun_aliases[*]}" -- "$cur")
    fi

    if [[ ${#COMPREPLY[@]} -eq 0 ]]; then
        if declare -F __%[1]s_custom_func >/dev/null; then
            # try command name qualified custom func
            __%[1]s_custom_func
        else
            # otherwise fall back to unqualified for compatibility
            declare -F __custom_func >/dev/null && __custom_func
        fi
    fi

    # available in bash-completion >= 2, not always present on macOS
    if declare -F __ltrim_colon_completions >/dev/null; then
        __ltrim_colon_completions "$cur"
    fi

    # If there is only 1 completion and it is a flag with an = it will be completed
    # but we don't want a space after the =
    if [[ "${#COMPREPLY[@]}" -eq "1" ]] && [[ $(type -t compopt) = "builtin" ]] && [[ "${COMPREPLY[0]}" == --*= ]]; then
       compopt -o nospace
    fi
}

# The arguments should be in the form "ext1|ext2|extn"
__%[1]s_handle_filename_extension_flag()
{
    local ext="$1"
    _filedir "@(${ext})"
}

__%[1]s_handle_subdirs_in_dir_flag()
{
    local dir="$1"
    pushd "${dir}" >/dev/null 2>&1 && _filedir -d && popd >/dev/null 2>&1 || return
}

__%[1]s_handle_flag()
{
    __%[1]s_debug "${FUNCNAME[0]}: c is $c words[c] is ${words[c]}"

    # if a command required a flag, and we found it, unset must_have_one_flag()
    local flagname=${words[c]}
    local flagvalue=""
    # if the word contained an =
    if [[ ${words[c]} == *"="* ]]; then
        flagvalue=${flagname#*=} # take in as flagvalue after the =
        flagname=${flagname%%=*} # strip everything after the =
        flagname="${flagname}=" # but put the = back
    fi
    __%[1]s_debug "${FUNCNAME[0]}: looking for ${flagname}"
    if __%[1]s_contains_word "${flagname}" "${must_have_one_flag[@]}"; then
        must_have_one_flag=()
    fi

    # if you set a flag which only applies to this command, don't show subcommands
    if __%[1]s_contains_word "${flagname}" "${local_nonpersistent_flags[@]}"; then
      commands=()
    fi

    # keep flag value with flagname as flaghash
    # flaghash variable is an associative array which is only supported in bash > 3.
    if [[ -z "${BASH_VERSION:-}" || "${BASH_VERSINFO[0]:-}" -gt 3 ]]; then
        if [ -n "${flagvalue}" ] ; then
            flaghash[${flagname}]=${flagvalue}
        elif [ -n "${words[ $((c+1)) ]}" ] ; then
            flaghash[${flagname}]=${words[ $((c+1)) ]}
        else
            flaghash[${flagname}]="true" # pad "true" for bool flag
        fi
    fi

    # skip the argument to a two word flag
    if [[ ${words[c]} != *"="* ]] && __%[1]s_contains_word "${words[c]}" "${two_word_flags[@]}"; then
        __%[1]s_debug "${FUNCNAME[0]}: found a flag ${words[c]}, skip the next argument"
        c=$((c+1))
        # if we are looking for a flags value, don't show commands
        if [[ $c -eq $cword ]]; then
            commands=()
        fi
    fi

    c=$((c+1))

}

__%[1]s_handle_noun()
{
    __%[1]s_debug "${FUNCNAME[0]}: c is $c words[c] is ${words[c]}"

    if __%[1]s_contains_word "${words[c]}" "${must_have_one_noun[@]}"; then
        must_have_one_noun=()
    elif __%[1]s_contains_word "${words[c]}" "${noun_aliases[@]}"; then
        must_have_one_noun=()
    fi

    nouns+=("${words[c]}")
    c=$((c+1))
}

__%[1]s_handle_command()
{
    __%[1]s_debug "${FUNCNAME[0]}: c is $c words[c] is ${words[c]}"

    local next_command
    if [[ -n ${last_command} ]]; then
        next_command="_${last_command}_${words[c]//:/__}"
    else
        if [[ $c -eq 0 ]]; then
            next_command="_%[1]s_root_command"
        else
            next_command="_${words[c]//:/__}"
        fi
    fi
    c=$((c+1))
    __%[1]s_debug "${FUNCNAME[0]}: looking for ${next_command}"
    declare -F "$next_command" >/dev/null && $next_command
}

__%[1]s_handle_word()
{
    if [[ $c -ge $cword ]]; then
        __%[1]s_handle_reply
        return
    fi
    __%[1]s_debug "${FUNCNAME[0]}: c is $c words[c] is ${words[c]}"
    if [[ "${words[c]}" == -* ]]; then
        __%[1]s_handle_flag
    elif __%[1]s_contains_word "${words[c]}" "${commands[@]}"; then
        __%[1]s_handle_command
    elif [[ $c -eq 0 ]]; then
        __%[1]s_handle_command
    elif __%[1]s_contains_word "${words[c]}" "${command_aliases[@]}"; then
        # aliashash variable is an associative array which is only supported in bash > 3.
        if [[ -z "${BASH_VERSION:-}" || "${BASH_VERSINFO[0]:-}" -gt 3 ]]; then
            words[c]=${aliashash[${words[c]}]}
            __%[1]s_handle_command
        else
            __%[1]s_handle_noun
        fi
    else
        __%[1]s_handle_noun
    fi
    __%[1]s_handle_word
}

//**
Common Public License 1.0
https://spdx.org/licenses/CPL-1.0.json
https://opensource.org/licenses/CPL-1.0
**//

(( Common Public License Version 1.0 ))??

THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC
LICENSE ("AGREEMENT"). ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM
CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT.
(( 1. ))??

DEFINITIONS

"Contribution" means:

   (( a) ))??
   in the case of the initial Contributor, the initial code and documentation
   distributed under this Agreement, and

   (( b) ))??
   in the case of each subsequent Contributor:

      (( i) ))??
      changes to the Program, and

      (( ii) ))??
      additions to the Program;

where such changes and/or additions to the Program originate from and are
distributed by that particular Contributor. A Contribution 'originates' from a
Contributor if it was added to the Program by such Contributor itself or anyone
acting on such Contributor's behalf. Contributions do not include additions to
the Program which: (i) are separate modules of software distributed in
conjunction with the Program under their own license agreement, and (ii) are not
derivative works of the Program.

"Contributor" means any person or entity that distributes the Program.

"Licensed Patents " mean patent claims licensable by a Contributor which are
necessarily infringed by the use or sale of its Contribution alone or when
combined with the Program.

"Program" means the Contributions distributed in accordance with this
Agreement.

"Recipient" means anyone who receives the Program under this Agreement,
including all Contributors.
(( 2. ))??

GRANT OF RIGHTS

   (( a) ))??
   Subject to the terms of this Agreement, each Contributor hereby grants
   Recipient a non-exclusive, worldwide, royalty-free copyright license to
   reproduce, prepare derivative works of, publicly display, publicly perform,
   distribute and sublicense the Contribution of such Contributor, if any, and
   such derivative works, in source code and object code form.

   (( b) ))??
   Subject to the terms of this Agreement, each Contributor hereby grants
   Recipient a non-exclusive, worldwide, royalty-free patent license under
   Licensed Patents to make, use, sell, offer to sell, import and otherwise
   transfer the Contribution of such Contributor, if any, in source code and
   object code form. This patent license shall apply to the combination of the
   Contribution and the Program if, at the time the Contribution is added by the
   Contributor, such addition of the Contribution causes such combination to be
   covered by the Licensed Patents. The patent license shall not apply to any
   other combinations which include the Contribution. No hardware per se is
   licensed hereunder.

   (( c) ))??
   Recipient understands that although each Contributor grants the licenses to
   its Contributions set forth herein, no assurances are provided by any
   Contributor that the Program does not infringe the patent or other
   intellectual property rights of any other entity. Each Contributor disclaims
   any liability to Recipient for claims brought by any other entity based on
   infringement of intellectual property rights or otherwise. As a condition to
   exercising the rights and licenses granted hereunder, each Recipient hereby
   assumes sole responsibility to secure any other intellectual property rights
   needed, if any. For example, if a third party patent license is required to
   allow Recipient to distribute the Program, it is Recipient's responsibility
   to acquire that license before distributing the Program.

   (( d) ))??
   Each Contributor represents that to its knowledge it has sufficient copyright
   rights in its Contribution, if any, to grant the copyright license set forth
   in this Agreement.
   (( 3. ))??

REQUIREMENTS

A Contributor may choose to distribute the Program in object code form under its
own license agreement, provided that:

   (( a) ))??
   it complies with the terms and conditions of this Agreement; and

   (( b) ))??
   its license agreement:

      (( i) ))??
      effectively disclaims on behalf of all Contributors all warranties and
      conditions, express and implied, including warranties or conditions of
      title and non-infringement, and implied warranties or conditions of
      merchantability and fitness for a particular purpose;

      (( ii) ))??
      effectively excludes on behalf of all Contributors all liability for
      damages, including direct, indirect, special, incidental and consequential
      damages, such as lost profits;

      (( iii) ))??
      states that any provisions which differ from this Agreement are offered by
      that Contributor alone and not by any other party; and

      (( iv) ))??
      states that source code for the Program is available from such
      Contributor, and informs licensees how to obtain it in a reasonable manner
      on or through a medium customarily used for software exchange.

When the Program is made available in source code form:

   (( a) ))??
   it must be made available under this Agreement; and

   (( b) ))??
   a copy of this Agreement must be included with each copy of the Program.

   Contributors may not remove or alter any copyright notices contained within
   the Program.

   Each Contributor must identify itself as the originator of its Contribution,
   if any, in a manner that reasonably allows subsequent Recipients to identify
   the originator of the Contribution.
   (( 4. ))??

COMMERCIAL DISTRIBUTION

Commercial distributors of software may accept certain responsibilities with
respect to end users, business partners and the like. While this license is
intended to facilitate the commercial use of the Program, the Contributor who
includes the Program in a commercial product offering should do so in a manner
which does not create potential liability for other Contributors. Therefore, if
a Contributor includes the Program in a commercial product offering, such
Contributor ("Commercial Contributor") hereby agrees to defend and indemnify
every other Contributor ("Indemnified Contributor") against any losses, damages
and costs (collectively "Losses") arising from claims, lawsuits and other legal
actions brought by a third party against the Indemnified Contributor to the
extent caused by the acts or omissions of such Commercial Contributor in
connection with its distribution of the Program in a commercial product
offering. The obligations in this section do not apply to any claims or Losses
relating to any actual or alleged intellectual property infringement. In order
to qualify, an Indemnified Contributor must: a) promptly notify the Commercial
Contributor in writing of such claim, and b) allow the Commercial Contributor to
control, and cooperate with the Commercial Contributor in, the defense and any
related settlement negotiations. The Indemnified Contributor may participate in
any such claim at its own expense.

For example, a Contributor might include the Program in a commercial product
offering, Product X. That Contributor is then a Commercial Contributor. If that
Commercial Contributor then makes performance claims, or offers warranties
related to Product X, those performance claims and warranties are such
Commercial Contributor's responsibility alone. Under this section, the
Commercial Contributor would have to defend claims against the other
Contributors related to those performance claims and warranties, and if a court
requires any other Contributor to pay any damages as a result, the Commercial
Contributor must pay those damages.
(( 5. ))??

NO WARRANTY

EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN
"AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR
IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE,
NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Each
Recipient is solely responsible for determining the appropriateness of using and
distributing the Program and assumes all risks associated with its exercise of
rights under this Agreement, including but not limited to the risks and costs of
program errors, compliance with applicable laws, damage to or loss of data,
programs or equipment, and unavailability or interruption of operations.
(( 6. ))??

DISCLAIMER OF LIABILITY

EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY
CONTRIBUTORS SHALL HAVE ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION LOST
PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS
GRANTED HEREUNDER, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
(( 7. ))??

GENERAL

If any provision of this Agreement is invalid or unenforceable under applicable
law, it shall not affect the validity or enforceability of the remainder of the
terms of this Agreement, and without further action by the parties hereto, such
provision shall be reformed to the minimum extent necessary to make such
provision valid and enforceable.

If Recipient institutes patent litigation against a Contributor with respect to
a patent applicable to software (including a cross-claim or counterclaim in a
lawsuit), then any patent licenses granted by that Contributor to such Recipient
under this Agreement shall terminate as of the date such litigation is filed. In
addition, if Recipient institutes patent litigation against any entity
(including a cross-claim or counterclaim in a lawsuit) alleging that the Program
itself (excluding combinations of the Program with other software or hardware)
infringes such Recipient's patent(s), then such Recipient's rights granted under
Section 2(b) shall terminate as of the date such litigation is filed.

All Recipient's rights under this Agreement shall terminate if it fails to
comply with any of the material terms or conditions of this Agreement and does
not cure such failure in a reasonable period of time after becoming aware of
such noncompliance. If all Recipient's rights under this Agreement terminate,
Recipient agrees to cease use and distribution of the Program as soon as
reasonably practicable. However, Recipient's obligations under this Agreement
and any licenses granted by Recipient relating to the Program shall continue and
survive.

Everyone is permitted to copy and distribute copies of this Agreement, but in
order to avoid inconsistency the Agreement is copyrighted and may only be
modified in the following manner. The Agreement Steward reserves the right to
publish new versions (including revisions) of this Agreement from time to time.
No one other than the Agreement Steward has the right to modify this Agreement.
IBM is the initial Agreement Steward. IBM may assign the responsibility to serve
as the Agreement Steward to a suitable separate entity. Each new version of the
Agreement will be given a distinguishing version number. The Program (including
Contributions) may always be distributed subject to the version of the Agreement
under which it was received. In addition, after a new version of the Agreement
is published, Contributor may elect to distribute the Program (including its
Contributions) under the new version. Except as expressly stated in Sections
2(a) and 2(b) above, Recipient receives no rights or licenses to the
intellectual property of any Contributor under this Agreement, whether
expressly, by implication, estoppel or otherwise. All rights in the Program not
expressly granted under this Agreement are reserved.

This Agreement is governed by the laws of the State of New York and the
intellectual property laws of the United States of America. No party to this
Agreement will bring a legal action under this Agreement more than one year
after the cause of action arose. Each party waives its rights to a jury trial in
any resulting litigation.
//**
Solderpad Hardware License, Version 0.51
https://spdx.org/licenses/SHL-0.51.json
https://solderpad.org/licenses/SHL-0.51/
**//

(( SOLDERPAD HARDWARE LICENSE version 0.51 ))??

This license is based closely on the Apache License Version 2.0, but is not
approved or endorsed by the Apache Foundation. A copy of the non-modified Apache
License 2.0 can be found at http:/www.apache.org/licenses/LICENSE-2.0.

As this license is not currently OSI or FSF approved, the Licensor permits any
Work licensed under this License, at the option of the Licensee, to be treated
as licensed under the Apache License Version 2.0 (which is so approved).

This License is licensed under the terms of this License and in particular
clause 7 below (Disclaimer of Warranties) applies in relation to its use.
(( TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION ))??

   (( 1. ))??
   Definitions.

      "License" shall mean the terms and conditions for use, reproduction, and
      distribution as defined by Sections 1 through 9 of this document.

      "Licensor" shall mean the Rights owner or entity authorized by the Rights
      owner that is granting the License.

      "Legal Entity" shall mean the union of the acting entity and all other
      entities that control, are controlled by, or are under common control with
      that entity. For the purposes of this definition, "control" means (i) the
      power, direct or indirect, to cause the direction or management of such
      entity, whether by contract or otherwise, or (ii) ownership of fifty
      percent (50%) or more of the outstanding shares, or (iii) beneficial
      ownership of such entity.

      "You" (or "Your") shall mean an individual or Legal Entity exercising
      permissions granted by this License.

      "Rights" means copyright and any similar right including design right
      (whether registered or unregistered), semiconductor topography (mask)
      rights and database rights (but excluding Patents and Trademarks).

      "Source" form shall mean the preferred form for making modifications,
      including but not limited to source code, net lists, board layouts, CAD
      files, documentation source, and configuration files.

      "Object" form shall mean any form resulting from mechanical transformation
      or translation of a Source form, including but not limited to compiled
      object code, generated documentation, the instantiation of a hardware
      design and conversions to other media types, including intermediate forms
      such as bytecodes, FPGA bitstreams, artwork and semiconductor topographies
      (mask works).

      "Work" shall mean the work of authorship, whether in Source form or other
      Object form, made available under the License, as indicated by a Rights
      notice that is included in or attached to the work (an example is provided
      in the Appendix below).

      "Derivative Works" shall mean any work, whether in Source or Object form,
      that is based on (or derived from) the Work and for which the editorial
      revisions, annotations, elaborations, or other modifications represent, as
      a whole, an original work of authorship. For the purposes of this License,
      Derivative Works shall not include works that remain separable from, or
      merely link (or bind by name) or physically connect to or interoperate
      with the interfaces of, the Work and Derivative Works thereof.

      "Contribution" shall mean any design or work of authorship, including the
      original version of the Work and any modifications or additions to that
      Work or Derivative Works thereof, that is intentionally submitted to
      Licensor for inclusion in the Work by the Rights owner or by an individual
      or Legal Entity authorized to submit on behalf of the Rights owner. For
      the purposes of this definition, "submitted" means any form of electronic,
      verbal, or written communication sent to the Licensor or its
      representatives, including but not limited to communication on electronic
      mailing lists, source code control systems, and issue tracking systems
      that are managed by, or on behalf of, the Licensor for the purpose of
      discussing and improving the Work, but excluding communication that is
      conspicuously marked or otherwise designated in writing by the Rights
      owner as "Not a Contribution."

      "Contributor" shall mean Licensor and any individual or Legal Entity on
      behalf of whom a Contribution has been received by Licensor and
      subsequently incorporated within the Work.

   (( 2. ))??
   Grant of License. Subject to the terms and conditions of this License, each
   Contributor hereby grants to You a perpetual, worldwide, non-exclusive,
   no-charge, royalty-free, irrevocable license under the Rights to reproduce,
   prepare Derivative Works of, publicly display, publicly perform, sublicense,
   and distribute the Work and such Derivative Works in Source or Object form
   and do anything in relation to the Work as if the Rights did not exist.

   (( 3. ))??
   Grant of Patent License. Subject to the terms and conditions of this License,
   each Contributor hereby grants to You a perpetual, worldwide, non-exclusive,
   no-charge, royalty-free, irrevocable (except as stated in this section)
   patent license to make, have made, use, offer to sell, sell, import, and
   otherwise transfer the Work, where such license applies only to those patent
   claims licensable by such Contributor that are necessarily infringed by their
   Contribution(s) alone or by combination of their Contribution(s) with the
   Work to which such Contribution(s) was submitted. If You institute patent
   litigation against any entity (including a cross-claim or counterclaim in a
   lawsuit) alleging that the Work or a Contribution incorporated within the
   Work constitutes direct or contributory patent infringement, then any patent
   licenses granted to You under this License for that Work shall terminate as
   of the date such litigation is filed.

   (( 4. ))??
   Redistribution. You may reproduce and distribute copies of the Work or
   Derivative Works thereof in any medium, with or without modifications, and in
   Source or Object form, provided that You meet the following conditions:

      (( 1. ))??
      You must give any other recipients of the Work or Derivative Works a copy
      of this License; and

      (( 2. ))??
      You must cause any modified files to carry prominent notices stating that
      You changed the files; and

      (( 3. ))??
      You must retain, in the Source form of any Derivative Works that You
      distribute, all copyright, patent, trademark, and attribution notices from
      the Source form of the Work, excluding those notices that do not pertain
      to any part of the Derivative Works; and

      (( 4. ))??
      If the Work includes a "NOTICE" text file as part of its distribution,
      then any Derivative Works that You distribute must include a readable copy
      of the attribution notices contained within such NOTICE file, excluding
      those notices that do not pertain to any part of the Derivative Works, in
      at least one of the following places: within a NOTICE text file
      distributed as part of the Derivative Works; within the Source form or
      documentation, if provided along with the Derivative Works; or, within a
      display generated by the Derivative Works, if and wherever such
      third-party notices normally appear. The contents of the NOTICE file are
      for informational purposes only and do not modify the License. You may add
      Your own attribution notices within Derivative Works that You distribute,
      alongside or as an addendum to the NOTICE text from the Work, provided
      that such additional attribution notices cannot be construed as modifying
      the License. You may add Your own copyright statement to Your
      modifications and may provide additional or different license terms and
      conditions for use, reproduction, or distribution of Your modifications,
      or for any such Derivative Works as a whole, provided Your use,
      reproduction, and distribution of the Work otherwise complies with the
      conditions stated in this License.

   (( 5. ))??
   Submission of Contributions. Unless You explicitly state otherwise, any
   Contribution intentionally submitted for inclusion in the Work by You to the
   Licensor shall be under the terms and conditions of this License, without any
   additional terms or conditions. Notwithstanding the above, nothing herein
   shall supersede or modify the terms of any separate license agreement you may
   have executed with Licensor regarding such Contributions.

   (( 6. ))??
   Trademarks. This License does not grant permission to use the trade names,
   trademarks, service marks, or product names of the Licensor, except as
   required for reasonable and customary use in describing the origin of the
   Work and reproducing the content of the NOTICE file.

   (( 7. ))??
   Disclaimer of Warranty. Unless required by applicable law or agreed to in
   writing, Licensor provides the Work (and each Contributor provides its
   Contributions) on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
   KIND, either express or implied, including, without limitation, any
   warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or
   FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining
   the appropriateness of using or redistributing the Work and assume any risks
   associated with Your exercise of permissions under this License.

   (( 8. ))??
   Limitation of Liability. In no event and under no legal theory, whether in
   tort (including negligence), contract, or otherwise, unless required by
   applicable law (such as deliberate and grossly negligent acts) or agreed to
   in writing, shall any Contributor be liable to You for damages, including any
   direct, indirect, special, incidental, or consequential damages of any
   character arising as a result of this License or out of the use or inability
   to use the Work (including but not limited to damages for loss of goodwill,
   work stoppage, computer failure or malfunction, or any and all other
   commercial damages or losses), even if such Contributor has been advised of
   the possibility of such damages.

   (( 9. ))??
   Accepting Warranty or Additional Liability. While redistributing the Work or
   Derivative Works thereof, You may choose to offer, and charge a fee for,
   acceptance of support, warranty, indemnity, or other liability obligations
   and/or rights consistent with this License. However, in accepting such
   obligations, You may act only on Your own behalf and on Your sole
   responsibility, not on behalf of any other Contributor, and only if You agree
   to indemnify, defend, and hold each Contributor harmless for any liability
   incurred by, or claims asserted against, such Contributor by reason of your
   accepting any such warranty or additional liability.
   (( END OF TERMS AND CONDITIONS

APPENDIX: How to apply this license to your work

To apply this license to your work, attach the following boilerplate notice,
with the fields enclosed by brackets "[]" replaced with your own identifying
information. (Don't include the brackets!) The text should be enclosed in the
appropriate comment syntax for the file format. We also recommend that a file or
class name and description of purpose be included on the same "printed page" as
the copyright notice for easier identification within third-party archives.

Copyright __20__

Copyright and related rights are licensed under the Solderpad Hardware License,
Version 0.51 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http:/solderpad.org/licenses/SHL-0.51. Unless required by applicable law or
agreed to in writing, software, hardware and materials distributed under this
License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF
ANY KIND, either express or implied. See the License for the specific language
governing permissions and limitations under the License. ))??
//**
Eclipse Public License 1.0
https://spdx.org/licenses/EPL-1.0.json
http://www.eclipse.org/legal/epl-v10.html
https://opensource.org/licenses/EPL-1.0
**//

(( Eclipse Public License - v 1.0 ))??

((THE ACCOMPANYING PROGRAM))??
IS PROVIDED UNDER THE TERMS OF THIS ECLIPSE PUBLIC
LICENSE ("AGREEMENT"). ANY USE, REPRODUCTION OR DISTRIBUTION OF
((THE PROGRAM || THIS SOFTWARE))
CONSTITUTES
((THE))??
RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT.

   (( 1. ))??
   DEFINITIONS

   "Contribution" means:

      (( a) ))??
      in the case of the initial Contributor, the initial code and documentation
      distributed under this Agreement, and

      (( b) ))??
      in the case of each subsequent Contributor:

         (( i) ))??
         changes to the Program, and

         (( ii) ))??
         additions to the Program;

         where such changes and/or additions to the Program originate from and
         are distributed by that particular Contributor. A Contribution
         'originates' from a Contributor if it was added to the Program by such
         Contributor itself or anyone acting on such Contributor's behalf.
         Contributions do not include additions to the Program which: (i) are
         separate modules of software distributed in conjunction with the
         Program under their own license agreement, and (ii) are not derivative
         works of the Program.

   "Contributor" means any person or entity that distributes the Program.

   "Licensed Patents" mean patent claims licensable by a Contributor which are
   necessarily infringed by the use or sale of its Contribution alone or when
   combined with the Program.

   "Program" means the Contributions distributed in accordance with this
   Agreement.

   "Recipient" means anyone who receives the Program under this Agreement,
   including all Contributors.

   (( 2. ))??
   GRANT OF RIGHTS

      (( a) ))??
      Subject to the terms of this Agreement, each Contributor hereby grants
      Recipient a non-exclusive, worldwide, royalty-free copyright license to
      reproduce, prepare derivative works of, publicly display, publicly
      perform, distribute and sublicense the Contribution of such Contributor,
      if any, and such derivative works, in source code and object code form.

      (( b) ))??
      Subject to the terms of this Agreement, each Contributor hereby grants
      Recipient a non-exclusive, worldwide, royalty-free patent license under
      Licensed Patents to make, use, sell, offer to sell, import and otherwise
      transfer the Contribution of such Contributor, if any, in source code and
      object code form. This patent license shall apply to the combination of
      the Contribution and the Program if, at the time the Contribution is added
      by the Contributor, such addition of the Contribution causes such
      combination to be covered by the Licensed Patents. The patent license
      shall not apply to any other combinations which include the Contribution.
      No hardware per se is licensed hereunder.

      (( c) ))??
      Recipient understands that although each Contributor grants the licenses
      to its Contributions set forth herein, no assurances are provided by any
      Contributor that the Program does not infringe the patent or other
      intellectual property rights of any other entity. Each Contributor
      disclaims any liability to Recipient for claims brought by any other
      entity based on infringement of intellectual property rights or otherwise.
      As a condition to exercising the rights and licenses granted hereunder,
      each Recipient hereby assumes sole responsibility to secure any other
      intellectual property rights needed, if any. For example, if a third party
      patent license is required to allow Recipient to distribute the Program,
      it is Recipient's responsibility to acquire that license before
      distributing the Program.

      (( d) ))??
      Each Contributor represents that to its knowledge it has sufficient
      copyright rights in its Contribution, if any, to grant the copyright
      license set forth in this Agreement.

   (( 3. ))??
   REQUIREMENTS

   A Contributor may choose to distribute the Program in object code form under
   its own license agreement, provided that:

      (( a) ))??
      it complies with the terms and conditions of this Agreement; and

      (( b) ))??
      its license agreement:

         (( i) ))??
         effectively disclaims on behalf of all Contributors all warranties and
         conditions, express and implied, including warranties or conditions of
         title and non-infringement, and implied warranties or conditions of
         merchantability and fitness for a particular purpose;

         (( ii) ))??
         effectively excludes on behalf of all Contributors all liability for
         damages, including direct, indirect, special, incidental and
         consequential damages, such as lost profits;

         (( iii) ))??
         states that any provisions which differ from this Agreement are offered
         by that Contributor alone and not by any other party; and

         (( iv) ))??
         states that source code for the Program is available from such
         Contributor, and informs licensees how to obtain it in a reasonable
         manner on or through a medium customarily used for software exchange.

   When the Program is made available in source code form:

      (( a) ))??
      it must be made available under this Agreement; and

      (( b) ))??
      a copy of this Agreement must be included with each copy of the Program.

      Contributors may not remove or alter any copyright notices contained
      within the Program.

   Each Contributor must identify itself as the originator of its Contribution,
   if any, in a manner that reasonably allows subsequent Recipients to identify
   the originator of the Contribution.

   (( 4. ))??
   COMMERCIAL DISTRIBUTION

   Commercial distributors of software may accept certain responsibilities with
   respect to end users, business partners and the like. While this license is
   intended to facilitate the commercial use of the Program, the Contributor who
   includes the Program in a commercial product offering should do so in a
   manner which does not create potential liability for other Contributors.
   Therefore, if a Contributor includes the Program in a commercial product
   offering, such Contributor ("Commercial Contributor") hereby agrees to defend
   and indemnify every other Contributor ("Indemnified Contributor") against any
   losses, damages and costs (collectively "Losses") arising from claims,
   lawsuits and other legal actions brought by a third party against the
   Indemnified Contributor to the extent caused by the acts or omissions of such
   Commercial Contributor in connection with its distribution of the Program in
   a commercial product offering. The obligations in this section do not apply
   to any claims or Losses relating to any actual or alleged intellectual
   property infringement. In order to qualify, an Indemnified Contributor must:
   a) promptly notify the Commercial Contributor in writing of such claim, and
   b) allow the Commercial Contributor to control, and cooperate with the
   Commercial Contributor in, the defense and any related settlement
   negotiations. The Indemnified Contributor may participate in any such claim
   at its own expense.

   For example, a Contributor might include the Program in a commercial product
   offering, Product X. That Contributor is then a Commercial Contributor. If
   that Commercial Contributor then makes performance claims, or offers
   warranties related to Product X, those performance claims and warranties are
   such Commercial Contributor's responsibility alone. Under this section, the
   Commercial Contributor would have to defend claims against the other
   Contributors related to those performance claims and warranties, and if a
   court requires any other Contributor to pay any damages as a result, the
   Commercial Contributor must pay those damages.

   (( 5. ))??
   NO WARRANTY

   EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON
   AN "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER
   EXPRESS OR IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR
   CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS FOR A
   PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the
   appropriateness of using and distributing the Program and assumes all risks
   associated with its exercise of rights under this Agreement, including but
   not limited to the risks and costs of program errors, compliance with
   applicable laws, damage to or loss of data, programs or equipment, and
   unavailability or interruption of operations.

   (( 6. ))??
   DISCLAIMER OF LIABILITY

   EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY
   CONTRIBUTORS SHALL HAVE ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION
   LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
   ARISING IN ANY WAY OUT OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE
   EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE POSSIBILITY
   OF SUCH DAMAGES.

   (( 7. ))??
   GENERAL

   If any provision of this Agreement is invalid or unenforceable under
   applicable law, it shall not affect the validity or enforceability of the
   remainder of the terms of this Agreement, and without further action by the
   parties hereto, such provision shall be reformed to the minimum extent
   necessary to make such provision valid and enforceable.

   If Recipient institutes patent litigation against any entity (including a
   cross-claim or counterclaim in a lawsuit) alleging that the Program itself
   (excluding combinations of the Program with other software or hardware)
   infringes such Recipient's patent(s), then such Recipient's rights granted
   under Section 2(b) shall terminate as of the date such litigation is filed.

   All Recipient's rights under this Agreement shall terminate if it fails to
   comply with any of the material terms or conditions of this Agreement and
   does not cure such failure in a reasonable period of time after becoming
   aware of such noncompliance. If all Recipient's rights under this Agreement
   terminate, Recipient agrees to cease use and distribution of the Program as
   soon as reasonably practicable. However, Recipient's obligations under this
   Agreement and any licenses granted by Recipient relating to the Program shall
   continue and survive.

   Everyone is permitted to copy and distribute copies of this Agreement, but in
   order to avoid inconsistency the Agreement is copyrighted and may only be
   modified in the following manner. The Agreement Steward reserves the right to
   publish new versions (including revisions) of this Agreement from time to
   time. No one other than the Agreement Steward has the right to modify this
   Agreement. The Eclipse Foundation is the initial Agreement Steward. The
   Eclipse Foundation may assign the responsibility to serve as the Agreement
   Steward to a suitable separate entity. Each new version of the Agreement will
   be given a distinguishing version number. The Program (including
   Contributions) may always be distributed subject to the version of the
   Agreement under which it was received. In addition, after a new version of
   the Agreement is published, Contributor may elect to distribute the Program
   (including its Contributions) under the new version. Except as expressly
   stated in Sections 2(a) and 2(b) above, Recipient receives no rights or
   licenses to the intellectual property of any Contributor under this
   Agreement, whether expressly, by implication, estoppel or otherwise. All
   rights in the Program not expressly granted under this Agreement are
   reserved.

   This Agreement is governed by the laws of the State of __2__ and the
   intellectual property laws of the United States of America. No party to this
   Agreement will bring a legal action under this Agreement more than one year
   after the cause of action arose. Each party waives its rights to a jury trial
   in any resulting litigation.

 google/protobuf/descriptor.proto